/* SPDX-License-Identifier: GPL-2.0-only */
/*
 * Copyright (c) 2021, The Linux Foundation. All rights reserved.
 */

#ifndef __IPA_HWIO_H__
#define __IPA_HWIO_H__
/**
  @file ipa_hwio.h
  @brief Auto-generated HWIO interface include file.

  This file contains HWIO register definitions for the following modules:
    IPA.*

  'Include' filters applied: <none>
  'Exclude' filters applied: RESERVED DUMMY

  Attribute definitions for the HWIO_*_ATTR macros are as follows:
    0x0: Command register
    0x1: Read-Only
    0x2: Write-Only
    0x3: Read/Write
*/

/*----------------------------------------------------------------------------
 * MODULE: IPA_UC_IPA_UC
 *--------------------------------------------------------------------------*/

#define IPA_UC_IPA_UC_REG_BASE (IPA_0_IPA_WRAPPER_BASE      + 0x001a0000)
#define IPA_UC_IPA_UC_REG_BASE_PHYS (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x001a0000)
#define IPA_UC_IPA_UC_REG_BASE_OFFS 0x001a0000

/*----------------------------------------------------------------------------
 * MODULE: IPA_UC_IPA_UC_RAM
 *--------------------------------------------------------------------------*/

#define IPA_UC_IPA_UC_RAM_REG_BASE                      (IPA_0_IPA_WRAPPER_BASE      + 0x001a0000)
#define IPA_UC_IPA_UC_RAM_REG_BASE_PHYS                 (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x001a0000)
#define IPA_UC_IPA_UC_RAM_REG_BASE_OFFS                 0x001a0000

#define HWIO_IPA_UC_IRAM_START_ADDR                     (IPA_UC_IPA_UC_RAM_REG_BASE      + 0x00000000)
#define HWIO_IPA_UC_IRAM_START_PHYS                     (IPA_UC_IPA_UC_RAM_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_UC_IRAM_START_OFFS                     (IPA_UC_IPA_UC_RAM_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_UC_IRAM_START_RMSK                     0xffffffff
#define HWIO_IPA_UC_IRAM_START_ATTR                            0x3
#define HWIO_IPA_UC_IRAM_START_IN          \
        in_dword_masked(HWIO_IPA_UC_IRAM_START_ADDR, HWIO_IPA_UC_IRAM_START_RMSK)
#define HWIO_IPA_UC_IRAM_START_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_IRAM_START_ADDR, m)
#define HWIO_IPA_UC_IRAM_START_OUT(v)      \
        out_dword(HWIO_IPA_UC_IRAM_START_ADDR,v)
#define HWIO_IPA_UC_IRAM_START_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_IRAM_START_ADDR,m,v,HWIO_IPA_UC_IRAM_START_IN)
#define HWIO_IPA_UC_IRAM_START_DATA_BMSK                0xffffffff
#define HWIO_IPA_UC_IRAM_START_DATA_SHFT                       0x0

#define HWIO_IPA_UC_DRAM_START_ADDR                     (IPA_UC_IPA_UC_RAM_REG_BASE      + 0x00008000)
#define HWIO_IPA_UC_DRAM_START_PHYS                     (IPA_UC_IPA_UC_RAM_REG_BASE_PHYS + 0x00008000)
#define HWIO_IPA_UC_DRAM_START_OFFS                     (IPA_UC_IPA_UC_RAM_REG_BASE_OFFS + 0x00008000)
#define HWIO_IPA_UC_DRAM_START_RMSK                     0xffffffff
#define HWIO_IPA_UC_DRAM_START_ATTR                            0x3
#define HWIO_IPA_UC_DRAM_START_IN          \
        in_dword_masked(HWIO_IPA_UC_DRAM_START_ADDR, HWIO_IPA_UC_DRAM_START_RMSK)
#define HWIO_IPA_UC_DRAM_START_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_DRAM_START_ADDR, m)
#define HWIO_IPA_UC_DRAM_START_OUT(v)      \
        out_dword(HWIO_IPA_UC_DRAM_START_ADDR,v)
#define HWIO_IPA_UC_DRAM_START_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_DRAM_START_ADDR,m,v,HWIO_IPA_UC_DRAM_START_IN)
#define HWIO_IPA_UC_DRAM_START_DATA_BMSK                0xffffffff
#define HWIO_IPA_UC_DRAM_START_DATA_SHFT                       0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_UC_IPA_UC_PER
 *--------------------------------------------------------------------------*/

#define IPA_UC_IPA_UC_PER_REG_BASE                                                       (IPA_0_IPA_WRAPPER_BASE      + 0x001c0000)
#define IPA_UC_IPA_UC_PER_REG_BASE_PHYS                                                  (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x001c0000)
#define IPA_UC_IPA_UC_PER_REG_BASE_OFFS                                                  0x001c0000

#define HWIO_IPA_UC_STATUS_ADDR                                                          (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000000)
#define HWIO_IPA_UC_STATUS_PHYS                                                          (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_UC_STATUS_OFFS                                                          (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_UC_STATUS_RMSK                                                                 0xf
#define HWIO_IPA_UC_STATUS_ATTR                                                                 0x1
#define HWIO_IPA_UC_STATUS_IN          \
        in_dword_masked(HWIO_IPA_UC_STATUS_ADDR, HWIO_IPA_UC_STATUS_RMSK)
#define HWIO_IPA_UC_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_STATUS_ADDR, m)
#define HWIO_IPA_UC_STATUS_UC_ENABLE_BMSK                                                       0x8
#define HWIO_IPA_UC_STATUS_UC_ENABLE_SHFT                                                       0x3
#define HWIO_IPA_UC_STATUS_LOCKUP_BMSK                                                          0x4
#define HWIO_IPA_UC_STATUS_LOCKUP_SHFT                                                          0x2
#define HWIO_IPA_UC_STATUS_SLEEP_BMSK                                                           0x2
#define HWIO_IPA_UC_STATUS_SLEEP_SHFT                                                           0x1
#define HWIO_IPA_UC_STATUS_SLEEPDEEP_BMSK                                                       0x1
#define HWIO_IPA_UC_STATUS_SLEEPDEEP_SHFT                                                       0x0

#define HWIO_IPA_UC_CONTROL_ADDR                                                         (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000004)
#define HWIO_IPA_UC_CONTROL_PHYS                                                         (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000004)
#define HWIO_IPA_UC_CONTROL_OFFS                                                         (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000004)
#define HWIO_IPA_UC_CONTROL_RMSK                                                          0x9000ffe
#define HWIO_IPA_UC_CONTROL_ATTR                                                                0x3
#define HWIO_IPA_UC_CONTROL_IN          \
        in_dword_masked(HWIO_IPA_UC_CONTROL_ADDR, HWIO_IPA_UC_CONTROL_RMSK)
#define HWIO_IPA_UC_CONTROL_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CONTROL_ADDR, m)
#define HWIO_IPA_UC_CONTROL_OUT(v)      \
        out_dword(HWIO_IPA_UC_CONTROL_ADDR,v)
#define HWIO_IPA_UC_CONTROL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_CONTROL_ADDR,m,v,HWIO_IPA_UC_CONTROL_IN)
#define HWIO_IPA_UC_CONTROL_UC_RAM_RD_CLI_CACHE_DIS_BMSK                                  0x8000000
#define HWIO_IPA_UC_CONTROL_UC_RAM_RD_CLI_CACHE_DIS_SHFT                                       0x1b
#define HWIO_IPA_UC_CONTROL_WARMBOOT_DIS_BMSK                                             0x1000000
#define HWIO_IPA_UC_CONTROL_WARMBOOT_DIS_SHFT                                                  0x18
#define HWIO_IPA_UC_CONTROL_MBOX_DIS_BMSK                                                     0xff0
#define HWIO_IPA_UC_CONTROL_MBOX_DIS_SHFT                                                       0x4
#define HWIO_IPA_UC_CONTROL_UC_CLOCK_GATING_DIS_BMSK                                            0x8
#define HWIO_IPA_UC_CONTROL_UC_CLOCK_GATING_DIS_SHFT                                            0x3
#define HWIO_IPA_UC_CONTROL_QMB_SNOC_BYPASS_DIS_BMSK                                            0x4
#define HWIO_IPA_UC_CONTROL_QMB_SNOC_BYPASS_DIS_SHFT                                            0x2
#define HWIO_IPA_UC_CONTROL_UC_DSMODE_BMSK                                                      0x2
#define HWIO_IPA_UC_CONTROL_UC_DSMODE_SHFT                                                      0x1

#define HWIO_IPA_UC_SYS_BUS_ATTRIB_ADDR                                                  (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000010)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_PHYS                                                  (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_OFFS                                                  (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_RMSK                                                      0x1117
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_ATTR                                                         0x3
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_IN          \
        in_dword_masked(HWIO_IPA_UC_SYS_BUS_ATTRIB_ADDR, HWIO_IPA_UC_SYS_BUS_ATTRIB_RMSK)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_SYS_BUS_ATTRIB_ADDR, m)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_OUT(v)      \
        out_dword(HWIO_IPA_UC_SYS_BUS_ATTRIB_ADDR,v)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_SYS_BUS_ATTRIB_ADDR,m,v,HWIO_IPA_UC_SYS_BUS_ATTRIB_IN)
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_SHARED_BMSK                                               0x1000
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_SHARED_SHFT                                                  0xc
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_INNERSHARED_BMSK                                           0x100
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_INNERSHARED_SHFT                                             0x8
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_NOALLOCATE_BMSK                                             0x10
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_NOALLOCATE_SHFT                                              0x4
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_BMSK                                                 0x7
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_SHFT                                                 0x0
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_STRONGLY_ORDERED_FVAL                                0x0
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_DEVICE_FVAL                                          0x1
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_NON_CACHEABLE_FVAL                                   0x2
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_COPYBACK_WRITEALLOCATE_FVAL                          0x3
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_WRITETHROUGH_NOALLOCATE_FVAL                         0x6
#define HWIO_IPA_UC_SYS_BUS_ATTRIB_MEMTYPE_COPYBACK_NOALLOCATE_FVAL                             0x7

#define HWIO_IPA_UC_PEND_IRQ_ADDR                                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000014)
#define HWIO_IPA_UC_PEND_IRQ_PHYS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000014)
#define HWIO_IPA_UC_PEND_IRQ_OFFS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000014)
#define HWIO_IPA_UC_PEND_IRQ_RMSK                                                        0xffffffff
#define HWIO_IPA_UC_PEND_IRQ_ATTR                                                               0x1
#define HWIO_IPA_UC_PEND_IRQ_IN          \
        in_dword_masked(HWIO_IPA_UC_PEND_IRQ_ADDR, HWIO_IPA_UC_PEND_IRQ_RMSK)
#define HWIO_IPA_UC_PEND_IRQ_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_PEND_IRQ_ADDR, m)
#define HWIO_IPA_UC_PEND_IRQ_PEND_IRQ_BMSK                                               0xffffffff
#define HWIO_IPA_UC_PEND_IRQ_PEND_IRQ_SHFT                                                      0x0

#define HWIO_IPA_UC_TRACE_BUFFER_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000018)
#define HWIO_IPA_UC_TRACE_BUFFER_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000018)
#define HWIO_IPA_UC_TRACE_BUFFER_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000018)
#define HWIO_IPA_UC_TRACE_BUFFER_RMSK                                                    0xffffffff
#define HWIO_IPA_UC_TRACE_BUFFER_ATTR                                                           0x1
#define HWIO_IPA_UC_TRACE_BUFFER_IN          \
        in_dword_masked(HWIO_IPA_UC_TRACE_BUFFER_ADDR, HWIO_IPA_UC_TRACE_BUFFER_RMSK)
#define HWIO_IPA_UC_TRACE_BUFFER_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_TRACE_BUFFER_ADDR, m)
#define HWIO_IPA_UC_TRACE_BUFFER_TRACE_BUFFER_BMSK                                       0xffffffff
#define HWIO_IPA_UC_TRACE_BUFFER_TRACE_BUFFER_SHFT                                              0x0

#define HWIO_IPA_UC_PC_ADDR                                                              (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000001c)
#define HWIO_IPA_UC_PC_PHYS                                                              (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000001c)
#define HWIO_IPA_UC_PC_OFFS                                                              (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000001c)
#define HWIO_IPA_UC_PC_RMSK                                                              0xffffffff
#define HWIO_IPA_UC_PC_ATTR                                                                     0x1
#define HWIO_IPA_UC_PC_IN          \
        in_dword_masked(HWIO_IPA_UC_PC_ADDR, HWIO_IPA_UC_PC_RMSK)
#define HWIO_IPA_UC_PC_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_PC_ADDR, m)
#define HWIO_IPA_UC_PC_PC_BMSK                                                           0xffffffff
#define HWIO_IPA_UC_PC_PC_SHFT                                                                  0x0

#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_ADDR                                            (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000024)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_PHYS                                            (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000024)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_OFFS                                            (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000024)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_RMSK                                            0xffffffff
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_ATTR                                                   0x1
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_IN          \
        in_dword_masked(HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_ADDR, HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_RMSK)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_ADDR, m)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_ADDRRESS_BMSK                                   0xffffffff
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_LSB_ADDRRESS_SHFT                                          0x0

#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_ADDR                                            (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000028)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_PHYS                                            (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000028)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_OFFS                                            (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000028)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_RMSK                                                 0x1ff
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_ATTR                                                   0x1
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_IN          \
        in_dword_masked(HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_ADDR, HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_RMSK)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_ADDR, m)
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_ADDRRESS_BMSK                                        0x1ff
#define HWIO_IPA_UC_VUIC_INT_ADDRESS_MSB_ADDRRESS_SHFT                                          0x0

#define HWIO_IPA_UC_QMB_SYS_ADDR_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000100)
#define HWIO_IPA_UC_QMB_SYS_ADDR_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000100)
#define HWIO_IPA_UC_QMB_SYS_ADDR_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000100)
#define HWIO_IPA_UC_QMB_SYS_ADDR_RMSK                                                    0xffffffff
#define HWIO_IPA_UC_QMB_SYS_ADDR_ATTR                                                           0x3
#define HWIO_IPA_UC_QMB_SYS_ADDR_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_SYS_ADDR_ADDR, HWIO_IPA_UC_QMB_SYS_ADDR_RMSK)
#define HWIO_IPA_UC_QMB_SYS_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_SYS_ADDR_ADDR, m)
#define HWIO_IPA_UC_QMB_SYS_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_SYS_ADDR_ADDR,v)
#define HWIO_IPA_UC_QMB_SYS_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_SYS_ADDR_ADDR,m,v,HWIO_IPA_UC_QMB_SYS_ADDR_IN)
#define HWIO_IPA_UC_QMB_SYS_ADDR_ADDR_BMSK                                               0xffffffff
#define HWIO_IPA_UC_QMB_SYS_ADDR_ADDR_SHFT                                                      0x0

#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR                                                (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000104)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_PHYS                                                (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000104)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_OFFS                                                (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000104)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_RMSK                                                0xffffffff
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ATTR                                                       0x3
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR, HWIO_IPA_UC_QMB_SYS_ADDR_MSB_RMSK)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR, m)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR,v)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR,m,v,HWIO_IPA_UC_QMB_SYS_ADDR_MSB_IN)
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR_MSB_BMSK                                       0xffffffff
#define HWIO_IPA_UC_QMB_SYS_ADDR_MSB_ADDR_MSB_SHFT                                              0x0

#define HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR                                                  (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000108)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_PHYS                                                  (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000108)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_OFFS                                                  (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000108)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_RMSK                                                     0x3ffff
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_ATTR                                                         0x3
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR, HWIO_IPA_UC_QMB_LOCAL_ADDR_RMSK)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR, m)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR,v)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR,m,v,HWIO_IPA_UC_QMB_LOCAL_ADDR_IN)
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR_BMSK                                                0x3ffff
#define HWIO_IPA_UC_QMB_LOCAL_ADDR_ADDR_SHFT                                                    0x0

#define HWIO_IPA_UC_QMB_LENGTH_ADDR                                                      (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000010c)
#define HWIO_IPA_UC_QMB_LENGTH_PHYS                                                      (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000010c)
#define HWIO_IPA_UC_QMB_LENGTH_OFFS                                                      (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000010c)
#define HWIO_IPA_UC_QMB_LENGTH_RMSK                                                          0xffff
#define HWIO_IPA_UC_QMB_LENGTH_ATTR                                                             0x3
#define HWIO_IPA_UC_QMB_LENGTH_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_LENGTH_ADDR, HWIO_IPA_UC_QMB_LENGTH_RMSK)
#define HWIO_IPA_UC_QMB_LENGTH_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_LENGTH_ADDR, m)
#define HWIO_IPA_UC_QMB_LENGTH_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_LENGTH_ADDR,v)
#define HWIO_IPA_UC_QMB_LENGTH_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_LENGTH_ADDR,m,v,HWIO_IPA_UC_QMB_LENGTH_IN)
#define HWIO_IPA_UC_QMB_LENGTH_LENGTH_BMSK                                                   0xffff
#define HWIO_IPA_UC_QMB_LENGTH_LENGTH_SHFT                                                      0x0

#define HWIO_IPA_UC_QMB_TRIGGER_ADDR                                                     (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000110)
#define HWIO_IPA_UC_QMB_TRIGGER_PHYS                                                     (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000110)
#define HWIO_IPA_UC_QMB_TRIGGER_OFFS                                                     (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000110)
#define HWIO_IPA_UC_QMB_TRIGGER_RMSK                                                     0xffffffff
#define HWIO_IPA_UC_QMB_TRIGGER_ATTR                                                            0x2
#define HWIO_IPA_UC_QMB_TRIGGER_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_TRIGGER_ADDR,v)
#define HWIO_IPA_UC_QMB_TRIGGER_RSV_BMSK                                                 0xffffffff
#define HWIO_IPA_UC_QMB_TRIGGER_RSV_SHFT                                                        0x0

#define HWIO_IPA_UC_QMB_COMMAND_ATTR_ADDR                                                (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000114)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_PHYS                                                (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000114)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_OFFS                                                (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000114)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_RMSK                                                 0x7ff003f
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_ATTR                                                       0x3
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_COMMAND_ATTR_ADDR, HWIO_IPA_UC_QMB_COMMAND_ATTR_RMSK)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_COMMAND_ATTR_ADDR, m)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_COMMAND_ATTR_ADDR,v)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_COMMAND_ATTR_ADDR,m,v,HWIO_IPA_UC_QMB_COMMAND_ATTR_IN)
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_USER_BMSK                                            0x7ff0000
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_USER_SHFT                                                 0x10
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_QUEUE_NUMBER_BMSK                                         0x20
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_QUEUE_NUMBER_SHFT                                          0x5
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_INTERRUPT_ON_COMPLETION_BMSK                              0x10
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_INTERRUPT_ON_COMPLETION_SHFT                               0x4
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_SYNC_BMSK                                                  0x8
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_SYNC_SHFT                                                  0x3
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_WAIT_FOR_RESPONSE_MODE_BMSK                                0x4
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_WAIT_FOR_RESPONSE_MODE_SHFT                                0x2
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_INORDER_BMSK                                               0x2
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_INORDER_SHFT                                               0x1
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_DIRECTION_BMSK                                             0x1
#define HWIO_IPA_UC_QMB_COMMAND_ATTR_DIRECTION_SHFT                                             0x0

#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_ADDR                                               (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000118)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_PHYS                                               (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000118)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_OFFS                                               (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000118)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_RMSK                                                  0x3ffff
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_ATTR                                                      0x3
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_COMMAND_UCTAG_ADDR, HWIO_IPA_UC_QMB_COMMAND_UCTAG_RMSK)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_COMMAND_UCTAG_ADDR, m)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_COMMAND_UCTAG_ADDR,v)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_COMMAND_UCTAG_ADDR,m,v,HWIO_IPA_UC_QMB_COMMAND_UCTAG_IN)
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_UCTAG_BMSK                                            0x3ffff
#define HWIO_IPA_UC_QMB_COMMAND_UCTAG_UCTAG_SHFT                                                0x0

#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_ADDR(n)                                         (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000011c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_PHYS(n)                                         (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000011c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_OFFS(n)                                         (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000011c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_RMSK                                            0xc7ffffff
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_MAXn                                                     1
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_ATTR                                                   0x1
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_ADDR(n), HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_RMSK)
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_ADDR(n), mask)
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_FULL_BMSK                                       0x80000000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_FULL_SHFT                                             0x1f
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_EMPTY_BMSK                                      0x40000000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_EMPTY_SHFT                                            0x1e
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_ERROR_BMSK                                       0x4000000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_ERROR_SHFT                                            0x1a
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_FIFO_CNT_BMSK                                    0x3c00000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_FIFO_CNT_SHFT                                         0x16
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_FIFO_SIZE_BMSK                                    0x3c0000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_FIFO_SIZE_SHFT                                        0x12
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_UCTAG_BMSK                                         0x3ffff
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_n_UCTAG_SHFT                                             0x0

#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_ADDR(n)                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000012c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_PHYS(n)                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000012c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_OFFS(n)                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000012c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_RMSK                                       0xc7ffffff
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_MAXn                                                1
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_ATTR                                              0x1
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_ADDR(n), HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_RMSK)
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_ADDR(n), mask)
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_FULL_BMSK                                  0x80000000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_FULL_SHFT                                        0x1f
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_EMPTY_BMSK                                 0x40000000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_EMPTY_SHFT                                       0x1e
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_ERROR_BMSK                                  0x4000000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_ERROR_SHFT                                       0x1a
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_FIFO_CNT_BMSK                               0x3c00000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_FIFO_CNT_SHFT                                    0x16
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_FIFO_SIZE_BMSK                               0x3c0000
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_FIFO_SIZE_SHFT                                   0x12
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_UCTAG_BMSK                                    0x3ffff
#define HWIO_IPA_UC_QMB_COMPLETED_FIFO_PEEK_n_UCTAG_SHFT                                        0x0

#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_ADDR(n)                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000013c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_PHYS(n)                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000013c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_OFFS(n)                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000013c + 0x4 * (n))
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_RMSK                                              0x300ff
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_MAXn                                                    1
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_ATTR                                                  0x1
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_ADDR(n), HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_RMSK)
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_ADDR(n), mask)
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_FULL_BMSK                                         0x20000
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_FULL_SHFT                                            0x11
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_EMPTY_BMSK                                        0x10000
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_EMPTY_SHFT                                           0x10
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_FIFO_CNT_BMSK                                        0xf0
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_FIFO_CNT_SHFT                                         0x4
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_FIFO_SIZE_BMSK                                        0xf
#define HWIO_IPA_UC_QMB_CMD_FIFO_STATUS_n_FIFO_SIZE_SHFT                                        0x0

#define HWIO_IPA_UC_QMB_SYNC_STATUS_ADDR                                                 (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000150)
#define HWIO_IPA_UC_QMB_SYNC_STATUS_PHYS                                                 (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000150)
#define HWIO_IPA_UC_QMB_SYNC_STATUS_OFFS                                                 (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000150)
#define HWIO_IPA_UC_QMB_SYNC_STATUS_RMSK                                                    0x10001
#define HWIO_IPA_UC_QMB_SYNC_STATUS_ATTR                                                        0x1
#define HWIO_IPA_UC_QMB_SYNC_STATUS_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_SYNC_STATUS_ADDR, HWIO_IPA_UC_QMB_SYNC_STATUS_RMSK)
#define HWIO_IPA_UC_QMB_SYNC_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_SYNC_STATUS_ADDR, m)
#define HWIO_IPA_UC_QMB_SYNC_STATUS_ERROR_QUEUE_1_BMSK                                      0x10000
#define HWIO_IPA_UC_QMB_SYNC_STATUS_ERROR_QUEUE_1_SHFT                                         0x10
#define HWIO_IPA_UC_QMB_SYNC_STATUS_ERROR_QUEUE_0_BMSK                                          0x1
#define HWIO_IPA_UC_QMB_SYNC_STATUS_ERROR_QUEUE_0_SHFT                                          0x0

#define HWIO_IPA_UC_QMB_BUS_ATTRIB_ADDR                                                  (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000154)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_PHYS                                                  (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000154)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_OFFS                                                  (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000154)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_RMSK                                                      0x1117
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_ATTR                                                         0x3
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_BUS_ATTRIB_ADDR, HWIO_IPA_UC_QMB_BUS_ATTRIB_RMSK)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_BUS_ATTRIB_ADDR, m)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_BUS_ATTRIB_ADDR,v)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_BUS_ATTRIB_ADDR,m,v,HWIO_IPA_UC_QMB_BUS_ATTRIB_IN)
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_SHARED_BMSK                                               0x1000
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_SHARED_SHFT                                                  0xc
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_INNERSHARED_BMSK                                           0x100
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_INNERSHARED_SHFT                                             0x8
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_NOALLOCATE_BMSK                                             0x10
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_NOALLOCATE_SHFT                                              0x4
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_BMSK                                                 0x7
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_SHFT                                                 0x0
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_STRONGLY_ORDERED_FVAL                                0x0
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_DEVICE_FVAL                                          0x1
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_NON_CACHEABLE_FVAL                                   0x2
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_COPYBACK_WRITEALLOCATE_FVAL                          0x3
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_WRITETHROUGH_NOALLOCATE_FVAL                         0x6
#define HWIO_IPA_UC_QMB_BUS_ATTRIB_MEMTYPE_COPYBACK_NOALLOCATE_FVAL                             0x7

#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_ADDR                                             (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000158)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_PHYS                                             (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000158)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_OFFS                                             (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000158)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_RMSK                                               0xffffff
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_ATTR                                                    0x3
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_OUTSTANDING_CFG_ADDR, HWIO_IPA_UC_QMB_OUTSTANDING_CFG_RMSK)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_OUTSTANDING_CFG_ADDR, m)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_OUTSTANDING_CFG_ADDR,v)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_OUTSTANDING_CFG_ADDR,m,v,HWIO_IPA_UC_QMB_OUTSTANDING_CFG_IN)
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_MAX_OT_WR_BMSK                                     0xff0000
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_MAX_OT_WR_SHFT                                         0x10
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_MAX_OT_RD_BMSK                                       0xff00
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_MAX_OT_RD_SHFT                                          0x8
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_MAX_OT_OVERALL_BMSK                                    0xff
#define HWIO_IPA_UC_QMB_OUTSTANDING_CFG_MAX_OT_OVERALL_SHFT                                     0x0

#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_ADDR                                          (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000015c)
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_PHYS                                          (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000015c)
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_OFFS                                          (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000015c)
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_RMSK                                            0xffffff
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_ATTR                                                 0x1
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_ADDR, HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_RMSK)
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_ADDR, m)
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_CURRENT_OT_WR_BMSK                              0xff0000
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_CURRENT_OT_WR_SHFT                                  0x10
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_CURRENT_OT_RD_BMSK                                0xff00
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_CURRENT_OT_RD_SHFT                                   0x8
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_CURRENT_OT_OVERALL_BMSK                             0xff
#define HWIO_IPA_UC_QMB_OUTSTANDING_STATUS_CURRENT_OT_OVERALL_SHFT                              0x0

#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_ADDR                                            (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000160)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_PHYS                                            (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000160)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_OFFS                                            (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000160)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_RMSK                                               0x70007
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_ATTR                                                   0x3
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_ADDR, HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_RMSK)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_ADDR, m)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_ADDR,v)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_ADDR,m,v,HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_IN)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_1_IOC_CMD_BMSK                           0x40000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_1_IOC_CMD_SHFT                              0x12
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_1_FULL_BMSK                              0x20000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_1_FULL_SHFT                                 0x11
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_1_NOT_EMPTY_BMSK                         0x10000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_1_NOT_EMPTY_SHFT                            0x10
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_0_IOC_CMD_BMSK                               0x4
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_0_IOC_CMD_SHFT                               0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_0_FULL_BMSK                                  0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_0_FULL_SHFT                                  0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_0_NOT_EMPTY_BMSK                             0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_EN_COMP_FIFO_0_NOT_EMPTY_SHFT                             0x0

#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_ADDR                                           (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000164)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_PHYS                                           (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000164)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_OFFS                                           (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000164)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_RMSK                                              0x70007
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_ATTR                                                  0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_ADDR,v)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_1_IOC_CMD_BMSK                          0x40000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_1_IOC_CMD_SHFT                             0x12
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_1_FULL_BMSK                             0x20000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_1_FULL_SHFT                                0x11
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_1_NOT_EMPTY_BMSK                        0x10000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_1_NOT_EMPTY_SHFT                           0x10
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_0_IOC_CMD_BMSK                              0x4
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_0_IOC_CMD_SHFT                              0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_0_FULL_BMSK                                 0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_0_FULL_SHFT                                 0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_0_NOT_EMPTY_BMSK                            0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_CLR_COMP_FIFO_0_NOT_EMPTY_SHFT                            0x0

#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_ADDR                                          (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000168)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_PHYS                                          (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000168)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_OFFS                                          (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000168)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_RMSK                                             0x70007
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_ATTR                                                 0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_ADDR, HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_RMSK)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_ADDR, m)
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_1_IOC_CMD_BMSK                         0x40000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_1_IOC_CMD_SHFT                            0x12
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_1_FULL_BMSK                            0x20000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_1_FULL_SHFT                               0x11
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_1_NOT_EMPTY_BMSK                       0x10000
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_1_NOT_EMPTY_SHFT                          0x10
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_0_IOC_CMD_BMSK                             0x4
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_0_IOC_CMD_SHFT                             0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_0_FULL_BMSK                                0x2
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_0_FULL_SHFT                                0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_0_NOT_EMPTY_BMSK                           0x1
#define HWIO_IPA_UC_QMB_COMP_FIFO_INT_STTS_COMP_FIFO_0_NOT_EMPTY_SHFT                           0x0

#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_ADDR                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000016c)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_PHYS                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000016c)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_OFFS                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000016c)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_RMSK                                               0x3
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_ATTR                                               0x3
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_ADDR, HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_RMSK)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_ADDR, m)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_ADDR,v)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_ADDR,m,v,HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_IN)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_SYNC_COMPLETED_1_BMSK                              0x2
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_SYNC_COMPLETED_1_SHFT                              0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_SYNC_COMPLETED_0_BMSK                              0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_EN_SYNC_COMPLETED_0_SHFT                              0x0

#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_ADDR                                       (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000170)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_PHYS                                       (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000170)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_OFFS                                       (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000170)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_RMSK                                              0x3
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_ATTR                                              0x2
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_OUT(v)      \
        out_dword(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_ADDR,v)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_SYNC_COMPLETED_1_BMSK                             0x2
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_SYNC_COMPLETED_1_SHFT                             0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_SYNC_COMPLETED_0_BMSK                             0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_CLR_SYNC_COMPLETED_0_SHFT                             0x0

#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_ADDR                                      (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000174)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_PHYS                                      (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000174)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_OFFS                                      (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000174)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_RMSK                                             0x3
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_ATTR                                             0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_IN          \
        in_dword_masked(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_ADDR, HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_RMSK)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_ADDR, m)
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_SYNC_COMPLETED_1_BMSK                            0x2
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_SYNC_COMPLETED_1_SHFT                            0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_SYNC_COMPLETED_0_BMSK                            0x1
#define HWIO_IPA_UC_QMB_SYNC_COMPLETE_INT_STTS_SYNC_COMPLETED_0_SHFT                            0x0

#define HWIO_IPA_UC_MBOX_INT_STTS_n_ADDR(n)                                              (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000200 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_STTS_n_PHYS(n)                                              (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000200 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_STTS_n_OFFS(n)                                              (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000200 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_STTS_n_RMSK                                                     0xffff
#define HWIO_IPA_UC_MBOX_INT_STTS_n_MAXn                                                          7
#define HWIO_IPA_UC_MBOX_INT_STTS_n_ATTR                                                        0x1
#define HWIO_IPA_UC_MBOX_INT_STTS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_MBOX_INT_STTS_n_ADDR(n), HWIO_IPA_UC_MBOX_INT_STTS_n_RMSK)
#define HWIO_IPA_UC_MBOX_INT_STTS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_MBOX_INT_STTS_n_ADDR(n), mask)
#define HWIO_IPA_UC_MBOX_INT_STTS_n_IRQ_STATUS_BMSK                                          0xffff
#define HWIO_IPA_UC_MBOX_INT_STTS_n_IRQ_STATUS_SHFT                                             0x0

#define HWIO_IPA_UC_MBOX_INT_EN_n_ADDR(n)                                                (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000204 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_EN_n_PHYS(n)                                                (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000204 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_EN_n_OFFS(n)                                                (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000204 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_EN_n_RMSK                                                       0xffff
#define HWIO_IPA_UC_MBOX_INT_EN_n_MAXn                                                            7
#define HWIO_IPA_UC_MBOX_INT_EN_n_ATTR                                                          0x3
#define HWIO_IPA_UC_MBOX_INT_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_MBOX_INT_EN_n_ADDR(n), HWIO_IPA_UC_MBOX_INT_EN_n_RMSK)
#define HWIO_IPA_UC_MBOX_INT_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_MBOX_INT_EN_n_ADDR(n), mask)
#define HWIO_IPA_UC_MBOX_INT_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_UC_MBOX_INT_EN_n_ADDR(n),val)
#define HWIO_IPA_UC_MBOX_INT_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_UC_MBOX_INT_EN_n_ADDR(n),mask,val,HWIO_IPA_UC_MBOX_INT_EN_n_INI(n))
#define HWIO_IPA_UC_MBOX_INT_EN_n_IRQ_EN_BMSK                                                0xffff
#define HWIO_IPA_UC_MBOX_INT_EN_n_IRQ_EN_SHFT                                                   0x0

#define HWIO_IPA_UC_MBOX_INT_CLR_n_ADDR(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000208 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_CLR_n_PHYS(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000208 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_CLR_n_OFFS(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000208 + 0x10 * (n))
#define HWIO_IPA_UC_MBOX_INT_CLR_n_RMSK                                                      0xffff
#define HWIO_IPA_UC_MBOX_INT_CLR_n_MAXn                                                           7
#define HWIO_IPA_UC_MBOX_INT_CLR_n_ATTR                                                         0x0
#define HWIO_IPA_UC_MBOX_INT_CLR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_UC_MBOX_INT_CLR_n_ADDR(n),val)
#define HWIO_IPA_UC_MBOX_INT_CLR_n_IRQ_CLR_BMSK                                              0xffff
#define HWIO_IPA_UC_MBOX_INT_CLR_n_IRQ_CLR_SHFT                                                 0x0

#define HWIO_IPA_UC_IPA_INT_STTS_n_ADDR(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000300 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_STTS_n_PHYS(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000300 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_STTS_n_OFFS(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000300 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_STTS_n_RMSK                                                         0xf
#define HWIO_IPA_UC_IPA_INT_STTS_n_MAXn                                                           3
#define HWIO_IPA_UC_IPA_INT_STTS_n_ATTR                                                         0x1
#define HWIO_IPA_UC_IPA_INT_STTS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_IPA_INT_STTS_n_ADDR(n), HWIO_IPA_UC_IPA_INT_STTS_n_RMSK)
#define HWIO_IPA_UC_IPA_INT_STTS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_IPA_INT_STTS_n_ADDR(n), mask)
#define HWIO_IPA_UC_IPA_INT_STTS_n_IRQ_STATUS_BMSK                                              0xf
#define HWIO_IPA_UC_IPA_INT_STTS_n_IRQ_STATUS_SHFT                                              0x0

#define HWIO_IPA_UC_IPA_INT_EN_n_ADDR(n)                                                 (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000304 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_EN_n_PHYS(n)                                                 (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000304 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_EN_n_OFFS(n)                                                 (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000304 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_EN_n_RMSK                                                           0xf
#define HWIO_IPA_UC_IPA_INT_EN_n_MAXn                                                             3
#define HWIO_IPA_UC_IPA_INT_EN_n_ATTR                                                           0x3
#define HWIO_IPA_UC_IPA_INT_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_IPA_INT_EN_n_ADDR(n), HWIO_IPA_UC_IPA_INT_EN_n_RMSK)
#define HWIO_IPA_UC_IPA_INT_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_IPA_INT_EN_n_ADDR(n), mask)
#define HWIO_IPA_UC_IPA_INT_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_UC_IPA_INT_EN_n_ADDR(n),val)
#define HWIO_IPA_UC_IPA_INT_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_UC_IPA_INT_EN_n_ADDR(n),mask,val,HWIO_IPA_UC_IPA_INT_EN_n_INI(n))
#define HWIO_IPA_UC_IPA_INT_EN_n_IRQ_EN_BMSK                                                    0xf
#define HWIO_IPA_UC_IPA_INT_EN_n_IRQ_EN_SHFT                                                    0x0

#define HWIO_IPA_UC_IPA_INT_CLR_n_ADDR(n)                                                (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000308 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_CLR_n_PHYS(n)                                                (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000308 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_CLR_n_OFFS(n)                                                (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000308 + 0x10 * (n))
#define HWIO_IPA_UC_IPA_INT_CLR_n_RMSK                                                          0xf
#define HWIO_IPA_UC_IPA_INT_CLR_n_MAXn                                                            3
#define HWIO_IPA_UC_IPA_INT_CLR_n_ATTR                                                          0x0
#define HWIO_IPA_UC_IPA_INT_CLR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_UC_IPA_INT_CLR_n_ADDR(n),val)
#define HWIO_IPA_UC_IPA_INT_CLR_n_IRQ_CLR_BMSK                                                  0xf
#define HWIO_IPA_UC_IPA_INT_CLR_n_IRQ_CLR_SHFT                                                  0x0

#define HWIO_IPA_UC_HWEV_INT_STTS_ADDR                                                   (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000400)
#define HWIO_IPA_UC_HWEV_INT_STTS_PHYS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_UC_HWEV_INT_STTS_OFFS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_UC_HWEV_INT_STTS_RMSK                                                   0xffffffff
#define HWIO_IPA_UC_HWEV_INT_STTS_ATTR                                                          0x1
#define HWIO_IPA_UC_HWEV_INT_STTS_IN          \
        in_dword_masked(HWIO_IPA_UC_HWEV_INT_STTS_ADDR, HWIO_IPA_UC_HWEV_INT_STTS_RMSK)
#define HWIO_IPA_UC_HWEV_INT_STTS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_HWEV_INT_STTS_ADDR, m)
#define HWIO_IPA_UC_HWEV_INT_STTS_IRQ_STATUS_BMSK                                        0xffffffff
#define HWIO_IPA_UC_HWEV_INT_STTS_IRQ_STATUS_SHFT                                               0x0

#define HWIO_IPA_UC_HWEV_INT_EN_ADDR                                                     (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000404)
#define HWIO_IPA_UC_HWEV_INT_EN_PHYS                                                     (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000404)
#define HWIO_IPA_UC_HWEV_INT_EN_OFFS                                                     (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000404)
#define HWIO_IPA_UC_HWEV_INT_EN_RMSK                                                     0xffffffff
#define HWIO_IPA_UC_HWEV_INT_EN_ATTR                                                            0x3
#define HWIO_IPA_UC_HWEV_INT_EN_IN          \
        in_dword_masked(HWIO_IPA_UC_HWEV_INT_EN_ADDR, HWIO_IPA_UC_HWEV_INT_EN_RMSK)
#define HWIO_IPA_UC_HWEV_INT_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_HWEV_INT_EN_ADDR, m)
#define HWIO_IPA_UC_HWEV_INT_EN_OUT(v)      \
        out_dword(HWIO_IPA_UC_HWEV_INT_EN_ADDR,v)
#define HWIO_IPA_UC_HWEV_INT_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_HWEV_INT_EN_ADDR,m,v,HWIO_IPA_UC_HWEV_INT_EN_IN)
#define HWIO_IPA_UC_HWEV_INT_EN_IRQ_EN_BMSK                                              0xffffffff
#define HWIO_IPA_UC_HWEV_INT_EN_IRQ_EN_SHFT                                                     0x0

#define HWIO_IPA_UC_HWEV_INT_CLR_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000408)
#define HWIO_IPA_UC_HWEV_INT_CLR_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000408)
#define HWIO_IPA_UC_HWEV_INT_CLR_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000408)
#define HWIO_IPA_UC_HWEV_INT_CLR_RMSK                                                    0xffffffff
#define HWIO_IPA_UC_HWEV_INT_CLR_ATTR                                                           0x0
#define HWIO_IPA_UC_HWEV_INT_CLR_OUT(v)      \
        out_dword(HWIO_IPA_UC_HWEV_INT_CLR_ADDR,v)
#define HWIO_IPA_UC_HWEV_INT_CLR_IRQ_CLR_BMSK                                            0xffffffff
#define HWIO_IPA_UC_HWEV_INT_CLR_IRQ_CLR_SHFT                                                   0x0

#define HWIO_IPA_UC_SWEV_INT_STTS_ADDR                                                   (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000410)
#define HWIO_IPA_UC_SWEV_INT_STTS_PHYS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000410)
#define HWIO_IPA_UC_SWEV_INT_STTS_OFFS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000410)
#define HWIO_IPA_UC_SWEV_INT_STTS_RMSK                                                   0xffffffff
#define HWIO_IPA_UC_SWEV_INT_STTS_ATTR                                                          0x1
#define HWIO_IPA_UC_SWEV_INT_STTS_IN          \
        in_dword_masked(HWIO_IPA_UC_SWEV_INT_STTS_ADDR, HWIO_IPA_UC_SWEV_INT_STTS_RMSK)
#define HWIO_IPA_UC_SWEV_INT_STTS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_SWEV_INT_STTS_ADDR, m)
#define HWIO_IPA_UC_SWEV_INT_STTS_IRQ_STATUS_BMSK                                        0xffffffff
#define HWIO_IPA_UC_SWEV_INT_STTS_IRQ_STATUS_SHFT                                               0x0

#define HWIO_IPA_UC_SWEV_INT_EN_ADDR                                                     (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000414)
#define HWIO_IPA_UC_SWEV_INT_EN_PHYS                                                     (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000414)
#define HWIO_IPA_UC_SWEV_INT_EN_OFFS                                                     (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000414)
#define HWIO_IPA_UC_SWEV_INT_EN_RMSK                                                     0xffffffff
#define HWIO_IPA_UC_SWEV_INT_EN_ATTR                                                            0x3
#define HWIO_IPA_UC_SWEV_INT_EN_IN          \
        in_dword_masked(HWIO_IPA_UC_SWEV_INT_EN_ADDR, HWIO_IPA_UC_SWEV_INT_EN_RMSK)
#define HWIO_IPA_UC_SWEV_INT_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_SWEV_INT_EN_ADDR, m)
#define HWIO_IPA_UC_SWEV_INT_EN_OUT(v)      \
        out_dword(HWIO_IPA_UC_SWEV_INT_EN_ADDR,v)
#define HWIO_IPA_UC_SWEV_INT_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_SWEV_INT_EN_ADDR,m,v,HWIO_IPA_UC_SWEV_INT_EN_IN)
#define HWIO_IPA_UC_SWEV_INT_EN_IRQ_EN_BMSK                                              0xffffffff
#define HWIO_IPA_UC_SWEV_INT_EN_IRQ_EN_SHFT                                                     0x0

#define HWIO_IPA_UC_SWEV_INT_CLR_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000418)
#define HWIO_IPA_UC_SWEV_INT_CLR_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000418)
#define HWIO_IPA_UC_SWEV_INT_CLR_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000418)
#define HWIO_IPA_UC_SWEV_INT_CLR_RMSK                                                    0xffffffff
#define HWIO_IPA_UC_SWEV_INT_CLR_ATTR                                                           0x0
#define HWIO_IPA_UC_SWEV_INT_CLR_OUT(v)      \
        out_dword(HWIO_IPA_UC_SWEV_INT_CLR_ADDR,v)
#define HWIO_IPA_UC_SWEV_INT_CLR_IRQ_CLR_BMSK                                            0xffffffff
#define HWIO_IPA_UC_SWEV_INT_CLR_IRQ_CLR_SHFT                                                   0x0

#define HWIO_IPA_UC_VUIC_INT_STTS_ADDR                                                   (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000041c)
#define HWIO_IPA_UC_VUIC_INT_STTS_PHYS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000041c)
#define HWIO_IPA_UC_VUIC_INT_STTS_OFFS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000041c)
#define HWIO_IPA_UC_VUIC_INT_STTS_RMSK                                                          0x1
#define HWIO_IPA_UC_VUIC_INT_STTS_ATTR                                                          0x1
#define HWIO_IPA_UC_VUIC_INT_STTS_IN          \
        in_dword_masked(HWIO_IPA_UC_VUIC_INT_STTS_ADDR, HWIO_IPA_UC_VUIC_INT_STTS_RMSK)
#define HWIO_IPA_UC_VUIC_INT_STTS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_VUIC_INT_STTS_ADDR, m)
#define HWIO_IPA_UC_VUIC_INT_STTS_IRQ_STATUS_BMSK                                               0x1
#define HWIO_IPA_UC_VUIC_INT_STTS_IRQ_STATUS_SHFT                                               0x0

#define HWIO_IPA_UC_VUIC_INT_CLR_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000420)
#define HWIO_IPA_UC_VUIC_INT_CLR_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000420)
#define HWIO_IPA_UC_VUIC_INT_CLR_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000420)
#define HWIO_IPA_UC_VUIC_INT_CLR_RMSK                                                           0x1
#define HWIO_IPA_UC_VUIC_INT_CLR_ATTR                                                           0x0
#define HWIO_IPA_UC_VUIC_INT_CLR_OUT(v)      \
        out_dword(HWIO_IPA_UC_VUIC_INT_CLR_ADDR,v)
#define HWIO_IPA_UC_VUIC_INT_CLR_IRQ_CLR_BMSK                                                   0x1
#define HWIO_IPA_UC_VUIC_INT_CLR_IRQ_CLR_SHFT                                                   0x0

#define HWIO_IPA_UC_TIMER_CTRL_n_ADDR(n)                                                 (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000500 + 0x10 * (n))
#define HWIO_IPA_UC_TIMER_CTRL_n_PHYS(n)                                                 (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000500 + 0x10 * (n))
#define HWIO_IPA_UC_TIMER_CTRL_n_OFFS(n)                                                 (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000500 + 0x10 * (n))
#define HWIO_IPA_UC_TIMER_CTRL_n_RMSK                                                    0xc17fffff
#define HWIO_IPA_UC_TIMER_CTRL_n_MAXn                                                             3
#define HWIO_IPA_UC_TIMER_CTRL_n_ATTR                                                           0x3
#define HWIO_IPA_UC_TIMER_CTRL_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_TIMER_CTRL_n_ADDR(n), HWIO_IPA_UC_TIMER_CTRL_n_RMSK)
#define HWIO_IPA_UC_TIMER_CTRL_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_TIMER_CTRL_n_ADDR(n), mask)
#define HWIO_IPA_UC_TIMER_CTRL_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_UC_TIMER_CTRL_n_ADDR(n),val)
#define HWIO_IPA_UC_TIMER_CTRL_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_UC_TIMER_CTRL_n_ADDR(n),mask,val,HWIO_IPA_UC_TIMER_CTRL_n_INI(n))
#define HWIO_IPA_UC_TIMER_CTRL_n_GRAN_SEL_BMSK                                           0xc0000000
#define HWIO_IPA_UC_TIMER_CTRL_n_GRAN_SEL_SHFT                                                 0x1e
#define HWIO_IPA_UC_TIMER_CTRL_n_RETRIG_BMSK                                              0x1000000
#define HWIO_IPA_UC_TIMER_CTRL_n_RETRIG_SHFT                                                   0x18
#define HWIO_IPA_UC_TIMER_CTRL_n_RETRIG_ONE_SHOT_FVAL                                           0x0
#define HWIO_IPA_UC_TIMER_CTRL_n_RETRIG_RETRIG_FVAL                                             0x1
#define HWIO_IPA_UC_TIMER_CTRL_n_EVENT_SEL_BMSK                                            0x7f0000
#define HWIO_IPA_UC_TIMER_CTRL_n_EVENT_SEL_SHFT                                                0x10
#define HWIO_IPA_UC_TIMER_CTRL_n_COUNT_BMSK                                                  0xffff
#define HWIO_IPA_UC_TIMER_CTRL_n_COUNT_SHFT                                                     0x0

#define HWIO_IPA_UC_TIMER_STATUS_n_ADDR(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000508 + 0x10 * (n))
#define HWIO_IPA_UC_TIMER_STATUS_n_PHYS(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000508 + 0x10 * (n))
#define HWIO_IPA_UC_TIMER_STATUS_n_OFFS(n)                                               (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000508 + 0x10 * (n))
#define HWIO_IPA_UC_TIMER_STATUS_n_RMSK                                                   0x100ffff
#define HWIO_IPA_UC_TIMER_STATUS_n_MAXn                                                           3
#define HWIO_IPA_UC_TIMER_STATUS_n_ATTR                                                         0x1
#define HWIO_IPA_UC_TIMER_STATUS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_UC_TIMER_STATUS_n_ADDR(n), HWIO_IPA_UC_TIMER_STATUS_n_RMSK)
#define HWIO_IPA_UC_TIMER_STATUS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_UC_TIMER_STATUS_n_ADDR(n), mask)
#define HWIO_IPA_UC_TIMER_STATUS_n_ACTIVE_BMSK                                            0x1000000
#define HWIO_IPA_UC_TIMER_STATUS_n_ACTIVE_SHFT                                                 0x18
#define HWIO_IPA_UC_TIMER_STATUS_n_COUNT_BMSK                                                0xffff
#define HWIO_IPA_UC_TIMER_STATUS_n_COUNT_SHFT                                                   0x0

#define HWIO_IPA_UC_EVENTS_ADDR                                                          (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000600)
#define HWIO_IPA_UC_EVENTS_PHYS                                                          (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000600)
#define HWIO_IPA_UC_EVENTS_OFFS                                                          (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000600)
#define HWIO_IPA_UC_EVENTS_RMSK                                                          0xffffffff
#define HWIO_IPA_UC_EVENTS_ATTR                                                                 0x2
#define HWIO_IPA_UC_EVENTS_OUT(v)      \
        out_dword(HWIO_IPA_UC_EVENTS_ADDR,v)
#define HWIO_IPA_UC_EVENTS_EVENTS_BMSK                                                   0xffffffff
#define HWIO_IPA_UC_EVENTS_EVENTS_SHFT                                                          0x0

#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_ADDR                                      (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000710)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_PHYS                                      (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000710)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_OFFS                                      (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000710)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_RMSK                                             0x3
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_ATTR                                             0x3
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_IN          \
        in_dword_masked(HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_ADDR, HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_RMSK)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_ADDR, m)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_OUT(v)      \
        out_dword(HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_ADDR,v)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_ADDR,m,v,HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_IN)
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_DIRECT_ADDR_TRANSLATE_BMSK                       0x2
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_DIRECT_ADDR_TRANSLATE_SHFT                       0x1
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_QMB_ADDR_TRANSLATE_BMSK                          0x1
#define HWIO_IPA_UC_VUIC_BUS_ADDR_TRANSLATE_EN_QMB_ADDR_TRANSLATE_SHFT                          0x0

#define HWIO_IPA_UC_SYS_ADDR_MSB_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000714)
#define HWIO_IPA_UC_SYS_ADDR_MSB_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000714)
#define HWIO_IPA_UC_SYS_ADDR_MSB_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000714)
#define HWIO_IPA_UC_SYS_ADDR_MSB_RMSK                                                    0xffffffff
#define HWIO_IPA_UC_SYS_ADDR_MSB_ATTR                                                           0x3
#define HWIO_IPA_UC_SYS_ADDR_MSB_IN          \
        in_dword_masked(HWIO_IPA_UC_SYS_ADDR_MSB_ADDR, HWIO_IPA_UC_SYS_ADDR_MSB_RMSK)
#define HWIO_IPA_UC_SYS_ADDR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_SYS_ADDR_MSB_ADDR, m)
#define HWIO_IPA_UC_SYS_ADDR_MSB_OUT(v)      \
        out_dword(HWIO_IPA_UC_SYS_ADDR_MSB_ADDR,v)
#define HWIO_IPA_UC_SYS_ADDR_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_SYS_ADDR_MSB_ADDR,m,v,HWIO_IPA_UC_SYS_ADDR_MSB_IN)
#define HWIO_IPA_UC_SYS_ADDR_MSB_SYS_ADDR_MSB_BMSK                                       0xffffffff
#define HWIO_IPA_UC_SYS_ADDR_MSB_SYS_ADDR_MSB_SHFT                                              0x0

#define HWIO_IPA_UC_PC_RESTORE_WR_ADDR                                                   (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000718)
#define HWIO_IPA_UC_PC_RESTORE_WR_PHYS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000718)
#define HWIO_IPA_UC_PC_RESTORE_WR_OFFS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000718)
#define HWIO_IPA_UC_PC_RESTORE_WR_RMSK                                                          0xf
#define HWIO_IPA_UC_PC_RESTORE_WR_ATTR                                                          0x2
#define HWIO_IPA_UC_PC_RESTORE_WR_OUT(v)      \
        out_dword(HWIO_IPA_UC_PC_RESTORE_WR_ADDR,v)
#define HWIO_IPA_UC_PC_RESTORE_WR_CLEAR_IPA_RESTORE_ACK_BMSK                                    0x8
#define HWIO_IPA_UC_PC_RESTORE_WR_CLEAR_IPA_RESTORE_ACK_SHFT                                    0x3
#define HWIO_IPA_UC_PC_RESTORE_WR_SET_IPA_RESTORE_ACK_BMSK                                      0x4
#define HWIO_IPA_UC_PC_RESTORE_WR_SET_IPA_RESTORE_ACK_SHFT                                      0x2
#define HWIO_IPA_UC_PC_RESTORE_WR_CLEAR_IPA_PC_ACK_BMSK                                         0x2
#define HWIO_IPA_UC_PC_RESTORE_WR_CLEAR_IPA_PC_ACK_SHFT                                         0x1
#define HWIO_IPA_UC_PC_RESTORE_WR_SET_IPA_PC_ACK_BMSK                                           0x1
#define HWIO_IPA_UC_PC_RESTORE_WR_SET_IPA_PC_ACK_SHFT                                           0x0

#define HWIO_IPA_UC_PC_RESTORE_RD_ADDR                                                   (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000071c)
#define HWIO_IPA_UC_PC_RESTORE_RD_PHYS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000071c)
#define HWIO_IPA_UC_PC_RESTORE_RD_OFFS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000071c)
#define HWIO_IPA_UC_PC_RESTORE_RD_RMSK                                                          0xf
#define HWIO_IPA_UC_PC_RESTORE_RD_ATTR                                                          0x1
#define HWIO_IPA_UC_PC_RESTORE_RD_IN          \
        in_dword_masked(HWIO_IPA_UC_PC_RESTORE_RD_ADDR, HWIO_IPA_UC_PC_RESTORE_RD_RMSK)
#define HWIO_IPA_UC_PC_RESTORE_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_PC_RESTORE_RD_ADDR, m)
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_RESTORE_ACK_BMSK                                          0x8
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_RESTORE_ACK_SHFT                                          0x3
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_RESTORE_REQ_BMSK                                          0x4
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_RESTORE_REQ_SHFT                                          0x2
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_PC_ACK_BMSK                                               0x2
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_PC_ACK_SHFT                                               0x1
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_PC_REQ_BMSK                                               0x1
#define HWIO_IPA_UC_PC_RESTORE_RD_IPA_PC_REQ_SHFT                                               0x0

#define HWIO_IPA_UC_CNT_GLOBAL_ADDR                                                      (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000800)
#define HWIO_IPA_UC_CNT_GLOBAL_PHYS                                                      (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000800)
#define HWIO_IPA_UC_CNT_GLOBAL_OFFS                                                      (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000800)
#define HWIO_IPA_UC_CNT_GLOBAL_RMSK                                                      0x80000003
#define HWIO_IPA_UC_CNT_GLOBAL_ATTR                                                             0x0
#define HWIO_IPA_UC_CNT_GLOBAL_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_GLOBAL_ADDR, HWIO_IPA_UC_CNT_GLOBAL_RMSK)
#define HWIO_IPA_UC_CNT_GLOBAL_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_GLOBAL_ADDR, m)
#define HWIO_IPA_UC_CNT_GLOBAL_OUT(v)      \
        out_dword(HWIO_IPA_UC_CNT_GLOBAL_ADDR,v)
#define HWIO_IPA_UC_CNT_GLOBAL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_CNT_GLOBAL_ADDR,m,v,HWIO_IPA_UC_CNT_GLOBAL_IN)
#define HWIO_IPA_UC_CNT_GLOBAL_CLEAR_ALL_BMSK                                            0x80000000
#define HWIO_IPA_UC_CNT_GLOBAL_CLEAR_ALL_SHFT                                                  0x1f
#define HWIO_IPA_UC_CNT_GLOBAL_COUNT_CGC_OPEN_BMSK                                              0x2
#define HWIO_IPA_UC_CNT_GLOBAL_COUNT_CGC_OPEN_SHFT                                              0x1
#define HWIO_IPA_UC_CNT_GLOBAL_COUNT_EN_BMSK                                                    0x1
#define HWIO_IPA_UC_CNT_GLOBAL_COUNT_EN_SHFT                                                    0x0

#define HWIO_IPA_UC_CNT_CTL_ADDR                                                         (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000804)
#define HWIO_IPA_UC_CNT_CTL_PHYS                                                         (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000804)
#define HWIO_IPA_UC_CNT_CTL_OFFS                                                         (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000804)
#define HWIO_IPA_UC_CNT_CTL_RMSK                                                            0xff755
#define HWIO_IPA_UC_CNT_CTL_ATTR                                                                0x0
#define HWIO_IPA_UC_CNT_CTL_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_CTL_ADDR, HWIO_IPA_UC_CNT_CTL_RMSK)
#define HWIO_IPA_UC_CNT_CTL_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_CTL_ADDR, m)
#define HWIO_IPA_UC_CNT_CTL_OUT(v)      \
        out_dword(HWIO_IPA_UC_CNT_CTL_ADDR,v)
#define HWIO_IPA_UC_CNT_CTL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_CNT_CTL_ADDR,m,v,HWIO_IPA_UC_CNT_CTL_IN)
#define HWIO_IPA_UC_CNT_CTL_DRAM_CNT_CLR_BMSK                                               0x80000
#define HWIO_IPA_UC_CNT_CTL_DRAM_CNT_CLR_SHFT                                                  0x13
#define HWIO_IPA_UC_CNT_CTL_DRAM_CLR_AFTER_RD_BMSK                                          0x40000
#define HWIO_IPA_UC_CNT_CTL_DRAM_CLR_AFTER_RD_SHFT                                             0x12
#define HWIO_IPA_UC_CNT_CTL_DRAM_WR_CNT_EN_BMSK                                             0x20000
#define HWIO_IPA_UC_CNT_CTL_DRAM_WR_CNT_EN_SHFT                                                0x11
#define HWIO_IPA_UC_CNT_CTL_DRAM_RD_CNT_EN_BMSK                                             0x10000
#define HWIO_IPA_UC_CNT_CTL_DRAM_RD_CNT_EN_SHFT                                                0x10
#define HWIO_IPA_UC_CNT_CTL_VUIC_CNT_CLR_BMSK                                                0x8000
#define HWIO_IPA_UC_CNT_CTL_VUIC_CNT_CLR_SHFT                                                   0xf
#define HWIO_IPA_UC_CNT_CTL_VUIC_CLR_AFTER_RD_BMSK                                           0x4000
#define HWIO_IPA_UC_CNT_CTL_VUIC_CLR_AFTER_RD_SHFT                                              0xe
#define HWIO_IPA_UC_CNT_CTL_VUIC_WR_CNT_EN_BMSK                                              0x2000
#define HWIO_IPA_UC_CNT_CTL_VUIC_WR_CNT_EN_SHFT                                                 0xd
#define HWIO_IPA_UC_CNT_CTL_VUIC_RD_CNT_EN_BMSK                                              0x1000
#define HWIO_IPA_UC_CNT_CTL_VUIC_RD_CNT_EN_SHFT                                                 0xc
#define HWIO_IPA_UC_CNT_CTL_INST_CNT_CLR_BMSK                                                 0x400
#define HWIO_IPA_UC_CNT_CTL_INST_CNT_CLR_SHFT                                                   0xa
#define HWIO_IPA_UC_CNT_CTL_INST_CLR_AFTER_RD_BMSK                                            0x200
#define HWIO_IPA_UC_CNT_CTL_INST_CLR_AFTER_RD_SHFT                                              0x9
#define HWIO_IPA_UC_CNT_CTL_INST_CNT_EN_BMSK                                                  0x100
#define HWIO_IPA_UC_CNT_CTL_INST_CNT_EN_SHFT                                                    0x8
#define HWIO_IPA_UC_CNT_CTL_IDLE_CNT_CLR_BMSK                                                  0x40
#define HWIO_IPA_UC_CNT_CTL_IDLE_CNT_CLR_SHFT                                                   0x6
#define HWIO_IPA_UC_CNT_CTL_IDLE_CNT_EN_BMSK                                                   0x10
#define HWIO_IPA_UC_CNT_CTL_IDLE_CNT_EN_SHFT                                                    0x4
#define HWIO_IPA_UC_CNT_CTL_CYCLE_CNT_CLR_BMSK                                                  0x4
#define HWIO_IPA_UC_CNT_CTL_CYCLE_CNT_CLR_SHFT                                                  0x2
#define HWIO_IPA_UC_CNT_CTL_CYCLE_CNT_EN_BMSK                                                   0x1
#define HWIO_IPA_UC_CNT_CTL_CYCLE_CNT_EN_SHFT                                                   0x0

#define HWIO_IPA_UC_CNT_CLK_CYCLE_ADDR                                                   (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000808)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_PHYS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000808)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_OFFS                                                   (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000808)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_RMSK                                                   0xffffffff
#define HWIO_IPA_UC_CNT_CLK_CYCLE_ATTR                                                          0x1
#define HWIO_IPA_UC_CNT_CLK_CYCLE_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_CLK_CYCLE_ADDR, HWIO_IPA_UC_CNT_CLK_CYCLE_RMSK)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_CLK_CYCLE_ADDR, m)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_COUNTER_BMSK                                           0xffffffff
#define HWIO_IPA_UC_CNT_CLK_CYCLE_COUNTER_SHFT                                                  0x0

#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_ADDR                                               (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000080c)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_PHYS                                               (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000080c)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_OFFS                                               (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000080c)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_RMSK                                                     0xff
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_ATTR                                                      0x1
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_ADDR, HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_RMSK)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_ADDR, m)
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_COUNTER_BMSK                                             0xff
#define HWIO_IPA_UC_CNT_CLK_CYCLE_MSB_COUNTER_SHFT                                              0x0

#define HWIO_IPA_UC_CNT_IDLE_ADDR                                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000810)
#define HWIO_IPA_UC_CNT_IDLE_PHYS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000810)
#define HWIO_IPA_UC_CNT_IDLE_OFFS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000810)
#define HWIO_IPA_UC_CNT_IDLE_RMSK                                                        0xffffffff
#define HWIO_IPA_UC_CNT_IDLE_ATTR                                                               0x1
#define HWIO_IPA_UC_CNT_IDLE_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_IDLE_ADDR, HWIO_IPA_UC_CNT_IDLE_RMSK)
#define HWIO_IPA_UC_CNT_IDLE_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_IDLE_ADDR, m)
#define HWIO_IPA_UC_CNT_IDLE_COUNTER_BMSK                                                0xffffffff
#define HWIO_IPA_UC_CNT_IDLE_COUNTER_SHFT                                                       0x0

#define HWIO_IPA_UC_CNT_IDLE_MSB_ADDR                                                    (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000814)
#define HWIO_IPA_UC_CNT_IDLE_MSB_PHYS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000814)
#define HWIO_IPA_UC_CNT_IDLE_MSB_OFFS                                                    (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000814)
#define HWIO_IPA_UC_CNT_IDLE_MSB_RMSK                                                          0xff
#define HWIO_IPA_UC_CNT_IDLE_MSB_ATTR                                                           0x1
#define HWIO_IPA_UC_CNT_IDLE_MSB_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_IDLE_MSB_ADDR, HWIO_IPA_UC_CNT_IDLE_MSB_RMSK)
#define HWIO_IPA_UC_CNT_IDLE_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_IDLE_MSB_ADDR, m)
#define HWIO_IPA_UC_CNT_IDLE_MSB_COUNTER_BMSK                                                  0xff
#define HWIO_IPA_UC_CNT_IDLE_MSB_COUNTER_SHFT                                                   0x0

#define HWIO_IPA_UC_CNT_INST_ADDR                                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000818)
#define HWIO_IPA_UC_CNT_INST_PHYS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000818)
#define HWIO_IPA_UC_CNT_INST_OFFS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000818)
#define HWIO_IPA_UC_CNT_INST_RMSK                                                        0xffffffff
#define HWIO_IPA_UC_CNT_INST_ATTR                                                               0x1
#define HWIO_IPA_UC_CNT_INST_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_INST_ADDR, HWIO_IPA_UC_CNT_INST_RMSK)
#define HWIO_IPA_UC_CNT_INST_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_INST_ADDR, m)
#define HWIO_IPA_UC_CNT_INST_COUNTER_BMSK                                                0xffffffff
#define HWIO_IPA_UC_CNT_INST_COUNTER_SHFT                                                       0x0

#define HWIO_IPA_UC_CNT_DRAM_ADDR                                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x0000081c)
#define HWIO_IPA_UC_CNT_DRAM_PHYS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x0000081c)
#define HWIO_IPA_UC_CNT_DRAM_OFFS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x0000081c)
#define HWIO_IPA_UC_CNT_DRAM_RMSK                                                        0xffffffff
#define HWIO_IPA_UC_CNT_DRAM_ATTR                                                               0x1
#define HWIO_IPA_UC_CNT_DRAM_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_DRAM_ADDR, HWIO_IPA_UC_CNT_DRAM_RMSK)
#define HWIO_IPA_UC_CNT_DRAM_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_DRAM_ADDR, m)
#define HWIO_IPA_UC_CNT_DRAM_COUNTER_BMSK                                                0xffffffff
#define HWIO_IPA_UC_CNT_DRAM_COUNTER_SHFT                                                       0x0

#define HWIO_IPA_UC_CNT_VUIC_ADDR                                                        (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00000820)
#define HWIO_IPA_UC_CNT_VUIC_PHYS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00000820)
#define HWIO_IPA_UC_CNT_VUIC_OFFS                                                        (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00000820)
#define HWIO_IPA_UC_CNT_VUIC_RMSK                                                        0xffffffff
#define HWIO_IPA_UC_CNT_VUIC_ATTR                                                               0x1
#define HWIO_IPA_UC_CNT_VUIC_IN          \
        in_dword_masked(HWIO_IPA_UC_CNT_VUIC_ADDR, HWIO_IPA_UC_CNT_VUIC_RMSK)
#define HWIO_IPA_UC_CNT_VUIC_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_CNT_VUIC_ADDR, m)
#define HWIO_IPA_UC_CNT_VUIC_COUNTER_BMSK                                                0xffffffff
#define HWIO_IPA_UC_CNT_VUIC_COUNTER_SHFT                                                       0x0

#define HWIO_IPA_UC_SPARE_ADDR                                                           (IPA_UC_IPA_UC_PER_REG_BASE      + 0x00001ffc)
#define HWIO_IPA_UC_SPARE_PHYS                                                           (IPA_UC_IPA_UC_PER_REG_BASE_PHYS + 0x00001ffc)
#define HWIO_IPA_UC_SPARE_OFFS                                                           (IPA_UC_IPA_UC_PER_REG_BASE_OFFS + 0x00001ffc)
#define HWIO_IPA_UC_SPARE_RMSK                                                           0xffffffff
#define HWIO_IPA_UC_SPARE_ATTR                                                                  0x3
#define HWIO_IPA_UC_SPARE_IN          \
        in_dword_masked(HWIO_IPA_UC_SPARE_ADDR, HWIO_IPA_UC_SPARE_RMSK)
#define HWIO_IPA_UC_SPARE_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_SPARE_ADDR, m)
#define HWIO_IPA_UC_SPARE_OUT(v)      \
        out_dword(HWIO_IPA_UC_SPARE_ADDR,v)
#define HWIO_IPA_UC_SPARE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_SPARE_ADDR,m,v,HWIO_IPA_UC_SPARE_IN)
#define HWIO_IPA_UC_SPARE_SPARE_BMSK                                                     0xffffffff
#define HWIO_IPA_UC_SPARE_SPARE_SHFT                                                            0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_UC_IPA_UC_MBOX
 *--------------------------------------------------------------------------*/

#define IPA_UC_IPA_UC_MBOX_REG_BASE                      (IPA_0_IPA_WRAPPER_BASE      + 0x001c2000)
#define IPA_UC_IPA_UC_MBOX_REG_BASE_PHYS                 (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x001c2000)
#define IPA_UC_IPA_UC_MBOX_REG_BASE_OFFS                 0x001c2000

#define HWIO_IPA_UC_MAILBOX_m_n_ADDR(m,n)                (IPA_UC_IPA_UC_MBOX_REG_BASE      + 0x00000000 + 0x80 * (m) + 0x4 * (n))
#define HWIO_IPA_UC_MAILBOX_m_n_PHYS(m,n)                (IPA_UC_IPA_UC_MBOX_REG_BASE_PHYS + 0x00000000 + 0x80 * (m) + 0x4 * (n))
#define HWIO_IPA_UC_MAILBOX_m_n_OFFS(m,n)                (IPA_UC_IPA_UC_MBOX_REG_BASE_OFFS + 0x00000000 + 0x80 * (m) + 0x4 * (n))
#define HWIO_IPA_UC_MAILBOX_m_n_RMSK                     0xffffffff
#define HWIO_IPA_UC_MAILBOX_m_n_MAXm                              3
#define HWIO_IPA_UC_MAILBOX_m_n_MAXn                             31
#define HWIO_IPA_UC_MAILBOX_m_n_ATTR                            0x3
#define HWIO_IPA_UC_MAILBOX_m_n_INI2(m,n)        \
        in_dword_masked(HWIO_IPA_UC_MAILBOX_m_n_ADDR(m,n), HWIO_IPA_UC_MAILBOX_m_n_RMSK)
#define HWIO_IPA_UC_MAILBOX_m_n_INMI2(m,n,mask)    \
        in_dword_masked(HWIO_IPA_UC_MAILBOX_m_n_ADDR(m,n), mask)
#define HWIO_IPA_UC_MAILBOX_m_n_OUTI2(m,n,val)    \
        out_dword(HWIO_IPA_UC_MAILBOX_m_n_ADDR(m,n),val)
#define HWIO_IPA_UC_MAILBOX_m_n_OUTMI2(m,n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_UC_MAILBOX_m_n_ADDR(m,n),mask,val,HWIO_IPA_UC_MAILBOX_m_n_INI2(m,n))
#define HWIO_IPA_UC_MAILBOX_m_n_DATA_BMSK                0xffffffff
#define HWIO_IPA_UC_MAILBOX_m_n_DATA_SHFT                       0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_RAM
 *--------------------------------------------------------------------------*/

#define IPA_RAM_REG_BASE                                                   (IPA_0_IPA_WRAPPER_BASE      + 0x00150000)
#define IPA_RAM_REG_BASE_PHYS                                              (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00150000)
#define IPA_RAM_REG_BASE_OFFS                                              0x00150000

#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n)                       (IPA_RAM_REG_BASE      + 0x00000000 + 0x4 * (n))
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_PHYS(n)                       (IPA_RAM_REG_BASE_PHYS + 0x00000000 + 0x4 * (n))
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_OFFS(n)                       (IPA_RAM_REG_BASE_OFFS + 0x00000000 + 0x4 * (n))
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_RMSK                          0xffffffff
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_MAXn                                5119
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_ATTR                                 0x3
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n), HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_RMSK)
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n), mask)
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n),val)
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n),mask,val,HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_INI(n))
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_DATA_WORD_BMSK                0xffffffff
#define HWIO_IPA_SW_AREA_RAM_DIRECT_ACCESS_n_DATA_WORD_SHFT                       0x0

#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n)                       (IPA_RAM_REG_BASE      + 0x00010000 + 0x4 * (n))
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_PHYS(n)                       (IPA_RAM_REG_BASE_PHYS + 0x00010000 + 0x4 * (n))
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_OFFS(n)                       (IPA_RAM_REG_BASE_OFFS + 0x00010000 + 0x4 * (n))
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_RMSK                          0xffffffff
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_MAXn                               10051
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_ATTR                                 0x3
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n), HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_RMSK)
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n), mask)
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n),val)
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_ADDR(n),mask,val,HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_INI(n))
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_DATA_WORD_BMSK                0xffffffff
#define HWIO_IPA_HW_AREA_RAM_DIRECT_ACCESS_n_DATA_WORD_SHFT                       0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_EE
 *--------------------------------------------------------------------------*/

#define IPA_EE_REG_BASE                                                                             (IPA_0_IPA_WRAPPER_BASE      + 0x0014c000)
#define IPA_EE_REG_BASE_PHYS                                                                        (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x0014c000)
#define IPA_EE_REG_BASE_OFFS                                                                        0x0014c000

#define HWIO_IPA_IRQ_STTS_EE_n_ADDR(n)                                                              (IPA_EE_REG_BASE      + 0x00000008 + 0x1000 * (n))
#define HWIO_IPA_IRQ_STTS_EE_n_PHYS(n)                                                              (IPA_EE_REG_BASE_PHYS + 0x00000008 + 0x1000 * (n))
#define HWIO_IPA_IRQ_STTS_EE_n_OFFS(n)                                                              (IPA_EE_REG_BASE_OFFS + 0x00000008 + 0x1000 * (n))
#define HWIO_IPA_IRQ_STTS_EE_n_RMSK                                                                 0x3fbffffd
#define HWIO_IPA_IRQ_STTS_EE_n_MAXn                                                                          3
#define HWIO_IPA_IRQ_STTS_EE_n_ATTR                                                                        0x1
#define HWIO_IPA_IRQ_STTS_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_IRQ_STTS_EE_n_ADDR(n), HWIO_IPA_IRQ_STTS_EE_n_RMSK)
#define HWIO_IPA_IRQ_STTS_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_IRQ_STTS_EE_n_ADDR(n), mask)
#define HWIO_IPA_IRQ_STTS_EE_n_DRBIP_IMM_CMD_NO_FLSH_HZRD_IRQ_BMSK                                  0x20000000
#define HWIO_IPA_IRQ_STTS_EE_n_DRBIP_IMM_CMD_NO_FLSH_HZRD_IRQ_SHFT                                        0x1d
#define HWIO_IPA_IRQ_STTS_EE_n_DRBIP_DATA_SCTR_CFG_ERROR_IRQ_BMSK                                   0x10000000
#define HWIO_IPA_IRQ_STTS_EE_n_DRBIP_DATA_SCTR_CFG_ERROR_IRQ_SHFT                                         0x1c
#define HWIO_IPA_IRQ_STTS_EE_n_DRBIP_PKT_EXCEED_MAX_SIZE_IRQ_BMSK                                    0x8000000
#define HWIO_IPA_IRQ_STTS_EE_n_DRBIP_PKT_EXCEED_MAX_SIZE_IRQ_SHFT                                         0x1b
#define HWIO_IPA_IRQ_STTS_EE_n_TLV_LEN_MIN_DSM_IRQ_BMSK                                              0x4000000
#define HWIO_IPA_IRQ_STTS_EE_n_TLV_LEN_MIN_DSM_IRQ_SHFT                                                   0x1a
#define HWIO_IPA_IRQ_STTS_EE_n_GSI_UC_IRQ_BMSK                                                       0x2000000
#define HWIO_IPA_IRQ_STTS_EE_n_GSI_UC_IRQ_SHFT                                                            0x19
#define HWIO_IPA_IRQ_STTS_EE_n_GSI_IPA_IF_TLV_RCVD_IRQ_BMSK                                          0x1000000
#define HWIO_IPA_IRQ_STTS_EE_n_GSI_IPA_IF_TLV_RCVD_IRQ_SHFT                                               0x18
#define HWIO_IPA_IRQ_STTS_EE_n_GSI_EE_IRQ_BMSK                                                        0x800000
#define HWIO_IPA_IRQ_STTS_EE_n_GSI_EE_IRQ_SHFT                                                            0x17
#define HWIO_IPA_IRQ_STTS_EE_n_UCP_IRQ_BMSK                                                           0x200000
#define HWIO_IPA_IRQ_STTS_EE_n_UCP_IRQ_SHFT                                                               0x15
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_RED_MARKER_ABOVE_IRQ_BMSK                                         0x100000
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_RED_MARKER_ABOVE_IRQ_SHFT                                             0x14
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_YELLOW_MARKER_ABOVE_IRQ_BMSK                                       0x80000
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_YELLOW_MARKER_ABOVE_IRQ_SHFT                                          0x13
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_RED_MARKER_BELOW_IRQ_BMSK                                          0x40000
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_RED_MARKER_BELOW_IRQ_SHFT                                             0x12
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_YELLOW_MARKER_BELOW_IRQ_BMSK                                       0x20000
#define HWIO_IPA_IRQ_STTS_EE_n_PIPE_YELLOW_MARKER_BELOW_IRQ_SHFT                                          0x11
#define HWIO_IPA_IRQ_STTS_EE_n_BAM_GSI_IDLE_IRQ_BMSK                                                   0x10000
#define HWIO_IPA_IRQ_STTS_EE_n_BAM_GSI_IDLE_IRQ_SHFT                                                      0x10
#define HWIO_IPA_IRQ_STTS_EE_n_TX_HOLB_DROP_IRQ_BMSK                                                    0x8000
#define HWIO_IPA_IRQ_STTS_EE_n_TX_HOLB_DROP_IRQ_SHFT                                                       0xf
#define HWIO_IPA_IRQ_STTS_EE_n_TX_SUSPEND_IRQ_BMSK                                                      0x4000
#define HWIO_IPA_IRQ_STTS_EE_n_TX_SUSPEND_IRQ_SHFT                                                         0xe
#define HWIO_IPA_IRQ_STTS_EE_n_PROC_ERR_IRQ_BMSK                                                        0x2000
#define HWIO_IPA_IRQ_STTS_EE_n_PROC_ERR_IRQ_SHFT                                                           0xd
#define HWIO_IPA_IRQ_STTS_EE_n_STEP_MODE_IRQ_BMSK                                                       0x1000
#define HWIO_IPA_IRQ_STTS_EE_n_STEP_MODE_IRQ_SHFT                                                          0xc
#define HWIO_IPA_IRQ_STTS_EE_n_TX_ERR_IRQ_BMSK                                                           0x800
#define HWIO_IPA_IRQ_STTS_EE_n_TX_ERR_IRQ_SHFT                                                             0xb
#define HWIO_IPA_IRQ_STTS_EE_n_DEAGGR_ERR_IRQ_BMSK                                                       0x400
#define HWIO_IPA_IRQ_STTS_EE_n_DEAGGR_ERR_IRQ_SHFT                                                         0xa
#define HWIO_IPA_IRQ_STTS_EE_n_RX_ERR_IRQ_BMSK                                                           0x200
#define HWIO_IPA_IRQ_STTS_EE_n_RX_ERR_IRQ_SHFT                                                             0x9
#define HWIO_IPA_IRQ_STTS_EE_n_PROC_TO_UC_ACK_Q_NOT_EMPTY_IRQ_BMSK                                       0x100
#define HWIO_IPA_IRQ_STTS_EE_n_PROC_TO_UC_ACK_Q_NOT_EMPTY_IRQ_SHFT                                         0x8
#define HWIO_IPA_IRQ_STTS_EE_n_UC_RX_CMD_Q_NOT_FULL_IRQ_BMSK                                              0x80
#define HWIO_IPA_IRQ_STTS_EE_n_UC_RX_CMD_Q_NOT_FULL_IRQ_SHFT                                               0x7
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IN_Q_NOT_EMPTY_IRQ_BMSK                                                 0x40
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IN_Q_NOT_EMPTY_IRQ_SHFT                                                  0x6
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_3_BMSK                                                              0x20
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_3_SHFT                                                               0x5
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_2_BMSK                                                              0x10
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_2_SHFT                                                               0x4
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_1_BMSK                                                               0x8
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_1_SHFT                                                               0x3
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_0_BMSK                                                               0x4
#define HWIO_IPA_IRQ_STTS_EE_n_UC_IRQ_0_SHFT                                                               0x2
#define HWIO_IPA_IRQ_STTS_EE_n_BAD_SNOC_ACCESS_IRQ_BMSK                                                    0x1
#define HWIO_IPA_IRQ_STTS_EE_n_BAD_SNOC_ACCESS_IRQ_SHFT                                                    0x0

#define HWIO_IPA_IRQ_EN_EE_n_ADDR(n)                                                                (IPA_EE_REG_BASE      + 0x0000000c + 0x1000 * (n))
#define HWIO_IPA_IRQ_EN_EE_n_PHYS(n)                                                                (IPA_EE_REG_BASE_PHYS + 0x0000000c + 0x1000 * (n))
#define HWIO_IPA_IRQ_EN_EE_n_OFFS(n)                                                                (IPA_EE_REG_BASE_OFFS + 0x0000000c + 0x1000 * (n))
#define HWIO_IPA_IRQ_EN_EE_n_RMSK                                                                   0x3fbffffd
#define HWIO_IPA_IRQ_EN_EE_n_MAXn                                                                            3
#define HWIO_IPA_IRQ_EN_EE_n_ATTR                                                                          0x3
#define HWIO_IPA_IRQ_EN_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_IRQ_EN_EE_n_ADDR(n), HWIO_IPA_IRQ_EN_EE_n_RMSK)
#define HWIO_IPA_IRQ_EN_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_IRQ_EN_EE_n_ADDR(n), mask)
#define HWIO_IPA_IRQ_EN_EE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_IRQ_EN_EE_n_ADDR(n),val)
#define HWIO_IPA_IRQ_EN_EE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_IRQ_EN_EE_n_ADDR(n),mask,val,HWIO_IPA_IRQ_EN_EE_n_INI(n))
#define HWIO_IPA_IRQ_EN_EE_n_DRBIP_IMM_CMD_NO_FLSH_HZRD_IRQ_EN_BMSK                                 0x20000000
#define HWIO_IPA_IRQ_EN_EE_n_DRBIP_IMM_CMD_NO_FLSH_HZRD_IRQ_EN_SHFT                                       0x1d
#define HWIO_IPA_IRQ_EN_EE_n_DRBIP_DATA_SCTR_CFG_ERROR_IRQ_EN_BMSK                                  0x10000000
#define HWIO_IPA_IRQ_EN_EE_n_DRBIP_DATA_SCTR_CFG_ERROR_IRQ_EN_SHFT                                        0x1c
#define HWIO_IPA_IRQ_EN_EE_n_DRBIP_PKT_EXCEED_MAX_SIZE_IRQ_EN_BMSK                                   0x8000000
#define HWIO_IPA_IRQ_EN_EE_n_DRBIP_PKT_EXCEED_MAX_SIZE_IRQ_EN_SHFT                                        0x1b
#define HWIO_IPA_IRQ_EN_EE_n_TLV_LEN_MIN_DSM_IRQ_EN_BMSK                                             0x4000000
#define HWIO_IPA_IRQ_EN_EE_n_TLV_LEN_MIN_DSM_IRQ_EN_SHFT                                                  0x1a
#define HWIO_IPA_IRQ_EN_EE_n_GSI_UC_IRQ_EN_BMSK                                                      0x2000000
#define HWIO_IPA_IRQ_EN_EE_n_GSI_UC_IRQ_EN_SHFT                                                           0x19
#define HWIO_IPA_IRQ_EN_EE_n_GSI_IPA_IF_TLV_RCVD_IRQ_EN_BMSK                                         0x1000000
#define HWIO_IPA_IRQ_EN_EE_n_GSI_IPA_IF_TLV_RCVD_IRQ_EN_SHFT                                              0x18
#define HWIO_IPA_IRQ_EN_EE_n_GSI_EE_IRQ_EN_BMSK                                                       0x800000
#define HWIO_IPA_IRQ_EN_EE_n_GSI_EE_IRQ_EN_SHFT                                                           0x17
#define HWIO_IPA_IRQ_EN_EE_n_UCP_IRQ_EN_BMSK                                                          0x200000
#define HWIO_IPA_IRQ_EN_EE_n_UCP_IRQ_EN_SHFT                                                              0x15
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_RED_MARKER_ABOVE_IRQ_EN_BMSK                                        0x100000
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_RED_MARKER_ABOVE_IRQ_EN_SHFT                                            0x14
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_YELLOW_MARKER_ABOVE_IRQ_EN_BMSK                                      0x80000
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_YELLOW_MARKER_ABOVE_IRQ_EN_SHFT                                         0x13
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_RED_MARKER_BELOW_IRQ_EN_BMSK                                         0x40000
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_RED_MARKER_BELOW_IRQ_EN_SHFT                                            0x12
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_YELLOW_MARKER_BELOW_IRQ_EN_BMSK                                      0x20000
#define HWIO_IPA_IRQ_EN_EE_n_PIPE_YELLOW_MARKER_BELOW_IRQ_EN_SHFT                                         0x11
#define HWIO_IPA_IRQ_EN_EE_n_BAM_GSI_IDLE_IRQ_EN_BMSK                                                  0x10000
#define HWIO_IPA_IRQ_EN_EE_n_BAM_GSI_IDLE_IRQ_EN_SHFT                                                     0x10
#define HWIO_IPA_IRQ_EN_EE_n_TX_HOLB_DROP_IRQ_EN_BMSK                                                   0x8000
#define HWIO_IPA_IRQ_EN_EE_n_TX_HOLB_DROP_IRQ_EN_SHFT                                                      0xf
#define HWIO_IPA_IRQ_EN_EE_n_TX_SUSPEND_IRQ_EN_BMSK                                                     0x4000
#define HWIO_IPA_IRQ_EN_EE_n_TX_SUSPEND_IRQ_EN_SHFT                                                        0xe
#define HWIO_IPA_IRQ_EN_EE_n_PROC_ERR_IRQ_EN_BMSK                                                       0x2000
#define HWIO_IPA_IRQ_EN_EE_n_PROC_ERR_IRQ_EN_SHFT                                                          0xd
#define HWIO_IPA_IRQ_EN_EE_n_STEP_MODE_IRQ_EN_BMSK                                                      0x1000
#define HWIO_IPA_IRQ_EN_EE_n_STEP_MODE_IRQ_EN_SHFT                                                         0xc
#define HWIO_IPA_IRQ_EN_EE_n_TX_ERR_IRQ_EN_BMSK                                                          0x800
#define HWIO_IPA_IRQ_EN_EE_n_TX_ERR_IRQ_EN_SHFT                                                            0xb
#define HWIO_IPA_IRQ_EN_EE_n_DEAGGR_ERR_IRQ_EN_BMSK                                                      0x400
#define HWIO_IPA_IRQ_EN_EE_n_DEAGGR_ERR_IRQ_EN_SHFT                                                        0xa
#define HWIO_IPA_IRQ_EN_EE_n_RX_ERR_IRQ_EN_BMSK                                                          0x200
#define HWIO_IPA_IRQ_EN_EE_n_RX_ERR_IRQ_EN_SHFT                                                            0x9
#define HWIO_IPA_IRQ_EN_EE_n_PROC_TO_UC_ACK_Q_NOT_EMPTY_IRQ_EN_BMSK                                      0x100
#define HWIO_IPA_IRQ_EN_EE_n_PROC_TO_UC_ACK_Q_NOT_EMPTY_IRQ_EN_SHFT                                        0x8
#define HWIO_IPA_IRQ_EN_EE_n_UC_RX_CMD_Q_NOT_FULL_IRQ_EN_BMSK                                             0x80
#define HWIO_IPA_IRQ_EN_EE_n_UC_RX_CMD_Q_NOT_FULL_IRQ_EN_SHFT                                              0x7
#define HWIO_IPA_IRQ_EN_EE_n_UC_IN_Q_NOT_EMPTY_IRQ_EN_BMSK                                                0x40
#define HWIO_IPA_IRQ_EN_EE_n_UC_IN_Q_NOT_EMPTY_IRQ_EN_SHFT                                                 0x6
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_3_IRQ_EN_BMSK                                                         0x20
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_3_IRQ_EN_SHFT                                                          0x5
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_2_IRQ_EN_BMSK                                                         0x10
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_2_IRQ_EN_SHFT                                                          0x4
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_1_IRQ_EN_BMSK                                                          0x8
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_1_IRQ_EN_SHFT                                                          0x3
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_0_IRQ_EN_BMSK                                                          0x4
#define HWIO_IPA_IRQ_EN_EE_n_UC_IRQ_0_IRQ_EN_SHFT                                                          0x2
#define HWIO_IPA_IRQ_EN_EE_n_BAD_SNOC_ACCESS_IRQ_EN_BMSK                                                   0x1
#define HWIO_IPA_IRQ_EN_EE_n_BAD_SNOC_ACCESS_IRQ_EN_SHFT                                                   0x0

#define HWIO_IPA_IRQ_CLR_EE_n_ADDR(n)                                                               (IPA_EE_REG_BASE      + 0x00000010 + 0x1000 * (n))
#define HWIO_IPA_IRQ_CLR_EE_n_PHYS(n)                                                               (IPA_EE_REG_BASE_PHYS + 0x00000010 + 0x1000 * (n))
#define HWIO_IPA_IRQ_CLR_EE_n_OFFS(n)                                                               (IPA_EE_REG_BASE_OFFS + 0x00000010 + 0x1000 * (n))
#define HWIO_IPA_IRQ_CLR_EE_n_RMSK                                                                  0x3fbffffd
#define HWIO_IPA_IRQ_CLR_EE_n_MAXn                                                                           3
#define HWIO_IPA_IRQ_CLR_EE_n_ATTR                                                                         0x2
#define HWIO_IPA_IRQ_CLR_EE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_IRQ_CLR_EE_n_ADDR(n),val)
#define HWIO_IPA_IRQ_CLR_EE_n_DRBIP_IMM_CMD_NO_FLSH_HZRD_IRQ_CLR_BMSK                               0x20000000
#define HWIO_IPA_IRQ_CLR_EE_n_DRBIP_IMM_CMD_NO_FLSH_HZRD_IRQ_CLR_SHFT                                     0x1d
#define HWIO_IPA_IRQ_CLR_EE_n_DRBIP_DATA_SCTR_CFG_ERROR_IRQ_CLR_BMSK                                0x10000000
#define HWIO_IPA_IRQ_CLR_EE_n_DRBIP_DATA_SCTR_CFG_ERROR_IRQ_CLR_SHFT                                      0x1c
#define HWIO_IPA_IRQ_CLR_EE_n_DRBIP_PKT_EXCEED_MAX_SIZE_IRQ_CLR_BMSK                                 0x8000000
#define HWIO_IPA_IRQ_CLR_EE_n_DRBIP_PKT_EXCEED_MAX_SIZE_IRQ_CLR_SHFT                                      0x1b
#define HWIO_IPA_IRQ_CLR_EE_n_TLV_LEN_MIN_DSM_IRQ_CLR_BMSK                                           0x4000000
#define HWIO_IPA_IRQ_CLR_EE_n_TLV_LEN_MIN_DSM_IRQ_CLR_SHFT                                                0x1a
#define HWIO_IPA_IRQ_CLR_EE_n_GSI_UC_IRQ_CLR_BMSK                                                    0x2000000
#define HWIO_IPA_IRQ_CLR_EE_n_GSI_UC_IRQ_CLR_SHFT                                                         0x19
#define HWIO_IPA_IRQ_CLR_EE_n_GSI_IPA_IF_TLV_RCVD_IRQ_CLR_BMSK                                       0x1000000
#define HWIO_IPA_IRQ_CLR_EE_n_GSI_IPA_IF_TLV_RCVD_IRQ_CLR_SHFT                                            0x18
#define HWIO_IPA_IRQ_CLR_EE_n_GSI_EE_IRQ_CLR_BMSK                                                     0x800000
#define HWIO_IPA_IRQ_CLR_EE_n_GSI_EE_IRQ_CLR_SHFT                                                         0x17
#define HWIO_IPA_IRQ_CLR_EE_n_UCP_IRQ_CLR_BMSK                                                        0x200000
#define HWIO_IPA_IRQ_CLR_EE_n_UCP_IRQ_CLR_SHFT                                                            0x15
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_RED_MARKER_ABOVE_IRQ_CLR_BMSK                                      0x100000
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_RED_MARKER_ABOVE_IRQ_CLR_SHFT                                          0x14
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_YELLOW_MARKER_ABOVE_IRQ_CLR_BMSK                                    0x80000
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_YELLOW_MARKER_ABOVE_IRQ_CLR_SHFT                                       0x13
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_RED_MARKER_BELOW_IRQ_CLR_BMSK                                       0x40000
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_RED_MARKER_BELOW_IRQ_CLR_SHFT                                          0x12
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_YELLOW_MARKER_BELOW_IRQ_CLR_BMSK                                    0x20000
#define HWIO_IPA_IRQ_CLR_EE_n_PIPE_YELLOW_MARKER_BELOW_IRQ_CLR_SHFT                                       0x11
#define HWIO_IPA_IRQ_CLR_EE_n_BAM_GSI_IDLE_IRQ_CLR_BMSK                                                0x10000
#define HWIO_IPA_IRQ_CLR_EE_n_BAM_GSI_IDLE_IRQ_CLR_SHFT                                                   0x10
#define HWIO_IPA_IRQ_CLR_EE_n_TX_HOLB_DROP_IRQ_CLR_BMSK                                                 0x8000
#define HWIO_IPA_IRQ_CLR_EE_n_TX_HOLB_DROP_IRQ_CLR_SHFT                                                    0xf
#define HWIO_IPA_IRQ_CLR_EE_n_TX_SUSPEND_IRQ_CLR_BMSK                                                   0x4000
#define HWIO_IPA_IRQ_CLR_EE_n_TX_SUSPEND_IRQ_CLR_SHFT                                                      0xe
#define HWIO_IPA_IRQ_CLR_EE_n_PROC_ERR_IRQ_CLR_BMSK                                                     0x2000
#define HWIO_IPA_IRQ_CLR_EE_n_PROC_ERR_IRQ_CLR_SHFT                                                        0xd
#define HWIO_IPA_IRQ_CLR_EE_n_STEP_MODE_IRQ_CLR_BMSK                                                    0x1000
#define HWIO_IPA_IRQ_CLR_EE_n_STEP_MODE_IRQ_CLR_SHFT                                                       0xc
#define HWIO_IPA_IRQ_CLR_EE_n_TX_ERR_IRQ_CLR_BMSK                                                        0x800
#define HWIO_IPA_IRQ_CLR_EE_n_TX_ERR_IRQ_CLR_SHFT                                                          0xb
#define HWIO_IPA_IRQ_CLR_EE_n_DEAGGR_ERR_IRQ_CLR_BMSK                                                    0x400
#define HWIO_IPA_IRQ_CLR_EE_n_DEAGGR_ERR_IRQ_CLR_SHFT                                                      0xa
#define HWIO_IPA_IRQ_CLR_EE_n_RX_ERR_IRQ_CLR_BMSK                                                        0x200
#define HWIO_IPA_IRQ_CLR_EE_n_RX_ERR_IRQ_CLR_SHFT                                                          0x9
#define HWIO_IPA_IRQ_CLR_EE_n_PROC_TO_UC_ACK_Q_NOT_EMPTY_IRQ_CLR_BMSK                                    0x100
#define HWIO_IPA_IRQ_CLR_EE_n_PROC_TO_UC_ACK_Q_NOT_EMPTY_IRQ_CLR_SHFT                                      0x8
#define HWIO_IPA_IRQ_CLR_EE_n_UC_RX_CMD_Q_NOT_FULL_IRQ_CLR_BMSK                                           0x80
#define HWIO_IPA_IRQ_CLR_EE_n_UC_RX_CMD_Q_NOT_FULL_IRQ_CLR_SHFT                                            0x7
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IN_Q_NOT_EMPTY_IRQ_CLR_BMSK                                              0x40
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IN_Q_NOT_EMPTY_IRQ_CLR_SHFT                                               0x6
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_3_CLR_BMSK                                                           0x20
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_3_CLR_SHFT                                                            0x5
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_2_CLR_BMSK                                                           0x10
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_2_CLR_SHFT                                                            0x4
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_1_CLR_BMSK                                                            0x8
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_1_CLR_SHFT                                                            0x3
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_0_CLR_BMSK                                                            0x4
#define HWIO_IPA_IRQ_CLR_EE_n_UC_IRQ_0_CLR_SHFT                                                            0x2
#define HWIO_IPA_IRQ_CLR_EE_n_BAD_SNOC_ACCESS_IRQ_CLR_BMSK                                                 0x1
#define HWIO_IPA_IRQ_CLR_EE_n_BAD_SNOC_ACCESS_IRQ_CLR_SHFT                                                 0x0

#define HWIO_IPA_SNOC_FEC_EE_n_ADDR(n)                                                              (IPA_EE_REG_BASE      + 0x00000018 + 0x1000 * (n))
#define HWIO_IPA_SNOC_FEC_EE_n_PHYS(n)                                                              (IPA_EE_REG_BASE_PHYS + 0x00000018 + 0x1000 * (n))
#define HWIO_IPA_SNOC_FEC_EE_n_OFFS(n)                                                              (IPA_EE_REG_BASE_OFFS + 0x00000018 + 0x1000 * (n))
#define HWIO_IPA_SNOC_FEC_EE_n_RMSK                                                                 0xb001ffff
#define HWIO_IPA_SNOC_FEC_EE_n_MAXn                                                                          3
#define HWIO_IPA_SNOC_FEC_EE_n_ATTR                                                                        0x3
#define HWIO_IPA_SNOC_FEC_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SNOC_FEC_EE_n_ADDR(n), HWIO_IPA_SNOC_FEC_EE_n_RMSK)
#define HWIO_IPA_SNOC_FEC_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SNOC_FEC_EE_n_ADDR(n), mask)
#define HWIO_IPA_SNOC_FEC_EE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SNOC_FEC_EE_n_ADDR(n),val)
#define HWIO_IPA_SNOC_FEC_EE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SNOC_FEC_EE_n_ADDR(n),mask,val,HWIO_IPA_SNOC_FEC_EE_n_INI(n))
#define HWIO_IPA_SNOC_FEC_EE_n_DIRECTION_BMSK                                                       0x80000000
#define HWIO_IPA_SNOC_FEC_EE_n_DIRECTION_SHFT                                                             0x1f
#define HWIO_IPA_SNOC_FEC_EE_n_CLEAR_BMSK                                                           0x20000000
#define HWIO_IPA_SNOC_FEC_EE_n_CLEAR_SHFT                                                                 0x1d
#define HWIO_IPA_SNOC_FEC_EE_n_VALID_BMSK                                                           0x10000000
#define HWIO_IPA_SNOC_FEC_EE_n_VALID_SHFT                                                                 0x1c
#define HWIO_IPA_SNOC_FEC_EE_n_TID_BMSK                                                                0x1f000
#define HWIO_IPA_SNOC_FEC_EE_n_TID_SHFT                                                                    0xc
#define HWIO_IPA_SNOC_FEC_EE_n_NOC_MASTER_BMSK                                                           0xe00
#define HWIO_IPA_SNOC_FEC_EE_n_NOC_MASTER_SHFT                                                             0x9
#define HWIO_IPA_SNOC_FEC_EE_n_NOC_PORT_BMSK                                                             0x100
#define HWIO_IPA_SNOC_FEC_EE_n_NOC_PORT_SHFT                                                               0x8
#define HWIO_IPA_SNOC_FEC_EE_n_CLIENT_BMSK                                                                0xff
#define HWIO_IPA_SNOC_FEC_EE_n_CLIENT_SHFT                                                                 0x0

#define HWIO_IPA_IRQ_EE_UC_n_ADDR(n)                                                                (IPA_EE_REG_BASE      + 0x0000001c + 0x1000 * (n))
#define HWIO_IPA_IRQ_EE_UC_n_PHYS(n)                                                                (IPA_EE_REG_BASE_PHYS + 0x0000001c + 0x1000 * (n))
#define HWIO_IPA_IRQ_EE_UC_n_OFFS(n)                                                                (IPA_EE_REG_BASE_OFFS + 0x0000001c + 0x1000 * (n))
#define HWIO_IPA_IRQ_EE_UC_n_RMSK                                                                          0x1
#define HWIO_IPA_IRQ_EE_UC_n_MAXn                                                                            3
#define HWIO_IPA_IRQ_EE_UC_n_ATTR                                                                          0x2
#define HWIO_IPA_IRQ_EE_UC_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_IRQ_EE_UC_n_ADDR(n),val)
#define HWIO_IPA_IRQ_EE_UC_n_INTR_BMSK                                                                     0x1
#define HWIO_IPA_IRQ_EE_UC_n_INTR_SHFT                                                                     0x0

#define HWIO_IPA_FEC_ADDR_EE_n_ADDR(n)                                                              (IPA_EE_REG_BASE      + 0x00000020 + 0x1000 * (n))
#define HWIO_IPA_FEC_ADDR_EE_n_PHYS(n)                                                              (IPA_EE_REG_BASE_PHYS + 0x00000020 + 0x1000 * (n))
#define HWIO_IPA_FEC_ADDR_EE_n_OFFS(n)                                                              (IPA_EE_REG_BASE_OFFS + 0x00000020 + 0x1000 * (n))
#define HWIO_IPA_FEC_ADDR_EE_n_RMSK                                                                 0xffffffff
#define HWIO_IPA_FEC_ADDR_EE_n_MAXn                                                                          3
#define HWIO_IPA_FEC_ADDR_EE_n_ATTR                                                                        0x1
#define HWIO_IPA_FEC_ADDR_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_FEC_ADDR_EE_n_ADDR(n), HWIO_IPA_FEC_ADDR_EE_n_RMSK)
#define HWIO_IPA_FEC_ADDR_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_FEC_ADDR_EE_n_ADDR(n), mask)
#define HWIO_IPA_FEC_ADDR_EE_n_ADDR_BMSK                                                            0xffffffff
#define HWIO_IPA_FEC_ADDR_EE_n_ADDR_SHFT                                                                   0x0

#define HWIO_IPA_FEC_ADDR_MSB_EE_n_ADDR(n)                                                          (IPA_EE_REG_BASE      + 0x00000024 + 0x1000 * (n))
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_PHYS(n)                                                          (IPA_EE_REG_BASE_PHYS + 0x00000024 + 0x1000 * (n))
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_OFFS(n)                                                          (IPA_EE_REG_BASE_OFFS + 0x00000024 + 0x1000 * (n))
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_RMSK                                                             0xffffffff
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_MAXn                                                                      3
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_ATTR                                                                    0x1
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_FEC_ADDR_MSB_EE_n_ADDR(n), HWIO_IPA_FEC_ADDR_MSB_EE_n_RMSK)
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_FEC_ADDR_MSB_EE_n_ADDR(n), mask)
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_ADDR_BMSK                                                        0xffffffff
#define HWIO_IPA_FEC_ADDR_MSB_EE_n_ADDR_SHFT                                                               0x0

#define HWIO_IPA_FEC_ATTR_EE_n_ADDR(n)                                                              (IPA_EE_REG_BASE      + 0x00000028 + 0x1000 * (n))
#define HWIO_IPA_FEC_ATTR_EE_n_PHYS(n)                                                              (IPA_EE_REG_BASE_PHYS + 0x00000028 + 0x1000 * (n))
#define HWIO_IPA_FEC_ATTR_EE_n_OFFS(n)                                                              (IPA_EE_REG_BASE_OFFS + 0x00000028 + 0x1000 * (n))
#define HWIO_IPA_FEC_ATTR_EE_n_RMSK                                                                 0xffffffff
#define HWIO_IPA_FEC_ATTR_EE_n_MAXn                                                                          3
#define HWIO_IPA_FEC_ATTR_EE_n_ATTR                                                                        0x1
#define HWIO_IPA_FEC_ATTR_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_FEC_ATTR_EE_n_ADDR(n), HWIO_IPA_FEC_ATTR_EE_n_RMSK)
#define HWIO_IPA_FEC_ATTR_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_FEC_ATTR_EE_n_ADDR(n), mask)
#define HWIO_IPA_FEC_ATTR_EE_n_ERROR_INFO_BMSK                                                      0xffffffc0
#define HWIO_IPA_FEC_ATTR_EE_n_ERROR_INFO_SHFT                                                             0x6
#define HWIO_IPA_FEC_ATTR_EE_n_OPCODE_BMSK                                                                0x3f
#define HWIO_IPA_FEC_ATTR_EE_n_OPCODE_SHFT                                                                 0x0

#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_ADDR(n)                                                        (IPA_EE_REG_BASE      + 0x00000060 + 0x1000 * (n))
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_PHYS(n)                                                        (IPA_EE_REG_BASE_PHYS + 0x00000060 + 0x1000 * (n))
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_OFFS(n)                                                        (IPA_EE_REG_BASE_OFFS + 0x00000060 + 0x1000 * (n))
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_RMSK                                                           0xffffffff
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_MAXn                                                                    3
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_ATTR                                                                  0x1
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DRBIP_FEC_INFO_EE_n_ADDR(n), HWIO_IPA_DRBIP_FEC_INFO_EE_n_RMSK)
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DRBIP_FEC_INFO_EE_n_ADDR(n), mask)
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_AVAIL_DATA_SECTORS_BMSK                                        0xff000000
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_AVAIL_DATA_SECTORS_SHFT                                              0x18
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_REQUIRED_DATA_SECTORS_BMSK                                       0xff0000
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_REQUIRED_DATA_SECTORS_SHFT                                           0x10
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_SRC_PIPE_BMSK                                                      0xff00
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_SRC_PIPE_SHFT                                                         0x8
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_SRC_GRP_BMSK                                                         0xf0
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_SRC_GRP_SHFT                                                          0x4
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_ERROR_CODE_BMSK                                                       0xf
#define HWIO_IPA_DRBIP_FEC_INFO_EE_n_ERROR_CODE_SHFT                                                       0x0

#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_ADDR(n)                                                    (IPA_EE_REG_BASE      + 0x00000064 + 0x1000 * (n))
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_PHYS(n)                                                    (IPA_EE_REG_BASE_PHYS + 0x00000064 + 0x1000 * (n))
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_OFFS(n)                                                    (IPA_EE_REG_BASE_OFFS + 0x00000064 + 0x1000 * (n))
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_RMSK                                                         0xffffff
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_MAXn                                                                3
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_ATTR                                                              0x1
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_ADDR(n), HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_RMSK)
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_ADDR(n), mask)
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_OPOCODE_BMSK                                                 0xff0000
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_OPOCODE_SHFT                                                     0x10
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_SIZE_BMSK                                                      0xffff
#define HWIO_IPA_DRBIP_FEC_INFO_EXT_EE_n_SIZE_SHFT                                                         0x0

#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_ADDR(n,k)                                              (IPA_EE_REG_BASE      + 0x00000030 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_PHYS(n,k)                                              (IPA_EE_REG_BASE_PHYS + 0x00000030 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_OFFS(n,k)                                              (IPA_EE_REG_BASE_OFFS + 0x00000030 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_RMSK                                                   0xffffffff
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_MAXn                                                            3
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_MAXk                                                            1
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_ATTR                                                          0x1
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_ADDR(n,k), HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_RMSK)
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_ENDPOINTS_BMSK                                         0xffffffff
#define HWIO_IPA_SUSPEND_IRQ_INFO_EE_n_REG_k_ENDPOINTS_SHFT                                                0x0

#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ADDR(n,k)                                                (IPA_EE_REG_BASE      + 0x00000050 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_PHYS(n,k)                                                (IPA_EE_REG_BASE_PHYS + 0x00000050 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_OFFS(n,k)                                                (IPA_EE_REG_BASE_OFFS + 0x00000050 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_RMSK                                                     0xffffffff
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_MAXn                                                              3
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_MAXk                                                              1
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ATTR                                                            0x3
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ADDR(n,k), HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_RMSK)
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ADDR(n,k),mask,val,HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_INI2(n,k))
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ENDPOINTS_BMSK                                           0xffffffff
#define HWIO_IPA_SUSPEND_IRQ_EN_EE_n_REG_k_ENDPOINTS_SHFT                                                  0x0

#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_ADDR(n,k)                                               (IPA_EE_REG_BASE      + 0x00000070 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_PHYS(n,k)                                               (IPA_EE_REG_BASE_PHYS + 0x00000070 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_OFFS(n,k)                                               (IPA_EE_REG_BASE_OFFS + 0x00000070 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_RMSK                                                    0xffffffff
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_MAXn                                                             3
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_MAXk                                                             1
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_ATTR                                                           0x2
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_ENDPOINTS_BMSK                                          0xffffffff
#define HWIO_IPA_SUSPEND_IRQ_CLR_EE_n_REG_k_ENDPOINTS_SHFT                                                 0x0

#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_ADDR(n,k)                                            (IPA_EE_REG_BASE      + 0x00000090 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_PHYS(n,k)                                            (IPA_EE_REG_BASE_PHYS + 0x00000090 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_OFFS(n,k)                                            (IPA_EE_REG_BASE_OFFS + 0x00000090 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_RMSK                                                 0xffffffff
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_MAXn                                                          3
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_MAXk                                                          1
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_ATTR                                                        0x1
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_ADDR(n,k), HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_RMSK)
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_ENDPOINTS_BMSK                                       0xffffffff
#define HWIO_IPA_HOLB_DROP_IRQ_INFO_EE_n_REG_k_ENDPOINTS_SHFT                                              0x0

#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ADDR(n,k)                                              (IPA_EE_REG_BASE      + 0x000000b0 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_PHYS(n,k)                                              (IPA_EE_REG_BASE_PHYS + 0x000000b0 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_OFFS(n,k)                                              (IPA_EE_REG_BASE_OFFS + 0x000000b0 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_RMSK                                                   0xffffffff
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_MAXn                                                            3
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_MAXk                                                            1
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ATTR                                                          0x3
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ADDR(n,k), HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_RMSK)
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ADDR(n,k),mask,val,HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_INI2(n,k))
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ENDPOINTS_BMSK                                         0xffffffff
#define HWIO_IPA_HOLB_DROP_IRQ_EN_EE_n_REG_k_ENDPOINTS_SHFT                                                0x0

#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_ADDR(n,k)                                             (IPA_EE_REG_BASE      + 0x000000c0 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_PHYS(n,k)                                             (IPA_EE_REG_BASE_PHYS + 0x000000c0 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_OFFS(n,k)                                             (IPA_EE_REG_BASE_OFFS + 0x000000c0 + 0x1000 * (n) + 0x4 * (k))
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_RMSK                                                  0xffffffff
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_MAXn                                                           3
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_MAXk                                                           1
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_ATTR                                                         0x2
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_ENDPOINTS_BMSK                                        0xffffffff
#define HWIO_IPA_HOLB_DROP_IRQ_CLR_EE_n_REG_k_ENDPOINTS_SHFT                                               0x0

#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_ADDR                                                    (IPA_EE_REG_BASE      + 0x00001100)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_PHYS                                                    (IPA_EE_REG_BASE_PHYS + 0x00001100)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_OFFS                                                    (IPA_EE_REG_BASE_OFFS + 0x00001100)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_RMSK                                                    0xff1ff0ff
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_ATTR                                                           0x1
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_IN          \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_ADDR, HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_RMSK)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_INM(m)      \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_ADDR, m)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_BEARER_BMSK                           0xff000000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_BEARER_SHFT                                 0x18
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_CPHR_KEY_INDX_BMSK                      0x1f0000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_CPHR_KEY_INDX_SHFT                          0x10
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_CPHR_ALGORITHM_BMSK                       0xf000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_CPHR_ALGORITHM_SHFT                          0xc
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_L2_HDR_SIZE_BMSK                            0xff
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_0_MODEM_BEARER_INIT_L2_HDR_SIZE_SHFT                             0x0

#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_ADDR                                                    (IPA_EE_REG_BASE      + 0x00001104)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_PHYS                                                    (IPA_EE_REG_BASE_PHYS + 0x00001104)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_OFFS                                                    (IPA_EE_REG_BASE_OFFS + 0x00001104)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_RMSK                                                    0xffffffff
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_ATTR                                                           0x1
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_IN          \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_ADDR, HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_RMSK)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_INM(m)      \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_ADDR, m)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_BEARER_SEL_BMSK                       0x80000000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_BEARER_SEL_SHFT                             0x1f
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_DIRECTION_BMSK                        0x40000000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_DIRECTION_SHFT                              0x1e
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_CPHR_OFST_START_BMSK                  0x3fff0000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_CPHR_OFST_START_SHFT                        0x10
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_CPHR_OFST_KEYSTRM_BMSK                    0xffff
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_1_MODEM_BEARER_INIT_CPHR_OFST_KEYSTRM_SHFT                       0x0

#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_ADDR                                                    (IPA_EE_REG_BASE      + 0x00001108)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_PHYS                                                    (IPA_EE_REG_BASE_PHYS + 0x00001108)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_OFFS                                                    (IPA_EE_REG_BASE_OFFS + 0x00001108)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_RMSK                                                        0x31ff
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_ATTR                                                           0x1
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_IN          \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_ADDR, HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_RMSK)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_INM(m)      \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_ADDR, m)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_MODEM_BEARER_INIT_IP_MACI_SIZE_BMSK                         0x3000
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_MODEM_BEARER_INIT_IP_MACI_SIZE_SHFT                            0xc
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_MODEM_BEARER_INIT_IP_KEY_INDX_BMSK                           0x1f0
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_MODEM_BEARER_INIT_IP_KEY_INDX_SHFT                             0x4
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_MODEM_BEARER_INIT_IP_ALGORITHM_BMSK                            0xf
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_2_MODEM_BEARER_INIT_IP_ALGORITHM_SHFT                            0x0

#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_ADDR                                                  (IPA_EE_REG_BASE      + 0x0000110c)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_PHYS                                                  (IPA_EE_REG_BASE_PHYS + 0x0000110c)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_OFFS                                                  (IPA_EE_REG_BASE_OFFS + 0x0000110c)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_RMSK                                                  0xffffffff
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_ATTR                                                         0x1
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_IN          \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_ADDR, HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_RMSK)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_INM(m)      \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_ADDR, m)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_MODEM_BEARER_CONFIG_COUNT_F_BMSK                      0xffffffff
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_0_MODEM_BEARER_CONFIG_COUNT_F_SHFT                             0x0

#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_ADDR                                                  (IPA_EE_REG_BASE      + 0x00001110)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_PHYS                                                  (IPA_EE_REG_BASE_PHYS + 0x00001110)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_OFFS                                                  (IPA_EE_REG_BASE_OFFS + 0x00001110)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_RMSK                                                      0xffff
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_ATTR                                                         0x1
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_IN          \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_ADDR, HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_RMSK)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_INM(m)      \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_ADDR, m)
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_MODEM_BEARER_CONFIG_SIZE_F_BMSK                           0xffff
#define HWIO_IPA_MODEM_BEARER_CONFIG_VALUES_1_MODEM_BEARER_CONFIG_SIZE_F_SHFT                              0x0

#define HWIO_IPA_SECURED_PIPES_n_ADDR(n)                                                            (IPA_EE_REG_BASE      + 0x00001120 + 0x4 * (n))
#define HWIO_IPA_SECURED_PIPES_n_PHYS(n)                                                            (IPA_EE_REG_BASE_PHYS + 0x00001120 + 0x4 * (n))
#define HWIO_IPA_SECURED_PIPES_n_OFFS(n)                                                            (IPA_EE_REG_BASE_OFFS + 0x00001120 + 0x4 * (n))
#define HWIO_IPA_SECURED_PIPES_n_RMSK                                                               0xffffffff
#define HWIO_IPA_SECURED_PIPES_n_MAXn                                                                        1
#define HWIO_IPA_SECURED_PIPES_n_ATTR                                                                      0x3
#define HWIO_IPA_SECURED_PIPES_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SECURED_PIPES_n_ADDR(n), HWIO_IPA_SECURED_PIPES_n_RMSK)
#define HWIO_IPA_SECURED_PIPES_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SECURED_PIPES_n_ADDR(n), mask)
#define HWIO_IPA_SECURED_PIPES_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SECURED_PIPES_n_ADDR(n),val)
#define HWIO_IPA_SECURED_PIPES_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SECURED_PIPES_n_ADDR(n),mask,val,HWIO_IPA_SECURED_PIPES_n_INI(n))
#define HWIO_IPA_SECURED_PIPES_n_ENDPOINTS_BMSK                                                     0xffffffff
#define HWIO_IPA_SECURED_PIPES_n_ENDPOINTS_SHFT                                                            0x0

#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_ADDR                                                  (IPA_EE_REG_BASE      + 0x00001140)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_PHYS                                                  (IPA_EE_REG_BASE_PHYS + 0x00001140)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_OFFS                                                  (IPA_EE_REG_BASE_OFFS + 0x00001140)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_RMSK                                                         0x3
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_ATTR                                                         0x3
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_IN          \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_ADDR, HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_RMSK)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_ADDR, m)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_OUT(v)      \
        out_dword(HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_ADDR,v)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_ADDR,m,v,HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_IN)
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_BEARER_CONTEXT_INDEX_SEL_BMSK                                0x3
#define HWIO_IPA_MODEM_BEARER_INIT_VALUES_CFG_BEARER_CONTEXT_INDEX_SEL_SHFT                                0x0

#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_ADDR                                                   (IPA_EE_REG_BASE      + 0x00001200)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_PHYS                                                   (IPA_EE_REG_BASE_PHYS + 0x00001200)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_OFFS                                                   (IPA_EE_REG_BASE_OFFS + 0x00001200)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_RMSK                                                          0x1
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_ATTR                                                          0x3
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_IN          \
        in_dword_masked(HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_ADDR, HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_RMSK)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_ADDR, m)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_OUT(v)      \
        out_dword(HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_ADDR,v)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_ADDR,m,v,HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_IN)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_UC_ENABLE_BMSK                                                0x1
#define HWIO_IPA_UC_REGS_INSIDE_IPA__CONTROL_UC_ENABLE_SHFT                                                0x0

#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_ADDR                                                       (IPA_EE_REG_BASE      + 0x00001204)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_PHYS                                                       (IPA_EE_REG_BASE_PHYS + 0x00001204)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_OFFS                                                       (IPA_EE_REG_BASE_OFFS + 0x00001204)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_RMSK                                                              0x1
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_ATTR                                                              0x2
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_OUT(v)      \
        out_dword(HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_ADDR,v)
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_PULSE_BMSK                                                        0x1
#define HWIO_IPA_UC_REGS_INSIDE_IPA__NMI_PULSE_SHFT                                                        0x0

#define HWIO_IPA_DRBIP_CFG_ADDR                                                                     (IPA_EE_REG_BASE      + 0x00001400)
#define HWIO_IPA_DRBIP_CFG_PHYS                                                                     (IPA_EE_REG_BASE_PHYS + 0x00001400)
#define HWIO_IPA_DRBIP_CFG_OFFS                                                                     (IPA_EE_REG_BASE_OFFS + 0x00001400)
#define HWIO_IPA_DRBIP_CFG_RMSK                                                                            0x1
#define HWIO_IPA_DRBIP_CFG_ATTR                                                                            0x3
#define HWIO_IPA_DRBIP_CFG_IN          \
        in_dword_masked(HWIO_IPA_DRBIP_CFG_ADDR, HWIO_IPA_DRBIP_CFG_RMSK)
#define HWIO_IPA_DRBIP_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_DRBIP_CFG_ADDR, m)
#define HWIO_IPA_DRBIP_CFG_OUT(v)      \
        out_dword(HWIO_IPA_DRBIP_CFG_ADDR,v)
#define HWIO_IPA_DRBIP_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DRBIP_CFG_ADDR,m,v,HWIO_IPA_DRBIP_CFG_IN)
#define HWIO_IPA_DRBIP_CFG_OPERATION_MODE_BMSK                                                             0x1
#define HWIO_IPA_DRBIP_CFG_OPERATION_MODE_SHFT                                                             0x0

#define HWIO_IPA_SET_UC_IRQ_EE_n_ADDR(n)                                                            (IPA_EE_REG_BASE      + 0x000020e0 + 0x4 * (n))
#define HWIO_IPA_SET_UC_IRQ_EE_n_PHYS(n)                                                            (IPA_EE_REG_BASE_PHYS + 0x000020e0 + 0x4 * (n))
#define HWIO_IPA_SET_UC_IRQ_EE_n_OFFS(n)                                                            (IPA_EE_REG_BASE_OFFS + 0x000020e0 + 0x4 * (n))
#define HWIO_IPA_SET_UC_IRQ_EE_n_RMSK                                                                      0xf
#define HWIO_IPA_SET_UC_IRQ_EE_n_MAXn                                                                        3
#define HWIO_IPA_SET_UC_IRQ_EE_n_ATTR                                                                      0x2
#define HWIO_IPA_SET_UC_IRQ_EE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SET_UC_IRQ_EE_n_ADDR(n),val)
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_3_BMSK                                                         0x8
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_3_SHFT                                                         0x3
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_2_BMSK                                                         0x4
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_2_SHFT                                                         0x2
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_1_BMSK                                                         0x2
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_1_SHFT                                                         0x1
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_0_BMSK                                                         0x1
#define HWIO_IPA_SET_UC_IRQ_EE_n_SET_UC_IRQ_0_SHFT                                                         0x0

#define HWIO_IPA_SET_UC_IRQ_ALL_EES_ADDR                                                            (IPA_EE_REG_BASE      + 0x000020f0)
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_PHYS                                                            (IPA_EE_REG_BASE_PHYS + 0x000020f0)
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_OFFS                                                            (IPA_EE_REG_BASE_OFFS + 0x000020f0)
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_RMSK                                                                   0xf
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_ATTR                                                                   0x2
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_OUT(v)      \
        out_dword(HWIO_IPA_SET_UC_IRQ_ALL_EES_ADDR,v)
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_3_BMSK                                                      0x8
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_3_SHFT                                                      0x3
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_2_BMSK                                                      0x4
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_2_SHFT                                                      0x2
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_1_BMSK                                                      0x2
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_1_SHFT                                                      0x1
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_0_BMSK                                                      0x1
#define HWIO_IPA_SET_UC_IRQ_ALL_EES_SET_UC_IRQ_0_SHFT                                                      0x0

#define HWIO_IPA_UCP_RESUME_ADDR                                                                    (IPA_EE_REG_BASE      + 0x000030e0)
#define HWIO_IPA_UCP_RESUME_PHYS                                                                    (IPA_EE_REG_BASE_PHYS + 0x000030e0)
#define HWIO_IPA_UCP_RESUME_OFFS                                                                    (IPA_EE_REG_BASE_OFFS + 0x000030e0)
#define HWIO_IPA_UCP_RESUME_RMSK                                                                      0x19ff36
#define HWIO_IPA_UCP_RESUME_ATTR                                                                           0x2
#define HWIO_IPA_UCP_RESUME_OUT(v)      \
        out_dword(HWIO_IPA_UCP_RESUME_ADDR,v)
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_METADATA_OVERRIDE_BMSK                                     0x100000
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_METADATA_OVERRIDE_SHFT                                         0x14
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_NEXT_PKT_PARSER_DIS_BMSK                                    0x80000
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_NEXT_PKT_PARSER_DIS_SHFT                                       0x13
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_EXCEPTION_BMSK                                              0x10000
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_EXCEPTION_SHFT                                                 0x10
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_DEST_PIPE_VALUE_BMSK                                         0xff00
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_DEST_PIPE_VALUE_SHFT                                            0x8
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_TPORT_CHECKSUM_FIX_EN_BMSK                                     0x20
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_TPORT_CHECKSUM_FIX_EN_SHFT                                      0x5
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_IP_CHECKSUM_FIX_EN_BMSK                                        0x10
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_IP_CHECKSUM_FIX_EN_SHFT                                         0x4
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_DEST_PIPE_OVERRIDE_BMSK                                         0x4
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_DEST_PIPE_OVERRIDE_SHFT                                         0x2
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_NEXT_ROUND_EN_BMSK                                              0x2
#define HWIO_IPA_UCP_RESUME_IPA_UCP_RESUME_NEXT_ROUND_EN_SHFT                                              0x1

#define HWIO_IPA_UCP_RESUME_METADATA_ADDR                                                           (IPA_EE_REG_BASE      + 0x000030e4)
#define HWIO_IPA_UCP_RESUME_METADATA_PHYS                                                           (IPA_EE_REG_BASE_PHYS + 0x000030e4)
#define HWIO_IPA_UCP_RESUME_METADATA_OFFS                                                           (IPA_EE_REG_BASE_OFFS + 0x000030e4)
#define HWIO_IPA_UCP_RESUME_METADATA_RMSK                                                           0xffffffff
#define HWIO_IPA_UCP_RESUME_METADATA_ATTR                                                                  0x3
#define HWIO_IPA_UCP_RESUME_METADATA_IN          \
        in_dword_masked(HWIO_IPA_UCP_RESUME_METADATA_ADDR, HWIO_IPA_UCP_RESUME_METADATA_RMSK)
#define HWIO_IPA_UCP_RESUME_METADATA_INM(m)      \
        in_dword_masked(HWIO_IPA_UCP_RESUME_METADATA_ADDR, m)
#define HWIO_IPA_UCP_RESUME_METADATA_OUT(v)      \
        out_dword(HWIO_IPA_UCP_RESUME_METADATA_ADDR,v)
#define HWIO_IPA_UCP_RESUME_METADATA_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UCP_RESUME_METADATA_ADDR,m,v,HWIO_IPA_UCP_RESUME_METADATA_IN)
#define HWIO_IPA_UCP_RESUME_METADATA_METADATA_BMSK                                                  0xffffffff
#define HWIO_IPA_UCP_RESUME_METADATA_METADATA_SHFT                                                         0x0

#define HWIO_IPA_PROC_UCP_CFG_ADDR                                                                  (IPA_EE_REG_BASE      + 0x000030e8)
#define HWIO_IPA_PROC_UCP_CFG_PHYS                                                                  (IPA_EE_REG_BASE_PHYS + 0x000030e8)
#define HWIO_IPA_PROC_UCP_CFG_OFFS                                                                  (IPA_EE_REG_BASE_OFFS + 0x000030e8)
#define HWIO_IPA_PROC_UCP_CFG_RMSK                                                                         0x1
#define HWIO_IPA_PROC_UCP_CFG_ATTR                                                                         0x3
#define HWIO_IPA_PROC_UCP_CFG_IN          \
        in_dword_masked(HWIO_IPA_PROC_UCP_CFG_ADDR, HWIO_IPA_PROC_UCP_CFG_RMSK)
#define HWIO_IPA_PROC_UCP_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_PROC_UCP_CFG_ADDR, m)
#define HWIO_IPA_PROC_UCP_CFG_OUT(v)      \
        out_dword(HWIO_IPA_PROC_UCP_CFG_ADDR,v)
#define HWIO_IPA_PROC_UCP_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROC_UCP_CFG_ADDR,m,v,HWIO_IPA_PROC_UCP_CFG_IN)
#define HWIO_IPA_PROC_UCP_CFG_IPA_UCP_IRQ_SW_EVENTS_UC_MUX_EN_BMSK                                         0x1
#define HWIO_IPA_PROC_UCP_CFG_IPA_UCP_IRQ_SW_EVENTS_UC_MUX_EN_SHFT                                         0x0

#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_ADDR                                                    (IPA_EE_REG_BASE      + 0x000030ec)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_PHYS                                                    (IPA_EE_REG_BASE_PHYS + 0x000030ec)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_OFFS                                                    (IPA_EE_REG_BASE_OFFS + 0x000030ec)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_RMSK                                                       0x3ffff
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_ATTR                                                           0x3
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_IN          \
        in_dword_masked(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_ADDR, HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_RMSK)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_ADDR, m)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_OUT(v)      \
        out_dword(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_ADDR,v)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_ADDR,m,v,HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_IN)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_IPA_UC_PKT_PROCESS_CONTEXT_BASE_BMSK                       0x3ffff
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_0_IPA_UC_PKT_PROCESS_CONTEXT_BASE_SHFT                           0x0

#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_ADDR                                                    (IPA_EE_REG_BASE      + 0x000030f0)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_PHYS                                                    (IPA_EE_REG_BASE_PHYS + 0x000030f0)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_OFFS                                                    (IPA_EE_REG_BASE_OFFS + 0x000030f0)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_RMSK                                                       0x3ffff
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_ATTR                                                           0x3
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_IN          \
        in_dword_masked(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_ADDR, HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_RMSK)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_ADDR, m)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_OUT(v)      \
        out_dword(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_ADDR,v)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_ADDR,m,v,HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_IN)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_IPA_UC_PKT_PROCESS_PKT_BASE_BMSK                           0x3ffff
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_1_IPA_UC_PKT_PROCESS_PKT_BASE_SHFT                               0x0

#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_ADDR                                                    (IPA_EE_REG_BASE      + 0x000030f4)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_PHYS                                                    (IPA_EE_REG_BASE_PHYS + 0x000030f4)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_OFFS                                                    (IPA_EE_REG_BASE_OFFS + 0x000030f4)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_RMSK                                                       0x3ffff
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_ATTR                                                           0x3
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_IN          \
        in_dword_masked(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_ADDR, HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_RMSK)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_ADDR, m)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_OUT(v)      \
        out_dword(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_ADDR,v)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_ADDR,m,v,HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_IN)
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_IPA_UC_PKT_PROCESS_HDR_BASE_BMSK                           0x3ffff
#define HWIO_IPA_UC_PKT_PROCESS_BASE_ADDR_2_IPA_UC_PKT_PROCESS_HDR_BASE_SHFT                               0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_DEBUG
 *--------------------------------------------------------------------------*/

#define IPA_DEBUG_REG_BASE                                                                   (IPA_0_IPA_WRAPPER_BASE      + 0x00148000)
#define IPA_DEBUG_REG_BASE_PHYS                                                              (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00148000)
#define IPA_DEBUG_REG_BASE_OFFS                                                              0x00148000

#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ADDR                                          (IPA_DEBUG_REG_BASE      + 0x00000000)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_PHYS                                          (IPA_DEBUG_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_OFFS                                          (IPA_DEBUG_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_RMSK                                           0xf3f3f77
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ATTR                                                 0x3
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ADDR, HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_RMSK)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ADDR, m)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ADDR,v)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ADDR,m,v,HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_IN)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_LIST_TYPE_BMSK                           0xc000000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_LIST_TYPE_SHFT                                0x1a
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_HOLD_BMSK                                0x1000000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_HOLD_SHFT                                     0x18
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_LIST_ID_BMSK                              0x3f0000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_LIST_ID_SHFT                                  0x10
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_RSRC_ID_CURR_BMSK                           0x3f00
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_RSRC_ID_CURR_SHFT                              0x8
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_RSRC_GRP_BMSK                                 0x70
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_RSRC_GRP_SHFT                                  0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_RSRC_TYPE_BMSK                                 0x7
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_ALLOC_CFG_ALLOC_RSRC_TYPE_SHFT                                 0x0

#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_ADDR                                           (IPA_DEBUG_REG_BASE      + 0x00000004)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_PHYS                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000004)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_OFFS                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000004)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_RMSK                                              0xff7f7
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_ATTR                                                  0x3
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_ADDR, HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_RMSK)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_ADDR, m)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_ADDR,v)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_ADDR,m,v,HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_IN)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_LIST_TYPE_BMSK                               0xc0000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_LIST_TYPE_SHFT                                  0x12
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_LIST_ID_BMSK                                 0x3f000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_LIST_ID_SHFT                                     0xc
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_RSRC_CNT_BMSK                                  0x7f0
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_RSRC_CNT_SHFT                                    0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_RSRC_TYPE_BMSK                                   0x7
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_SRCH_CFG_SRCH_RSRC_TYPE_SHFT                                   0x0

#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000008)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_RMSK                                              0xff3f77
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_ATTR                                                   0x3
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_ADDR, HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_RMSK)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_ADDR, m)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_ADDR,v)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_ADDR,m,v,HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_IN)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_LIST_TYPE_BMSK                                0xc00000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_LIST_TYPE_SHFT                                    0x16
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_LIST_ID_BMSK                                  0x3f0000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_LIST_ID_SHFT                                      0x10
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_RSRC_ID_BMSK                                    0x3f00
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_RSRC_ID_SHFT                                       0x8
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_RSRC_GRP_BMSK                                     0x70
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_RSRC_GRP_SHFT                                      0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_RSRC_TYPE_BMSK                                     0x7
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_REL_CFG_REL_RSRC_TYPE_SHFT                                     0x0

#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_ADDR                                           (IPA_DEBUG_REG_BASE      + 0x0000000c)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_PHYS                                           (IPA_DEBUG_REG_BASE_PHYS + 0x0000000c)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_OFFS                                           (IPA_DEBUG_REG_BASE_OFFS + 0x0000000c)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RMSK                                               0x3f77
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_ATTR                                                  0x3
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_ADDR, HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RMSK)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_ADDR, m)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_ADDR,v)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_ADDR,m,v,HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_IN)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RSRV_RSRC_AMOUNT_BMSK                              0x3f00
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RSRV_RSRC_AMOUNT_SHFT                                 0x8
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RSRV_RSRC_GRP_BMSK                                   0x70
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RSRV_RSRC_GRP_SHFT                                    0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RSRV_RSRC_TYPE_BMSK                                   0x7
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_RSRV_CFG_RSRV_RSRC_TYPE_SHFT                                   0x0

#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x00000010)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_RMSK                                                       0xf
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_ATTR                                                       0x2
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_ADDR,v)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_RSRV_VALID_BMSK                                            0x8
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_RSRV_VALID_SHFT                                            0x3
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_REL_VALID_BMSK                                             0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_REL_VALID_SHFT                                             0x2
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_SRCH_VALID_BMSK                                            0x2
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_SRCH_VALID_SHFT                                            0x1
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_ALLOC_VALID_BMSK                                           0x1
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_CMD_ALLOC_VALID_SHFT                                           0x0

#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x00000014)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x00000014)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x00000014)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_RMSK                                                0x3f3ff
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ATTR                                                    0x1
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ADDR, HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_RMSK)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ADDR, m)
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_SRCH_RSRC_ID_NEXT_BMSK                              0x3f000
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_SRCH_RSRC_ID_NEXT_SHFT                                  0xc
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ALLOC_RSRC_ID_NEXT_BMSK                               0x3f0
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ALLOC_RSRC_ID_NEXT_SHFT                                 0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_RSRV_READY_BMSK                                         0x8
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_RSRV_READY_SHFT                                         0x3
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_REL_READY_BMSK                                          0x4
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_REL_READY_SHFT                                          0x2
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_SRCH_READY_BMSK                                         0x2
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_SRCH_READY_SHFT                                         0x1
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ALLOC_READY_BMSK                                        0x1
#define HWIO_IPA_RSRC_MNGR_SW_ACCESS_STATUS_ALLOC_READY_SHFT                                        0x0

#define HWIO_IPA_RSRC_MNGR_DB_CFG_ADDR                                                       (IPA_DEBUG_REG_BASE      + 0x00000018)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_PHYS                                                       (IPA_DEBUG_REG_BASE_PHYS + 0x00000018)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_OFFS                                                       (IPA_DEBUG_REG_BASE_OFFS + 0x00000018)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RMSK                                                           0x3f77
#define HWIO_IPA_RSRC_MNGR_DB_CFG_ATTR                                                              0x3
#define HWIO_IPA_RSRC_MNGR_DB_CFG_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_DB_CFG_ADDR, HWIO_IPA_RSRC_MNGR_DB_CFG_RMSK, HWIO_IPA_RSRC_MNGR_DB_CFG_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_DB_CFG_ADDR, m, HWIO_IPA_RSRC_MNGR_DB_CFG_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_MNGR_DB_CFG_ADDR,v, HWIO_IPA_RSRC_MNGR_DB_CFG_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_MNGR_DB_CFG_ADDR,m,v,HWIO_IPA_RSRC_MNGR_DB_CFG_IN)
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RSRC_ID_SEL_BMSK                                               0x3f00
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RSRC_ID_SEL_SHFT                                                  0x8
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RSRC_TYPE_SEL_BMSK                                               0x70
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RSRC_TYPE_SEL_SHFT                                                0x4
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RSRC_GRP_SEL_BMSK                                                 0x7
#define HWIO_IPA_RSRC_MNGR_DB_CFG_RSRC_GRP_SEL_SHFT                                                 0x0

#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x0000001c)
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x0000001c)
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x0000001c)
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RMSK                                                      0x3f3
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_ATTR                                                        0x1
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_ADDR, HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RMSK, HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_ADDR, m, HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RSRC_NEXT_INDEX_BMSK                                      0x3f0
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RSRC_NEXT_INDEX_SHFT                                        0x4
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RSRC_NEXT_VALID_BMSK                                        0x2
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RSRC_NEXT_VALID_SHFT                                        0x1
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RSRC_OCCUPIED_BMSK                                          0x1
#define HWIO_IPA_RSRC_MNGR_DB_RSRC_READ_RSRC_OCCUPIED_SHFT                                          0x0

#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x00000020)
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000020)
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000020)
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RMSK                                                  0x7f7f3f3
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_ATTR                                                        0x1
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_DB_LIST_READ_ADDR, HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RMSK, HWIO_IPA_RSRC_MNGR_DB_LIST_READ_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_DB_LIST_READ_ADDR, m, HWIO_IPA_RSRC_MNGR_DB_LIST_READ_ATTR)
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_ENTRY_CNT_BMSK                              0x7f00000
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_ENTRY_CNT_SHFT                                   0x14
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_HEAD_CNT_BMSK                                 0x7f000
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_HEAD_CNT_SHFT                                     0xc
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_HEAD_RSRC_BMSK                                  0x3f0
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_HEAD_RSRC_SHFT                                    0x4
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_HOLD_BMSK                                         0x2
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_HOLD_SHFT                                         0x1
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_VALID_BMSK                                        0x1
#define HWIO_IPA_RSRC_MNGR_DB_LIST_READ_RSRC_LIST_VALID_SHFT                                        0x0

#define HWIO_IPA_RSRC_MNGR_CONTEXTS_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000024)
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000024)
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000024)
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_RMSK                                                         0xffff
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_ATTR                                                            0x1
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_IN          \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_CONTEXTS_ADDR, HWIO_IPA_RSRC_MNGR_CONTEXTS_RMSK)
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_MNGR_CONTEXTS_ADDR, m)
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_RSRC_OCCUPIED_CONTEXTS_BITMAP_BMSK                           0xffff
#define HWIO_IPA_RSRC_MNGR_CONTEXTS_RSRC_OCCUPIED_CONTEXTS_BITMAP_SHFT                              0x0

#define HWIO_IPA_BRESP_DB_CFG_ADDR                                                           (IPA_DEBUG_REG_BASE      + 0x00000028)
#define HWIO_IPA_BRESP_DB_CFG_PHYS                                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000028)
#define HWIO_IPA_BRESP_DB_CFG_OFFS                                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000028)
#define HWIO_IPA_BRESP_DB_CFG_RMSK                                                                0x7ff
#define HWIO_IPA_BRESP_DB_CFG_ATTR                                                                  0x3
#define HWIO_IPA_BRESP_DB_CFG_IN          \
        in_dword_masked(HWIO_IPA_BRESP_DB_CFG_ADDR, HWIO_IPA_BRESP_DB_CFG_RMSK)
#define HWIO_IPA_BRESP_DB_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_BRESP_DB_CFG_ADDR, m)
#define HWIO_IPA_BRESP_DB_CFG_OUT(v)      \
        out_dword(HWIO_IPA_BRESP_DB_CFG_ADDR,v)
#define HWIO_IPA_BRESP_DB_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_BRESP_DB_CFG_ADDR,m,v,HWIO_IPA_BRESP_DB_CFG_IN)
#define HWIO_IPA_BRESP_DB_CFG_SEL_PIPE_BMSK                                                       0x7f8
#define HWIO_IPA_BRESP_DB_CFG_SEL_PIPE_SHFT                                                         0x3
#define HWIO_IPA_BRESP_DB_CFG_SEL_ENTRY_BMSK                                                        0x7
#define HWIO_IPA_BRESP_DB_CFG_SEL_ENTRY_SHFT                                                        0x0

#define HWIO_IPA_BRESP_DB_DATA_ADDR                                                          (IPA_DEBUG_REG_BASE      + 0x0000002c)
#define HWIO_IPA_BRESP_DB_DATA_PHYS                                                          (IPA_DEBUG_REG_BASE_PHYS + 0x0000002c)
#define HWIO_IPA_BRESP_DB_DATA_OFFS                                                          (IPA_DEBUG_REG_BASE_OFFS + 0x0000002c)
#define HWIO_IPA_BRESP_DB_DATA_RMSK                                                          0xffffffff
#define HWIO_IPA_BRESP_DB_DATA_ATTR                                                                 0x1
#define HWIO_IPA_BRESP_DB_DATA_IN          \
        in_dword_masked(HWIO_IPA_BRESP_DB_DATA_ADDR, HWIO_IPA_BRESP_DB_DATA_RMSK)
#define HWIO_IPA_BRESP_DB_DATA_INM(m)      \
        in_dword_masked(HWIO_IPA_BRESP_DB_DATA_ADDR, m)
#define HWIO_IPA_BRESP_DB_DATA_DATA_BMSK                                                     0xffffffff
#define HWIO_IPA_BRESP_DB_DATA_DATA_SHFT                                                            0x0

#define HWIO_IPA_SNOC_MONITORING_CFG_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x00000030)
#define HWIO_IPA_SNOC_MONITORING_CFG_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x00000030)
#define HWIO_IPA_SNOC_MONITORING_CFG_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x00000030)
#define HWIO_IPA_SNOC_MONITORING_CFG_RMSK                                                           0x1
#define HWIO_IPA_SNOC_MONITORING_CFG_ATTR                                                           0x3
#define HWIO_IPA_SNOC_MONITORING_CFG_IN          \
        in_dword_masked(HWIO_IPA_SNOC_MONITORING_CFG_ADDR, HWIO_IPA_SNOC_MONITORING_CFG_RMSK)
#define HWIO_IPA_SNOC_MONITORING_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_SNOC_MONITORING_CFG_ADDR, m)
#define HWIO_IPA_SNOC_MONITORING_CFG_OUT(v)      \
        out_dword(HWIO_IPA_SNOC_MONITORING_CFG_ADDR,v)
#define HWIO_IPA_SNOC_MONITORING_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SNOC_MONITORING_CFG_ADDR,m,v,HWIO_IPA_SNOC_MONITORING_CFG_IN)
#define HWIO_IPA_SNOC_MONITORING_CFG_ENABLE_BMSK                                                    0x1
#define HWIO_IPA_SNOC_MONITORING_CFG_ENABLE_SHFT                                                    0x0

#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000034)
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000034)
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000034)
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_RMSK                                                  0x1f7df7df
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_ATTR                                                         0x1
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_IN          \
        in_dword_masked(HWIO_IPA_PCIE_SNOC_MONITOR_CNT_ADDR, HWIO_IPA_PCIE_SNOC_MONITOR_CNT_RMSK)
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_INM(m)      \
        in_dword_masked(HWIO_IPA_PCIE_SNOC_MONITOR_CNT_ADDR, m)
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_B_VALUE_BMSK                                          0x1f000000
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_B_VALUE_SHFT                                                0x18
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_W_VALUE_BMSK                                            0x7c0000
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_W_VALUE_SHFT                                                0x12
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_R_VALUE_BMSK                                             0x1f000
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_R_VALUE_SHFT                                                 0xc
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_AW_VALUE_BMSK                                              0x7c0
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_AW_VALUE_SHFT                                                0x6
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_AR_VALUE_BMSK                                               0x1f
#define HWIO_IPA_PCIE_SNOC_MONITOR_CNT_AR_VALUE_SHFT                                                0x0

#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_ADDR                                                   (IPA_DEBUG_REG_BASE      + 0x00000038)
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_PHYS                                                   (IPA_DEBUG_REG_BASE_PHYS + 0x00000038)
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_OFFS                                                   (IPA_DEBUG_REG_BASE_OFFS + 0x00000038)
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_RMSK                                                   0x1f7df7df
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_ATTR                                                          0x1
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_IN          \
        in_dword_masked(HWIO_IPA_DDR_SNOC_MONITOR_CNT_ADDR, HWIO_IPA_DDR_SNOC_MONITOR_CNT_RMSK)
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_INM(m)      \
        in_dword_masked(HWIO_IPA_DDR_SNOC_MONITOR_CNT_ADDR, m)
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_B_VALUE_BMSK                                           0x1f000000
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_B_VALUE_SHFT                                                 0x18
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_W_VALUE_BMSK                                             0x7c0000
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_W_VALUE_SHFT                                                 0x12
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_R_VALUE_BMSK                                              0x1f000
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_R_VALUE_SHFT                                                  0xc
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_AW_VALUE_BMSK                                               0x7c0
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_AW_VALUE_SHFT                                                 0x6
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_AR_VALUE_BMSK                                                0x1f
#define HWIO_IPA_DDR_SNOC_MONITOR_CNT_AR_VALUE_SHFT                                                 0x0

#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_ADDR                                                   (IPA_DEBUG_REG_BASE      + 0x0000003c)
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_PHYS                                                   (IPA_DEBUG_REG_BASE_PHYS + 0x0000003c)
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_OFFS                                                   (IPA_DEBUG_REG_BASE_OFFS + 0x0000003c)
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_RMSK                                                   0x1f7df7df
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_ATTR                                                          0x1
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_IN          \
        in_dword_masked(HWIO_IPA_GSI_SNOC_MONITOR_CNT_ADDR, HWIO_IPA_GSI_SNOC_MONITOR_CNT_RMSK)
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_SNOC_MONITOR_CNT_ADDR, m)
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_B_VALUE_BMSK                                           0x1f000000
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_B_VALUE_SHFT                                                 0x18
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_W_VALUE_BMSK                                             0x7c0000
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_W_VALUE_SHFT                                                 0x12
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_R_VALUE_BMSK                                              0x1f000
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_R_VALUE_SHFT                                                  0xc
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_AW_VALUE_BMSK                                               0x7c0
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_AW_VALUE_SHFT                                                 0x6
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_AR_VALUE_BMSK                                                0x1f
#define HWIO_IPA_GSI_SNOC_MONITOR_CNT_AR_VALUE_SHFT                                                 0x0

#define HWIO_IPA_DEBUG_DATA_ADDR                                                             (IPA_DEBUG_REG_BASE      + 0x00000040)
#define HWIO_IPA_DEBUG_DATA_PHYS                                                             (IPA_DEBUG_REG_BASE_PHYS + 0x00000040)
#define HWIO_IPA_DEBUG_DATA_OFFS                                                             (IPA_DEBUG_REG_BASE_OFFS + 0x00000040)
#define HWIO_IPA_DEBUG_DATA_RMSK                                                             0xffffffff
#define HWIO_IPA_DEBUG_DATA_ATTR                                                                    0x1
#define HWIO_IPA_DEBUG_DATA_IN          \
        in_dword_masked(HWIO_IPA_DEBUG_DATA_ADDR, HWIO_IPA_DEBUG_DATA_RMSK, HWIO_IPA_DEBUG_DATA_ATTR)
#define HWIO_IPA_DEBUG_DATA_INM(m)      \
        in_dword_masked(HWIO_IPA_DEBUG_DATA_ADDR, m, HWIO_IPA_DEBUG_DATA_ATTR)
#define HWIO_IPA_DEBUG_DATA_DEBUG_DATA_BMSK                                                  0xffffffff
#define HWIO_IPA_DEBUG_DATA_DEBUG_DATA_SHFT                                                         0x0

#define HWIO_IPA_TESTBUS_SEL_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x0000004c)
#define HWIO_IPA_TESTBUS_SEL_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000004c)
#define HWIO_IPA_TESTBUS_SEL_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000004c)
#define HWIO_IPA_TESTBUS_SEL_RMSK                                                               0xffff1
#define HWIO_IPA_TESTBUS_SEL_ATTR                                                                   0x3
#define HWIO_IPA_TESTBUS_SEL_IN          \
        in_dword_masked(HWIO_IPA_TESTBUS_SEL_ADDR, HWIO_IPA_TESTBUS_SEL_RMSK, HWIO_IPA_TESTBUS_SEL_ATTR)
#define HWIO_IPA_TESTBUS_SEL_INM(m)      \
        in_dword_masked(HWIO_IPA_TESTBUS_SEL_ADDR, m, HWIO_IPA_TESTBUS_SEL_ATTR)
#define HWIO_IPA_TESTBUS_SEL_OUT(v)      \
        out_dword(HWIO_IPA_TESTBUS_SEL_ADDR,v, HWIO_IPA_TESTBUS_SEL_ATTR)
#define HWIO_IPA_TESTBUS_SEL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TESTBUS_SEL_ADDR,m,v,HWIO_IPA_TESTBUS_SEL_IN)
#define HWIO_IPA_TESTBUS_SEL_INTERNAL_BLOCK_SELECT_BMSK                                         0xff000
#define HWIO_IPA_TESTBUS_SEL_INTERNAL_BLOCK_SELECT_SHFT                                             0xc
#define HWIO_IPA_TESTBUS_SEL_EXTERNAL_BLOCK_SELECT_BMSK                                           0xff0
#define HWIO_IPA_TESTBUS_SEL_EXTERNAL_BLOCK_SELECT_SHFT                                             0x4
#define HWIO_IPA_TESTBUS_SEL_TESTBUS_EN_BMSK                                                        0x1
#define HWIO_IPA_TESTBUS_SEL_TESTBUS_EN_SHFT                                                        0x0

#define HWIO_IPA_STEP_MODE_BREAKPOINTS_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000050)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000050)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000050)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_RMSK                                                  0xffffffff
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_ATTR                                                         0x3
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_BREAKPOINTS_ADDR, HWIO_IPA_STEP_MODE_BREAKPOINTS_RMSK)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_BREAKPOINTS_ADDR, m)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_BREAKPOINTS_ADDR,v)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_BREAKPOINTS_ADDR,m,v,HWIO_IPA_STEP_MODE_BREAKPOINTS_IN)
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_HW_EN_BMSK                                            0xffffffff
#define HWIO_IPA_STEP_MODE_BREAKPOINTS_HW_EN_SHFT                                                   0x0

#define HWIO_IPA_STEP_MODE_STATUS_ADDR                                                       (IPA_DEBUG_REG_BASE      + 0x00000054)
#define HWIO_IPA_STEP_MODE_STATUS_PHYS                                                       (IPA_DEBUG_REG_BASE_PHYS + 0x00000054)
#define HWIO_IPA_STEP_MODE_STATUS_OFFS                                                       (IPA_DEBUG_REG_BASE_OFFS + 0x00000054)
#define HWIO_IPA_STEP_MODE_STATUS_RMSK                                                       0xffffffff
#define HWIO_IPA_STEP_MODE_STATUS_ATTR                                                              0x1
#define HWIO_IPA_STEP_MODE_STATUS_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_STATUS_ADDR, HWIO_IPA_STEP_MODE_STATUS_RMSK)
#define HWIO_IPA_STEP_MODE_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_STATUS_ADDR, m)
#define HWIO_IPA_STEP_MODE_STATUS_HW_EN_BMSK                                                 0xffffffff
#define HWIO_IPA_STEP_MODE_STATUS_HW_EN_SHFT                                                        0x0

#define HWIO_IPA_STEP_MODE_GO_ADDR                                                           (IPA_DEBUG_REG_BASE      + 0x00000058)
#define HWIO_IPA_STEP_MODE_GO_PHYS                                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000058)
#define HWIO_IPA_STEP_MODE_GO_OFFS                                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000058)
#define HWIO_IPA_STEP_MODE_GO_RMSK                                                           0xffffffff
#define HWIO_IPA_STEP_MODE_GO_ATTR                                                                  0x2
#define HWIO_IPA_STEP_MODE_GO_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_GO_ADDR,v)
#define HWIO_IPA_STEP_MODE_GO_HW_EN_BMSK                                                     0xffffffff
#define HWIO_IPA_STEP_MODE_GO_HW_EN_SHFT                                                            0x0

#define HWIO_IPA_HW_EVENTS_CFG_ADDR                                                          (IPA_DEBUG_REG_BASE      + 0x0000005c)
#define HWIO_IPA_HW_EVENTS_CFG_PHYS                                                          (IPA_DEBUG_REG_BASE_PHYS + 0x0000005c)
#define HWIO_IPA_HW_EVENTS_CFG_OFFS                                                          (IPA_DEBUG_REG_BASE_OFFS + 0x0000005c)
#define HWIO_IPA_HW_EVENTS_CFG_RMSK                                                               0xfff
#define HWIO_IPA_HW_EVENTS_CFG_ATTR                                                                 0x3
#define HWIO_IPA_HW_EVENTS_CFG_IN          \
        in_dword_masked(HWIO_IPA_HW_EVENTS_CFG_ADDR, HWIO_IPA_HW_EVENTS_CFG_RMSK)
#define HWIO_IPA_HW_EVENTS_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_HW_EVENTS_CFG_ADDR, m)
#define HWIO_IPA_HW_EVENTS_CFG_OUT(v)      \
        out_dword(HWIO_IPA_HW_EVENTS_CFG_ADDR,v)
#define HWIO_IPA_HW_EVENTS_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_HW_EVENTS_CFG_ADDR,m,v,HWIO_IPA_HW_EVENTS_CFG_IN)
#define HWIO_IPA_HW_EVENTS_CFG_RX_EVENTS_PIPE_SELECT_BMSK                                         0xff0
#define HWIO_IPA_HW_EVENTS_CFG_RX_EVENTS_PIPE_SELECT_SHFT                                           0x4
#define HWIO_IPA_HW_EVENTS_CFG_HW_EVENTS_SELECT_BMSK                                                0xf
#define HWIO_IPA_HW_EVENTS_CFG_HW_EVENTS_SELECT_SHFT                                                0x0

#define HWIO_IPA_LOG_ADDR                                                                    (IPA_DEBUG_REG_BASE      + 0x00000060)
#define HWIO_IPA_LOG_PHYS                                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x00000060)
#define HWIO_IPA_LOG_OFFS                                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x00000060)
#define HWIO_IPA_LOG_RMSK                                                                      0x3ffff2
#define HWIO_IPA_LOG_ATTR                                                                           0x3
#define HWIO_IPA_LOG_IN          \
        in_dword_masked(HWIO_IPA_LOG_ADDR, HWIO_IPA_LOG_RMSK)
#define HWIO_IPA_LOG_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_ADDR, m)
#define HWIO_IPA_LOG_OUT(v)      \
        out_dword(HWIO_IPA_LOG_ADDR,v)
#define HWIO_IPA_LOG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_ADDR,m,v,HWIO_IPA_LOG_IN)
#define HWIO_IPA_LOG_LOG_DPL_L2_REMOVE_EN_BMSK                                                 0x200000
#define HWIO_IPA_LOG_LOG_DPL_L2_REMOVE_EN_SHFT                                                     0x15
#define HWIO_IPA_LOG_LOG_REDUCTION_EN_BMSK                                                     0x100000
#define HWIO_IPA_LOG_LOG_REDUCTION_EN_SHFT                                                         0x14
#define HWIO_IPA_LOG_LOG_LENGTH_BMSK                                                            0xff000
#define HWIO_IPA_LOG_LOG_LENGTH_SHFT                                                                0xc
#define HWIO_IPA_LOG_LOG_PIPE_BMSK                                                                0xff0
#define HWIO_IPA_LOG_LOG_PIPE_SHFT                                                                  0x4
#define HWIO_IPA_LOG_LOG_EN_BMSK                                                                    0x2
#define HWIO_IPA_LOG_LOG_EN_SHFT                                                                    0x1

#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x00000064)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x00000064)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x00000064)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_RMSK                                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_ATTR                                                           0x3
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_ADDR_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_CMD_ADDR_IN)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_START_ADDR_BMSK                                         0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_START_ADDR_SHFT                                                0x0

#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x00000068)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x00000068)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x00000068)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_RMSK                                                0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_ATTR                                                       0x3
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_IN)
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_START_ADDR_BMSK                                     0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_ADDR_MSB_START_ADDR_SHFT                                            0x0

#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x0000006c)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x0000006c)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x0000006c)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_RMSK                                               0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_ATTR                                                      0x1
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_WRITR_ADDR_BMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_WRITR_ADDR_SHFT                                           0x0

#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_ADDR                                           (IPA_DEBUG_REG_BASE      + 0x00000070)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_PHYS                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000070)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_OFFS                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000070)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_RMSK                                           0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_ATTR                                                  0x1
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_WRITR_ADDR_BMSK                                0xffffffff
#define HWIO_IPA_LOG_BUF_HW_CMD_WRITE_PTR_MSB_WRITR_ADDR_SHFT                                       0x0

#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000074)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000074)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000074)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_RMSK                                                        0x7ffff
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_ATTR                                                            0x3
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_CFG_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_CFG_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_CFG_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_CMD_CFG_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_CMD_CFG_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_CMD_CFG_IN)
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_TPDM_ENABLE_BMSK                                            0x40000
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_TPDM_ENABLE_SHFT                                               0x12
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_SKIP_DDR_DMA_BMSK                                           0x20000
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_SKIP_DDR_DMA_SHFT                                              0x11
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_ENABLE_BMSK                                                 0x10000
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_ENABLE_SHFT                                                    0x10
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_SIZE_BMSK                                                    0xffff
#define HWIO_IPA_LOG_BUF_HW_CMD_CFG_SIZE_SHFT                                                       0x0

#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x00000078)
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000078)
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000078)
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_RMSK                                                 0xffff3fff
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_ATTR                                                        0x1
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_SKIP_DDR_WRAP_HAPPENED_BMSK                          0x80000000
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_SKIP_DDR_WRAP_HAPPENED_SHFT                                0x1f
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_FULL_BMSK                                            0x40000000
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_FULL_SHFT                                                  0x1e
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_WRITE_PTR_BMSK                                       0x3fff0000
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_WRITE_PTR_SHFT                                             0x10
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_READ_PTR_BMSK                                            0x3fff
#define HWIO_IPA_LOG_BUF_HW_CMD_RAM_PTR_READ_PTR_SHFT                                               0x0

#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_ADDR                                          (IPA_DEBUG_REG_BASE      + 0x00000080)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_PHYS                                          (IPA_DEBUG_REG_BASE_PHYS + 0x00000080)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_OFFS                                          (IPA_DEBUG_REG_BASE_OFFS + 0x00000080)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_RMSK                                               0x3ff
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_ATTR                                                 0x3
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_ADDR, HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_RMSK)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_IN)
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_UC_RESP_EN_BMSK                                    0x200
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_UC_RESP_EN_SHFT                                      0x9
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_GSI_RESP_EN_BMSK                                   0x100
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_GSI_RESP_EN_SHFT                                     0x8
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_QMB_RESP_EN_BMSK                                    0x80
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_QMB_RESP_EN_SHFT                                     0x7
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_UC_WR_EN_BMSK                                       0x40
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_UC_WR_EN_SHFT                                        0x6
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_UC_RD_EN_BMSK                                       0x20
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_UC_RD_EN_SHFT                                        0x5
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_GSI_WR_EN_BMSK                                      0x10
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_GSI_WR_EN_SHFT                                       0x4
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_GSI_RD_EN_BMSK                                       0x8
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_GSI_RD_EN_SHFT                                       0x3
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_QMB_WR_EN_BMSK                                       0x4
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_QMB_WR_EN_SHFT                                       0x2
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_QMB_RD_EN_BMSK                                       0x2
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_QMB_RD_EN_SHFT                                       0x1
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_NOC_PORT_SEL_BMSK                                    0x1
#define HWIO_IPA_LOG_BUF_HW_CMD_NOC_MASTER_SEL_NOC_PORT_SEL_SHFT                                    0x0

#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000084)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000084)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000084)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_RMSK                                            0xffffffff
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ATTR                                                   0x3
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR, HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_RMSK)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR, m)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR,v)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR,m,v,HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_IN)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR_LSB_BMSK                                   0xffffffff
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_LSB_ADDR_LSB_SHFT                                          0x0

#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000088)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000088)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000088)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_RMSK                                            0xffffffff
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ATTR                                                   0x3
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR, HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_RMSK)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR, m)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR,v)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR,m,v,HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_IN)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR_MSB_BMSK                                   0xffffffff
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_MSB_ADDR_MSB_SHFT                                          0x0

#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_ADDR                                         (IPA_DEBUG_REG_BASE      + 0x0000008c)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_PHYS                                         (IPA_DEBUG_REG_BASE_PHYS + 0x0000008c)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_OFFS                                         (IPA_DEBUG_REG_BASE_OFFS + 0x0000008c)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_RMSK                                           0x7fffff
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_ATTR                                                0x1
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_ADDR, HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_RMSK)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_ADDR, m)
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_TYPE_F_BMSK                                    0x400000
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_TYPE_F_SHFT                                        0x16
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_OPCODE_F_BMSK                                  0x300000
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_OPCODE_F_SHFT                                      0x14
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_SRC_PIPE_F_BMSK                                 0xff000
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_SRC_PIPE_F_SHFT                                     0xc
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_SRC_ID_F_BMSK                                     0xff0
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_SRC_ID_F_SHFT                                       0x4
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_CTX_ID_F_BMSK                                       0xf
#define HWIO_IPA_STEP_MODE_HFETCHER_ADDR_RESULT_CTX_ID_F_SHFT                                       0x0

#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x00000090)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_RMSK                                              0x1fffffff
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ATTR                                                     0x3
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ADDR, HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_RMSK)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ADDR, m)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ADDR,v)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ADDR,m,v,HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_IN)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ACL_ID_F_BMSK                                     0x1f800000
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_ACL_ID_F_SHFT                                           0x17
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_TYPE_F_BMSK                                         0x400000
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_TYPE_F_SHFT                                             0x16
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_OPCODE_F_BMSK                                       0x300000
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_OPCODE_F_SHFT                                           0x14
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_SRC_PIPE_F_BMSK                                      0xff000
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_SRC_PIPE_F_SHFT                                          0xc
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_SRC_ID_F_BMSK                                          0xff0
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_SRC_ID_F_SHFT                                            0x4
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_CTX_ID_F_BMSK                                            0xf
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_CTX_ID_F_SHFT                                            0x0

#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000094)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000094)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000094)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_RMSK                                                  0x3f
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ATTR                                                   0x3
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ADDR, HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_RMSK)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ADDR, m)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ADDR,v)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ADDR,m,v,HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_IN)
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ACL_ID_V_BMSK                                         0x20
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_ACL_ID_V_SHFT                                          0x5
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_TYPE_V_BMSK                                           0x10
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_TYPE_V_SHFT                                            0x4
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_OPCODE_V_BMSK                                          0x8
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_OPCODE_V_SHFT                                          0x3
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_SRC_PIPE_V_BMSK                                        0x4
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_SRC_PIPE_V_SHFT                                        0x2
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_SRC_ID_V_BMSK                                          0x2
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_SRC_ID_V_SHFT                                          0x1
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_CTX_ID_V_BMSK                                          0x1
#define HWIO_IPA_STEP_MODE_HSEQ_BREAKPOINT_1_CTX_ID_V_SHFT                                          0x0

#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000098)
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000098)
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000098)
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_RMSK                                                  0x1fffffff
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_ATTR                                                         0x1
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_HSEQ_STATUS_ADDR, HWIO_IPA_STEP_MODE_HSEQ_STATUS_RMSK)
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_HSEQ_STATUS_ADDR, m)
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_ACL_ID_F_BMSK                                         0x1f800000
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_ACL_ID_F_SHFT                                               0x17
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_TYPE_F_BMSK                                             0x400000
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_TYPE_F_SHFT                                                 0x16
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_OPCODE_F_BMSK                                           0x300000
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_OPCODE_F_SHFT                                               0x14
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_SRC_PIPE_F_BMSK                                          0xff000
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_SRC_PIPE_F_SHFT                                              0xc
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_SRC_ID_F_BMSK                                              0xff0
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_SRC_ID_F_SHFT                                                0x4
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_CTX_ID_F_BMSK                                                0xf
#define HWIO_IPA_STEP_MODE_HSEQ_STATUS_CTX_ID_F_SHFT                                                0x0

#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x0000009c)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x0000009c)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x0000009c)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_RMSK                                              0x1fffffff
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ATTR                                                     0x3
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ADDR, HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_RMSK)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ADDR, m)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ADDR,v)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ADDR,m,v,HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_IN)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ACL_ID_F_BMSK                                     0x1f800000
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_ACL_ID_F_SHFT                                           0x17
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_TYPE_F_BMSK                                         0x400000
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_TYPE_F_SHFT                                             0x16
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_OPCODE_F_BMSK                                       0x300000
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_OPCODE_F_SHFT                                           0x14
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_SRC_PIPE_F_BMSK                                      0xff000
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_SRC_PIPE_F_SHFT                                          0xc
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_SRC_ID_F_BMSK                                          0xff0
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_SRC_ID_F_SHFT                                            0x4
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_CTX_ID_F_BMSK                                            0xf
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_CTX_ID_F_SHFT                                            0x0

#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000100)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000100)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000100)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_RMSK                                                  0x3f
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ATTR                                                   0x3
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ADDR, HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_RMSK)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ADDR, m)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_OUT(v)      \
        out_dword(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ADDR,v)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ADDR,m,v,HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_IN)
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ACL_ID_V_BMSK                                         0x20
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_ACL_ID_V_SHFT                                          0x5
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_TYPE_V_BMSK                                           0x10
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_TYPE_V_SHFT                                            0x4
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_OPCODE_V_BMSK                                          0x8
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_OPCODE_V_SHFT                                          0x3
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_SRC_PIPE_V_BMSK                                        0x4
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_SRC_PIPE_V_SHFT                                        0x2
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_SRC_ID_V_BMSK                                          0x2
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_SRC_ID_V_SHFT                                          0x1
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_CTX_ID_V_BMSK                                          0x1
#define HWIO_IPA_STEP_MODE_DSEQ_BREAKPOINT_1_CTX_ID_V_SHFT                                          0x0

#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000104)
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000104)
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000104)
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_RMSK                                                  0x1fffffff
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_ATTR                                                         0x1
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_STEP_MODE_DSEQ_STATUS_ADDR, HWIO_IPA_STEP_MODE_DSEQ_STATUS_RMSK)
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_STEP_MODE_DSEQ_STATUS_ADDR, m)
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_ACL_ID_F_BMSK                                         0x1f800000
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_ACL_ID_F_SHFT                                               0x17
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_TYPE_F_BMSK                                             0x400000
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_TYPE_F_SHFT                                                 0x16
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_OPCODE_F_BMSK                                           0x300000
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_OPCODE_F_SHFT                                               0x14
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_SRC_PIPE_F_BMSK                                          0xff000
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_SRC_PIPE_F_SHFT                                              0xc
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_SRC_ID_F_BMSK                                              0xff0
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_SRC_ID_F_SHFT                                                0x4
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_CTX_ID_F_BMSK                                                0xf
#define HWIO_IPA_STEP_MODE_DSEQ_STATUS_CTX_ID_F_SHFT                                                0x0

#define HWIO_IPA_RX_ACKQ_CMD_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x00000158)
#define HWIO_IPA_RX_ACKQ_CMD_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000158)
#define HWIO_IPA_RX_ACKQ_CMD_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000158)
#define HWIO_IPA_RX_ACKQ_CMD_RMSK                                                                   0xf
#define HWIO_IPA_RX_ACKQ_CMD_ATTR                                                                   0x2
#define HWIO_IPA_RX_ACKQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_RX_ACKQ_CMD_ADDR,v)
#define HWIO_IPA_RX_ACKQ_CMD_RELEASE_WR_CMD_BMSK                                                    0x8
#define HWIO_IPA_RX_ACKQ_CMD_RELEASE_WR_CMD_SHFT                                                    0x3
#define HWIO_IPA_RX_ACKQ_CMD_RELEASE_RD_CMD_BMSK                                                    0x4
#define HWIO_IPA_RX_ACKQ_CMD_RELEASE_RD_CMD_SHFT                                                    0x2
#define HWIO_IPA_RX_ACKQ_CMD_POP_CMD_BMSK                                                           0x2
#define HWIO_IPA_RX_ACKQ_CMD_POP_CMD_SHFT                                                           0x1
#define HWIO_IPA_RX_ACKQ_CMD_WRITE_CMD_BMSK                                                         0x1
#define HWIO_IPA_RX_ACKQ_CMD_WRITE_CMD_SHFT                                                         0x0

#define HWIO_IPA_RX_ACKQ_CFG_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x0000015c)
#define HWIO_IPA_RX_ACKQ_CFG_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000015c)
#define HWIO_IPA_RX_ACKQ_CFG_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000015c)
#define HWIO_IPA_RX_ACKQ_CFG_RMSK                                                                   0x3
#define HWIO_IPA_RX_ACKQ_CFG_ATTR                                                                   0x3
#define HWIO_IPA_RX_ACKQ_CFG_IN          \
        in_dword_masked(HWIO_IPA_RX_ACKQ_CFG_ADDR, HWIO_IPA_RX_ACKQ_CFG_RMSK)
#define HWIO_IPA_RX_ACKQ_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_ACKQ_CFG_ADDR, m)
#define HWIO_IPA_RX_ACKQ_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RX_ACKQ_CFG_ADDR,v)
#define HWIO_IPA_RX_ACKQ_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_ACKQ_CFG_ADDR,m,v,HWIO_IPA_RX_ACKQ_CFG_IN)
#define HWIO_IPA_RX_ACKQ_CFG_BLOCK_WR_BMSK                                                          0x2
#define HWIO_IPA_RX_ACKQ_CFG_BLOCK_WR_SHFT                                                          0x1
#define HWIO_IPA_RX_ACKQ_CFG_BLOCK_RD_REQ_BMSK                                                      0x1
#define HWIO_IPA_RX_ACKQ_CFG_BLOCK_RD_REQ_SHFT                                                      0x0

#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000160)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000160)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000160)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_RMSK                                                       0x1ffffff
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ATTR                                                             0x3
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_RX_ACKQ_DATA_WR_0_ADDR, HWIO_IPA_RX_ACKQ_DATA_WR_0_RMSK)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_ACKQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_RX_ACKQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_ACKQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_RX_ACKQ_DATA_WR_0_IN)
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ACK_VALUE1_TYPE_BMSK                                       0x1000000
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ACK_VALUE1_TYPE_SHFT                                            0x18
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ACK_VALUE2_BMSK                                             0xff0000
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ACK_VALUE2_SHFT                                                 0x10
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ACK_VALUE1_BMSK                                               0xffff
#define HWIO_IPA_RX_ACKQ_DATA_WR_0_ACK_VALUE1_SHFT                                                  0x0

#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000164)
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000164)
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000164)
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_RMSK                                                       0x1ffffff
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ATTR                                                             0x1
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_RX_ACKQ_DATA_RD_0_ADDR, HWIO_IPA_RX_ACKQ_DATA_RD_0_RMSK)
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_ACKQ_DATA_RD_0_ADDR, m)
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ACK_VALUE1_TYPE_BMSK                                       0x1000000
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ACK_VALUE1_TYPE_SHFT                                            0x18
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ACK_VALUE2_BMSK                                             0xff0000
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ACK_VALUE2_SHFT                                                 0x10
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ACK_VALUE1_BMSK                                               0xffff
#define HWIO_IPA_RX_ACKQ_DATA_RD_0_ACK_VALUE1_SHFT                                                  0x0

#define HWIO_IPA_RX_ACKQ_STATUS_ADDR                                                         (IPA_DEBUG_REG_BASE      + 0x00000168)
#define HWIO_IPA_RX_ACKQ_STATUS_PHYS                                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000168)
#define HWIO_IPA_RX_ACKQ_STATUS_OFFS                                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000168)
#define HWIO_IPA_RX_ACKQ_STATUS_RMSK                                                             0x1ff7
#define HWIO_IPA_RX_ACKQ_STATUS_ATTR                                                                0x1
#define HWIO_IPA_RX_ACKQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_RX_ACKQ_STATUS_ADDR, HWIO_IPA_RX_ACKQ_STATUS_RMSK)
#define HWIO_IPA_RX_ACKQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_ACKQ_STATUS_ADDR, m)
#define HWIO_IPA_RX_ACKQ_STATUS_BLOCK_RD_ACK_BMSK                                                0x1000
#define HWIO_IPA_RX_ACKQ_STATUS_BLOCK_RD_ACK_SHFT                                                   0xc
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_DEPTH_BMSK                                                   0xf00
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_DEPTH_SHFT                                                     0x8
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_COUNT_BMSK                                                    0xf0
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_COUNT_SHFT                                                     0x4
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_FULL_BMSK                                                      0x4
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_FULL_SHFT                                                      0x2
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_EMPTY_BMSK                                                     0x2
#define HWIO_IPA_RX_ACKQ_STATUS_ACKQ_EMPTY_SHFT                                                     0x1
#define HWIO_IPA_RX_ACKQ_STATUS_STATUS_BMSK                                                         0x1
#define HWIO_IPA_RX_ACKQ_STATUS_STATUS_SHFT                                                         0x0

#define HWIO_IPA_UC_ACKQ_CMD_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x0000016c)
#define HWIO_IPA_UC_ACKQ_CMD_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000016c)
#define HWIO_IPA_UC_ACKQ_CMD_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000016c)
#define HWIO_IPA_UC_ACKQ_CMD_RMSK                                                                   0xf
#define HWIO_IPA_UC_ACKQ_CMD_ATTR                                                                   0x2
#define HWIO_IPA_UC_ACKQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_UC_ACKQ_CMD_ADDR,v)
#define HWIO_IPA_UC_ACKQ_CMD_RELEASE_WR_CMD_BMSK                                                    0x8
#define HWIO_IPA_UC_ACKQ_CMD_RELEASE_WR_CMD_SHFT                                                    0x3
#define HWIO_IPA_UC_ACKQ_CMD_RELEASE_RD_CMD_BMSK                                                    0x4
#define HWIO_IPA_UC_ACKQ_CMD_RELEASE_RD_CMD_SHFT                                                    0x2
#define HWIO_IPA_UC_ACKQ_CMD_POP_CMD_BMSK                                                           0x2
#define HWIO_IPA_UC_ACKQ_CMD_POP_CMD_SHFT                                                           0x1
#define HWIO_IPA_UC_ACKQ_CMD_WRITE_CMD_BMSK                                                         0x1
#define HWIO_IPA_UC_ACKQ_CMD_WRITE_CMD_SHFT                                                         0x0

#define HWIO_IPA_UC_ACKQ_CFG_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x00000170)
#define HWIO_IPA_UC_ACKQ_CFG_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000170)
#define HWIO_IPA_UC_ACKQ_CFG_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000170)
#define HWIO_IPA_UC_ACKQ_CFG_RMSK                                                                   0x3
#define HWIO_IPA_UC_ACKQ_CFG_ATTR                                                                   0x3
#define HWIO_IPA_UC_ACKQ_CFG_IN          \
        in_dword_masked(HWIO_IPA_UC_ACKQ_CFG_ADDR, HWIO_IPA_UC_ACKQ_CFG_RMSK)
#define HWIO_IPA_UC_ACKQ_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_ACKQ_CFG_ADDR, m)
#define HWIO_IPA_UC_ACKQ_CFG_OUT(v)      \
        out_dword(HWIO_IPA_UC_ACKQ_CFG_ADDR,v)
#define HWIO_IPA_UC_ACKQ_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_ACKQ_CFG_ADDR,m,v,HWIO_IPA_UC_ACKQ_CFG_IN)
#define HWIO_IPA_UC_ACKQ_CFG_BLOCK_WR_BMSK                                                          0x2
#define HWIO_IPA_UC_ACKQ_CFG_BLOCK_WR_SHFT                                                          0x1
#define HWIO_IPA_UC_ACKQ_CFG_BLOCK_RD_BMSK                                                          0x1
#define HWIO_IPA_UC_ACKQ_CFG_BLOCK_RD_SHFT                                                          0x0

#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000174)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000174)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000174)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_RMSK                                                       0x1ffffff
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ATTR                                                             0x3
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_UC_ACKQ_DATA_WR_0_ADDR, HWIO_IPA_UC_ACKQ_DATA_WR_0_RMSK)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_ACKQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_UC_ACKQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_ACKQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_UC_ACKQ_DATA_WR_0_IN)
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ACK_VALUE1_TYPE_BMSK                                       0x1000000
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ACK_VALUE1_TYPE_SHFT                                            0x18
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ACK_VALUE2_BMSK                                             0xff0000
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ACK_VALUE2_SHFT                                                 0x10
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ACK_VALUE1_BMSK                                               0xffff
#define HWIO_IPA_UC_ACKQ_DATA_WR_0_ACK_VALUE1_SHFT                                                  0x0

#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000178)
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000178)
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000178)
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_RMSK                                                       0x1ffffff
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ATTR                                                             0x1
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_UC_ACKQ_DATA_RD_0_ADDR, HWIO_IPA_UC_ACKQ_DATA_RD_0_RMSK)
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_ACKQ_DATA_RD_0_ADDR, m)
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ACK_VALUE1_TYPE_BMSK                                       0x1000000
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ACK_VALUE1_TYPE_SHFT                                            0x18
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ACK_VALUE2_BMSK                                             0xff0000
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ACK_VALUE2_SHFT                                                 0x10
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ACK_VALUE1_BMSK                                               0xffff
#define HWIO_IPA_UC_ACKQ_DATA_RD_0_ACK_VALUE1_SHFT                                                  0x0

#define HWIO_IPA_UC_ACKQ_STATUS_ADDR                                                         (IPA_DEBUG_REG_BASE      + 0x0000017c)
#define HWIO_IPA_UC_ACKQ_STATUS_PHYS                                                         (IPA_DEBUG_REG_BASE_PHYS + 0x0000017c)
#define HWIO_IPA_UC_ACKQ_STATUS_OFFS                                                         (IPA_DEBUG_REG_BASE_OFFS + 0x0000017c)
#define HWIO_IPA_UC_ACKQ_STATUS_RMSK                                                            0x1f1f7
#define HWIO_IPA_UC_ACKQ_STATUS_ATTR                                                                0x1
#define HWIO_IPA_UC_ACKQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_UC_ACKQ_STATUS_ADDR, HWIO_IPA_UC_ACKQ_STATUS_RMSK)
#define HWIO_IPA_UC_ACKQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_ACKQ_STATUS_ADDR, m)
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_DEPTH_BMSK                                                 0x1f000
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_DEPTH_SHFT                                                     0xc
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_COUNT_BMSK                                                   0x1f0
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_COUNT_SHFT                                                     0x4
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_FULL_BMSK                                                      0x4
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_FULL_SHFT                                                      0x2
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_EMPTY_BMSK                                                     0x2
#define HWIO_IPA_UC_ACKQ_STATUS_ACKQ_EMPTY_SHFT                                                     0x1
#define HWIO_IPA_UC_ACKQ_STATUS_STATUS_BMSK                                                         0x1
#define HWIO_IPA_UC_ACKQ_STATUS_STATUS_SHFT                                                         0x0

#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_ADDR(n)                                                  (IPA_DEBUG_REG_BASE      + 0x00000180 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_PHYS(n)                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000180 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_OFFS(n)                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000180 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RMSK                                                           0x7f
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_MAXn                                                              4
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_ATTR                                                            0x2
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RX_SPLT_CMDQ_CMD_n_ADDR(n),val)
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_RD_PKT_ENHANCED_BMSK                                   0x40
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_RD_PKT_ENHANCED_SHFT                                    0x6
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_WR_PKT_BMSK                                            0x20
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_WR_PKT_SHFT                                             0x5
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_RD_PKT_BMSK                                            0x10
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_RD_PKT_SHFT                                             0x4
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_WR_CMD_BMSK                                             0x8
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_WR_CMD_SHFT                                             0x3
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_RD_CMD_BMSK                                             0x4
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_RELEASE_RD_CMD_SHFT                                             0x2
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_POP_CMD_BMSK                                                    0x2
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_POP_CMD_SHFT                                                    0x1
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_WRITE_CMD_BMSK                                                  0x1
#define HWIO_IPA_RX_SPLT_CMDQ_CMD_n_WRITE_CMD_SHFT                                                  0x0

#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_ADDR(n)                                                  (IPA_DEBUG_REG_BASE      + 0x00000184 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_PHYS(n)                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000184 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_OFFS(n)                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000184 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_RMSK                                                            0x3
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_MAXn                                                              4
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_ATTR                                                            0x3
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_CFG_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_CFG_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_CFG_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RX_SPLT_CMDQ_CFG_n_ADDR(n),val)
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RX_SPLT_CMDQ_CFG_n_ADDR(n),mask,val,HWIO_IPA_RX_SPLT_CMDQ_CFG_n_INI(n))
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_BLOCK_WR_BMSK                                                   0x2
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_BLOCK_WR_SHFT                                                   0x1
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_BLOCK_RD_BMSK                                                   0x1
#define HWIO_IPA_RX_SPLT_CMDQ_CFG_n_BLOCK_RD_SHFT                                                   0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x00000188 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000188 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000188 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_ATTR                                                      0x3
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_ADDR(n),val)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_ADDR(n),mask,val,HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_INI(n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_CMDQ_SRC_LEN_F_BMSK                                0xffff0000
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_CMDQ_SRC_LEN_F_SHFT                                      0x10
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_CMDQ_PACKET_LEN_F_BMSK                                 0xffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_0_n_CMDQ_PACKET_LEN_F_SHFT                                    0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x0000018c + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000018c + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000018c + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_ATTR                                                      0x3
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_ADDR(n),val)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_ADDR(n),mask,val,HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_INI(n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_METADATA_F_BMSK                               0xff000000
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_METADATA_F_SHFT                                     0x18
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_OPCODE_F_BMSK                                   0xff0000
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_OPCODE_F_SHFT                                       0x10
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_FLAGS_F_BMSK                                      0xfc00
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_FLAGS_F_SHFT                                         0xa
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_ORDER_F_BMSK                                       0x300
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_ORDER_F_SHFT                                         0x8
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_SRC_PIPE_F_BMSK                                     0xff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_1_n_CMDQ_SRC_PIPE_F_SHFT                                      0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x00000190 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000190 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000190 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_ATTR                                                      0x3
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_ADDR(n),val)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_ADDR(n),mask,val,HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_INI(n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_CMDQ_ADDR_LSB_F_BMSK                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_2_n_CMDQ_ADDR_LSB_F_SHFT                                      0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x00000194 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000194 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000194 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_ATTR                                                      0x3
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_ADDR(n),val)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_ADDR(n),mask,val,HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_INI(n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_CMDQ_ADDR_MSB_F_BMSK                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_WR_3_n_CMDQ_ADDR_MSB_F_SHFT                                      0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x00000198 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000198 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000198 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_ATTR                                                      0x1
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_CMDQ_SRC_LEN_F_BMSK                                0xffff0000
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_CMDQ_SRC_LEN_F_SHFT                                      0x10
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_CMDQ_PACKET_LEN_F_BMSK                                 0xffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_0_n_CMDQ_PACKET_LEN_F_SHFT                                    0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x0000019c + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000019c + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000019c + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_ATTR                                                      0x1
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_METADATA_F_BMSK                               0xff000000
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_METADATA_F_SHFT                                     0x18
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_OPCODE_F_BMSK                                   0xff0000
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_OPCODE_F_SHFT                                       0x10
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_FLAGS_F_BMSK                                      0xfc00
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_FLAGS_F_SHFT                                         0xa
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_ORDER_F_BMSK                                       0x300
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_ORDER_F_SHFT                                         0x8
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_SRC_PIPE_F_BMSK                                     0xff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_1_n_CMDQ_SRC_PIPE_F_SHFT                                      0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x000001a0 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x000001a0 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x000001a0 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_ATTR                                                      0x1
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_CMDQ_ADDR_LSB_F_BMSK                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_2_n_CMDQ_ADDR_LSB_F_SHFT                                      0x0

#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x000001a4 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x000001a4 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x000001a4 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_RMSK                                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_MAXn                                                        4
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_ATTR                                                      0x1
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_CMDQ_ADDR_MSB_F_BMSK                               0xffffffff
#define HWIO_IPA_RX_SPLT_CMDQ_DATA_RD_3_n_CMDQ_ADDR_MSB_F_SHFT                                      0x0

#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_ADDR(n)                                               (IPA_DEBUG_REG_BASE      + 0x000001a8 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_PHYS(n)                                               (IPA_DEBUG_REG_BASE_PHYS + 0x000001a8 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_OFFS(n)                                               (IPA_DEBUG_REG_BASE_OFFS + 0x000001a8 + 0x2C * (n))
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_RMSK                                                        0x7f
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_MAXn                                                           4
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_ATTR                                                         0x1
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_ADDR(n), HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_RMSK)
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_ADDR(n), mask)
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_DEPTH_BMSK                                             0x60
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_DEPTH_SHFT                                              0x5
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_COUNT_BMSK                                             0x18
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_COUNT_SHFT                                              0x3
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_FULL_BMSK                                               0x4
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_FULL_SHFT                                               0x2
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_EMPTY_BMSK                                              0x2
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_CMDQ_EMPTY_SHFT                                              0x1
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_STATUS_BMSK                                                  0x1
#define HWIO_IPA_RX_SPLT_CMDQ_STATUS_n_STATUS_SHFT                                                  0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x0000025c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x0000025c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x0000025c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_RMSK                                                        0x17
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_ATTR                                                         0x2
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_TX_COMMANDER_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_RELEASE_WR_PKT_BMSK                                         0x10
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_RELEASE_WR_PKT_SHFT                                          0x4
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_RELEASE_WR_CMD_BMSK                                          0x4
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_RELEASE_WR_CMD_SHFT                                          0x2
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_POP_CMD_BMSK                                                 0x2
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_POP_CMD_SHFT                                                 0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_WRITE_CMD_BMSK                                               0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_CMD_WRITE_CMD_SHFT                                               0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000260)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000260)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000260)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_RMSK                                                        0x11
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_ATTR                                                         0x3
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_CFG_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_CFG_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_CFG_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_OUT(v)      \
        out_dword(HWIO_IPA_TX_COMMANDER_CMDQ_CFG_ADDR,v)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TX_COMMANDER_CMDQ_CFG_ADDR,m,v,HWIO_IPA_TX_COMMANDER_CMDQ_CFG_IN)
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_TX_SELECT_BMSK                                              0x10
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_TX_SELECT_SHFT                                               0x4
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_BLOCK_WR_BMSK                                                0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_CFG_BLOCK_WR_SHFT                                                0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000264)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000264)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000264)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_RMSK                                            0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_ATTR                                                   0x3
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_IN)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_CMDQ_DEST_LEN_F_BMSK                            0xffff0000
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_CMDQ_DEST_LEN_F_SHFT                                  0x10
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_CMDQ_PACKET_LEN_F_BMSK                              0xffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_0_CMDQ_PACKET_LEN_F_SHFT                                 0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000268)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000268)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000268)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_RMSK                                            0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_ATTR                                                   0x3
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_OUT(v)      \
        out_dword(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_ADDR,v)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_ADDR,m,v,HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_IN)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_RSRC_ARG_F_BMSK                            0xff000000
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_RSRC_ARG_F_SHFT                                  0x18
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_RSRC_TYPE_F_BMSK                             0xff0000
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_RSRC_TYPE_F_SHFT                                 0x10
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_FLAGS_F_BMSK                                   0xfc00
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_FLAGS_F_SHFT                                      0xa
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_ORDER_F_BMSK                                    0x300
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_ORDER_F_SHFT                                      0x8
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_DEST_PIPE_F_BMSK                                 0xff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_1_CMDQ_DEST_PIPE_F_SHFT                                  0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x0000026c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000026c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000026c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_RMSK                                            0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_ATTR                                                   0x3
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_OUT(v)      \
        out_dword(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_ADDR,v)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_ADDR,m,v,HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_IN)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_CMDQ_ADDR_F_BMSK                                0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_WR_2_CMDQ_ADDR_F_SHFT                                       0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000270)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000270)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000270)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_RMSK                                            0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_ATTR                                                   0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_CMDQ_DEST_LEN_F_BMSK                            0xffff0000
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_CMDQ_DEST_LEN_F_SHFT                                  0x10
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_CMDQ_PACKET_LEN_F_BMSK                              0xffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_0_CMDQ_PACKET_LEN_F_SHFT                                 0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000274)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000274)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000274)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_RMSK                                            0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_ATTR                                                   0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_RSRC_ARG_F_BMSK                            0xff000000
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_RSRC_ARG_F_SHFT                                  0x18
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_RSRC_TYPE_F_BMSK                             0xff0000
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_RSRC_TYPE_F_SHFT                                 0x10
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_FLAGS_F_BMSK                                   0xfc00
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_FLAGS_F_SHFT                                      0xa
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_ORDER_F_BMSK                                    0x300
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_ORDER_F_SHFT                                      0x8
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_DEST_PIPE_F_BMSK                                 0xff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_1_CMDQ_DEST_PIPE_F_SHFT                                  0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x00000278)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000278)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000278)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_RMSK                                            0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_ATTR                                                   0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_CMDQ_ADDR_F_BMSK                                0xffffffff
#define HWIO_IPA_TX_COMMANDER_CMDQ_DATA_RD_2_CMDQ_ADDR_F_SHFT                                       0x0

#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x0000027c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x0000027c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x0000027c)
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_RMSK                                                      0x7
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_ATTR                                                      0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_ADDR, HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_RMSK)
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_ADDR, m)
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_CMDQ_FULL_BMSK                                            0x4
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_CMDQ_FULL_SHFT                                            0x2
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_CMDQ_EMPTY_BMSK                                           0x2
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_CMDQ_EMPTY_SHFT                                           0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_STATUS_BMSK                                               0x1
#define HWIO_IPA_TX_COMMANDER_CMDQ_STATUS_STATUS_SHFT                                               0x0

#define HWIO_IPA_RX_HPS_CMDQ_CMD_ADDR                                                        (IPA_DEBUG_REG_BASE      + 0x00000280)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_PHYS                                                        (IPA_DEBUG_REG_BASE_PHYS + 0x00000280)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_OFFS                                                        (IPA_DEBUG_REG_BASE_OFFS + 0x00000280)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_RMSK                                                              0x3f
#define HWIO_IPA_RX_HPS_CMDQ_CMD_ATTR                                                               0x3
#define HWIO_IPA_RX_HPS_CMDQ_CMD_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_CMD_ADDR, HWIO_IPA_RX_HPS_CMDQ_CMD_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_CMD_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_CMD_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_CMD_IN)
#define HWIO_IPA_RX_HPS_CMDQ_CMD_RD_REQ_BMSK                                                       0x20
#define HWIO_IPA_RX_HPS_CMDQ_CMD_RD_REQ_SHFT                                                        0x5
#define HWIO_IPA_RX_HPS_CMDQ_CMD_CMD_CLIENT_BMSK                                                   0x1c
#define HWIO_IPA_RX_HPS_CMDQ_CMD_CMD_CLIENT_SHFT                                                    0x2
#define HWIO_IPA_RX_HPS_CMDQ_CMD_POP_CMD_BMSK                                                       0x2
#define HWIO_IPA_RX_HPS_CMDQ_CMD_POP_CMD_SHFT                                                       0x1
#define HWIO_IPA_RX_HPS_CMDQ_CMD_WRITE_CMD_BMSK                                                     0x1
#define HWIO_IPA_RX_HPS_CMDQ_CMD_WRITE_CMD_SHFT                                                     0x0

#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x00000284)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000284)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000284)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_RMSK                                                       0x3f
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_ATTR                                                        0x2
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_RELEASE_WR_CMD_BMSK                                        0x3f
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_WR_RELEASE_WR_CMD_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x00000288)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000288)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000288)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_RMSK                                                       0x3f
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_ATTR                                                        0x2
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_RELEASE_RD_CMD_BMSK                                        0x3f
#define HWIO_IPA_RX_HPS_CMDQ_RELEASE_RD_RELEASE_RD_CMD_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x0000028c)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x0000028c)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x0000028c)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_RMSK                                                           0x3f
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_ATTR                                                            0x3
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_CFG_WR_ADDR, HWIO_IPA_RX_HPS_CMDQ_CFG_WR_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_CFG_WR_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_CFG_WR_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_CFG_WR_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_CFG_WR_IN)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_BLOCK_WR_BMSK                                                  0x3f
#define HWIO_IPA_RX_HPS_CMDQ_CFG_WR_BLOCK_WR_SHFT                                                   0x0

#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000290)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000290)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000290)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_RMSK                                                           0x3f
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_ATTR                                                            0x3
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_CFG_RD_ADDR, HWIO_IPA_RX_HPS_CMDQ_CFG_RD_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_CFG_RD_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_CFG_RD_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_CFG_RD_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_CFG_RD_IN)
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_BLOCK_RD_BMSK                                                  0x3f
#define HWIO_IPA_RX_HPS_CMDQ_CFG_RD_BLOCK_RD_SHFT                                                   0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000294)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000294)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000294)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_ATTR                                                         0x3
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_IN)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_CMDQ_DEST_LEN_F_BMSK                                  0xffff0000
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_CMDQ_DEST_LEN_F_SHFT                                        0x10
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_CMDQ_PACKET_LEN_F_BMSK                                    0xffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_0_CMDQ_PACKET_LEN_F_SHFT                                       0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000298)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000298)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000298)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_ATTR                                                         0x3
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_IN)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_METADATA_F_BMSK                                  0xff000000
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_METADATA_F_SHFT                                        0x18
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_OPCODE_F_BMSK                                      0xff0000
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_OPCODE_F_SHFT                                          0x10
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_FLAGS_F_BMSK                                         0xfc00
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_FLAGS_F_SHFT                                            0xa
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_ORDER_F_BMSK                                          0x300
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_ORDER_F_SHFT                                            0x8
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_SRC_PIPE_F_BMSK                                        0xff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_1_CMDQ_SRC_PIPE_F_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x0000029c)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x0000029c)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x0000029c)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_ATTR                                                         0x3
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_IN)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_CMDQ_ADDR_LSB_F_BMSK                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_2_CMDQ_ADDR_LSB_F_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x000002a0)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x000002a0)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x000002a0)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_ATTR                                                         0x3
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_ADDR,v)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_ADDR,m,v,HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_IN)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_CMDQ_ADDR_MSB_F_BMSK                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_WR_3_CMDQ_ADDR_MSB_F_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x000002a4)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x000002a4)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x000002a4)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_ATTR                                                         0x1
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_RMSK, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_ADDR, m, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_CMDQ_DEST_LEN_F_BMSK                                  0xffff0000
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_CMDQ_DEST_LEN_F_SHFT                                        0x10
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_CMDQ_PACKET_LEN_F_BMSK                                    0xffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_0_CMDQ_PACKET_LEN_F_SHFT                                       0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x000002a8)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x000002a8)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x000002a8)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_ATTR                                                         0x1
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_RMSK, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_ADDR, m, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_METADATA_F_BMSK                                  0xff000000
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_METADATA_F_SHFT                                        0x18
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_OPCODE_F_BMSK                                      0xff0000
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_OPCODE_F_SHFT                                          0x10
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_FLAGS_F_BMSK                                         0xfc00
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_FLAGS_F_SHFT                                            0xa
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_ORDER_F_BMSK                                          0x300
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_ORDER_F_SHFT                                            0x8
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_SRC_PIPE_F_BMSK                                        0xff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_1_CMDQ_SRC_PIPE_F_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x000002ac)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x000002ac)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x000002ac)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_ATTR                                                         0x1
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_RMSK, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_ADDR, m, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_CMDQ_ADDR_LSB_F_BMSK                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_2_CMDQ_ADDR_LSB_F_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x000002b0)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x000002b0)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x000002b0)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_RMSK                                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_ATTR                                                         0x1
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_ADDR, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_RMSK, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_ADDR, m, HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_CMDQ_ADDR_MSB_F_BMSK                                  0xffffffff
#define HWIO_IPA_RX_HPS_CMDQ_DATA_RD_3_CMDQ_ADDR_MSB_F_SHFT                                         0x0

#define HWIO_IPA_RX_HPS_CMDQ_STATUS_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x000002b4)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x000002b4)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x000002b4)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_RMSK                                                          0x1ff
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_ATTR                                                            0x1
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_STATUS_ADDR, HWIO_IPA_RX_HPS_CMDQ_STATUS_RMSK, HWIO_IPA_RX_HPS_CMDQ_STATUS_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_STATUS_ADDR, m, HWIO_IPA_RX_HPS_CMDQ_STATUS_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                               0x1fc
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                                 0x2
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_CMDQ_FULL_BMSK                                                  0x2
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_CMDQ_FULL_SHFT                                                  0x1
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_STATUS_BMSK                                                     0x1
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_STATUS_SHFT                                                     0x0

#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x000002b8)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x000002b8)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x000002b8)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_RMSK                                                     0x3f
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_ATTR                                                      0x1
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_ADDR, HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_RMSK)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_ADDR, m)
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_CMDQ_EMPTY_BMSK                                          0x3f
#define HWIO_IPA_RX_HPS_CMDQ_STATUS_EMPTY_CMDQ_EMPTY_SHFT                                           0x0

#define HWIO_IPA_RX_HPS_SNP_ADDR                                                             (IPA_DEBUG_REG_BASE      + 0x000002bc)
#define HWIO_IPA_RX_HPS_SNP_PHYS                                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000002bc)
#define HWIO_IPA_RX_HPS_SNP_OFFS                                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000002bc)
#define HWIO_IPA_RX_HPS_SNP_RMSK                                                                 0xffff
#define HWIO_IPA_RX_HPS_SNP_ATTR                                                                    0x3
#define HWIO_IPA_RX_HPS_SNP_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_SNP_ADDR, HWIO_IPA_RX_HPS_SNP_RMSK)
#define HWIO_IPA_RX_HPS_SNP_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_SNP_ADDR, m)
#define HWIO_IPA_RX_HPS_SNP_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_SNP_ADDR,v)
#define HWIO_IPA_RX_HPS_SNP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_SNP_ADDR,m,v,HWIO_IPA_RX_HPS_SNP_IN)
#define HWIO_IPA_RX_HPS_SNP_SNP_ADDR_BMSK                                                        0xf000
#define HWIO_IPA_RX_HPS_SNP_SNP_ADDR_SHFT                                                           0xc
#define HWIO_IPA_RX_HPS_SNP_SNP_HEAD_BMSK                                                         0xf00
#define HWIO_IPA_RX_HPS_SNP_SNP_HEAD_SHFT                                                           0x8
#define HWIO_IPA_RX_HPS_SNP_SNP_NEXT_BMSK                                                          0xf0
#define HWIO_IPA_RX_HPS_SNP_SNP_NEXT_SHFT                                                           0x4
#define HWIO_IPA_RX_HPS_SNP_SNP_NEXT_IS_VALID_BMSK                                                  0x8
#define HWIO_IPA_RX_HPS_SNP_SNP_NEXT_IS_VALID_SHFT                                                  0x3
#define HWIO_IPA_RX_HPS_SNP_SNP_VALID_BMSK                                                          0x4
#define HWIO_IPA_RX_HPS_SNP_SNP_VALID_SHFT                                                          0x2
#define HWIO_IPA_RX_HPS_SNP_SNP_WRITE_BMSK                                                          0x2
#define HWIO_IPA_RX_HPS_SNP_SNP_WRITE_SHFT                                                          0x1
#define HWIO_IPA_RX_HPS_SNP_SNP_LAST_BMSK                                                           0x1
#define HWIO_IPA_RX_HPS_SNP_SNP_LAST_SHFT                                                           0x0

#define HWIO_IPA_RX_HPS_CMDQ_COUNT_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x000002c0)
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x000002c0)
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x000002c0)
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_RMSK                                                            0x7f
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_ATTR                                                             0x1
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_COUNT_ADDR, HWIO_IPA_RX_HPS_CMDQ_COUNT_RMSK, HWIO_IPA_RX_HPS_CMDQ_COUNT_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CMDQ_COUNT_ADDR, m, HWIO_IPA_RX_HPS_CMDQ_COUNT_ATTR)
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_FIFO_COUNT_BMSK                                                 0x7f
#define HWIO_IPA_RX_HPS_CMDQ_COUNT_FIFO_COUNT_SHFT                                                  0x0

#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000002c4)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000002c4)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000002c4)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_RMSK                                             0xff0f0f0f
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_ATTR                                                    0x3
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_ADDR, HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_RMSK)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_ADDR, m)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_ADDR,v)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_ADDR,m,v,HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_IN)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_4_MIN_DEPTH_BMSK                          0xf0000000
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_4_MIN_DEPTH_SHFT                                0x1c
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_3_MIN_DEPTH_BMSK                           0xf000000
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_3_MIN_DEPTH_SHFT                                0x18
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_2_MIN_DEPTH_BMSK                             0xf0000
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_2_MIN_DEPTH_SHFT                                0x10
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_1_MIN_DEPTH_BMSK                               0xf00
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_1_MIN_DEPTH_SHFT                                 0x8
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_0_MIN_DEPTH_BMSK                                 0xf
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_0_CLIENT_0_MIN_DEPTH_SHFT                                 0x0

#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000002c8)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000002c8)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000002c8)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_RMSK                                             0xff0f0f0f
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_ATTR                                                    0x3
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_ADDR, HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_RMSK)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_ADDR, m)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_ADDR,v)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_ADDR,m,v,HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_IN)
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_9_MIN_DEPTH_BMSK                          0xf0000000
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_9_MIN_DEPTH_SHFT                                0x1c
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_8_MIN_DEPTH_BMSK                           0xf000000
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_8_MIN_DEPTH_SHFT                                0x18
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_7_MIN_DEPTH_BMSK                             0xf0000
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_7_MIN_DEPTH_SHFT                                0x10
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_6_MIN_DEPTH_BMSK                               0xf00
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_6_MIN_DEPTH_SHFT                                 0x8
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_5_MIN_DEPTH_BMSK                                 0xf
#define HWIO_IPA_RX_HPS_CLIENTS_MIN_DEPTH_1_CLIENT_5_MIN_DEPTH_SHFT                                 0x0

#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000002cc)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000002cc)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000002cc)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_RMSK                                             0xff0f0f0f
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_ATTR                                                    0x3
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_ADDR, HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_RMSK)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_ADDR, m)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_ADDR,v)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_ADDR,m,v,HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_IN)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_4_MAX_DEPTH_BMSK                          0xf0000000
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_4_MAX_DEPTH_SHFT                                0x1c
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_3_MAX_DEPTH_BMSK                           0xf000000
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_3_MAX_DEPTH_SHFT                                0x18
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_2_MAX_DEPTH_BMSK                             0xf0000
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_2_MAX_DEPTH_SHFT                                0x10
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_1_MAX_DEPTH_BMSK                               0xf00
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_1_MAX_DEPTH_SHFT                                 0x8
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_0_MAX_DEPTH_BMSK                                 0xf
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_0_CLIENT_0_MAX_DEPTH_SHFT                                 0x0

#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000002d0)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000002d0)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000002d0)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_RMSK                                             0xff0f0f0f
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_ATTR                                                    0x3
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_IN          \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_ADDR, HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_RMSK)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_ADDR, m)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_OUT(v)      \
        out_dword(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_ADDR,v)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_ADDR,m,v,HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_IN)
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_9_MAX_DEPTH_BMSK                          0xf0000000
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_9_MAX_DEPTH_SHFT                                0x1c
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_8_MAX_DEPTH_BMSK                           0xf000000
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_8_MAX_DEPTH_SHFT                                0x18
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_7_MAX_DEPTH_BMSK                             0xf0000
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_7_MAX_DEPTH_SHFT                                0x10
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_6_MAX_DEPTH_BMSK                               0xf00
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_6_MAX_DEPTH_SHFT                                 0x8
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_5_MAX_DEPTH_BMSK                                 0xf
#define HWIO_IPA_RX_HPS_CLIENTS_MAX_DEPTH_1_CLIENT_5_MAX_DEPTH_SHFT                                 0x0

#define HWIO_IPA_HPS_DPS_CMDQ_CMD_ADDR                                                       (IPA_DEBUG_REG_BASE      + 0x000002e0)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_PHYS                                                       (IPA_DEBUG_REG_BASE_PHYS + 0x000002e0)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_OFFS                                                       (IPA_DEBUG_REG_BASE_OFFS + 0x000002e0)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_RMSK                                                            0xff7
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_ATTR                                                              0x3
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_IN          \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_CMD_ADDR, HWIO_IPA_HPS_DPS_CMDQ_CMD_RMSK)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_CMD_ADDR, m)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_HPS_DPS_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_HPS_DPS_CMDQ_CMD_ADDR,m,v,HWIO_IPA_HPS_DPS_CMDQ_CMD_IN)
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_CMD_CLIENT_BMSK                                                 0xff0
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_CMD_CLIENT_SHFT                                                   0x4
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_RD_REQ_BMSK                                                       0x4
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_RD_REQ_SHFT                                                       0x2
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_POP_CMD_BMSK                                                      0x2
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_POP_CMD_SHFT                                                      0x1
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_WRITE_CMD_BMSK                                                    0x1
#define HWIO_IPA_HPS_DPS_CMDQ_CMD_WRITE_CMD_SHFT                                                    0x0

#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x000002e4)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x000002e4)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x000002e4)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_RMSK                                                   0xffffff
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_ATTR                                                        0x3
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_ADDR, HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_RMSK)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_IN)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_VIRT_COD_F_BMSK                                   0x800000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_VIRT_COD_F_SHFT                                       0x17
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_TYPE_F_BMSK                                       0x400000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_TYPE_F_SHFT                                           0x16
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_OPCODE_F_BMSK                                     0x300000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_OPCODE_F_SHFT                                         0x14
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_SRC_PIPE_F_BMSK                                    0xff000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_SRC_PIPE_F_SHFT                                        0xc
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_SRC_ID_F_BMSK                                        0xff0
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_SRC_ID_F_SHFT                                          0x4
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_CTX_ID_F_BMSK                                          0xf
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_WR_0_CMDQ_CTX_ID_F_SHFT                                          0x0

#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x000002e8)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x000002e8)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x000002e8)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_RMSK                                                   0xffffff
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_ATTR                                                        0x1
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_ADDR, HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_RMSK, HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_ADDR, m, HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_VIRT_COD_F_BMSK                                   0x800000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_VIRT_COD_F_SHFT                                       0x17
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_TYPE_F_BMSK                                       0x400000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_TYPE_F_SHFT                                           0x16
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_OPCODE_F_BMSK                                     0x300000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_OPCODE_F_SHFT                                         0x14
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_SRC_PIPE_F_BMSK                                    0xff000
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_SRC_PIPE_F_SHFT                                        0xc
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_SRC_ID_F_BMSK                                        0xff0
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_SRC_ID_F_SHFT                                          0x4
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_CTX_ID_F_BMSK                                          0xf
#define HWIO_IPA_HPS_DPS_CMDQ_DATA_RD_0_CMDQ_CTX_ID_F_SHFT                                          0x0

#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x000002ec)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x000002ec)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x000002ec)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_RMSK                                                         0xff3
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_ATTR                                                           0x1
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_STATUS_ADDR, HWIO_IPA_HPS_DPS_CMDQ_STATUS_RMSK, HWIO_IPA_HPS_DPS_CMDQ_STATUS_ATTR)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_STATUS_ADDR, m, HWIO_IPA_HPS_DPS_CMDQ_STATUS_ATTR)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                              0xff0
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                                0x4
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_CMDQ_FULL_BMSK                                                 0x2
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_CMDQ_FULL_SHFT                                                 0x1
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_STATUS_BMSK                                                    0x1
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_STATUS_SHFT                                                    0x0

#define HWIO_IPA_HPS_DPS_SNP_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x000002f0)
#define HWIO_IPA_HPS_DPS_SNP_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x000002f0)
#define HWIO_IPA_HPS_DPS_SNP_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x000002f0)
#define HWIO_IPA_HPS_DPS_SNP_RMSK                                                             0xfffffff
#define HWIO_IPA_HPS_DPS_SNP_ATTR                                                                   0x3
#define HWIO_IPA_HPS_DPS_SNP_IN          \
        in_dword_masked(HWIO_IPA_HPS_DPS_SNP_ADDR, HWIO_IPA_HPS_DPS_SNP_RMSK)
#define HWIO_IPA_HPS_DPS_SNP_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_DPS_SNP_ADDR, m)
#define HWIO_IPA_HPS_DPS_SNP_OUT(v)      \
        out_dword(HWIO_IPA_HPS_DPS_SNP_ADDR,v)
#define HWIO_IPA_HPS_DPS_SNP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_HPS_DPS_SNP_ADDR,m,v,HWIO_IPA_HPS_DPS_SNP_IN)
#define HWIO_IPA_HPS_DPS_SNP_SNP_ADDR_BMSK                                                    0xff00000
#define HWIO_IPA_HPS_DPS_SNP_SNP_ADDR_SHFT                                                         0x14
#define HWIO_IPA_HPS_DPS_SNP_SNP_HEAD_BMSK                                                      0xff000
#define HWIO_IPA_HPS_DPS_SNP_SNP_HEAD_SHFT                                                          0xc
#define HWIO_IPA_HPS_DPS_SNP_SNP_NEXT_BMSK                                                        0xff0
#define HWIO_IPA_HPS_DPS_SNP_SNP_NEXT_SHFT                                                          0x4
#define HWIO_IPA_HPS_DPS_SNP_SNP_NEXT_IS_VALID_BMSK                                                 0x8
#define HWIO_IPA_HPS_DPS_SNP_SNP_NEXT_IS_VALID_SHFT                                                 0x3
#define HWIO_IPA_HPS_DPS_SNP_SNP_VALID_BMSK                                                         0x4
#define HWIO_IPA_HPS_DPS_SNP_SNP_VALID_SHFT                                                         0x2
#define HWIO_IPA_HPS_DPS_SNP_SNP_WRITE_BMSK                                                         0x2
#define HWIO_IPA_HPS_DPS_SNP_SNP_WRITE_SHFT                                                         0x1
#define HWIO_IPA_HPS_DPS_SNP_SNP_LAST_BMSK                                                          0x1
#define HWIO_IPA_HPS_DPS_SNP_SNP_LAST_SHFT                                                          0x0

#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x000002f4)
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x000002f4)
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x000002f4)
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_RMSK                                                           0xff
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_ATTR                                                            0x1
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_IN          \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_COUNT_ADDR, HWIO_IPA_HPS_DPS_CMDQ_COUNT_RMSK, HWIO_IPA_HPS_DPS_CMDQ_COUNT_ATTR)
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_COUNT_ADDR, m, HWIO_IPA_HPS_DPS_CMDQ_COUNT_ATTR)
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_FIFO_COUNT_BMSK                                                0xff
#define HWIO_IPA_HPS_DPS_CMDQ_COUNT_FIFO_COUNT_SHFT                                                 0x0

#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_ADDR(n)                                           (IPA_DEBUG_REG_BASE      + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_PHYS(n)                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_OFFS(n)                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_RMSK                                              0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_MAXn                                                       1
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_ATTR                                                     0x2
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_ADDR(n),val)
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_RELEASE_WR_CMD_BMSK                               0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_WR_n_RELEASE_WR_CMD_SHFT                                      0x0

#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_ADDR(n)                                           (IPA_DEBUG_REG_BASE      + 0x00000320 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_PHYS(n)                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000320 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_OFFS(n)                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000320 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_RMSK                                              0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_MAXn                                                       1
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_ATTR                                                     0x2
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_ADDR(n),val)
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_RELEASE_RD_CMD_BMSK                               0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_RELEASE_RD_n_RELEASE_RD_CMD_SHFT                                      0x0

#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_ADDR(n)                                               (IPA_DEBUG_REG_BASE      + 0x00000340 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_PHYS(n)                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000340 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_OFFS(n)                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000340 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_RMSK                                                  0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_MAXn                                                           1
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_ATTR                                                         0x3
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_INI(n)        \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_ADDR(n), HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_RMSK)
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_ADDR(n), mask)
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_ADDR(n),val)
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_ADDR(n),mask,val,HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_INI(n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_BLOCK_WR_BMSK                                         0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_WR_n_BLOCK_WR_SHFT                                                0x0

#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_ADDR(n)                                               (IPA_DEBUG_REG_BASE      + 0x00000360 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_PHYS(n)                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000360 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_OFFS(n)                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000360 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_RMSK                                                  0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_MAXn                                                           1
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_ATTR                                                         0x3
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_INI(n)        \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_ADDR(n), HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_RMSK)
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_ADDR(n), mask)
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_ADDR(n),val)
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_ADDR(n),mask,val,HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_INI(n))
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_BLOCK_RD_BMSK                                         0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_CFG_RD_n_BLOCK_RD_SHFT                                                0x0

#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_ADDR(n)                                         (IPA_DEBUG_REG_BASE      + 0x00000380 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_PHYS(n)                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000380 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_OFFS(n)                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000380 + 0x4 * (n))
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_RMSK                                            0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_MAXn                                                     1
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_ATTR                                                   0x1
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_INI(n)        \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_ADDR(n), HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_RMSK)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_ADDR(n), mask)
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_BMSK                                 0xffffffff
#define HWIO_IPA_HPS_DPS_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_SHFT                                        0x0

#define HWIO_IPA_DPS_TX_CMDQ_CMD_ADDR                                                        (IPA_DEBUG_REG_BASE      + 0x00000400)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_PHYS                                                        (IPA_DEBUG_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_OFFS                                                        (IPA_DEBUG_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_RMSK                                                              0x7f
#define HWIO_IPA_DPS_TX_CMDQ_CMD_ATTR                                                               0x3
#define HWIO_IPA_DPS_TX_CMDQ_CMD_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_CMD_ADDR, HWIO_IPA_DPS_TX_CMDQ_CMD_RMSK)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_CMD_ADDR, m)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPS_TX_CMDQ_CMD_ADDR,m,v,HWIO_IPA_DPS_TX_CMDQ_CMD_IN)
#define HWIO_IPA_DPS_TX_CMDQ_CMD_CMD_CLIENT_BMSK                                                   0x78
#define HWIO_IPA_DPS_TX_CMDQ_CMD_CMD_CLIENT_SHFT                                                    0x3
#define HWIO_IPA_DPS_TX_CMDQ_CMD_RD_REQ_BMSK                                                        0x4
#define HWIO_IPA_DPS_TX_CMDQ_CMD_RD_REQ_SHFT                                                        0x2
#define HWIO_IPA_DPS_TX_CMDQ_CMD_POP_CMD_BMSK                                                       0x2
#define HWIO_IPA_DPS_TX_CMDQ_CMD_POP_CMD_SHFT                                                       0x1
#define HWIO_IPA_DPS_TX_CMDQ_CMD_WRITE_CMD_BMSK                                                     0x1
#define HWIO_IPA_DPS_TX_CMDQ_CMD_WRITE_CMD_SHFT                                                     0x0

#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x00000404)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000404)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000404)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_RMSK                                                      0xfff
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_ATTR                                                        0x2
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_ADDR,v)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_RELEASE_WR_CMD_BMSK                                       0xfff
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_WR_RELEASE_WR_CMD_SHFT                                         0x0

#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x00000408)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000408)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000408)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_RMSK                                                      0xfff
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_ATTR                                                        0x2
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_ADDR,v)
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_RELEASE_RD_CMD_BMSK                                       0xfff
#define HWIO_IPA_DPS_TX_CMDQ_RELEASE_RD_RELEASE_RD_CMD_SHFT                                         0x0

#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x0000040c)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x0000040c)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x0000040c)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_RMSK                                                          0xfff
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_ATTR                                                            0x3
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_CFG_WR_ADDR, HWIO_IPA_DPS_TX_CMDQ_CFG_WR_RMSK)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_CFG_WR_ADDR, m)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_CMDQ_CFG_WR_ADDR,v)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPS_TX_CMDQ_CFG_WR_ADDR,m,v,HWIO_IPA_DPS_TX_CMDQ_CFG_WR_IN)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_BLOCK_WR_BMSK                                                 0xfff
#define HWIO_IPA_DPS_TX_CMDQ_CFG_WR_BLOCK_WR_SHFT                                                   0x0

#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000410)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000410)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000410)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_RMSK                                                          0xfff
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_ATTR                                                            0x3
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_CFG_RD_ADDR, HWIO_IPA_DPS_TX_CMDQ_CFG_RD_RMSK)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_CFG_RD_ADDR, m)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_CMDQ_CFG_RD_ADDR,v)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPS_TX_CMDQ_CFG_RD_ADDR,m,v,HWIO_IPA_DPS_TX_CMDQ_CFG_RD_IN)
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_BLOCK_RD_BMSK                                                 0xfff
#define HWIO_IPA_DPS_TX_CMDQ_CFG_RD_BLOCK_RD_SHFT                                                   0x0

#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000414)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000414)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000414)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_RMSK                                                   0x7ffffff
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_ATTR                                                         0x3
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_ADDR, HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_RMSK)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_IN)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_SEG_CTX_ID_F_BMSK                                      0x6000000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_SEG_CTX_ID_F_SHFT                                           0x19
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_SEG_VALID_F_BMSK                                       0x1000000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_SEG_VALID_F_SHFT                                            0x18
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_VIRT_COD_F_BMSK                                    0x800000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_VIRT_COD_F_SHFT                                        0x17
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_TYPE_F_BMSK                                        0x400000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_TYPE_F_SHFT                                            0x16
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_OPCODE_F_BMSK                                      0x300000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_OPCODE_F_SHFT                                          0x14
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_SRC_PIPE_F_BMSK                                     0xff000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_SRC_PIPE_F_SHFT                                         0xc
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_SRC_ID_F_BMSK                                         0xff0
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_SRC_ID_F_SHFT                                           0x4
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_CTX_ID_F_BMSK                                           0xf
#define HWIO_IPA_DPS_TX_CMDQ_DATA_WR_0_CMDQ_CTX_ID_F_SHFT                                           0x0

#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000418)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000418)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000418)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_RMSK                                                   0x7ffffff
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_ATTR                                                         0x1
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_ADDR, HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_RMSK, HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_ADDR, m, HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_SEG_CTX_ID_F_BMSK                                      0x6000000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_SEG_CTX_ID_F_SHFT                                           0x19
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_SEG_VALID_F_BMSK                                       0x1000000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_SEG_VALID_F_SHFT                                            0x18
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_VIRT_COD_F_BMSK                                    0x800000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_VIRT_COD_F_SHFT                                        0x17
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_TYPE_F_BMSK                                        0x400000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_TYPE_F_SHFT                                            0x16
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_OPCODE_F_BMSK                                      0x300000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_OPCODE_F_SHFT                                          0x14
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_SRC_PIPE_F_BMSK                                     0xff000
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_SRC_PIPE_F_SHFT                                         0xc
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_SRC_ID_F_BMSK                                         0xff0
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_SRC_ID_F_SHFT                                           0x4
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_CTX_ID_F_BMSK                                           0xf
#define HWIO_IPA_DPS_TX_CMDQ_DATA_RD_0_CMDQ_CTX_ID_F_SHFT                                           0x0

#define HWIO_IPA_DPS_TX_CMDQ_STATUS_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x0000041c)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x0000041c)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x0000041c)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_RMSK                                                          0xff3
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_ATTR                                                            0x1
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_STATUS_ADDR, HWIO_IPA_DPS_TX_CMDQ_STATUS_RMSK, HWIO_IPA_DPS_TX_CMDQ_STATUS_ATTR)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_STATUS_ADDR, m, HWIO_IPA_DPS_TX_CMDQ_STATUS_ATTR)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                               0xff0
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                                 0x4
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_CMDQ_FULL_BMSK                                                  0x2
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_CMDQ_FULL_SHFT                                                  0x1
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_STATUS_BMSK                                                     0x1
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_STATUS_SHFT                                                     0x0

#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000420)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000420)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000420)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_RMSK                                                    0xfff
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_ATTR                                                      0x1
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_ADDR, HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_RMSK)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_ADDR, m)
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_CMDQ_EMPTY_BMSK                                         0xfff
#define HWIO_IPA_DPS_TX_CMDQ_STATUS_EMPTY_CMDQ_EMPTY_SHFT                                           0x0

#define HWIO_IPA_DPS_TX_SNP_ADDR                                                             (IPA_DEBUG_REG_BASE      + 0x00000424)
#define HWIO_IPA_DPS_TX_SNP_PHYS                                                             (IPA_DEBUG_REG_BASE_PHYS + 0x00000424)
#define HWIO_IPA_DPS_TX_SNP_OFFS                                                             (IPA_DEBUG_REG_BASE_OFFS + 0x00000424)
#define HWIO_IPA_DPS_TX_SNP_RMSK                                                              0xfffffff
#define HWIO_IPA_DPS_TX_SNP_ATTR                                                                    0x3
#define HWIO_IPA_DPS_TX_SNP_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_SNP_ADDR, HWIO_IPA_DPS_TX_SNP_RMSK)
#define HWIO_IPA_DPS_TX_SNP_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_SNP_ADDR, m)
#define HWIO_IPA_DPS_TX_SNP_OUT(v)      \
        out_dword(HWIO_IPA_DPS_TX_SNP_ADDR,v)
#define HWIO_IPA_DPS_TX_SNP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPS_TX_SNP_ADDR,m,v,HWIO_IPA_DPS_TX_SNP_IN)
#define HWIO_IPA_DPS_TX_SNP_SNP_ADDR_BMSK                                                     0xff00000
#define HWIO_IPA_DPS_TX_SNP_SNP_ADDR_SHFT                                                          0x14
#define HWIO_IPA_DPS_TX_SNP_SNP_HEAD_BMSK                                                       0xff000
#define HWIO_IPA_DPS_TX_SNP_SNP_HEAD_SHFT                                                           0xc
#define HWIO_IPA_DPS_TX_SNP_SNP_NEXT_BMSK                                                         0xff0
#define HWIO_IPA_DPS_TX_SNP_SNP_NEXT_SHFT                                                           0x4
#define HWIO_IPA_DPS_TX_SNP_SNP_NEXT_IS_VALID_BMSK                                                  0x8
#define HWIO_IPA_DPS_TX_SNP_SNP_NEXT_IS_VALID_SHFT                                                  0x3
#define HWIO_IPA_DPS_TX_SNP_SNP_VALID_BMSK                                                          0x4
#define HWIO_IPA_DPS_TX_SNP_SNP_VALID_SHFT                                                          0x2
#define HWIO_IPA_DPS_TX_SNP_SNP_WRITE_BMSK                                                          0x2
#define HWIO_IPA_DPS_TX_SNP_SNP_WRITE_SHFT                                                          0x1
#define HWIO_IPA_DPS_TX_SNP_SNP_LAST_BMSK                                                           0x1
#define HWIO_IPA_DPS_TX_SNP_SNP_LAST_SHFT                                                           0x0

#define HWIO_IPA_DPS_TX_CMDQ_COUNT_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000428)
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000428)
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000428)
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_RMSK                                                            0x7f
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_ATTR                                                             0x1
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_IN          \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_COUNT_ADDR, HWIO_IPA_DPS_TX_CMDQ_COUNT_RMSK, HWIO_IPA_DPS_TX_CMDQ_COUNT_ATTR)
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_TX_CMDQ_COUNT_ADDR, m, HWIO_IPA_DPS_TX_CMDQ_COUNT_ATTR)
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_FIFO_COUNT_BMSK                                                 0x7f
#define HWIO_IPA_DPS_TX_CMDQ_COUNT_FIFO_COUNT_SHFT                                                  0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x0000042c)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x0000042c)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x0000042c)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_RMSK                                                         0x7
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_ATTR                                                         0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_ADDR, HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_IN)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_BITMAP_BMSK                                                  0x7
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_EN_BITMAP_SHFT                                                  0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_ADDR                                         (IPA_DEBUG_REG_BASE      + 0x00000430)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_PHYS                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000430)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_OFFS                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000430)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_RMSK                                                0x7
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_ATTR                                                0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_ADDR, HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_IN)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_BITMAP_BMSK                                         0x7
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_WR_N_RD_SEL_BITMAP_SHFT                                         0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x00000434)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x00000434)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x00000434)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_RMSK                                                 0x7fff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ATTR                                                    0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ADDR, HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_IN)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ALL_CLI_MUX_CONCAT_BMSK                              0x7fff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_CLI_MUX_ALL_CLI_MUX_CONCAT_SHFT                                 0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x00000438 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000438 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000438 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_0_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x0000043c + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x0000043c + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x0000043c + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_1_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x00000440 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000440 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000440 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_2_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x00000444 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000444 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000444 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_COMP_VAL_3_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x00000468 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000468 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000468 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_0_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x0000046c + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x0000046c + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x0000046c + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_1_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x00000470 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000470 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000470 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_2_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_ADDR(n)                                 (IPA_DEBUG_REG_BASE      + 0x00000474 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_PHYS(n)                                 (IPA_DEBUG_REG_BASE_PHYS + 0x00000474 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_OFFS(n)                                 (IPA_DEBUG_REG_BASE_OFFS + 0x00000474 + 0x10 * (n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_RMSK                                    0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_MAXn                                             2
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_ATTR                                           0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_INI(n)        \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_ADDR(n), HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_ADDR(n), mask)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_ADDR(n),val)
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_ADDR(n),mask,val,HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_INI(n))
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_VALUE_BMSK                              0xffffffff
#define HWIO_IPA_LOG_BUF_HW_SNIF_EL_MASK_VAL_3_CLI_n_VALUE_SHFT                                     0x0

#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x00000498)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x00000498)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x00000498)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_RMSK                                                     0x7
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_ATTR                                                     0x3
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_ADDR, HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_RMSK)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_IN)
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_SRC_GROUP_SEL_BMSK                                       0x7
#define HWIO_IPA_LOG_BUF_HW_SNIF_LEGACY_RX_SRC_GROUP_SEL_SHFT                                       0x0

#define HWIO_IPA_ACKMNGR_CMDQ_CMD_ADDR                                                       (IPA_DEBUG_REG_BASE      + 0x000004a0)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_PHYS                                                       (IPA_DEBUG_REG_BASE_PHYS + 0x000004a0)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_OFFS                                                       (IPA_DEBUG_REG_BASE_OFFS + 0x000004a0)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_RMSK                                                            0x7ff
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_ATTR                                                              0x3
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_CMD_ADDR, HWIO_IPA_ACKMNGR_CMDQ_CMD_RMSK)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_CMD_ADDR, m)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_ACKMNGR_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_ACKMNGR_CMDQ_CMD_ADDR,m,v,HWIO_IPA_ACKMNGR_CMDQ_CMD_IN)
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_RD_REQ_BMSK                                                     0x400
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_RD_REQ_SHFT                                                       0xa
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_CMD_CLIENT_BMSK                                                 0x3fc
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_CMD_CLIENT_SHFT                                                   0x2
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_POP_CMD_BMSK                                                      0x2
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_POP_CMD_SHFT                                                      0x1
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_WRITE_CMD_BMSK                                                    0x1
#define HWIO_IPA_ACKMNGR_CMDQ_CMD_WRITE_CMD_SHFT                                                    0x0

#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_ADDR                                                   (IPA_DEBUG_REG_BASE      + 0x000004b8)
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_PHYS                                                   (IPA_DEBUG_REG_BASE_PHYS + 0x000004b8)
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_OFFS                                                   (IPA_DEBUG_REG_BASE_OFFS + 0x000004b8)
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_RMSK                                                    0xfffffff
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_ATTR                                                          0x1
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_ADDR, HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_RMSK, HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_ATTR)
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_ADDR, m, HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_ATTR)
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_ERROR_BMSK                                         0x8000000
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_ERROR_SHFT                                              0x1b
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_VALID_BMSK                                  0x4000000
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_VALID_SHFT                                       0x1a
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_SENT_BMSK                                          0x2000000
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_SENT_SHFT                                               0x19
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_ORIGIN_BMSK                                        0x1000000
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_ORIGIN_SHFT                                             0x18
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_LENGTH_BMSK                                         0xffff00
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_LENGTH_SHFT                                              0x8
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_BMSK                                             0xff
#define HWIO_IPA_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_SHFT                                              0x0

#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x000004bc)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x000004bc)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x000004bc)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_RMSK                                                         0x1ff
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_ATTR                                                           0x1
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_STATUS_ADDR, HWIO_IPA_ACKMNGR_CMDQ_STATUS_RMSK, HWIO_IPA_ACKMNGR_CMDQ_STATUS_ATTR)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_STATUS_ADDR, m, HWIO_IPA_ACKMNGR_CMDQ_STATUS_ATTR)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                              0x1fc
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                                0x2
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_CMDQ_FULL_BMSK                                                 0x2
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_CMDQ_FULL_SHFT                                                 0x1
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_STATUS_BMSK                                                    0x1
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_STATUS_SHFT                                                    0x0

#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_ADDR(n)                                         (IPA_DEBUG_REG_BASE      + 0x000004c0 + 0x4 * (n))
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_PHYS(n)                                         (IPA_DEBUG_REG_BASE_PHYS + 0x000004c0 + 0x4 * (n))
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_OFFS(n)                                         (IPA_DEBUG_REG_BASE_OFFS + 0x000004c0 + 0x4 * (n))
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_RMSK                                            0xffffffff
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_MAXn                                                     1
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_ATTR                                                   0x1
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_ADDR(n), HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_RMSK)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_ADDR(n), mask)
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_BMSK                                 0xffffffff
#define HWIO_IPA_ACKMNGR_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_SHFT                                        0x0

#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x000004e0)
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x000004e0)
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x000004e0)
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_RMSK                                                           0x7f
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_ATTR                                                            0x1
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_COUNT_ADDR, HWIO_IPA_ACKMNGR_CMDQ_COUNT_RMSK, HWIO_IPA_ACKMNGR_CMDQ_COUNT_ATTR)
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_CMDQ_COUNT_ADDR, m, HWIO_IPA_ACKMNGR_CMDQ_COUNT_ATTR)
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_FIFO_COUNT_BMSK                                                0x7f
#define HWIO_IPA_ACKMNGR_CMDQ_COUNT_FIFO_COUNT_SHFT                                                 0x0

#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_ADDR                                                   (IPA_DEBUG_REG_BASE      + 0x000004e4)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_PHYS                                                   (IPA_DEBUG_REG_BASE_PHYS + 0x000004e4)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_OFFS                                                   (IPA_DEBUG_REG_BASE_OFFS + 0x000004e4)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_RMSK                                                         0x3f
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_ATTR                                                          0x3
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_IN          \
        in_dword_masked(HWIO_IPA_GSI_FIFO_STATUS_CTRL_ADDR, HWIO_IPA_GSI_FIFO_STATUS_CTRL_RMSK, HWIO_IPA_GSI_FIFO_STATUS_CTRL_ATTR)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_FIFO_STATUS_CTRL_ADDR, m, HWIO_IPA_GSI_FIFO_STATUS_CTRL_ATTR)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_FIFO_STATUS_CTRL_ADDR,v, HWIO_IPA_GSI_FIFO_STATUS_CTRL_ATTR)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_FIFO_STATUS_CTRL_ADDR,m,v,HWIO_IPA_GSI_FIFO_STATUS_CTRL_IN)
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_IPA_GSI_FIFO_STATUS_EN_BMSK                                  0x20
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_IPA_GSI_FIFO_STATUS_EN_SHFT                                   0x5
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_IPA_GSI_FIFO_STATUS_PORT_SEL_BMSK                            0x1f
#define HWIO_IPA_GSI_FIFO_STATUS_CTRL_IPA_GSI_FIFO_STATUS_PORT_SEL_SHFT                             0x0

#define HWIO_IPA_GSI_TLV_FIFO_STATUS_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x000004e8)
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x000004e8)
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x000004e8)
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_RMSK                                                    0x7fffffff
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_ATTR                                                           0x1
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_IN          \
        in_dword_masked(HWIO_IPA_GSI_TLV_FIFO_STATUS_ADDR, HWIO_IPA_GSI_TLV_FIFO_STATUS_RMSK, HWIO_IPA_GSI_TLV_FIFO_STATUS_ATTR)
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TLV_FIFO_STATUS_ADDR, m, HWIO_IPA_GSI_TLV_FIFO_STATUS_ATTR)
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_HEAD_IS_BUBBLE_BMSK                                0x40000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_HEAD_IS_BUBBLE_SHFT                                      0x1e
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_FULL_PUB_BMSK                                      0x20000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_FULL_PUB_SHFT                                            0x1d
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_ALMOST_FULL_PUB_BMSK                               0x10000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_ALMOST_FULL_PUB_SHFT                                     0x1c
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_FULL_BMSK                                           0x8000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_FULL_SHFT                                                0x1b
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_ALMOST_FULL_BMSK                                    0x4000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_ALMOST_FULL_SHFT                                         0x1a
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_EMPTY_PUB_BMSK                                      0x2000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_EMPTY_PUB_SHFT                                           0x19
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_EMPTY_BMSK                                          0x1000000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_EMPTY_SHFT                                               0x18
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_RD_PUB_PTR_BMSK                                      0xff0000
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_RD_PUB_PTR_SHFT                                          0x10
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_RD_PTR_BMSK                                            0xff00
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_RD_PTR_SHFT                                               0x8
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_WR_PTR_BMSK                                              0xff
#define HWIO_IPA_GSI_TLV_FIFO_STATUS_FIFO_WR_PTR_SHFT                                               0x0

#define HWIO_IPA_GSI_AOS_FIFO_STATUS_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x000004ec)
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x000004ec)
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x000004ec)
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_RMSK                                                    0x7fffffff
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_ATTR                                                           0x1
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_IN          \
        in_dword_masked(HWIO_IPA_GSI_AOS_FIFO_STATUS_ADDR, HWIO_IPA_GSI_AOS_FIFO_STATUS_RMSK, HWIO_IPA_GSI_AOS_FIFO_STATUS_ATTR)
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_AOS_FIFO_STATUS_ADDR, m, HWIO_IPA_GSI_AOS_FIFO_STATUS_ATTR)
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_HEAD_IS_BUBBLE_BMSK                                0x40000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_HEAD_IS_BUBBLE_SHFT                                      0x1e
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_FULL_PUB_BMSK                                      0x20000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_FULL_PUB_SHFT                                            0x1d
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_ALMOST_FULL_PUB_BMSK                               0x10000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_ALMOST_FULL_PUB_SHFT                                     0x1c
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_FULL_BMSK                                           0x8000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_FULL_SHFT                                                0x1b
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_ALMOST_FULL_BMSK                                    0x4000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_ALMOST_FULL_SHFT                                         0x1a
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_EMPTY_PUB_BMSK                                      0x2000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_EMPTY_PUB_SHFT                                           0x19
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_EMPTY_BMSK                                          0x1000000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_EMPTY_SHFT                                               0x18
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_RD_PUB_PTR_BMSK                                      0xff0000
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_RD_PUB_PTR_SHFT                                          0x10
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_RD_PTR_BMSK                                            0xff00
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_RD_PTR_SHFT                                               0x8
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_WR_PTR_BMSK                                              0xff
#define HWIO_IPA_GSI_AOS_FIFO_STATUS_FIFO_WR_PTR_SHFT                                               0x0

#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x000004f0)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x000004f0)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x000004f0)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_RMSK                                                    0xffff
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_ATTR                                                       0x1
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_IN          \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_ADDR, HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_RMSK)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_INM(m)      \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_ADDR, m)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_CONS_BYTES_BMSK                                         0xffff
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_TLV_CONS_BYTES_SHFT                                            0x0

#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x000004f4)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x000004f4)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x000004f4)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_RMSK                                                    0xffff
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_ATTR                                                       0x1
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_IN          \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_ADDR, HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_RMSK)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_INM(m)      \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_ADDR, m)
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_CONS_BYTES_BMSK                                         0xffff
#define HWIO_IPA_ENDP_GSI_CONS_BYTES_AOS_CONS_BYTES_SHFT                                            0x0

#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x000004f8)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x000004f8)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x000004f8)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_RMSK                                              0x80f7ffff
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ATTR                                                     0x3
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_IN          \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ADDR, HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_RMSK)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_INM(m)      \
        in_dword_masked(HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ADDR, m)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_OUT(v)      \
        out_dword(HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ADDR,v)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ADDR,m,v,HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_IN)
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ENABLE_BMSK                                       0x80000000
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_ENABLE_SHFT                                             0x1f
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_RAM_REGION_SIZE_BMSK                                0xf00000
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_RAM_REGION_SIZE_SHFT                                    0x14
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_RAM_REGION_BADDR_BMSK                                0x7ffff
#define HWIO_IPA_LOG_BUF_HW_GEN_RAM_OFFSET_RAM_REGION_BADDR_SHFT                                    0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000538)
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000538)
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000538)
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RMSK                                                           0x7f
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_ATTR                                                            0x2
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_UC_RX_HND_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_RD_PKT_ENHANCED_BMSK                                   0x40
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_RD_PKT_ENHANCED_SHFT                                    0x6
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_WR_PKT_BMSK                                            0x20
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_WR_PKT_SHFT                                             0x5
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_RD_PKT_BMSK                                            0x10
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_RD_PKT_SHFT                                             0x4
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_WR_CMD_BMSK                                             0x8
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_WR_CMD_SHFT                                             0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_RD_CMD_BMSK                                             0x4
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_RELEASE_RD_CMD_SHFT                                             0x2
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_POP_CMD_BMSK                                                    0x2
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_POP_CMD_SHFT                                                    0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_WRITE_CMD_BMSK                                                  0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_CMD_WRITE_CMD_SHFT                                                  0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x0000053c)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x0000053c)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x0000053c)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_RMSK                                                            0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_ATTR                                                            0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_CFG_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_CFG_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_CFG_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_OUT(v)      \
        out_dword(HWIO_IPA_UC_RX_HND_CMDQ_CFG_ADDR,v)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_RX_HND_CMDQ_CFG_ADDR,m,v,HWIO_IPA_UC_RX_HND_CMDQ_CFG_IN)
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_BLOCK_WR_BMSK                                                   0x2
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_BLOCK_WR_SHFT                                                   0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_BLOCK_RD_BMSK                                                   0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_CFG_BLOCK_RD_SHFT                                                   0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000540)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000540)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000540)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_ATTR                                                      0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_IN)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_CMDQ_SRC_LEN_F_BMSK                                0xffff0000
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_CMDQ_SRC_LEN_F_SHFT                                      0x10
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_CMDQ_PACKET_LEN_F_BMSK                                 0xffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_0_CMDQ_PACKET_LEN_F_SHFT                                    0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000544)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000544)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000544)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_ATTR                                                      0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_OUT(v)      \
        out_dword(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_ADDR,v)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_ADDR,m,v,HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_IN)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_METADATA_F_BMSK                               0xff000000
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_METADATA_F_SHFT                                     0x18
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_OPCODE_F_BMSK                                   0xff0000
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_OPCODE_F_SHFT                                       0x10
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_FLAGS_F_BMSK                                      0xfc00
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_FLAGS_F_SHFT                                         0xa
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_ORDER_F_BMSK                                       0x300
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_ORDER_F_SHFT                                         0x8
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_SRC_PIPE_F_BMSK                                     0xff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_1_CMDQ_SRC_PIPE_F_SHFT                                      0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000548)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000548)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000548)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_ATTR                                                      0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_OUT(v)      \
        out_dword(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_ADDR,v)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_ADDR,m,v,HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_IN)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_CMDQ_ADDR_LSB_F_BMSK                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_2_CMDQ_ADDR_LSB_F_SHFT                                      0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x0000054c)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x0000054c)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x0000054c)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_ATTR                                                      0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_OUT(v)      \
        out_dword(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_ADDR,v)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_ADDR,m,v,HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_IN)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_CMDQ_ADDR_MSB_F_BMSK                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_WR_3_CMDQ_ADDR_MSB_F_SHFT                                      0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000550)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000550)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000550)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_ATTR                                                      0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_CMDQ_SRC_LEN_F_BMSK                                0xffff0000
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_CMDQ_SRC_LEN_F_SHFT                                      0x10
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_CMDQ_PACKET_LEN_F_BMSK                                 0xffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_0_CMDQ_PACKET_LEN_F_SHFT                                    0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000554)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000554)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000554)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_ATTR                                                      0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_METADATA_F_BMSK                               0xff000000
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_METADATA_F_SHFT                                     0x18
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_OPCODE_F_BMSK                                   0xff0000
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_OPCODE_F_SHFT                                       0x10
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_FLAGS_F_BMSK                                      0xfc00
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_FLAGS_F_SHFT                                         0xa
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_ORDER_F_BMSK                                       0x300
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_ORDER_F_SHFT                                         0x8
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_SRC_PIPE_F_BMSK                                     0xff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_1_CMDQ_SRC_PIPE_F_SHFT                                      0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000558)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000558)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000558)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_ATTR                                                      0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_CMDQ_ADDR_LSB_F_BMSK                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_2_CMDQ_ADDR_LSB_F_SHFT                                      0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x0000055c)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x0000055c)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x0000055c)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_RMSK                                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_ATTR                                                      0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_CMDQ_ADDR_MSB_F_BMSK                               0xffffffff
#define HWIO_IPA_UC_RX_HND_CMDQ_DATA_RD_3_CMDQ_ADDR_MSB_F_SHFT                                      0x0

#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000560)
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000560)
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000560)
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_RMSK                                                       0x7ff
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_ATTR                                                         0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_STATUS_ADDR, HWIO_IPA_UC_RX_HND_CMDQ_STATUS_RMSK)
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_UC_RX_HND_CMDQ_STATUS_ADDR, m)
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                            0x780
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                              0x7
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_COUNT_BMSK                                             0x78
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_COUNT_SHFT                                              0x3
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_FULL_BMSK                                               0x4
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_FULL_SHFT                                               0x2
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_EMPTY_BMSK                                              0x2
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_CMDQ_EMPTY_SHFT                                              0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_STATUS_BMSK                                                  0x1
#define HWIO_IPA_UC_RX_HND_CMDQ_STATUS_STATUS_SHFT                                                  0x0

#define HWIO_IPA_RAM_HW_FIRST_ADDR                                                           (IPA_DEBUG_REG_BASE      + 0x00000564)
#define HWIO_IPA_RAM_HW_FIRST_PHYS                                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000564)
#define HWIO_IPA_RAM_HW_FIRST_OFFS                                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000564)
#define HWIO_IPA_RAM_HW_FIRST_RMSK                                                           0xffffffff
#define HWIO_IPA_RAM_HW_FIRST_ATTR                                                                  0x1
#define HWIO_IPA_RAM_HW_FIRST_IN          \
        in_dword_masked(HWIO_IPA_RAM_HW_FIRST_ADDR, HWIO_IPA_RAM_HW_FIRST_RMSK)
#define HWIO_IPA_RAM_HW_FIRST_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_HW_FIRST_ADDR, m)
#define HWIO_IPA_RAM_HW_FIRST_ADDRESS_BMSK                                                   0xffffffff
#define HWIO_IPA_RAM_HW_FIRST_ADDRESS_SHFT                                                          0x0

#define HWIO_IPA_RAM_HW_LAST_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x00000568)
#define HWIO_IPA_RAM_HW_LAST_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000568)
#define HWIO_IPA_RAM_HW_LAST_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000568)
#define HWIO_IPA_RAM_HW_LAST_RMSK                                                            0xffffffff
#define HWIO_IPA_RAM_HW_LAST_ATTR                                                                   0x1
#define HWIO_IPA_RAM_HW_LAST_IN          \
        in_dword_masked(HWIO_IPA_RAM_HW_LAST_ADDR, HWIO_IPA_RAM_HW_LAST_RMSK)
#define HWIO_IPA_RAM_HW_LAST_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_HW_LAST_ADDR, m)
#define HWIO_IPA_RAM_HW_LAST_ADDRESS_BMSK                                                    0xffffffff
#define HWIO_IPA_RAM_HW_LAST_ADDRESS_SHFT                                                           0x0

#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x00000570)
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x00000570)
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x00000570)
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_RMSK                                                0xffffffff
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_ATTR                                                       0x1
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_ADDR, HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_ADDRESS_BMSK                                        0xffffffff
#define HWIO_IPA_RAM_FRAG_FRST_BASE_ADDR_ADDRESS_SHFT                                               0x0

#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x00000574)
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x00000574)
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x00000574)
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_RMSK                                                0xffffffff
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_ATTR                                                       0x1
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_ADDR, HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_ADDRESS_BMSK                                        0xffffffff
#define HWIO_IPA_RAM_FRAG_SCND_BASE_ADDR_ADDRESS_SHFT                                               0x0

#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000578)
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000578)
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000578)
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_RMSK                                                  0xffffffff
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_ATTR                                                         0x1
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_ADDR, HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_ADDRESS_BMSK                                          0xffffffff
#define HWIO_IPA_RAM_GSI_TLV_BASE_ADDR_ADDRESS_SHFT                                                 0x0

#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x0000057c)
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x0000057c)
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x0000057c)
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_RMSK                                                    0xffffffff
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_ATTR                                                           0x1
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_IN          \
        in_dword_masked(HWIO_IPA_RAM_DCPH_KEYS_FIRST_ADDR, HWIO_IPA_RAM_DCPH_KEYS_FIRST_RMSK)
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_DCPH_KEYS_FIRST_ADDR, m)
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_ADDRESS_BMSK                                            0xffffffff
#define HWIO_IPA_RAM_DCPH_KEYS_FIRST_ADDRESS_SHFT                                                   0x0

#define HWIO_IPA_RAM_DCPH_KEYS_LAST_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000580)
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000580)
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000580)
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_RMSK                                                     0xffffffff
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_ATTR                                                            0x1
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_IN          \
        in_dword_masked(HWIO_IPA_RAM_DCPH_KEYS_LAST_ADDR, HWIO_IPA_RAM_DCPH_KEYS_LAST_RMSK)
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_DCPH_KEYS_LAST_ADDR, m)
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_ADDRESS_BMSK                                             0xffffffff
#define HWIO_IPA_RAM_DCPH_KEYS_LAST_ADDRESS_SHFT                                                    0x0

#define HWIO_IPA_DPS_SEQUENCER_FIRST_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x00000584)
#define HWIO_IPA_DPS_SEQUENCER_FIRST_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x00000584)
#define HWIO_IPA_DPS_SEQUENCER_FIRST_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x00000584)
#define HWIO_IPA_DPS_SEQUENCER_FIRST_RMSK                                                    0xffffffff
#define HWIO_IPA_DPS_SEQUENCER_FIRST_ATTR                                                           0x1
#define HWIO_IPA_DPS_SEQUENCER_FIRST_IN          \
        in_dword_masked(HWIO_IPA_DPS_SEQUENCER_FIRST_ADDR, HWIO_IPA_DPS_SEQUENCER_FIRST_RMSK)
#define HWIO_IPA_DPS_SEQUENCER_FIRST_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_SEQUENCER_FIRST_ADDR, m)
#define HWIO_IPA_DPS_SEQUENCER_FIRST_ADDRESS_BMSK                                            0xffffffff
#define HWIO_IPA_DPS_SEQUENCER_FIRST_ADDRESS_SHFT                                                   0x0

#define HWIO_IPA_DPS_SEQUENCER_LAST_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000588)
#define HWIO_IPA_DPS_SEQUENCER_LAST_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000588)
#define HWIO_IPA_DPS_SEQUENCER_LAST_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000588)
#define HWIO_IPA_DPS_SEQUENCER_LAST_RMSK                                                     0xffffffff
#define HWIO_IPA_DPS_SEQUENCER_LAST_ATTR                                                            0x1
#define HWIO_IPA_DPS_SEQUENCER_LAST_IN          \
        in_dword_masked(HWIO_IPA_DPS_SEQUENCER_LAST_ADDR, HWIO_IPA_DPS_SEQUENCER_LAST_RMSK)
#define HWIO_IPA_DPS_SEQUENCER_LAST_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_SEQUENCER_LAST_ADDR, m)
#define HWIO_IPA_DPS_SEQUENCER_LAST_ADDRESS_BMSK                                             0xffffffff
#define HWIO_IPA_DPS_SEQUENCER_LAST_ADDRESS_SHFT                                                    0x0

#define HWIO_IPA_HPS_SEQUENCER_FIRST_ADDR                                                    (IPA_DEBUG_REG_BASE      + 0x0000058c)
#define HWIO_IPA_HPS_SEQUENCER_FIRST_PHYS                                                    (IPA_DEBUG_REG_BASE_PHYS + 0x0000058c)
#define HWIO_IPA_HPS_SEQUENCER_FIRST_OFFS                                                    (IPA_DEBUG_REG_BASE_OFFS + 0x0000058c)
#define HWIO_IPA_HPS_SEQUENCER_FIRST_RMSK                                                    0xffffffff
#define HWIO_IPA_HPS_SEQUENCER_FIRST_ATTR                                                           0x1
#define HWIO_IPA_HPS_SEQUENCER_FIRST_IN          \
        in_dword_masked(HWIO_IPA_HPS_SEQUENCER_FIRST_ADDR, HWIO_IPA_HPS_SEQUENCER_FIRST_RMSK)
#define HWIO_IPA_HPS_SEQUENCER_FIRST_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_SEQUENCER_FIRST_ADDR, m)
#define HWIO_IPA_HPS_SEQUENCER_FIRST_ADDRESS_BMSK                                            0xffffffff
#define HWIO_IPA_HPS_SEQUENCER_FIRST_ADDRESS_SHFT                                                   0x0

#define HWIO_IPA_HPS_SEQUENCER_LAST_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000590)
#define HWIO_IPA_HPS_SEQUENCER_LAST_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000590)
#define HWIO_IPA_HPS_SEQUENCER_LAST_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000590)
#define HWIO_IPA_HPS_SEQUENCER_LAST_RMSK                                                     0xffffffff
#define HWIO_IPA_HPS_SEQUENCER_LAST_ATTR                                                            0x1
#define HWIO_IPA_HPS_SEQUENCER_LAST_IN          \
        in_dword_masked(HWIO_IPA_HPS_SEQUENCER_LAST_ADDR, HWIO_IPA_HPS_SEQUENCER_LAST_RMSK)
#define HWIO_IPA_HPS_SEQUENCER_LAST_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_SEQUENCER_LAST_ADDR, m)
#define HWIO_IPA_HPS_SEQUENCER_LAST_ADDRESS_BMSK                                             0xffffffff
#define HWIO_IPA_HPS_SEQUENCER_LAST_ADDRESS_SHFT                                                    0x0

#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000594)
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000594)
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000594)
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_RMSK                                                  0xffffffff
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_ATTR                                                         0x1
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_ADDR, HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_ADDRESS_BMSK                                          0xffffffff
#define HWIO_IPA_RAM_PKT_CTX_BASE_ADDR_ADDRESS_SHFT                                                 0x0

#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000598)
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000598)
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000598)
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_RMSK                                                  0xffffffff
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_ATTR                                                         0x1
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_SW_AREA_BASE_ADDR_ADDR, HWIO_IPA_RAM_SW_AREA_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_SW_AREA_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_ADDRESS_BMSK                                          0xffffffff
#define HWIO_IPA_RAM_SW_AREA_BASE_ADDR_ADDRESS_SHFT                                                 0x0

#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x0000059c)
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x0000059c)
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x0000059c)
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_RMSK                                               0xffffffff
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_ATTR                                                      0x1
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_ADDR, HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_ADDRESS_BMSK                                       0xffffffff
#define HWIO_IPA_RAM_HDRI_TYPE1_BASE_ADDR_ADDRESS_SHFT                                              0x0

#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_ADDR                                        (IPA_DEBUG_REG_BASE      + 0x000005a0)
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_PHYS                                        (IPA_DEBUG_REG_BASE_PHYS + 0x000005a0)
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_OFFS                                        (IPA_DEBUG_REG_BASE_OFFS + 0x000005a0)
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_RMSK                                        0xffffffff
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_ATTR                                               0x1
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_ADDR, HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_ADDRESS_BMSK                                0xffffffff
#define HWIO_IPA_RAM_AGGR_NLO_COUNTERS_BASE_ADDR_ADDRESS_SHFT                                       0x0

#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000005a4)
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000005a4)
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000005a4)
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_RMSK                                             0xffffffff
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_ATTR                                                    0x1
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_ADDR, HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_ADDRESS_BMSK                                     0xffffffff
#define HWIO_IPA_RAM_NLO_VP_CACHE_BASE_ADDR_ADDRESS_SHFT                                            0x0

#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x000005a8)
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x000005a8)
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x000005a8)
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_RMSK                                            0xffffffff
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_ATTR                                                   0x1
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_ADDR, HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_ADDRESS_BMSK                                    0xffffffff
#define HWIO_IPA_RAM_COAL_VP_CACHE_BASE_ADDR_ADDRESS_SHFT                                           0x0

#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000005ac)
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000005ac)
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000005ac)
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_RMSK                                             0xffffffff
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_ATTR                                                    0x1
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_ADDR, HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_ADDRESS_BMSK                                     0xffffffff
#define HWIO_IPA_RAM_COAL_VP_FIFO_BASE_ADDR_ADDRESS_SHFT                                            0x0

#define HWIO_IPA_RAM_AGGR_BASE_ADDR_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x000005b4)
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x000005b4)
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x000005b4)
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_RMSK                                                     0xffffffff
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_ATTR                                                            0x1
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_AGGR_BASE_ADDR_ADDR, HWIO_IPA_RAM_AGGR_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_AGGR_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_ADDRESS_BMSK                                             0xffffffff
#define HWIO_IPA_RAM_AGGR_BASE_ADDR_ADDRESS_SHFT                                                    0x0

#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x000005b8)
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x000005b8)
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x000005b8)
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_RMSK                                              0xffffffff
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_ATTR                                                     0x1
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_ADDR, HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_ADDRESS_BMSK                                      0xffffffff
#define HWIO_IPA_RAM_TX_COUNTERS_BASE_ADDR_ADDRESS_SHFT                                             0x0

#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_ADDR                                                 (IPA_DEBUG_REG_BASE      + 0x000005bc)
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_PHYS                                                 (IPA_DEBUG_REG_BASE_PHYS + 0x000005bc)
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_OFFS                                                 (IPA_DEBUG_REG_BASE_OFFS + 0x000005bc)
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_RMSK                                                 0xffffffff
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_ATTR                                                        0x1
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_ADDR, HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_ADDRESS_BMSK                                         0xffffffff
#define HWIO_IPA_RAM_DPL_FIFO_BASE_ADDR_ADDRESS_SHFT                                                0x0

#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_ADDR                                       (IPA_DEBUG_REG_BASE      + 0x000005c0)
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_PHYS                                       (IPA_DEBUG_REG_BASE_PHYS + 0x000005c0)
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_OFFS                                       (IPA_DEBUG_REG_BASE_OFFS + 0x000005c0)
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_RMSK                                       0xffffffff
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_ATTR                                              0x1
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_ADDR, HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_ADDRESS_BMSK                               0xffffffff
#define HWIO_IPA_RAM_COAL_MASTER_VP_CTX_BASE_ADDR_ADDRESS_SHFT                                      0x0

#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_ADDR                                      (IPA_DEBUG_REG_BASE      + 0x000005c4)
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_PHYS                                      (IPA_DEBUG_REG_BASE_PHYS + 0x000005c4)
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_OFFS                                      (IPA_DEBUG_REG_BASE_OFFS + 0x000005c4)
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_RMSK                                      0xffffffff
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_ATTR                                             0x1
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_ADDR, HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_ADDRESS_BMSK                              0xffffffff
#define HWIO_IPA_RAM_COAL_MASTER_VP_AGGR_BASE_ADDR_ADDRESS_SHFT                                     0x0

#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_ADDR                                        (IPA_DEBUG_REG_BASE      + 0x000005c8)
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_PHYS                                        (IPA_DEBUG_REG_BASE_PHYS + 0x000005c8)
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_OFFS                                        (IPA_DEBUG_REG_BASE_OFFS + 0x000005c8)
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_RMSK                                        0xffffffff
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_ATTR                                               0x1
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_ADDR, HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_ADDRESS_BMSK                                0xffffffff
#define HWIO_IPA_RAM_COAL_SLAVE_VP_CTX_BASE_ADDR_ADDRESS_SHFT                                       0x0

#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x000005cc)
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x000005cc)
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x000005cc)
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_RMSK                                              0xffffffff
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_ATTR                                                     0x1
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_ADDR, HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_ADDRESS_BMSK                                      0xffffffff
#define HWIO_IPA_RAM_UL_NLO_AGGR_BASE_ADDR_ADDRESS_SHFT                                             0x0

#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x000005d0)
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x000005d0)
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x000005d0)
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_RMSK                                             0xffffffff
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_ATTR                                                    0x1
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_ADDR, HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_ADDRESS_BMSK                                     0xffffffff
#define HWIO_IPA_RAM_UC_IRAM_ADDR_BASE_ADDR_ADDRESS_SHFT                                            0x0

#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x000005d4)
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x000005d4)
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x000005d4)
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_RMSK                                               0xffffffff
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_ATTR                                                      0x1
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_ADDR, HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_ADDRESS_BMSK                                       0xffffffff
#define HWIO_IPA_RAM_SNIFFER_HW_BASE_ADDR_ADDRESS_SHFT                                              0x0

#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_ADDR                                      (IPA_DEBUG_REG_BASE      + 0x000005d8)
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_PHYS                                      (IPA_DEBUG_REG_BASE_PHYS + 0x000005d8)
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_OFFS                                      (IPA_DEBUG_REG_BASE_OFFS + 0x000005d8)
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_RMSK                                      0xffffffff
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_ATTR                                             0x1
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_ADDR, HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_RMSK)
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_ADDRESS_BMSK                              0xffffffff
#define HWIO_IPA_RAM_FILTER_ROUTER_CACHE_BASE_ADDR_ADDRESS_SHFT                                     0x0

#define HWIO_IPA_SPARE_REG_1_ADDR                                                            (IPA_DEBUG_REG_BASE      + 0x000005dc)
#define HWIO_IPA_SPARE_REG_1_PHYS                                                            (IPA_DEBUG_REG_BASE_PHYS + 0x000005dc)
#define HWIO_IPA_SPARE_REG_1_OFFS                                                            (IPA_DEBUG_REG_BASE_OFFS + 0x000005dc)
#define HWIO_IPA_SPARE_REG_1_RMSK                                                                0xffff
#define HWIO_IPA_SPARE_REG_1_ATTR                                                                   0x3
#define HWIO_IPA_SPARE_REG_1_IN          \
        in_dword_masked(HWIO_IPA_SPARE_REG_1_ADDR, HWIO_IPA_SPARE_REG_1_RMSK)
#define HWIO_IPA_SPARE_REG_1_INM(m)      \
        in_dword_masked(HWIO_IPA_SPARE_REG_1_ADDR, m)
#define HWIO_IPA_SPARE_REG_1_OUT(v)      \
        out_dword(HWIO_IPA_SPARE_REG_1_ADDR,v)
#define HWIO_IPA_SPARE_REG_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SPARE_REG_1_ADDR,m,v,HWIO_IPA_SPARE_REG_1_IN)
#define HWIO_IPA_SPARE_REG_1_SPARE_BITS_BMSK                                                     0xffff
#define HWIO_IPA_SPARE_REG_1_SPARE_BITS_SHFT                                                        0x0

#define HWIO_IPA_HPS_UC2SEQ_PUSH_ADDR                                                        (IPA_DEBUG_REG_BASE      + 0x000005e0)
#define HWIO_IPA_HPS_UC2SEQ_PUSH_PHYS                                                        (IPA_DEBUG_REG_BASE_PHYS + 0x000005e0)
#define HWIO_IPA_HPS_UC2SEQ_PUSH_OFFS                                                        (IPA_DEBUG_REG_BASE_OFFS + 0x000005e0)
#define HWIO_IPA_HPS_UC2SEQ_PUSH_RMSK                                                        0xc03fffff
#define HWIO_IPA_HPS_UC2SEQ_PUSH_ATTR                                                               0x2
#define HWIO_IPA_HPS_UC2SEQ_PUSH_OUT(v)      \
        out_dword(HWIO_IPA_HPS_UC2SEQ_PUSH_ADDR,v)
#define HWIO_IPA_HPS_UC2SEQ_PUSH_TYPE_BMSK                                                   0x80000000
#define HWIO_IPA_HPS_UC2SEQ_PUSH_TYPE_SHFT                                                         0x1f
#define HWIO_IPA_HPS_UC2SEQ_PUSH_VIRT_OPCODE_BMSK                                            0x40000000
#define HWIO_IPA_HPS_UC2SEQ_PUSH_VIRT_OPCODE_SHFT                                                  0x1e
#define HWIO_IPA_HPS_UC2SEQ_PUSH_CTX_ID_BMSK                                                   0x3c0000
#define HWIO_IPA_HPS_UC2SEQ_PUSH_CTX_ID_SHFT                                                       0x12
#define HWIO_IPA_HPS_UC2SEQ_PUSH_SRC_ID_BMSK                                                    0x3fc00
#define HWIO_IPA_HPS_UC2SEQ_PUSH_SRC_ID_SHFT                                                        0xa
#define HWIO_IPA_HPS_UC2SEQ_PUSH_SRC_FLAGS_BMSK                                                   0x300
#define HWIO_IPA_HPS_UC2SEQ_PUSH_SRC_FLAGS_SHFT                                                     0x8
#define HWIO_IPA_HPS_UC2SEQ_PUSH_SRC_PIPE_BMSK                                                     0xff
#define HWIO_IPA_HPS_UC2SEQ_PUSH_SRC_PIPE_SHFT                                                      0x0

#define HWIO_IPA_HPS_UC2SEQ_STATUS_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x000005e4)
#define HWIO_IPA_HPS_UC2SEQ_STATUS_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x000005e4)
#define HWIO_IPA_HPS_UC2SEQ_STATUS_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x000005e4)
#define HWIO_IPA_HPS_UC2SEQ_STATUS_RMSK                                                             0xf
#define HWIO_IPA_HPS_UC2SEQ_STATUS_ATTR                                                             0x1
#define HWIO_IPA_HPS_UC2SEQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_HPS_UC2SEQ_STATUS_ADDR, HWIO_IPA_HPS_UC2SEQ_STATUS_RMSK)
#define HWIO_IPA_HPS_UC2SEQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_UC2SEQ_STATUS_ADDR, m)
#define HWIO_IPA_HPS_UC2SEQ_STATUS_FILL_LEVEL_BMSK                                                  0xf
#define HWIO_IPA_HPS_UC2SEQ_STATUS_FILL_LEVEL_SHFT                                                  0x0

#define HWIO_IPA_HPS_SEQ2UC_RD_ADDR                                                          (IPA_DEBUG_REG_BASE      + 0x000005e8)
#define HWIO_IPA_HPS_SEQ2UC_RD_PHYS                                                          (IPA_DEBUG_REG_BASE_PHYS + 0x000005e8)
#define HWIO_IPA_HPS_SEQ2UC_RD_OFFS                                                          (IPA_DEBUG_REG_BASE_OFFS + 0x000005e8)
#define HWIO_IPA_HPS_SEQ2UC_RD_RMSK                                                          0x803fffff
#define HWIO_IPA_HPS_SEQ2UC_RD_ATTR                                                                 0x1
#define HWIO_IPA_HPS_SEQ2UC_RD_IN          \
        in_dword_masked(HWIO_IPA_HPS_SEQ2UC_RD_ADDR, HWIO_IPA_HPS_SEQ2UC_RD_RMSK)
#define HWIO_IPA_HPS_SEQ2UC_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_SEQ2UC_RD_ADDR, m)
#define HWIO_IPA_HPS_SEQ2UC_RD_TYPE_BMSK                                                     0x80000000
#define HWIO_IPA_HPS_SEQ2UC_RD_TYPE_SHFT                                                           0x1f
#define HWIO_IPA_HPS_SEQ2UC_RD_CTX_ID_BMSK                                                     0x3c0000
#define HWIO_IPA_HPS_SEQ2UC_RD_CTX_ID_SHFT                                                         0x12
#define HWIO_IPA_HPS_SEQ2UC_RD_SRC_ID_BMSK                                                      0x3fc00
#define HWIO_IPA_HPS_SEQ2UC_RD_SRC_ID_SHFT                                                          0xa
#define HWIO_IPA_HPS_SEQ2UC_RD_SRC_FLAGS_BMSK                                                     0x300
#define HWIO_IPA_HPS_SEQ2UC_RD_SRC_FLAGS_SHFT                                                       0x8
#define HWIO_IPA_HPS_SEQ2UC_RD_SRC_PIPE_BMSK                                                       0xff
#define HWIO_IPA_HPS_SEQ2UC_RD_SRC_PIPE_SHFT                                                        0x0

#define HWIO_IPA_HPS_SEQ2UC_STATUS_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x000005ec)
#define HWIO_IPA_HPS_SEQ2UC_STATUS_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x000005ec)
#define HWIO_IPA_HPS_SEQ2UC_STATUS_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x000005ec)
#define HWIO_IPA_HPS_SEQ2UC_STATUS_RMSK                                                             0xf
#define HWIO_IPA_HPS_SEQ2UC_STATUS_ATTR                                                             0x1
#define HWIO_IPA_HPS_SEQ2UC_STATUS_IN          \
        in_dword_masked(HWIO_IPA_HPS_SEQ2UC_STATUS_ADDR, HWIO_IPA_HPS_SEQ2UC_STATUS_RMSK)
#define HWIO_IPA_HPS_SEQ2UC_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_HPS_SEQ2UC_STATUS_ADDR, m)
#define HWIO_IPA_HPS_SEQ2UC_STATUS_FILL_LEVEL_BMSK                                                  0xf
#define HWIO_IPA_HPS_SEQ2UC_STATUS_FILL_LEVEL_SHFT                                                  0x0

#define HWIO_IPA_HPS_SEQ2UC_CMD_ADDR                                                         (IPA_DEBUG_REG_BASE      + 0x000005f0)
#define HWIO_IPA_HPS_SEQ2UC_CMD_PHYS                                                         (IPA_DEBUG_REG_BASE_PHYS + 0x000005f0)
#define HWIO_IPA_HPS_SEQ2UC_CMD_OFFS                                                         (IPA_DEBUG_REG_BASE_OFFS + 0x000005f0)
#define HWIO_IPA_HPS_SEQ2UC_CMD_RMSK                                                                0x1
#define HWIO_IPA_HPS_SEQ2UC_CMD_ATTR                                                                0x2
#define HWIO_IPA_HPS_SEQ2UC_CMD_OUT(v)      \
        out_dword(HWIO_IPA_HPS_SEQ2UC_CMD_ADDR,v)
#define HWIO_IPA_HPS_SEQ2UC_CMD_POP_BMSK                                                            0x1
#define HWIO_IPA_HPS_SEQ2UC_CMD_POP_SHFT                                                            0x0

#define HWIO_IPA_DPS_UC2SEQ_PUSH_ADDR                                                        (IPA_DEBUG_REG_BASE      + 0x000005f4)
#define HWIO_IPA_DPS_UC2SEQ_PUSH_PHYS                                                        (IPA_DEBUG_REG_BASE_PHYS + 0x000005f4)
#define HWIO_IPA_DPS_UC2SEQ_PUSH_OFFS                                                        (IPA_DEBUG_REG_BASE_OFFS + 0x000005f4)
#define HWIO_IPA_DPS_UC2SEQ_PUSH_RMSK                                                        0xbfffffff
#define HWIO_IPA_DPS_UC2SEQ_PUSH_ATTR                                                               0x2
#define HWIO_IPA_DPS_UC2SEQ_PUSH_OUT(v)      \
        out_dword(HWIO_IPA_DPS_UC2SEQ_PUSH_ADDR,v)
#define HWIO_IPA_DPS_UC2SEQ_PUSH_TYPE_BMSK                                                   0x80000000
#define HWIO_IPA_DPS_UC2SEQ_PUSH_TYPE_SHFT                                                         0x1f
#define HWIO_IPA_DPS_UC2SEQ_PUSH_DEST_PIPE_BMSK                                              0x3fc00000
#define HWIO_IPA_DPS_UC2SEQ_PUSH_DEST_PIPE_SHFT                                                    0x16
#define HWIO_IPA_DPS_UC2SEQ_PUSH_CTX_ID_BMSK                                                   0x3c0000
#define HWIO_IPA_DPS_UC2SEQ_PUSH_CTX_ID_SHFT                                                       0x12
#define HWIO_IPA_DPS_UC2SEQ_PUSH_SRC_ID_BMSK                                                    0x3fc00
#define HWIO_IPA_DPS_UC2SEQ_PUSH_SRC_ID_SHFT                                                        0xa
#define HWIO_IPA_DPS_UC2SEQ_PUSH_SRC_FLAGS_BMSK                                                   0x300
#define HWIO_IPA_DPS_UC2SEQ_PUSH_SRC_FLAGS_SHFT                                                     0x8
#define HWIO_IPA_DPS_UC2SEQ_PUSH_SRC_PIPE_BMSK                                                     0xff
#define HWIO_IPA_DPS_UC2SEQ_PUSH_SRC_PIPE_SHFT                                                      0x0

#define HWIO_IPA_DPS_UC2SEQ_STATUS_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x000005f8)
#define HWIO_IPA_DPS_UC2SEQ_STATUS_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x000005f8)
#define HWIO_IPA_DPS_UC2SEQ_STATUS_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x000005f8)
#define HWIO_IPA_DPS_UC2SEQ_STATUS_RMSK                                                             0xf
#define HWIO_IPA_DPS_UC2SEQ_STATUS_ATTR                                                             0x1
#define HWIO_IPA_DPS_UC2SEQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_DPS_UC2SEQ_STATUS_ADDR, HWIO_IPA_DPS_UC2SEQ_STATUS_RMSK)
#define HWIO_IPA_DPS_UC2SEQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_UC2SEQ_STATUS_ADDR, m)
#define HWIO_IPA_DPS_UC2SEQ_STATUS_FILL_LEVEL_BMSK                                                  0xf
#define HWIO_IPA_DPS_UC2SEQ_STATUS_FILL_LEVEL_SHFT                                                  0x0

#define HWIO_IPA_DPS_SEQ2UC_RD_ADDR                                                          (IPA_DEBUG_REG_BASE      + 0x000005fc)
#define HWIO_IPA_DPS_SEQ2UC_RD_PHYS                                                          (IPA_DEBUG_REG_BASE_PHYS + 0x000005fc)
#define HWIO_IPA_DPS_SEQ2UC_RD_OFFS                                                          (IPA_DEBUG_REG_BASE_OFFS + 0x000005fc)
#define HWIO_IPA_DPS_SEQ2UC_RD_RMSK                                                          0xbfffffff
#define HWIO_IPA_DPS_SEQ2UC_RD_ATTR                                                                 0x1
#define HWIO_IPA_DPS_SEQ2UC_RD_IN          \
        in_dword_masked(HWIO_IPA_DPS_SEQ2UC_RD_ADDR, HWIO_IPA_DPS_SEQ2UC_RD_RMSK)
#define HWIO_IPA_DPS_SEQ2UC_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_SEQ2UC_RD_ADDR, m)
#define HWIO_IPA_DPS_SEQ2UC_RD_TYPE_BMSK                                                     0x80000000
#define HWIO_IPA_DPS_SEQ2UC_RD_TYPE_SHFT                                                           0x1f
#define HWIO_IPA_DPS_SEQ2UC_RD_DEST_PIPE_BMSK                                                0x3fc00000
#define HWIO_IPA_DPS_SEQ2UC_RD_DEST_PIPE_SHFT                                                      0x16
#define HWIO_IPA_DPS_SEQ2UC_RD_CTX_ID_BMSK                                                     0x3c0000
#define HWIO_IPA_DPS_SEQ2UC_RD_CTX_ID_SHFT                                                         0x12
#define HWIO_IPA_DPS_SEQ2UC_RD_SRC_ID_BMSK                                                      0x3fc00
#define HWIO_IPA_DPS_SEQ2UC_RD_SRC_ID_SHFT                                                          0xa
#define HWIO_IPA_DPS_SEQ2UC_RD_SRC_FLAGS_BMSK                                                     0x300
#define HWIO_IPA_DPS_SEQ2UC_RD_SRC_FLAGS_SHFT                                                       0x8
#define HWIO_IPA_DPS_SEQ2UC_RD_SRC_PIPE_BMSK                                                       0xff
#define HWIO_IPA_DPS_SEQ2UC_RD_SRC_PIPE_SHFT                                                        0x0

#define HWIO_IPA_DPS_SEQ2UC_STATUS_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000600)
#define HWIO_IPA_DPS_SEQ2UC_STATUS_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000600)
#define HWIO_IPA_DPS_SEQ2UC_STATUS_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000600)
#define HWIO_IPA_DPS_SEQ2UC_STATUS_RMSK                                                             0xf
#define HWIO_IPA_DPS_SEQ2UC_STATUS_ATTR                                                             0x1
#define HWIO_IPA_DPS_SEQ2UC_STATUS_IN          \
        in_dword_masked(HWIO_IPA_DPS_SEQ2UC_STATUS_ADDR, HWIO_IPA_DPS_SEQ2UC_STATUS_RMSK)
#define HWIO_IPA_DPS_SEQ2UC_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_DPS_SEQ2UC_STATUS_ADDR, m)
#define HWIO_IPA_DPS_SEQ2UC_STATUS_FILL_LEVEL_BMSK                                                  0xf
#define HWIO_IPA_DPS_SEQ2UC_STATUS_FILL_LEVEL_SHFT                                                  0x0

#define HWIO_IPA_DPS_SEQ2UC_CMD_ADDR                                                         (IPA_DEBUG_REG_BASE      + 0x00000604)
#define HWIO_IPA_DPS_SEQ2UC_CMD_PHYS                                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000604)
#define HWIO_IPA_DPS_SEQ2UC_CMD_OFFS                                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000604)
#define HWIO_IPA_DPS_SEQ2UC_CMD_RMSK                                                                0x1
#define HWIO_IPA_DPS_SEQ2UC_CMD_ATTR                                                                0x2
#define HWIO_IPA_DPS_SEQ2UC_CMD_OUT(v)      \
        out_dword(HWIO_IPA_DPS_SEQ2UC_CMD_ADDR,v)
#define HWIO_IPA_DPS_SEQ2UC_CMD_POP_BMSK                                                            0x1
#define HWIO_IPA_DPS_SEQ2UC_CMD_POP_SHFT                                                            0x0

#define HWIO_IPA_NTF_TX_CMDQ_CMD_ADDR                                                        (IPA_DEBUG_REG_BASE      + 0x00000608)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_PHYS                                                        (IPA_DEBUG_REG_BASE_PHYS + 0x00000608)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_OFFS                                                        (IPA_DEBUG_REG_BASE_OFFS + 0x00000608)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_RMSK                                                             0xff7
#define HWIO_IPA_NTF_TX_CMDQ_CMD_ATTR                                                               0x3
#define HWIO_IPA_NTF_TX_CMDQ_CMD_IN          \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_CMD_ADDR, HWIO_IPA_NTF_TX_CMDQ_CMD_RMSK)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_CMD_ADDR, m)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_NTF_TX_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NTF_TX_CMDQ_CMD_ADDR,m,v,HWIO_IPA_NTF_TX_CMDQ_CMD_IN)
#define HWIO_IPA_NTF_TX_CMDQ_CMD_CMD_CLIENT_BMSK                                                  0xff0
#define HWIO_IPA_NTF_TX_CMDQ_CMD_CMD_CLIENT_SHFT                                                    0x4
#define HWIO_IPA_NTF_TX_CMDQ_CMD_RD_REQ_BMSK                                                        0x4
#define HWIO_IPA_NTF_TX_CMDQ_CMD_RD_REQ_SHFT                                                        0x2
#define HWIO_IPA_NTF_TX_CMDQ_CMD_POP_CMD_BMSK                                                       0x2
#define HWIO_IPA_NTF_TX_CMDQ_CMD_POP_CMD_SHFT                                                       0x1
#define HWIO_IPA_NTF_TX_CMDQ_CMD_WRITE_CMD_BMSK                                                     0x1
#define HWIO_IPA_NTF_TX_CMDQ_CMD_WRITE_CMD_SHFT                                                     0x0

#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x0000060c)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x0000060c)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x0000060c)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_RMSK                                                   0x7ffffff
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_ATTR                                                         0x3
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_IN          \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_ADDR, HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_RMSK)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_ADDR, m)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_OUT(v)      \
        out_dword(HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_ADDR,v)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_ADDR,m,v,HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_IN)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_SEG_CTX_ID_F_BMSK                                      0x6000000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_SEG_CTX_ID_F_SHFT                                           0x19
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_SEG_VALID_F_BMSK                                       0x1000000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_SEG_VALID_F_SHFT                                            0x18
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_VIRT_COD_F_BMSK                                    0x800000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_VIRT_COD_F_SHFT                                        0x17
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_TYPE_F_BMSK                                        0x400000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_TYPE_F_SHFT                                            0x16
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_OPCODE_F_BMSK                                      0x300000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_OPCODE_F_SHFT                                          0x14
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_SRC_PIPE_F_BMSK                                     0xff000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_SRC_PIPE_F_SHFT                                         0xc
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_SRC_ID_F_BMSK                                         0xff0
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_SRC_ID_F_SHFT                                           0x4
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_CTX_ID_F_BMSK                                           0xf
#define HWIO_IPA_NTF_TX_CMDQ_DATA_WR_0_CMDQ_CTX_ID_F_SHFT                                           0x0

#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000610)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000610)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000610)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_RMSK                                                   0x7ffffff
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_ATTR                                                         0x1
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_IN          \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_ADDR, HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_RMSK, HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_INM(m)      \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_ADDR, m, HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_ATTR)
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_SEG_CTX_ID_F_BMSK                                      0x6000000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_SEG_CTX_ID_F_SHFT                                           0x19
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_SEG_VALID_F_BMSK                                       0x1000000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_SEG_VALID_F_SHFT                                            0x18
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_VIRT_COD_F_BMSK                                    0x800000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_VIRT_COD_F_SHFT                                        0x17
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_TYPE_F_BMSK                                        0x400000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_TYPE_F_SHFT                                            0x16
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_OPCODE_F_BMSK                                      0x300000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_OPCODE_F_SHFT                                          0x14
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_SRC_PIPE_F_BMSK                                     0xff000
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_SRC_PIPE_F_SHFT                                         0xc
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_SRC_ID_F_BMSK                                         0xff0
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_SRC_ID_F_SHFT                                           0x4
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_CTX_ID_F_BMSK                                           0xf
#define HWIO_IPA_NTF_TX_CMDQ_DATA_RD_0_CMDQ_CTX_ID_F_SHFT                                           0x0

#define HWIO_IPA_NTF_TX_CMDQ_STATUS_ADDR                                                     (IPA_DEBUG_REG_BASE      + 0x00000614)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_PHYS                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000614)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_OFFS                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000614)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_RMSK                                                          0x1ff
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_ATTR                                                            0x1
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_STATUS_ADDR, HWIO_IPA_NTF_TX_CMDQ_STATUS_RMSK, HWIO_IPA_NTF_TX_CMDQ_STATUS_ATTR)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_STATUS_ADDR, m, HWIO_IPA_NTF_TX_CMDQ_STATUS_ATTR)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                               0x1fc
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                                 0x2
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_CMDQ_FULL_BMSK                                                  0x2
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_CMDQ_FULL_SHFT                                                  0x1
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_STATUS_BMSK                                                     0x1
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_STATUS_SHFT                                                     0x0

#define HWIO_IPA_NTF_TX_SNP_ADDR                                                             (IPA_DEBUG_REG_BASE      + 0x0000061c)
#define HWIO_IPA_NTF_TX_SNP_PHYS                                                             (IPA_DEBUG_REG_BASE_PHYS + 0x0000061c)
#define HWIO_IPA_NTF_TX_SNP_OFFS                                                             (IPA_DEBUG_REG_BASE_OFFS + 0x0000061c)
#define HWIO_IPA_NTF_TX_SNP_RMSK                                                              0xfffffff
#define HWIO_IPA_NTF_TX_SNP_ATTR                                                                    0x3
#define HWIO_IPA_NTF_TX_SNP_IN          \
        in_dword_masked(HWIO_IPA_NTF_TX_SNP_ADDR, HWIO_IPA_NTF_TX_SNP_RMSK)
#define HWIO_IPA_NTF_TX_SNP_INM(m)      \
        in_dword_masked(HWIO_IPA_NTF_TX_SNP_ADDR, m)
#define HWIO_IPA_NTF_TX_SNP_OUT(v)      \
        out_dword(HWIO_IPA_NTF_TX_SNP_ADDR,v)
#define HWIO_IPA_NTF_TX_SNP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NTF_TX_SNP_ADDR,m,v,HWIO_IPA_NTF_TX_SNP_IN)
#define HWIO_IPA_NTF_TX_SNP_SNP_ADDR_BMSK                                                     0xff00000
#define HWIO_IPA_NTF_TX_SNP_SNP_ADDR_SHFT                                                          0x14
#define HWIO_IPA_NTF_TX_SNP_SNP_HEAD_BMSK                                                       0xff000
#define HWIO_IPA_NTF_TX_SNP_SNP_HEAD_SHFT                                                           0xc
#define HWIO_IPA_NTF_TX_SNP_SNP_NEXT_BMSK                                                         0xff0
#define HWIO_IPA_NTF_TX_SNP_SNP_NEXT_SHFT                                                           0x4
#define HWIO_IPA_NTF_TX_SNP_SNP_NEXT_IS_VALID_BMSK                                                  0x8
#define HWIO_IPA_NTF_TX_SNP_SNP_NEXT_IS_VALID_SHFT                                                  0x3
#define HWIO_IPA_NTF_TX_SNP_SNP_VALID_BMSK                                                          0x4
#define HWIO_IPA_NTF_TX_SNP_SNP_VALID_SHFT                                                          0x2
#define HWIO_IPA_NTF_TX_SNP_SNP_WRITE_BMSK                                                          0x2
#define HWIO_IPA_NTF_TX_SNP_SNP_WRITE_SHFT                                                          0x1
#define HWIO_IPA_NTF_TX_SNP_SNP_LAST_BMSK                                                           0x1
#define HWIO_IPA_NTF_TX_SNP_SNP_LAST_SHFT                                                           0x0

#define HWIO_IPA_NTF_TX_CMDQ_COUNT_ADDR                                                      (IPA_DEBUG_REG_BASE      + 0x00000620)
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_PHYS                                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000620)
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_OFFS                                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000620)
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_RMSK                                                            0x7f
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_ATTR                                                             0x1
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_IN          \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_COUNT_ADDR, HWIO_IPA_NTF_TX_CMDQ_COUNT_RMSK, HWIO_IPA_NTF_TX_CMDQ_COUNT_ATTR)
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_INM(m)      \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_COUNT_ADDR, m, HWIO_IPA_NTF_TX_CMDQ_COUNT_ATTR)
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_FIFO_COUNT_BMSK                                                 0x7f
#define HWIO_IPA_NTF_TX_CMDQ_COUNT_FIFO_COUNT_SHFT                                                  0x0

#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000624)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000624)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000624)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_RMSK                                                       0x7ff
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_ATTR                                                         0x3
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_ADDR, HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_ADDR, m)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_OUT(v)      \
        out_dword(HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_ADDR,v)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_ADDR,m,v,HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_IN)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_RD_REQ_BMSK                                                0x400
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_RD_REQ_SHFT                                                  0xa
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_CMD_CLIENT_BMSK                                            0x3fc
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_CMD_CLIENT_SHFT                                              0x2
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_POP_CMD_BMSK                                                 0x2
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_POP_CMD_SHFT                                                 0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_WRITE_CMD_BMSK                                               0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_CMD_WRITE_CMD_SHFT                                               0x0

#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ADDR                                              (IPA_DEBUG_REG_BASE      + 0x00000628)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_PHYS                                              (IPA_DEBUG_REG_BASE_PHYS + 0x00000628)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_OFFS                                              (IPA_DEBUG_REG_BASE_OFFS + 0x00000628)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_RMSK                                              0xffffffff
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ATTR                                                     0x3
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ADDR, HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_RMSK, HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ATTR)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ADDR, m, HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ATTR)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_OUT(v)      \
        out_dword(HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ADDR,v)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_ADDR,m,v,HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_IN)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_USERDATA_BMSK                                0xf8000000
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_USERDATA_SHFT                                      0x1b
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_VALID_BMSK                             0x4000000
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_VALID_SHFT                                  0x1a
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_SENT_BMSK                                     0x2000000
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_SENT_SHFT                                          0x19
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_ORIGIN_BMSK                                   0x1000000
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_ORIGIN_SHFT                                        0x18
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_LENGTH_BMSK                                    0xffff00
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_LENGTH_SHFT                                         0x8
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_BMSK                                        0xff
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_CMDQ_SRC_ID_SHFT                                         0x0

#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_ADDR                                            (IPA_DEBUG_REG_BASE      + 0x0000062c)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_PHYS                                            (IPA_DEBUG_REG_BASE_PHYS + 0x0000062c)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_OFFS                                            (IPA_DEBUG_REG_BASE_OFFS + 0x0000062c)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_RMSK                                                   0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_ATTR                                                   0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_ADDR, HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_ADDR, m)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_CMDQ_FNR_AGGR_FC_BMSK                                  0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_DATA_RD_1_CMDQ_FNR_AGGR_FC_SHFT                                  0x0

#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_ADDR(n)                                    (IPA_DEBUG_REG_BASE      + 0x00000630 + 0x4 * (n))
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_PHYS(n)                                    (IPA_DEBUG_REG_BASE_PHYS + 0x00000630 + 0x4 * (n))
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_OFFS(n)                                    (IPA_DEBUG_REG_BASE_OFFS + 0x00000630 + 0x4 * (n))
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_RMSK                                       0xffffffff
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_MAXn                                                1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_ATTR                                              0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_INI(n)        \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_ADDR(n), HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_ADDR(n), mask)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_BMSK                            0xffffffff
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_SHFT                                   0x0

#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000650)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000650)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000650)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_RMSK                                                    0x1ff
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_ATTR                                                      0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_ADDR, HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_RMSK, HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_ATTR)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_ADDR, m, HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_ATTR)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_CMDQ_DEPTH_BMSK                                         0x1fc
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_CMDQ_DEPTH_SHFT                                           0x2
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_CMDQ_FULL_BMSK                                            0x2
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_CMDQ_FULL_SHFT                                            0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_STATUS_BMSK                                               0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_STATUS_STATUS_SHFT                                               0x0

#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_ADDR                                                (IPA_DEBUG_REG_BASE      + 0x00000654)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_PHYS                                                (IPA_DEBUG_REG_BASE_PHYS + 0x00000654)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_OFFS                                                (IPA_DEBUG_REG_BASE_OFFS + 0x00000654)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_RMSK                                                      0x7f
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_ATTR                                                       0x1
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_ADDR, HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_RMSK, HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_ATTR)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_ADDR, m, HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_ATTR)
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_FIFO_COUNT_BMSK                                           0x7f
#define HWIO_IPA_PROD_ACKMNGR_CMDQ_COUNT_FIFO_COUNT_SHFT                                            0x0

#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR                                           (IPA_DEBUG_REG_BASE      + 0x00000658)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_PHYS                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000658)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_OFFS                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000658)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_RMSK                                           0xffffffe0
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ATTR                                                  0x3
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR, HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_RMSK)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR, m)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_OUT(v)      \
        out_dword(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR,v)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR,m,v,HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_IN)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_LENGTH_BMSK                             0xffff0000
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_LENGTH_SHFT                                   0x10
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_BMSK                                 0xff00
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_SHFT                                    0x8
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SENT_BMSK                                     0x80
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SENT_SHFT                                      0x7
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_ORIGIN_BMSK                                   0x40
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_ORIGIN_SHFT                                    0x6
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_VALID_BMSK                             0x20
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_VALID_SHFT                              0x5

#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_ADDR                                          (IPA_DEBUG_REG_BASE      + 0x0000065c)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_PHYS                                          (IPA_DEBUG_REG_BASE_PHYS + 0x0000065c)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_OFFS                                          (IPA_DEBUG_REG_BASE_OFFS + 0x0000065c)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_RMSK                                              0xffff
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_ATTR                                                 0x3
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_ADDR, HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_RMSK)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_ADDR, m)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_OUT(v)      \
        out_dword(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_ADDR,v)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_ADDR,m,v,HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_IN)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_PROD_ACKINJ_SRC_PIPE_BMSK                         0xff00
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_PROD_ACKINJ_SRC_PIPE_SHFT                            0x8
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_CONS_ACKINJ_SRC_PIPE_BMSK                           0xff
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKINJ_PIPE_CONS_ACKINJ_SRC_PIPE_SHFT                            0x0

#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR                                           (IPA_DEBUG_REG_BASE      + 0x00000660)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_PHYS                                           (IPA_DEBUG_REG_BASE_PHYS + 0x00000660)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_OFFS                                           (IPA_DEBUG_REG_BASE_OFFS + 0x00000660)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_RMSK                                              0x1ffff
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ATTR                                                  0x3
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR, HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_RMSK)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR, m)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_OUT(v)      \
        out_dword(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR,v)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR,m,v,HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_IN)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_ERROR_BMSK                                 0x10000
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_ERROR_SHFT                                    0x10
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_ID_BMSK                                 0xff00
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_ID_SHFT                                    0x8
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_PIPE_BMSK                                 0xff
#define HWIO_IPA_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_PIPE_SHFT                                  0x0

#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000664)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000664)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000664)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_RMSK                                                         0x3
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ATTR                                                         0x2
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_OUT(v)      \
        out_dword(HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ADDR,v)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ACKUPD_VALID_BMSK                                            0x2
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ACKUPD_VALID_SHFT                                            0x1
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ACKINJ_VALID_BMSK                                            0x1
#define HWIO_IPA_ACKMNGR_SW_ACCESS_CMD_ACKINJ_VALID_SHFT                                            0x0

#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000668)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000668)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000668)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_RMSK                                                      0x3
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ATTR                                                      0x1
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_IN          \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ADDR, HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_RMSK)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ADDR, m)
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ACKUPD_READY_BMSK                                         0x2
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ACKUPD_READY_SHFT                                         0x1
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ACKINJ_READY_BMSK                                         0x1
#define HWIO_IPA_ACKMNGR_SW_ACCESS_STATUS_ACKINJ_READY_SHFT                                         0x0

#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR                                      (IPA_DEBUG_REG_BASE      + 0x0000066c)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_PHYS                                      (IPA_DEBUG_REG_BASE_PHYS + 0x0000066c)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_OFFS                                      (IPA_DEBUG_REG_BASE_OFFS + 0x0000066c)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_RMSK                                      0xffffffe0
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ATTR                                             0x3
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR, HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR, m)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_OUT(v)      \
        out_dword(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR,v)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ADDR,m,v,HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_IN)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_LENGTH_BMSK                        0xffff0000
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_LENGTH_SHFT                              0x10
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_BMSK                            0xff00
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_SHFT                               0x8
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SENT_BMSK                                0x80
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SENT_SHFT                                 0x7
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_ORIGIN_BMSK                              0x40
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_ORIGIN_SHFT                               0x6
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_VALID_BMSK                        0x20
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG_ACKINJ_SRC_ID_VALID_SHFT                         0x5

#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR                                      (IPA_DEBUG_REG_BASE      + 0x00000670)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_PHYS                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000670)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_OFFS                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000670)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_RMSK                                          0xffff
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ATTR                                             0x3
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR, HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR, m)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_OUT(v)      \
        out_dword(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR,v)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ADDR,m,v,HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_IN)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_ID_BMSK                            0xff00
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_ID_SHFT                               0x8
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_PIPE_BMSK                            0xff
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKUPD_CFG_ACKUPD_SRC_PIPE_SHFT                             0x0

#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ADDR                                             (IPA_DEBUG_REG_BASE      + 0x00000674)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_PHYS                                             (IPA_DEBUG_REG_BASE_PHYS + 0x00000674)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_OFFS                                             (IPA_DEBUG_REG_BASE_OFFS + 0x00000674)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_RMSK                                                    0x3
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ATTR                                                    0x2
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_OUT(v)      \
        out_dword(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ADDR,v)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ACKUPD_VALID_BMSK                                       0x2
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ACKUPD_VALID_SHFT                                       0x1
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ACKINJ_VALID_BMSK                                       0x1
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_CMD_ACKINJ_VALID_SHFT                                       0x0

#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ADDR                                          (IPA_DEBUG_REG_BASE      + 0x00000678)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_PHYS                                          (IPA_DEBUG_REG_BASE_PHYS + 0x00000678)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_OFFS                                          (IPA_DEBUG_REG_BASE_OFFS + 0x00000678)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_RMSK                                                 0x3
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ATTR                                                 0x1
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ADDR, HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ADDR, m)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ACKUPD_READY_BMSK                                    0x2
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ACKUPD_READY_SHFT                                    0x1
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ACKINJ_READY_BMSK                                    0x1
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_STATUS_ACKINJ_READY_SHFT                                    0x0

#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ADDR                                     (IPA_DEBUG_REG_BASE      + 0x0000067c)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_PHYS                                     (IPA_DEBUG_REG_BASE_PHYS + 0x0000067c)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_OFFS                                     (IPA_DEBUG_REG_BASE_OFFS + 0x0000067c)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_RMSK                                           0x3f
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ATTR                                            0x3
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_IN          \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ADDR, HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_RMSK)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_INM(m)      \
        in_dword_masked(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ADDR, m)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_OUT(v)      \
        out_dword(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ADDR,v)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ADDR,m,v,HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_IN)
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ACKINJ_USERDATA_BMSK                           0x3f
#define HWIO_IPA_PROD_ACKMNGR_SW_ACCESS_ACKINJ_CFG1_ACKINJ_USERDATA_SHFT                            0x0

#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x00000680 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x00000680 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x00000680 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_RMSK                                               0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_MAXn                                                        1
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_ATTR                                                      0x2
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_ADDR(n),val)
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_RELEASE_WR_CMD_BMSK                                0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_WR_n_RELEASE_WR_CMD_SHFT                                       0x0

#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_ADDR(n)                                            (IPA_DEBUG_REG_BASE      + 0x000006a0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_PHYS(n)                                            (IPA_DEBUG_REG_BASE_PHYS + 0x000006a0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_OFFS(n)                                            (IPA_DEBUG_REG_BASE_OFFS + 0x000006a0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_RMSK                                               0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_MAXn                                                        1
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_ATTR                                                      0x2
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_ADDR(n),val)
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_RELEASE_RD_CMD_BMSK                                0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_RELEASE_RD_n_RELEASE_RD_CMD_SHFT                                       0x0

#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_ADDR(n)                                                (IPA_DEBUG_REG_BASE      + 0x000006c0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_PHYS(n)                                                (IPA_DEBUG_REG_BASE_PHYS + 0x000006c0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_OFFS(n)                                                (IPA_DEBUG_REG_BASE_OFFS + 0x000006c0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_RMSK                                                   0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_MAXn                                                            1
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_ATTR                                                          0x3
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_INI(n)        \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_ADDR(n), HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_RMSK)
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_ADDR(n), mask)
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_ADDR(n),val)
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_ADDR(n),mask,val,HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_INI(n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_BLOCK_WR_BMSK                                          0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_CFG_WR_n_BLOCK_WR_SHFT                                                 0x0

#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_ADDR(n)                                                (IPA_DEBUG_REG_BASE      + 0x000006e0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_PHYS(n)                                                (IPA_DEBUG_REG_BASE_PHYS + 0x000006e0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_OFFS(n)                                                (IPA_DEBUG_REG_BASE_OFFS + 0x000006e0 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_RMSK                                                   0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_MAXn                                                            1
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_ATTR                                                          0x3
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_INI(n)        \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_ADDR(n), HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_RMSK)
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_ADDR(n), mask)
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_ADDR(n),val)
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_ADDR(n),mask,val,HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_INI(n))
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_BLOCK_RD_BMSK                                          0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_CFG_RD_n_BLOCK_RD_SHFT                                                 0x0

#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_ADDR(n)                                          (IPA_DEBUG_REG_BASE      + 0x00000700 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_PHYS(n)                                          (IPA_DEBUG_REG_BASE_PHYS + 0x00000700 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_OFFS(n)                                          (IPA_DEBUG_REG_BASE_OFFS + 0x00000700 + 0x4 * (n))
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_RMSK                                             0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_MAXn                                                      1
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_ATTR                                                    0x1
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_INI(n)        \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_ADDR(n), HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_RMSK)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_ADDR(n), mask)
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_BMSK                                  0xffffffff
#define HWIO_IPA_NTF_TX_CMDQ_STATUS_EMPTY_n_CMDQ_EMPTY_SHFT                                         0x0

#define HWIO_IPA_BASE_ADDR_ADDR                                                              (IPA_DEBUG_REG_BASE      + 0x00000720)
#define HWIO_IPA_BASE_ADDR_PHYS                                                              (IPA_DEBUG_REG_BASE_PHYS + 0x00000720)
#define HWIO_IPA_BASE_ADDR_OFFS                                                              (IPA_DEBUG_REG_BASE_OFFS + 0x00000720)
#define HWIO_IPA_BASE_ADDR_RMSK                                                              0xffffffff
#define HWIO_IPA_BASE_ADDR_ATTR                                                                     0x3
#define HWIO_IPA_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_BASE_ADDR_ADDR, HWIO_IPA_BASE_ADDR_RMSK)
#define HWIO_IPA_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_BASE_ADDR_ADDR, m)
#define HWIO_IPA_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_BASE_ADDR_ADDR,v)
#define HWIO_IPA_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_BASE_ADDR_ADDR,m,v,HWIO_IPA_BASE_ADDR_IN)
#define HWIO_IPA_BASE_ADDR_BASE_BMSK                                                         0xffe00000
#define HWIO_IPA_BASE_ADDR_BASE_SHFT                                                               0x15
#define HWIO_IPA_BASE_ADDR_ZERO_BMSK                                                           0x1fffff
#define HWIO_IPA_BASE_ADDR_ZERO_SHFT                                                                0x0

#define HWIO_IPA_BASE_ADDR_MSB_ADDR                                                          (IPA_DEBUG_REG_BASE      + 0x00000724)
#define HWIO_IPA_BASE_ADDR_MSB_PHYS                                                          (IPA_DEBUG_REG_BASE_PHYS + 0x00000724)
#define HWIO_IPA_BASE_ADDR_MSB_OFFS                                                          (IPA_DEBUG_REG_BASE_OFFS + 0x00000724)
#define HWIO_IPA_BASE_ADDR_MSB_RMSK                                                          0xffffffff
#define HWIO_IPA_BASE_ADDR_MSB_ATTR                                                                 0x3
#define HWIO_IPA_BASE_ADDR_MSB_IN          \
        in_dword_masked(HWIO_IPA_BASE_ADDR_MSB_ADDR, HWIO_IPA_BASE_ADDR_MSB_RMSK)
#define HWIO_IPA_BASE_ADDR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_BASE_ADDR_MSB_ADDR, m)
#define HWIO_IPA_BASE_ADDR_MSB_OUT(v)      \
        out_dword(HWIO_IPA_BASE_ADDR_MSB_ADDR,v)
#define HWIO_IPA_BASE_ADDR_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_BASE_ADDR_MSB_ADDR,m,v,HWIO_IPA_BASE_ADDR_MSB_IN)
#define HWIO_IPA_BASE_ADDR_MSB_BASE_MSB_BMSK                                                 0xffffffff
#define HWIO_IPA_BASE_ADDR_MSB_BASE_MSB_SHFT                                                        0x0

#define HWIO_IPA_ENDP_GSI_CFG1_n_ADDR(n)                                                     (IPA_DEBUG_REG_BASE      + 0x00000800 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG1_n_PHYS(n)                                                     (IPA_DEBUG_REG_BASE_PHYS + 0x00000800 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG1_n_OFFS(n)                                                     (IPA_DEBUG_REG_BASE_OFFS + 0x00000800 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG1_n_RMSK                                                        0x80010000
#define HWIO_IPA_ENDP_GSI_CFG1_n_MAXn                                                                35
#define HWIO_IPA_ENDP_GSI_CFG1_n_ATTR                                                               0x3
#define HWIO_IPA_ENDP_GSI_CFG1_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CFG1_n_ADDR(n), HWIO_IPA_ENDP_GSI_CFG1_n_RMSK)
#define HWIO_IPA_ENDP_GSI_CFG1_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CFG1_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_GSI_CFG1_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_GSI_CFG1_n_ADDR(n),val)
#define HWIO_IPA_ENDP_GSI_CFG1_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_GSI_CFG1_n_ADDR(n),mask,val,HWIO_IPA_ENDP_GSI_CFG1_n_INI(n))
#define HWIO_IPA_ENDP_GSI_CFG1_n_INIT_ENDP_BMSK                                              0x80000000
#define HWIO_IPA_ENDP_GSI_CFG1_n_INIT_ENDP_SHFT                                                    0x1f
#define HWIO_IPA_ENDP_GSI_CFG1_n_ENDP_EN_BMSK                                                   0x10000
#define HWIO_IPA_ENDP_GSI_CFG1_n_ENDP_EN_SHFT                                                      0x10

#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_ADDR                                         (IPA_DEBUG_REG_BASE      + 0x00000c00)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_PHYS                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000c00)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_OFFS                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000c00)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_RMSK                                         0xffffffff
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_ATTR                                                0x3
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_OUT(v)      \
        out_dword(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_ADDR,v)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_ADDR,m,v,HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_IN)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_GEN_TLV_OUT_ADDR_LSB_BMSK                    0xffffffff
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_1_GEN_TLV_OUT_ADDR_LSB_SHFT                           0x0

#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_ADDR                                         (IPA_DEBUG_REG_BASE      + 0x00000c04)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_PHYS                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000c04)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_OFFS                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000c04)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_RMSK                                         0xffffffff
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_ATTR                                                0x3
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_OUT(v)      \
        out_dword(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_ADDR,v)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_ADDR,m,v,HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_IN)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_EE_BMSK                          0xf0000000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_EE_SHFT                                0x1c
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_ROUTINE_BMSK                      0xf000000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_ROUTINE_SHFT                           0x18
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_LENGTH_BMSK                        0xffff00
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_LENGTH_SHFT                             0x8
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_ADDR_MSB_BMSK                          0xff
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_2_GEN_TLV_OUT_ADDR_MSB_SHFT                           0x0

#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_ADDR                                         (IPA_DEBUG_REG_BASE      + 0x00000c08)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_PHYS                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00000c08)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_OFFS                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00000c08)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_RMSK                                         0xffff3fff
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_ATTR                                                0x3
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_OUT(v)      \
        out_dword(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_ADDR,v)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_ADDR,m,v,HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_IN)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_USER_DATA_BMSK                   0xfffe0000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_USER_DATA_SHFT                         0x11
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_CHAIN_BMSK                          0x10000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_CHAIN_SHFT                             0x10
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_TOP_ADDR_BIT_BMSK                    0x2000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_TOP_ADDR_BIT_SHFT                       0xd
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_DIRECTION_BMSK                       0x1000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_DIRECTION_SHFT                          0xc
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_TYPE_BMSK                             0xf00
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_TYPE_SHFT                               0x8
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_CHID_BMSK                              0xff
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_3_GEN_TLV_OUT_CHID_SHFT                               0x0

#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_ADDR                                      (IPA_DEBUG_REG_BASE      + 0x00000c0c)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_PHYS                                      (IPA_DEBUG_REG_BASE_PHYS + 0x00000c0c)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_OFFS                                      (IPA_DEBUG_REG_BASE_OFFS + 0x00000c0c)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_RMSK                                        0x1100f1
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_ATTR                                             0x3
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_ADDR,v)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_ADDR,m,v,HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_IN)
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_EN_BMSK                         0x100000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_EN_SHFT                             0x14
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_ACTIVATE_BMSK                    0x10000
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_ACTIVATE_SHFT                       0x10
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_STATUS_BMSK                         0xf0
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_STATUS_SHFT                          0x4
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_RDY_BMSK                             0x1
#define HWIO_IPA_GSI_IPA_IF_TLV_OUT_GENERATOR_CTRL_GEN_TLV_OUT_RDY_SHFT                             0x0

#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_ADDR                                                  (IPA_DEBUG_REG_BASE      + 0x00000d10)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_PHYS                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00000d10)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_OFFS                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00000d10)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_RMSK                                                         0x1
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_ATTR                                                         0x3
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_OUT(v)      \
        out_dword(HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_ADDR,v)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_ADDR,m,v,HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_IN)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_GEN_TLV_IN_RDY_BMSK                                          0x1
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_RDY_GEN_TLV_IN_RDY_SHFT                                          0x0

#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000d14)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000d14)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000d14)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_RMSK                                               0xffffffff
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_ATTR                                                      0x1
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_GEN_TLV_IN_LENGTH_BMSK                             0xffff0000
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_GEN_TLV_IN_LENGTH_SHFT                                   0x10
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_GEN_TLV_IN_USER_DATA_BMSK                              0xffff
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_1_GEN_TLV_IN_USER_DATA_SHFT                                 0x0

#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_ADDR                                               (IPA_DEBUG_REG_BASE      + 0x00000d18)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_PHYS                                               (IPA_DEBUG_REG_BASE_PHYS + 0x00000d18)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_OFFS                                               (IPA_DEBUG_REG_BASE_OFFS + 0x00000d18)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_RMSK                                               0xf00ffff1
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_ATTR                                                      0x3
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_IN          \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_ADDR, HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_RMSK)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_ADDR, m)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_OUT(v)      \
        out_dword(HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_ADDR,v)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_ADDR,m,v,HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_IN)
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_ROUTINE_BMSK                            0xf0000000
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_ROUTINE_SHFT                                  0x1c
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_STATUS_BMSK                                0xf0000
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_STATUS_SHFT                                   0x10
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_CHID_BMSK                                   0xff00
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_CHID_SHFT                                      0x8
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_EE_BMSK                                       0xf0
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_EE_SHFT                                        0x4
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_EOT_BMSK                                       0x1
#define HWIO_IPA_GSI_IPA_IF_TLV_IN_DATA_2_GEN_TLV_IN_EOT_SHFT                                       0x0

#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_ADDR(n)                                                  (IPA_DEBUG_REG_BASE      + 0x00001000 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_PHYS(n)                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00001000 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_OFFS(n)                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00001000 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_RMSK                                                       0xffffff
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_MAXn                                                             35
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_ATTR                                                            0x3
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CFG_TLV_n_ADDR(n), HWIO_IPA_ENDP_GSI_CFG_TLV_n_RMSK)
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CFG_TLV_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_GSI_CFG_TLV_n_ADDR(n),val)
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_GSI_CFG_TLV_n_ADDR(n),mask,val,HWIO_IPA_ENDP_GSI_CFG_TLV_n_INI(n))
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_FIFO_SIZE_BMSK                                             0xff0000
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_FIFO_SIZE_SHFT                                                 0x10
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_FIFO_BASE_ADDR_BMSK                                          0xffff
#define HWIO_IPA_ENDP_GSI_CFG_TLV_n_FIFO_BASE_ADDR_SHFT                                             0x0

#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_ADDR(n)                                                  (IPA_DEBUG_REG_BASE      + 0x00001400 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_PHYS(n)                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00001400 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_OFFS(n)                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00001400 + 0x4 * (n))
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_RMSK                                                       0xffffff
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_MAXn                                                             35
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_ATTR                                                            0x3
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CFG_AOS_n_ADDR(n), HWIO_IPA_ENDP_GSI_CFG_AOS_n_RMSK)
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_GSI_CFG_AOS_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_GSI_CFG_AOS_n_ADDR(n),val)
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_GSI_CFG_AOS_n_ADDR(n),mask,val,HWIO_IPA_ENDP_GSI_CFG_AOS_n_INI(n))
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_FIFO_SIZE_BMSK                                             0xff0000
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_FIFO_SIZE_SHFT                                                 0x10
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_FIFO_BASE_ADDR_BMSK                                          0xffff
#define HWIO_IPA_ENDP_GSI_CFG_AOS_n_FIFO_BASE_ADDR_SHFT                                             0x0

#define HWIO_IPA_COAL_VP_AOS_FIFO_n_ADDR(n)                                                  (IPA_DEBUG_REG_BASE      + 0x00001800 + 0x4 * (n))
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_PHYS(n)                                                  (IPA_DEBUG_REG_BASE_PHYS + 0x00001800 + 0x4 * (n))
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_OFFS(n)                                                  (IPA_DEBUG_REG_BASE_OFFS + 0x00001800 + 0x4 * (n))
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_RMSK                                                       0xffffff
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_MAXn                                                              3
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_ATTR                                                            0x3
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_INI(n)        \
        in_dword_masked(HWIO_IPA_COAL_VP_AOS_FIFO_n_ADDR(n), HWIO_IPA_COAL_VP_AOS_FIFO_n_RMSK)
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_COAL_VP_AOS_FIFO_n_ADDR(n), mask)
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_COAL_VP_AOS_FIFO_n_ADDR(n),val)
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_COAL_VP_AOS_FIFO_n_ADDR(n),mask,val,HWIO_IPA_COAL_VP_AOS_FIFO_n_INI(n))
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_FIFO_SIZE_BMSK                                             0xff0000
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_FIFO_SIZE_SHFT                                                 0x10
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_FIFO_BASE_ADDR_BMSK                                          0xffff
#define HWIO_IPA_COAL_VP_AOS_FIFO_n_FIFO_BASE_ADDR_SHFT                                             0x0

#define HWIO_IPA_QMB_DEBUG_CTRL_ADDR                                                         (IPA_DEBUG_REG_BASE      + 0x00001d40)
#define HWIO_IPA_QMB_DEBUG_CTRL_PHYS                                                         (IPA_DEBUG_REG_BASE_PHYS + 0x00001d40)
#define HWIO_IPA_QMB_DEBUG_CTRL_OFFS                                                         (IPA_DEBUG_REG_BASE_OFFS + 0x00001d40)
#define HWIO_IPA_QMB_DEBUG_CTRL_RMSK                                                                0x1
#define HWIO_IPA_QMB_DEBUG_CTRL_ATTR                                                                0x3
#define HWIO_IPA_QMB_DEBUG_CTRL_IN          \
        in_dword_masked(HWIO_IPA_QMB_DEBUG_CTRL_ADDR, HWIO_IPA_QMB_DEBUG_CTRL_RMSK)
#define HWIO_IPA_QMB_DEBUG_CTRL_INM(m)      \
        in_dword_masked(HWIO_IPA_QMB_DEBUG_CTRL_ADDR, m)
#define HWIO_IPA_QMB_DEBUG_CTRL_OUT(v)      \
        out_dword(HWIO_IPA_QMB_DEBUG_CTRL_ADDR,v)
#define HWIO_IPA_QMB_DEBUG_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_QMB_DEBUG_CTRL_ADDR,m,v,HWIO_IPA_QMB_DEBUG_CTRL_IN)
#define HWIO_IPA_QMB_DEBUG_CTRL_RAM_SLAVEWAY_ACCESS_PROTECTION_DISABLE_BMSK                         0x1
#define HWIO_IPA_QMB_DEBUG_CTRL_RAM_SLAVEWAY_ACCESS_PROTECTION_DISABLE_SHFT                         0x0

#define HWIO_IPA_CTXH_CTRL_ADDR                                                              (IPA_DEBUG_REG_BASE      + 0x00001e50)
#define HWIO_IPA_CTXH_CTRL_PHYS                                                              (IPA_DEBUG_REG_BASE_PHYS + 0x00001e50)
#define HWIO_IPA_CTXH_CTRL_OFFS                                                              (IPA_DEBUG_REG_BASE_OFFS + 0x00001e50)
#define HWIO_IPA_CTXH_CTRL_RMSK                                                              0xe000000f
#define HWIO_IPA_CTXH_CTRL_ATTR                                                                     0x3
#define HWIO_IPA_CTXH_CTRL_IN          \
        in_dword_masked(HWIO_IPA_CTXH_CTRL_ADDR, HWIO_IPA_CTXH_CTRL_RMSK)
#define HWIO_IPA_CTXH_CTRL_INM(m)      \
        in_dword_masked(HWIO_IPA_CTXH_CTRL_ADDR, m)
#define HWIO_IPA_CTXH_CTRL_OUT(v)      \
        out_dword(HWIO_IPA_CTXH_CTRL_ADDR,v)
#define HWIO_IPA_CTXH_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_CTXH_CTRL_ADDR,m,v,HWIO_IPA_CTXH_CTRL_IN)
#define HWIO_IPA_CTXH_CTRL_CTXH_LOCK_BMSK                                                    0x80000000
#define HWIO_IPA_CTXH_CTRL_CTXH_LOCK_SHFT                                                          0x1f
#define HWIO_IPA_CTXH_CTRL_CTXH_LOCK_ACTIVE_BMSK                                             0x40000000
#define HWIO_IPA_CTXH_CTRL_CTXH_LOCK_ACTIVE_SHFT                                                   0x1e
#define HWIO_IPA_CTXH_CTRL_CTXH_WR_BLOCK_ON_NOC_ERR_BMSK                                     0x20000000
#define HWIO_IPA_CTXH_CTRL_CTXH_WR_BLOCK_ON_NOC_ERR_SHFT                                           0x1d
#define HWIO_IPA_CTXH_CTRL_CTXH_LOCK_ID_BMSK                                                        0xf
#define HWIO_IPA_CTXH_CTRL_CTXH_LOCK_ID_SHFT                                                        0x0

#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_ADDR(m,n)                                                (IPA_DEBUG_REG_BASE      + 0x00002000 + 0x100 * (m) + 0x4 * (n))
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_PHYS(m,n)                                                (IPA_DEBUG_REG_BASE_PHYS + 0x00002000 + 0x100 * (m) + 0x4 * (n))
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_OFFS(m,n)                                                (IPA_DEBUG_REG_BASE_OFFS + 0x00002000 + 0x100 * (m) + 0x4 * (n))
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_RMSK                                                     0xffffffff
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_MAXm                                                             15
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_MAXn                                                             63
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_ATTR                                                            0x3
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_INI2(m,n)        \
        in_dword_masked(HWIO_IPA_CTX_ID_m_CTX_NUM_n_ADDR(m,n), HWIO_IPA_CTX_ID_m_CTX_NUM_n_RMSK)
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_INMI2(m,n,mask)    \
        in_dword_masked(HWIO_IPA_CTX_ID_m_CTX_NUM_n_ADDR(m,n), mask)
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_OUTI2(m,n,val)    \
        out_dword(HWIO_IPA_CTX_ID_m_CTX_NUM_n_ADDR(m,n),val)
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_OUTMI2(m,n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_CTX_ID_m_CTX_NUM_n_ADDR(m,n),mask,val,HWIO_IPA_CTX_ID_m_CTX_NUM_n_INI2(m,n))
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_IPA_CTXH_DATA_BMSK                                       0xffffffff
#define HWIO_IPA_CTX_ID_m_CTX_NUM_n_IPA_CTXH_DATA_SHFT                                              0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_CFG
 *--------------------------------------------------------------------------*/

#define IPA_CFG_REG_BASE                                                                                          (IPA_0_IPA_WRAPPER_BASE      + 0x00140000)
#define IPA_CFG_REG_BASE_PHYS                                                                                     (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00140000)
#define IPA_CFG_REG_BASE_OFFS                                                                                     0x00140000

#define HWIO_IPA_FLAVOR_0_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000000)
#define HWIO_IPA_FLAVOR_0_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_FLAVOR_0_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_FLAVOR_0_RMSK                                                                                    0xffffffff
#define HWIO_IPA_FLAVOR_0_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_0_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_0_ADDR, HWIO_IPA_FLAVOR_0_RMSK)
#define HWIO_IPA_FLAVOR_0_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_0_ADDR, m)
#define HWIO_IPA_FLAVOR_0_IPA_PROD_LOWEST_BMSK                                                                    0xff000000
#define HWIO_IPA_FLAVOR_0_IPA_PROD_LOWEST_SHFT                                                                          0x18
#define HWIO_IPA_FLAVOR_0_IPA_PROD_PIPES_BMSK                                                                       0xff0000
#define HWIO_IPA_FLAVOR_0_IPA_PROD_PIPES_SHFT                                                                           0x10
#define HWIO_IPA_FLAVOR_0_IPA_CONS_PIPES_BMSK                                                                         0xff00
#define HWIO_IPA_FLAVOR_0_IPA_CONS_PIPES_SHFT                                                                            0x8
#define HWIO_IPA_FLAVOR_0_IPA_PIPES_BMSK                                                                                0xff
#define HWIO_IPA_FLAVOR_0_IPA_PIPES_SHFT                                                                                 0x0

#define HWIO_IPA_FLAVOR_1_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000004)
#define HWIO_IPA_FLAVOR_1_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000004)
#define HWIO_IPA_FLAVOR_1_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000004)
#define HWIO_IPA_FLAVOR_1_RMSK                                                                                    0x1fffdf3f
#define HWIO_IPA_FLAVOR_1_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_1_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_1_ADDR, HWIO_IPA_FLAVOR_1_RMSK)
#define HWIO_IPA_FLAVOR_1_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_1_ADDR, m)
#define HWIO_IPA_FLAVOR_1_D_DCPH_ENGINE_NUM_BMSK                                                                  0x18000000
#define HWIO_IPA_FLAVOR_1_D_DCPH_ENGINE_NUM_SHFT                                                                        0x1b
#define HWIO_IPA_FLAVOR_1_PCIE_PATH_EN_BMSK                                                                        0x4000000
#define HWIO_IPA_FLAVOR_1_PCIE_PATH_EN_SHFT                                                                             0x1a
#define HWIO_IPA_FLAVOR_1_GSI_SLAVEWAY_EN_BMSK                                                                     0x2000000
#define HWIO_IPA_FLAVOR_1_GSI_SLAVEWAY_EN_SHFT                                                                          0x19
#define HWIO_IPA_FLAVOR_1_RX_UC_HANDLER_EN_BMSK                                                                    0x1000000
#define HWIO_IPA_FLAVOR_1_RX_UC_HANDLER_EN_SHFT                                                                         0x18
#define HWIO_IPA_FLAVOR_1_DUAL_TX_EN_BMSK                                                                           0x800000
#define HWIO_IPA_FLAVOR_1_DUAL_TX_EN_SHFT                                                                               0x17
#define HWIO_IPA_FLAVOR_1_QMB1_EN_BMSK                                                                              0x400000
#define HWIO_IPA_FLAVOR_1_QMB1_EN_SHFT                                                                                  0x16
#define HWIO_IPA_FLAVOR_1_QMB1_SLAVEWAY_EN_BMSK                                                                     0x200000
#define HWIO_IPA_FLAVOR_1_QMB1_SLAVEWAY_EN_SHFT                                                                         0x15
#define HWIO_IPA_FLAVOR_1_QMB0_SLAVEWAY_EN_BMSK                                                                     0x100000
#define HWIO_IPA_FLAVOR_1_QMB0_SLAVEWAY_EN_SHFT                                                                         0x14
#define HWIO_IPA_FLAVOR_1_DPL_EN_BMSK                                                                                0x80000
#define HWIO_IPA_FLAVOR_1_DPL_EN_SHFT                                                                                   0x13
#define HWIO_IPA_FLAVOR_1_CPR_EN_BMSK                                                                                0x40000
#define HWIO_IPA_FLAVOR_1_CPR_EN_SHFT                                                                                   0x12
#define HWIO_IPA_FLAVOR_1_UC_EN_BMSK                                                                                 0x20000
#define HWIO_IPA_FLAVOR_1_UC_EN_SHFT                                                                                    0x11
#define HWIO_IPA_FLAVOR_1_VMIDMT_EN_BMSK                                                                             0x10000
#define HWIO_IPA_FLAVOR_1_VMIDMT_EN_SHFT                                                                                0x10
#define HWIO_IPA_FLAVOR_1_NAT_ACL_EN_BMSK                                                                             0x8000
#define HWIO_IPA_FLAVOR_1_NAT_ACL_EN_SHFT                                                                                0xf
#define HWIO_IPA_FLAVOR_1_FILTER_ROUTER_CACHE_GEN_BMSK                                                                0x4000
#define HWIO_IPA_FLAVOR_1_FILTER_ROUTER_CACHE_GEN_SHFT                                                                   0xe
#define HWIO_IPA_FLAVOR_1_H_DCPH_EN_BMSK                                                                              0x1000
#define HWIO_IPA_FLAVOR_1_H_DCPH_EN_SHFT                                                                                 0xc
#define HWIO_IPA_FLAVOR_1_D_DCPH_EN_BMSK                                                                               0x800
#define HWIO_IPA_FLAVOR_1_D_DCPH_EN_SHFT                                                                                 0xb
#define HWIO_IPA_FLAVOR_1_D_DCPH_2_EN_BMSK                                                                             0x400
#define HWIO_IPA_FLAVOR_1_D_DCPH_2_EN_SHFT                                                                               0xa
#define HWIO_IPA_FLAVOR_1_UCP_EN_BMSK                                                                                  0x200
#define HWIO_IPA_FLAVOR_1_UCP_EN_SHFT                                                                                    0x9
#define HWIO_IPA_FLAVOR_1_MBIM_DEAGG_EN_BMSK                                                                           0x100
#define HWIO_IPA_FLAVOR_1_MBIM_DEAGG_EN_SHFT                                                                             0x8
#define HWIO_IPA_FLAVOR_1_CTX_N_BMSK                                                                                    0x3f
#define HWIO_IPA_FLAVOR_1_CTX_N_SHFT                                                                                     0x0

#define HWIO_IPA_FLAVOR_2_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000008)
#define HWIO_IPA_FLAVOR_2_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_FLAVOR_2_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_FLAVOR_2_RMSK                                                                                    0x3f3f3f3f
#define HWIO_IPA_FLAVOR_2_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_2_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_2_ADDR, HWIO_IPA_FLAVOR_2_RMSK)
#define HWIO_IPA_FLAVOR_2_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_2_ADDR, m)
#define HWIO_IPA_FLAVOR_2_QMB1_OUTST_RD_BMSK                                                                      0x3f000000
#define HWIO_IPA_FLAVOR_2_QMB1_OUTST_RD_SHFT                                                                            0x18
#define HWIO_IPA_FLAVOR_2_QMB1_OUTST_WR_BMSK                                                                        0x3f0000
#define HWIO_IPA_FLAVOR_2_QMB1_OUTST_WR_SHFT                                                                            0x10
#define HWIO_IPA_FLAVOR_2_QMB0_OUTST_RD_BMSK                                                                          0x3f00
#define HWIO_IPA_FLAVOR_2_QMB0_OUTST_RD_SHFT                                                                             0x8
#define HWIO_IPA_FLAVOR_2_QMB0_OUTST_WR_BMSK                                                                            0x3f
#define HWIO_IPA_FLAVOR_2_QMB0_OUTST_WR_SHFT                                                                             0x0

#define HWIO_IPA_FLAVOR_3_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x0000000c)
#define HWIO_IPA_FLAVOR_3_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x0000000c)
#define HWIO_IPA_FLAVOR_3_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x0000000c)
#define HWIO_IPA_FLAVOR_3_RMSK                                                                                     0xfffffff
#define HWIO_IPA_FLAVOR_3_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_3_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_3_ADDR, HWIO_IPA_FLAVOR_3_RMSK)
#define HWIO_IPA_FLAVOR_3_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_3_ADDR, m)
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_DST_NUM_DRBIP_BMSK                                                              0xf000000
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_DST_NUM_DRBIP_SHFT                                                                   0x18
#define HWIO_IPA_FLAVOR_3_PKT_CTX_SIZE_BMSK                                                                         0xff0000
#define HWIO_IPA_FLAVOR_3_PKT_CTX_SIZE_SHFT                                                                             0x10
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_DST_NUM_UC_BMSK                                                                    0xf000
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_DST_NUM_UC_SHFT                                                                       0xc
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_DST_NUM_WO_UC_N_DRBIP_BMSK                                                          0xf00
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_DST_NUM_WO_UC_N_DRBIP_SHFT                                                            0x8
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_SRC_NUM_UC_BMSK                                                                      0xf0
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_SRC_NUM_UC_SHFT                                                                       0x4
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_SRC_NUM_WOUT_UC_BMSK                                                                  0xf
#define HWIO_IPA_FLAVOR_3_RSRC_GRP_SRC_NUM_WOUT_UC_SHFT                                                                  0x0

#define HWIO_IPA_FLAVOR_4_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000010)
#define HWIO_IPA_FLAVOR_4_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_FLAVOR_4_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_FLAVOR_4_RMSK                                                                                    0x30ffffff
#define HWIO_IPA_FLAVOR_4_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_4_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_4_ADDR, HWIO_IPA_FLAVOR_4_RMSK)
#define HWIO_IPA_FLAVOR_4_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_4_ADDR, m)
#define HWIO_IPA_FLAVOR_4_FRAG_TABLES_NUM_BMSK                                                                    0x30000000
#define HWIO_IPA_FLAVOR_4_FRAG_TABLES_NUM_SHFT                                                                          0x1c
#define HWIO_IPA_FLAVOR_4_MBIM_AGG_PIPES_BMSK                                                                       0xf00000
#define HWIO_IPA_FLAVOR_4_MBIM_AGG_PIPES_SHFT                                                                           0x14
#define HWIO_IPA_FLAVOR_4_BEARER_INIT_CTX_NUM_BMSK                                                                   0xf0000
#define HWIO_IPA_FLAVOR_4_BEARER_INIT_CTX_NUM_SHFT                                                                      0x10
#define HWIO_IPA_FLAVOR_4_GENERIC_DEAGG_PIPES_BMSK                                                                    0xff00
#define HWIO_IPA_FLAVOR_4_GENERIC_DEAGG_PIPES_SHFT                                                                       0x8
#define HWIO_IPA_FLAVOR_4_GENERIC_AGG_PIPES_BMSK                                                                        0xff
#define HWIO_IPA_FLAVOR_4_GENERIC_AGG_PIPES_SHFT                                                                         0x0

#define HWIO_IPA_FLAVOR_5_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000014)
#define HWIO_IPA_FLAVOR_5_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000014)
#define HWIO_IPA_FLAVOR_5_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000014)
#define HWIO_IPA_FLAVOR_5_RMSK                                                                                    0x3fff3f3f
#define HWIO_IPA_FLAVOR_5_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_5_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_5_ADDR, HWIO_IPA_FLAVOR_5_RMSK)
#define HWIO_IPA_FLAVOR_5_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_5_ADDR, m)
#define HWIO_IPA_FLAVOR_5_RX_HPS_CMDQ_Q_DEPTH_BMSK                                                                0x3f000000
#define HWIO_IPA_FLAVOR_5_RX_HPS_CMDQ_Q_DEPTH_SHFT                                                                      0x18
#define HWIO_IPA_FLAVOR_5_GSI_NUM_EES_BMSK                                                                          0xf00000
#define HWIO_IPA_FLAVOR_5_GSI_NUM_EES_SHFT                                                                              0x14
#define HWIO_IPA_FLAVOR_5_IPA_NUM_EES_BMSK                                                                           0xf0000
#define HWIO_IPA_FLAVOR_5_IPA_NUM_EES_SHFT                                                                              0x10
#define HWIO_IPA_FLAVOR_5_PRODUCER_ACK_MNGR_DB_DEPTH_BMSK                                                             0x3f00
#define HWIO_IPA_FLAVOR_5_PRODUCER_ACK_MNGR_DB_DEPTH_SHFT                                                                0x8
#define HWIO_IPA_FLAVOR_5_CONSUMER_ACK_MNGR_DB_DEPTH_BMSK                                                               0x3f
#define HWIO_IPA_FLAVOR_5_CONSUMER_ACK_MNGR_DB_DEPTH_SHFT                                                                0x0

#define HWIO_IPA_FLAVOR_6_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000018)
#define HWIO_IPA_FLAVOR_6_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000018)
#define HWIO_IPA_FLAVOR_6_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000018)
#define HWIO_IPA_FLAVOR_6_RMSK                                                                                    0x3fff3fff
#define HWIO_IPA_FLAVOR_6_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_6_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_6_ADDR, HWIO_IPA_FLAVOR_6_RMSK)
#define HWIO_IPA_FLAVOR_6_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_6_ADDR, m)
#define HWIO_IPA_FLAVOR_6_DATA_SECTORS_BMSK                                                                       0x3f000000
#define HWIO_IPA_FLAVOR_6_DATA_SECTORS_SHFT                                                                             0x18
#define HWIO_IPA_FLAVOR_6_DATA_DESCRIPTOR_BUFFERS_BMSK                                                              0xff0000
#define HWIO_IPA_FLAVOR_6_DATA_DESCRIPTOR_BUFFERS_SHFT                                                                  0x10
#define HWIO_IPA_FLAVOR_6_DATA_DESCRIPTOR_LISTS_BMSK                                                                  0x3f00
#define HWIO_IPA_FLAVOR_6_DATA_DESCRIPTOR_LISTS_SHFT                                                                     0x8
#define HWIO_IPA_FLAVOR_6_DPS_DMAR_NUM_BMSK                                                                             0xf0
#define HWIO_IPA_FLAVOR_6_DPS_DMAR_NUM_SHFT                                                                              0x4
#define HWIO_IPA_FLAVOR_6_HPS_DMAR_NUM_BMSK                                                                              0xf
#define HWIO_IPA_FLAVOR_6_HPS_DMAR_NUM_SHFT                                                                              0x0

#define HWIO_IPA_FLAVOR_7_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x0000001c)
#define HWIO_IPA_FLAVOR_7_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x0000001c)
#define HWIO_IPA_FLAVOR_7_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x0000001c)
#define HWIO_IPA_FLAVOR_7_RMSK                                                                                    0x3fff03ff
#define HWIO_IPA_FLAVOR_7_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_7_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_7_ADDR, HWIO_IPA_FLAVOR_7_RMSK)
#define HWIO_IPA_FLAVOR_7_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_7_ADDR, m)
#define HWIO_IPA_FLAVOR_7_COAL_VP_NUM_BMSK                                                                        0x3c000000
#define HWIO_IPA_FLAVOR_7_COAL_VP_NUM_SHFT                                                                              0x1a
#define HWIO_IPA_FLAVOR_7_AOS_ENTRY_NUM_BMSK                                                                       0x3ff0000
#define HWIO_IPA_FLAVOR_7_AOS_ENTRY_NUM_SHFT                                                                            0x10
#define HWIO_IPA_FLAVOR_7_TLV_ENTRY_NUM_BMSK                                                                           0x3ff
#define HWIO_IPA_FLAVOR_7_TLV_ENTRY_NUM_SHFT                                                                             0x0

#define HWIO_IPA_FLAVOR_8_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x00000020)
#define HWIO_IPA_FLAVOR_8_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000020)
#define HWIO_IPA_FLAVOR_8_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000020)
#define HWIO_IPA_FLAVOR_8_RMSK                                                                                          0xff
#define HWIO_IPA_FLAVOR_8_ATTR                                                                                           0x1
#define HWIO_IPA_FLAVOR_8_IN          \
        in_dword_masked(HWIO_IPA_FLAVOR_8_ADDR, HWIO_IPA_FLAVOR_8_RMSK)
#define HWIO_IPA_FLAVOR_8_INM(m)      \
        in_dword_masked(HWIO_IPA_FLAVOR_8_ADDR, m)
#define HWIO_IPA_FLAVOR_8_MULTI_DRBIP_DCPH_ENGINE_NUM_BMSK                                                              0xf0
#define HWIO_IPA_FLAVOR_8_MULTI_DRBIP_DCPH_ENGINE_NUM_SHFT                                                               0x4
#define HWIO_IPA_FLAVOR_8_MULTI_DRBIP_DMAR_ENGINE_NUM_BMSK                                                               0xf
#define HWIO_IPA_FLAVOR_8_MULTI_DRBIP_DMAR_ENGINE_NUM_SHFT                                                               0x0

#define HWIO_IPA_COMP_HW_VERSION_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x00000024)
#define HWIO_IPA_COMP_HW_VERSION_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x00000024)
#define HWIO_IPA_COMP_HW_VERSION_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x00000024)
#define HWIO_IPA_COMP_HW_VERSION_RMSK                                                                             0xffffffff
#define HWIO_IPA_COMP_HW_VERSION_ATTR                                                                                    0x1
#define HWIO_IPA_COMP_HW_VERSION_IN          \
        in_dword_masked(HWIO_IPA_COMP_HW_VERSION_ADDR, HWIO_IPA_COMP_HW_VERSION_RMSK)
#define HWIO_IPA_COMP_HW_VERSION_INM(m)      \
        in_dword_masked(HWIO_IPA_COMP_HW_VERSION_ADDR, m)
#define HWIO_IPA_COMP_HW_VERSION_MAJOR_BMSK                                                                       0xf0000000
#define HWIO_IPA_COMP_HW_VERSION_MAJOR_SHFT                                                                             0x1c
#define HWIO_IPA_COMP_HW_VERSION_MINOR_BMSK                                                                        0xfff0000
#define HWIO_IPA_COMP_HW_VERSION_MINOR_SHFT                                                                             0x10
#define HWIO_IPA_COMP_HW_VERSION_STEP_BMSK                                                                            0xffff
#define HWIO_IPA_COMP_HW_VERSION_STEP_SHFT                                                                               0x0

#define HWIO_IPA_VERSION_ADDR                                                                                     (IPA_CFG_REG_BASE      + 0x00000028)
#define HWIO_IPA_VERSION_PHYS                                                                                     (IPA_CFG_REG_BASE_PHYS + 0x00000028)
#define HWIO_IPA_VERSION_OFFS                                                                                     (IPA_CFG_REG_BASE_OFFS + 0x00000028)
#define HWIO_IPA_VERSION_RMSK                                                                                     0xffffffff
#define HWIO_IPA_VERSION_ATTR                                                                                            0x1
#define HWIO_IPA_VERSION_IN          \
        in_dword_masked(HWIO_IPA_VERSION_ADDR, HWIO_IPA_VERSION_RMSK)
#define HWIO_IPA_VERSION_INM(m)      \
        in_dword_masked(HWIO_IPA_VERSION_ADDR, m)
#define HWIO_IPA_VERSION_IPA_R_REV_BMSK                                                                           0xffffffff
#define HWIO_IPA_VERSION_IPA_R_REV_SHFT                                                                                  0x0

#define HWIO_IPA_COMP_CFG_ADDR                                                                                    (IPA_CFG_REG_BASE      + 0x0000002c)
#define HWIO_IPA_COMP_CFG_PHYS                                                                                    (IPA_CFG_REG_BASE_PHYS + 0x0000002c)
#define HWIO_IPA_COMP_CFG_OFFS                                                                                    (IPA_CFG_REG_BASE_OFFS + 0x0000002c)
#define HWIO_IPA_COMP_CFG_RMSK                                                                                    0xcffbffef
#define HWIO_IPA_COMP_CFG_ATTR                                                                                           0x3
#define HWIO_IPA_COMP_CFG_IN          \
        in_dword_masked(HWIO_IPA_COMP_CFG_ADDR, HWIO_IPA_COMP_CFG_RMSK)
#define HWIO_IPA_COMP_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_COMP_CFG_ADDR, m)
#define HWIO_IPA_COMP_CFG_OUT(v)      \
        out_dword(HWIO_IPA_COMP_CFG_ADDR,v)
#define HWIO_IPA_COMP_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_COMP_CFG_ADDR,m,v,HWIO_IPA_COMP_CFG_IN)
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_DYNAMIC_ASIZE_BMSK                                                            0x80000000
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_DYNAMIC_ASIZE_SHFT                                                                  0x1f
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_DYNAMIC_ASIZE_BMSK                                                            0x40000000
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_DYNAMIC_ASIZE_SHFT                                                                  0x1e
#define HWIO_IPA_COMP_CFG_IPA_ATOMIC_FETCHER_ARB_LOCK_DIS_BMSK                                                     0xfc00000
#define HWIO_IPA_COMP_CFG_IPA_ATOMIC_FETCHER_ARB_LOCK_DIS_SHFT                                                          0x16
#define HWIO_IPA_COMP_CFG_GSI_IF_OUT_OF_BUF_STOP_RESET_MASK_ENABLE_BMSK                                             0x200000
#define HWIO_IPA_COMP_CFG_GSI_IF_OUT_OF_BUF_STOP_RESET_MASK_ENABLE_SHFT                                                 0x15
#define HWIO_IPA_COMP_CFG_GENQMB_AOOOWR_BMSK                                                                        0x100000
#define HWIO_IPA_COMP_CFG_GENQMB_AOOOWR_SHFT                                                                            0x14
#define HWIO_IPA_COMP_CFG_QMB_RAM_RD_CACHE_DISABLE_BMSK                                                              0x80000
#define HWIO_IPA_COMP_CFG_QMB_RAM_RD_CACHE_DISABLE_SHFT                                                                 0x13
#define HWIO_IPA_COMP_CFG_IPA_FULL_FLUSH_WAIT_RSC_CLOSURE_EN_BMSK                                                    0x20000
#define HWIO_IPA_COMP_CFG_IPA_FULL_FLUSH_WAIT_RSC_CLOSURE_EN_SHFT                                                       0x11
#define HWIO_IPA_COMP_CFG_IPA_QMB_SELECT_BY_ADDRESS_GLOBAL_EN_BMSK                                                   0x10000
#define HWIO_IPA_COMP_CFG_IPA_QMB_SELECT_BY_ADDRESS_GLOBAL_EN_SHFT                                                      0x10
#define HWIO_IPA_COMP_CFG_GSI_MULTI_AXI_MASTERS_DIS_BMSK                                                              0x8000
#define HWIO_IPA_COMP_CFG_GSI_MULTI_AXI_MASTERS_DIS_SHFT                                                                 0xf
#define HWIO_IPA_COMP_CFG_GSI_SNOC_CNOC_LOOP_PROTECTION_DISABLE_BMSK                                                  0x4000
#define HWIO_IPA_COMP_CFG_GSI_SNOC_CNOC_LOOP_PROTECTION_DISABLE_SHFT                                                     0xe
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_SNOC_CNOC_LOOP_PROTECTION_DISABLE_BMSK                                            0x2000
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_SNOC_CNOC_LOOP_PROTECTION_DISABLE_SHFT                                               0xd
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_MULTI_INORDER_WR_DIS_BMSK                                                         0x1000
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_MULTI_INORDER_WR_DIS_SHFT                                                            0xc
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_MULTI_INORDER_WR_DIS_BMSK                                                          0x800
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_MULTI_INORDER_WR_DIS_SHFT                                                            0xb
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_MULTI_INORDER_RD_DIS_BMSK                                                          0x400
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_MULTI_INORDER_RD_DIS_SHFT                                                            0xa
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_MULTI_INORDER_RD_DIS_BMSK                                                          0x200
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_MULTI_INORDER_RD_DIS_SHFT                                                            0x9
#define HWIO_IPA_COMP_CFG_GSI_MULTI_INORDER_WR_DIS_BMSK                                                                0x100
#define HWIO_IPA_COMP_CFG_GSI_MULTI_INORDER_WR_DIS_SHFT                                                                  0x8
#define HWIO_IPA_COMP_CFG_GSI_MULTI_INORDER_RD_DIS_BMSK                                                                 0x80
#define HWIO_IPA_COMP_CFG_GSI_MULTI_INORDER_RD_DIS_SHFT                                                                  0x7
#define HWIO_IPA_COMP_CFG_IPA_QMB_SELECT_BY_ADDRESS_PROD_EN_BMSK                                                        0x40
#define HWIO_IPA_COMP_CFG_IPA_QMB_SELECT_BY_ADDRESS_PROD_EN_SHFT                                                         0x6
#define HWIO_IPA_COMP_CFG_IPA_QMB_SELECT_BY_ADDRESS_CONS_EN_BMSK                                                        0x20
#define HWIO_IPA_COMP_CFG_IPA_QMB_SELECT_BY_ADDRESS_CONS_EN_SHFT                                                         0x5
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_SNOC_BYPASS_DIS_BMSK                                                                 0x8
#define HWIO_IPA_COMP_CFG_GEN_QMB_1_SNOC_BYPASS_DIS_SHFT                                                                 0x3
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_SNOC_BYPASS_DIS_BMSK                                                                 0x4
#define HWIO_IPA_COMP_CFG_GEN_QMB_0_SNOC_BYPASS_DIS_SHFT                                                                 0x2
#define HWIO_IPA_COMP_CFG_GSI_SNOC_BYPASS_DIS_BMSK                                                                       0x2
#define HWIO_IPA_COMP_CFG_GSI_SNOC_BYPASS_DIS_SHFT                                                                       0x1
#define HWIO_IPA_COMP_CFG_RAM_ARB_PRIORITY_CLIENT_SAMP_FIX_DISABLE_BMSK                                                  0x1
#define HWIO_IPA_COMP_CFG_RAM_ARB_PRIORITY_CLIENT_SAMP_FIX_DISABLE_SHFT                                                  0x0

#define HWIO_IPA_CLKON_CFG_1_ADDR                                                                                 (IPA_CFG_REG_BASE      + 0x00000030)
#define HWIO_IPA_CLKON_CFG_1_PHYS                                                                                 (IPA_CFG_REG_BASE_PHYS + 0x00000030)
#define HWIO_IPA_CLKON_CFG_1_OFFS                                                                                 (IPA_CFG_REG_BASE_OFFS + 0x00000030)
#define HWIO_IPA_CLKON_CFG_1_RMSK                                                                                        0x1
#define HWIO_IPA_CLKON_CFG_1_ATTR                                                                                        0x3
#define HWIO_IPA_CLKON_CFG_1_IN          \
        in_dword_masked(HWIO_IPA_CLKON_CFG_1_ADDR, HWIO_IPA_CLKON_CFG_1_RMSK)
#define HWIO_IPA_CLKON_CFG_1_INM(m)      \
        in_dword_masked(HWIO_IPA_CLKON_CFG_1_ADDR, m)
#define HWIO_IPA_CLKON_CFG_1_OUT(v)      \
        out_dword(HWIO_IPA_CLKON_CFG_1_ADDR,v)
#define HWIO_IPA_CLKON_CFG_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_CLKON_CFG_1_ADDR,m,v,HWIO_IPA_CLKON_CFG_1_IN)
#define HWIO_IPA_CLKON_CFG_1_CGC_OPEN_IPA_CORE_CLK_PHASE_BMSK                                                            0x1
#define HWIO_IPA_CLKON_CFG_1_CGC_OPEN_IPA_CORE_CLK_PHASE_SHFT                                                            0x0

#define HWIO_IPA_CLKON_CFG_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x00000034)
#define HWIO_IPA_CLKON_CFG_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000034)
#define HWIO_IPA_CLKON_CFG_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000034)
#define HWIO_IPA_CLKON_CFG_RMSK                                                                                   0xfffdffff
#define HWIO_IPA_CLKON_CFG_ATTR                                                                                          0x3
#define HWIO_IPA_CLKON_CFG_IN          \
        in_dword_masked(HWIO_IPA_CLKON_CFG_ADDR, HWIO_IPA_CLKON_CFG_RMSK)
#define HWIO_IPA_CLKON_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_CLKON_CFG_ADDR, m)
#define HWIO_IPA_CLKON_CFG_OUT(v)      \
        out_dword(HWIO_IPA_CLKON_CFG_ADDR,v)
#define HWIO_IPA_CLKON_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_CLKON_CFG_ADDR,m,v,HWIO_IPA_CLKON_CFG_IN)
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DRBIP_BMSK                                                                    0x80000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DRBIP_SHFT                                                                          0x1f
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DPL_FIFO_BMSK                                                                 0x40000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DPL_FIFO_SHFT                                                                       0x1e
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_GLOBAL_2X_CLK_BMSK                                                            0x20000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_GLOBAL_2X_CLK_SHFT                                                                  0x1d
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_GLOBAL_BMSK                                                                   0x10000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_GLOBAL_SHFT                                                                         0x1c
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_GSI_IF_BMSK                                                                    0x8000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_GSI_IF_SHFT                                                                         0x1b
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_WEIGHT_ARB_BMSK                                                                0x4000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_WEIGHT_ARB_SHFT                                                                     0x1a
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_QMB_BMSK                                                                       0x2000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_QMB_SHFT                                                                            0x19
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RAM_SLAVEWAY_BMSK                                                              0x1000000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RAM_SLAVEWAY_SHFT                                                                   0x18
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_AGGR_WRAPPER_BMSK                                                               0x800000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_AGGR_WRAPPER_SHFT                                                                   0x17
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_QSB2AXI_CMDQ_L_BMSK                                                             0x400000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_QSB2AXI_CMDQ_L_SHFT                                                                 0x16
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_FNR_BMSK                                                                        0x200000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_FNR_SHFT                                                                            0x15
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_TX_1_BMSK                                                                       0x100000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_TX_1_SHFT                                                                           0x14
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_TX_0_BMSK                                                                        0x80000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_TX_0_SHFT                                                                           0x13
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_NTF_TX_CMDQS_BMSK                                                                0x40000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_NTF_TX_CMDQS_SHFT                                                                   0x12
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_H_DCPH_BMSK                                                                      0x10000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_H_DCPH_SHFT                                                                         0x10
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_D_DCPH_BMSK                                                                       0x8000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_D_DCPH_SHFT                                                                          0xf
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_ACK_MNGR_BMSK                                                                     0x4000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_ACK_MNGR_SHFT                                                                        0xe
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_CTX_HANDLER_BMSK                                                                  0x2000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_CTX_HANDLER_SHFT                                                                     0xd
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RSRC_MNGR_BMSK                                                                    0x1000
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RSRC_MNGR_SHFT                                                                       0xc
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DPS_TX_CMDQS_BMSK                                                                  0x800
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DPS_TX_CMDQS_SHFT                                                                    0xb
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_HPS_DPS_CMDQS_BMSK                                                                 0x400
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_HPS_DPS_CMDQS_SHFT                                                                   0xa
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RX_HPS_CMDQS_BMSK                                                                  0x200
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RX_HPS_CMDQS_SHFT                                                                    0x9
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DPS_BMSK                                                                           0x100
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_DPS_SHFT                                                                             0x8
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_HPS_BMSK                                                                            0x80
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_HPS_SHFT                                                                             0x7
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_FTCH_DPS_BMSK                                                                       0x40
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_FTCH_DPS_SHFT                                                                        0x6
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_FTCH_HPS_BMSK                                                                       0x20
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_FTCH_HPS_SHFT                                                                        0x5
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RAM_ARB_BMSK                                                                        0x10
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RAM_ARB_SHFT                                                                         0x4
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_MISC_BMSK                                                                            0x8
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_MISC_SHFT                                                                            0x3
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_TX_WRAPPER_BMSK                                                                      0x4
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_TX_WRAPPER_SHFT                                                                      0x2
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_PROC_BMSK                                                                            0x2
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_PROC_SHFT                                                                            0x1
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RX_BMSK                                                                              0x1
#define HWIO_IPA_CLKON_CFG_CGC_OPEN_RX_SHFT                                                                              0x0

#define HWIO_IPA_ROUTE_ADDR                                                                                       (IPA_CFG_REG_BASE      + 0x00000038)
#define HWIO_IPA_ROUTE_PHYS                                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000038)
#define HWIO_IPA_ROUTE_OFFS                                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000038)
#define HWIO_IPA_ROUTE_RMSK                                                                                       0x1fffffff
#define HWIO_IPA_ROUTE_ATTR                                                                                              0x3
#define HWIO_IPA_ROUTE_IN          \
        in_dword_masked(HWIO_IPA_ROUTE_ADDR, HWIO_IPA_ROUTE_RMSK)
#define HWIO_IPA_ROUTE_INM(m)      \
        in_dword_masked(HWIO_IPA_ROUTE_ADDR, m)
#define HWIO_IPA_ROUTE_OUT(v)      \
        out_dword(HWIO_IPA_ROUTE_ADDR,v)
#define HWIO_IPA_ROUTE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_ROUTE_ADDR,m,v,HWIO_IPA_ROUTE_IN)
#define HWIO_IPA_ROUTE_ROUTE_DIS_BMSK                                                                             0x10000000
#define HWIO_IPA_ROUTE_ROUTE_DIS_SHFT                                                                                   0x1c
#define HWIO_IPA_ROUTE_ROUTE_DEF_RETAIN_HDR_BMSK                                                                   0x8000000
#define HWIO_IPA_ROUTE_ROUTE_DEF_RETAIN_HDR_SHFT                                                                        0x1b
#define HWIO_IPA_ROUTE_ROUTE_DEF_HDR_TABLE_BMSK                                                                    0x4000000
#define HWIO_IPA_ROUTE_ROUTE_DEF_HDR_TABLE_SHFT                                                                         0x1a
#define HWIO_IPA_ROUTE_ROUTE_DEF_HDR_OFST_BMSK                                                                     0x3ff0000
#define HWIO_IPA_ROUTE_ROUTE_DEF_HDR_OFST_SHFT                                                                          0x10
#define HWIO_IPA_ROUTE_ROUTE_FRAG_DEF_PIPE_BMSK                                                                       0xff00
#define HWIO_IPA_ROUTE_ROUTE_FRAG_DEF_PIPE_SHFT                                                                          0x8
#define HWIO_IPA_ROUTE_ROUTE_DEF_PIPE_BMSK                                                                              0xff
#define HWIO_IPA_ROUTE_ROUTE_DEF_PIPE_SHFT                                                                               0x0

#define HWIO_IPA_MASTER_PRIORITY_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x0000003c)
#define HWIO_IPA_MASTER_PRIORITY_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x0000003c)
#define HWIO_IPA_MASTER_PRIORITY_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x0000003c)
#define HWIO_IPA_MASTER_PRIORITY_RMSK                                                                                    0xf
#define HWIO_IPA_MASTER_PRIORITY_ATTR                                                                                    0x3
#define HWIO_IPA_MASTER_PRIORITY_IN          \
        in_dword_masked(HWIO_IPA_MASTER_PRIORITY_ADDR, HWIO_IPA_MASTER_PRIORITY_RMSK)
#define HWIO_IPA_MASTER_PRIORITY_INM(m)      \
        in_dword_masked(HWIO_IPA_MASTER_PRIORITY_ADDR, m)
#define HWIO_IPA_MASTER_PRIORITY_OUT(v)      \
        out_dword(HWIO_IPA_MASTER_PRIORITY_ADDR,v)
#define HWIO_IPA_MASTER_PRIORITY_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MASTER_PRIORITY_ADDR,m,v,HWIO_IPA_MASTER_PRIORITY_IN)
#define HWIO_IPA_MASTER_PRIORITY_QMB_1_RD_BMSK                                                                           0xc
#define HWIO_IPA_MASTER_PRIORITY_QMB_1_RD_SHFT                                                                           0x2
#define HWIO_IPA_MASTER_PRIORITY_QMB_0_RD_BMSK                                                                           0x3
#define HWIO_IPA_MASTER_PRIORITY_QMB_0_RD_SHFT                                                                           0x0

#define HWIO_IPA_SHARED_MEM_SIZE_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x00000040)
#define HWIO_IPA_SHARED_MEM_SIZE_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x00000040)
#define HWIO_IPA_SHARED_MEM_SIZE_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x00000040)
#define HWIO_IPA_SHARED_MEM_SIZE_RMSK                                                                             0xffffffff
#define HWIO_IPA_SHARED_MEM_SIZE_ATTR                                                                                    0x1
#define HWIO_IPA_SHARED_MEM_SIZE_IN          \
        in_dword_masked(HWIO_IPA_SHARED_MEM_SIZE_ADDR, HWIO_IPA_SHARED_MEM_SIZE_RMSK)
#define HWIO_IPA_SHARED_MEM_SIZE_INM(m)      \
        in_dword_masked(HWIO_IPA_SHARED_MEM_SIZE_ADDR, m)
#define HWIO_IPA_SHARED_MEM_SIZE_SHARED_MEM_BADDR_BMSK                                                            0xffff0000
#define HWIO_IPA_SHARED_MEM_SIZE_SHARED_MEM_BADDR_SHFT                                                                  0x10
#define HWIO_IPA_SHARED_MEM_SIZE_SHARED_MEM_SIZE_BMSK                                                                 0xffff
#define HWIO_IPA_SHARED_MEM_SIZE_SHARED_MEM_SIZE_SHFT                                                                    0x0

#define HWIO_IPA_NAT_TIMER_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x00000048)
#define HWIO_IPA_NAT_TIMER_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000048)
#define HWIO_IPA_NAT_TIMER_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000048)
#define HWIO_IPA_NAT_TIMER_RMSK                                                                                     0xffffff
#define HWIO_IPA_NAT_TIMER_ATTR                                                                                          0x1
#define HWIO_IPA_NAT_TIMER_IN          \
        in_dword_masked(HWIO_IPA_NAT_TIMER_ADDR, HWIO_IPA_NAT_TIMER_RMSK)
#define HWIO_IPA_NAT_TIMER_INM(m)      \
        in_dword_masked(HWIO_IPA_NAT_TIMER_ADDR, m)
#define HWIO_IPA_NAT_TIMER_NAT_TIMER_BMSK                                                                           0xffffff
#define HWIO_IPA_NAT_TIMER_NAT_TIMER_SHFT                                                                                0x0

#define HWIO_IPA_TAG_TIMER_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x00000044)
#define HWIO_IPA_TAG_TIMER_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000044)
#define HWIO_IPA_TAG_TIMER_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000044)
#define HWIO_IPA_TAG_TIMER_RMSK                                                                                     0xffffff
#define HWIO_IPA_TAG_TIMER_ATTR                                                                                          0x1
#define HWIO_IPA_TAG_TIMER_IN          \
        in_dword_masked(HWIO_IPA_TAG_TIMER_ADDR, HWIO_IPA_TAG_TIMER_RMSK)
#define HWIO_IPA_TAG_TIMER_INM(m)      \
        in_dword_masked(HWIO_IPA_TAG_TIMER_ADDR, m)
#define HWIO_IPA_TAG_TIMER_TAG_TIMER_BMSK                                                                           0xffffff
#define HWIO_IPA_TAG_TIMER_TAG_TIMER_SHFT                                                                                0x0

#define HWIO_IPA_FRAG_RULES_CLR_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x0000004c)
#define HWIO_IPA_FRAG_RULES_CLR_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x0000004c)
#define HWIO_IPA_FRAG_RULES_CLR_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x0000004c)
#define HWIO_IPA_FRAG_RULES_CLR_RMSK                                                                                     0x1
#define HWIO_IPA_FRAG_RULES_CLR_ATTR                                                                                     0x2
#define HWIO_IPA_FRAG_RULES_CLR_OUT(v)      \
        out_dword(HWIO_IPA_FRAG_RULES_CLR_ADDR,v)
#define HWIO_IPA_FRAG_RULES_CLR_CLR_BMSK                                                                                 0x1
#define HWIO_IPA_FRAG_RULES_CLR_CLR_SHFT                                                                                 0x0

#define HWIO_IPA_PROC_IPH_CFG_ADDR                                                                                (IPA_CFG_REG_BASE      + 0x00000050)
#define HWIO_IPA_PROC_IPH_CFG_PHYS                                                                                (IPA_CFG_REG_BASE_PHYS + 0x00000050)
#define HWIO_IPA_PROC_IPH_CFG_OFFS                                                                                (IPA_CFG_REG_BASE_OFFS + 0x00000050)
#define HWIO_IPA_PROC_IPH_CFG_RMSK                                                                                 0x1ff0f00
#define HWIO_IPA_PROC_IPH_CFG_ATTR                                                                                       0x3
#define HWIO_IPA_PROC_IPH_CFG_IN          \
        in_dword_masked(HWIO_IPA_PROC_IPH_CFG_ADDR, HWIO_IPA_PROC_IPH_CFG_RMSK)
#define HWIO_IPA_PROC_IPH_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_PROC_IPH_CFG_ADDR, m)
#define HWIO_IPA_PROC_IPH_CFG_OUT(v)      \
        out_dword(HWIO_IPA_PROC_IPH_CFG_ADDR,v)
#define HWIO_IPA_PROC_IPH_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_PROC_IPH_CFG_ADDR,m,v,HWIO_IPA_PROC_IPH_CFG_IN)
#define HWIO_IPA_PROC_IPH_CFG_D_DCPH_MULTI_ENGINE_DISABLE_BMSK                                                     0x1000000
#define HWIO_IPA_PROC_IPH_CFG_D_DCPH_MULTI_ENGINE_DISABLE_SHFT                                                          0x18
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_VALUE_BMSK                                               0xff0000
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_VALUE_SHFT                                                   0x10
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_IHL_TO_2ND_FRAG_EN_BMSK                                                   0x800
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_IHL_TO_2ND_FRAG_EN_SHFT                                                     0xb
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_DEST_BMSK                                                   0x400
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_DEST_SHFT                                                     0xa
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_HOP_BMSK                                                    0x200
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_HOP_SHFT                                                      0x9
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_ENABLE_BMSK                                                 0x100
#define HWIO_IPA_PROC_IPH_CFG_IPH_PKT_PARSER_PROTOCOL_STOP_ENABLE_SHFT                                                   0x8

#define HWIO_IPA_QSB_MAX_WRITES_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x00000054)
#define HWIO_IPA_QSB_MAX_WRITES_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000054)
#define HWIO_IPA_QSB_MAX_WRITES_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000054)
#define HWIO_IPA_QSB_MAX_WRITES_RMSK                                                                                    0xff
#define HWIO_IPA_QSB_MAX_WRITES_ATTR                                                                                     0x3
#define HWIO_IPA_QSB_MAX_WRITES_IN          \
        in_dword_masked(HWIO_IPA_QSB_MAX_WRITES_ADDR, HWIO_IPA_QSB_MAX_WRITES_RMSK)
#define HWIO_IPA_QSB_MAX_WRITES_INM(m)      \
        in_dword_masked(HWIO_IPA_QSB_MAX_WRITES_ADDR, m)
#define HWIO_IPA_QSB_MAX_WRITES_OUT(v)      \
        out_dword(HWIO_IPA_QSB_MAX_WRITES_ADDR,v)
#define HWIO_IPA_QSB_MAX_WRITES_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_QSB_MAX_WRITES_ADDR,m,v,HWIO_IPA_QSB_MAX_WRITES_IN)
#define HWIO_IPA_QSB_MAX_WRITES_GEN_QMB_1_MAX_WRITES_BMSK                                                               0xf0
#define HWIO_IPA_QSB_MAX_WRITES_GEN_QMB_1_MAX_WRITES_SHFT                                                                0x4
#define HWIO_IPA_QSB_MAX_WRITES_GEN_QMB_0_MAX_WRITES_BMSK                                                                0xf
#define HWIO_IPA_QSB_MAX_WRITES_GEN_QMB_0_MAX_WRITES_SHFT                                                                0x0

#define HWIO_IPA_QSB_MAX_READS_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x00000058)
#define HWIO_IPA_QSB_MAX_READS_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000058)
#define HWIO_IPA_QSB_MAX_READS_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000058)
#define HWIO_IPA_QSB_MAX_READS_RMSK                                                                               0xffff00ff
#define HWIO_IPA_QSB_MAX_READS_ATTR                                                                                      0x3
#define HWIO_IPA_QSB_MAX_READS_IN          \
        in_dword_masked(HWIO_IPA_QSB_MAX_READS_ADDR, HWIO_IPA_QSB_MAX_READS_RMSK)
#define HWIO_IPA_QSB_MAX_READS_INM(m)      \
        in_dword_masked(HWIO_IPA_QSB_MAX_READS_ADDR, m)
#define HWIO_IPA_QSB_MAX_READS_OUT(v)      \
        out_dword(HWIO_IPA_QSB_MAX_READS_ADDR,v)
#define HWIO_IPA_QSB_MAX_READS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_QSB_MAX_READS_ADDR,m,v,HWIO_IPA_QSB_MAX_READS_IN)
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_1_MAX_READ_BEATS_BMSK                                                      0xff000000
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_1_MAX_READ_BEATS_SHFT                                                            0x18
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_0_MAX_READ_BEATS_BMSK                                                        0xff0000
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_0_MAX_READ_BEATS_SHFT                                                            0x10
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_1_MAX_READS_BMSK                                                                 0xf0
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_1_MAX_READS_SHFT                                                                  0x4
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_0_MAX_READS_BMSK                                                                  0xf
#define HWIO_IPA_QSB_MAX_READS_GEN_QMB_0_MAX_READS_SHFT                                                                  0x0

#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_ADDR                                                                     (IPA_CFG_REG_BASE      + 0x0000005c)
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_PHYS                                                                     (IPA_CFG_REG_BASE_PHYS + 0x0000005c)
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_OFFS                                                                     (IPA_CFG_REG_BASE_OFFS + 0x0000005c)
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_RMSK                                                                     0x1f1f1f1f
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_ATTR                                                                            0x1
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_IN          \
        in_dword_masked(HWIO_IPA_QSB_OUTSTANDING_COUNTER_ADDR, HWIO_IPA_QSB_OUTSTANDING_COUNTER_RMSK)
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_INM(m)      \
        in_dword_masked(HWIO_IPA_QSB_OUTSTANDING_COUNTER_ADDR, m)
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_1_WRITES_CNT_BMSK                                                0x1f000000
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_1_WRITES_CNT_SHFT                                                      0x18
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_0_WRITES_CNT_BMSK                                                  0x1f0000
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_0_WRITES_CNT_SHFT                                                      0x10
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_1_READS_CNT_BMSK                                                     0x1f00
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_1_READS_CNT_SHFT                                                        0x8
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_0_READS_CNT_BMSK                                                       0x1f
#define HWIO_IPA_QSB_OUTSTANDING_COUNTER_GEN_QMB_0_READS_CNT_SHFT                                                        0x0

#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_ADDR                                                               (IPA_CFG_REG_BASE      + 0x00000060)
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_PHYS                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000060)
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_OFFS                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000060)
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_RMSK                                                                   0xffff
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_ATTR                                                                      0x1
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_IN          \
        in_dword_masked(HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_ADDR, HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_RMSK)
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_INM(m)      \
        in_dword_masked(HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_ADDR, m)
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_GEN_QMB_1_READ_BEATS_CNT_BMSK                                          0xff00
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_GEN_QMB_1_READ_BEATS_CNT_SHFT                                             0x8
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_GEN_QMB_0_READ_BEATS_CNT_BMSK                                            0xff
#define HWIO_IPA_QSB_OUTSTANDING_BEATS_COUNTER_GEN_QMB_0_READ_BEATS_CNT_SHFT                                             0x0

#define HWIO_IPA_DPL_TIMER_LSB_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x00000064)
#define HWIO_IPA_DPL_TIMER_LSB_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000064)
#define HWIO_IPA_DPL_TIMER_LSB_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000064)
#define HWIO_IPA_DPL_TIMER_LSB_RMSK                                                                               0xffffffff
#define HWIO_IPA_DPL_TIMER_LSB_ATTR                                                                                      0x3
#define HWIO_IPA_DPL_TIMER_LSB_IN          \
        in_dword_masked(HWIO_IPA_DPL_TIMER_LSB_ADDR, HWIO_IPA_DPL_TIMER_LSB_RMSK)
#define HWIO_IPA_DPL_TIMER_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_DPL_TIMER_LSB_ADDR, m)
#define HWIO_IPA_DPL_TIMER_LSB_OUT(v)      \
        out_dword(HWIO_IPA_DPL_TIMER_LSB_ADDR,v)
#define HWIO_IPA_DPL_TIMER_LSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPL_TIMER_LSB_ADDR,m,v,HWIO_IPA_DPL_TIMER_LSB_IN)
#define HWIO_IPA_DPL_TIMER_LSB_TOD_LSB_BMSK                                                                       0xffffffff
#define HWIO_IPA_DPL_TIMER_LSB_TOD_LSB_SHFT                                                                              0x0

#define HWIO_IPA_DPL_TIMER_MSB_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x00000068)
#define HWIO_IPA_DPL_TIMER_MSB_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000068)
#define HWIO_IPA_DPL_TIMER_MSB_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000068)
#define HWIO_IPA_DPL_TIMER_MSB_RMSK                                                                               0xf800ffff
#define HWIO_IPA_DPL_TIMER_MSB_ATTR                                                                                      0x3
#define HWIO_IPA_DPL_TIMER_MSB_IN          \
        in_dword_masked(HWIO_IPA_DPL_TIMER_MSB_ADDR, HWIO_IPA_DPL_TIMER_MSB_RMSK)
#define HWIO_IPA_DPL_TIMER_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_DPL_TIMER_MSB_ADDR, m)
#define HWIO_IPA_DPL_TIMER_MSB_OUT(v)      \
        out_dword(HWIO_IPA_DPL_TIMER_MSB_ADDR,v)
#define HWIO_IPA_DPL_TIMER_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DPL_TIMER_MSB_ADDR,m,v,HWIO_IPA_DPL_TIMER_MSB_IN)
#define HWIO_IPA_DPL_TIMER_MSB_TIMER_EN_BMSK                                                                      0x80000000
#define HWIO_IPA_DPL_TIMER_MSB_TIMER_EN_SHFT                                                                            0x1f
#define HWIO_IPA_DPL_TIMER_MSB_GRAN_SEL_BMSK                                                                      0x78000000
#define HWIO_IPA_DPL_TIMER_MSB_GRAN_SEL_SHFT                                                                            0x1b
#define HWIO_IPA_DPL_TIMER_MSB_TOD_MSB_BMSK                                                                           0xffff
#define HWIO_IPA_DPL_TIMER_MSB_TOD_MSB_SHFT                                                                              0x0

#define HWIO_IPA_STATE_RX_ACTIVE_n_ADDR(n)                                                                        (IPA_CFG_REG_BASE      + 0x00000070 + 0x4 * (n))
#define HWIO_IPA_STATE_RX_ACTIVE_n_PHYS(n)                                                                        (IPA_CFG_REG_BASE_PHYS + 0x00000070 + 0x4 * (n))
#define HWIO_IPA_STATE_RX_ACTIVE_n_OFFS(n)                                                                        (IPA_CFG_REG_BASE_OFFS + 0x00000070 + 0x4 * (n))
#define HWIO_IPA_STATE_RX_ACTIVE_n_RMSK                                                                           0xffffffff
#define HWIO_IPA_STATE_RX_ACTIVE_n_MAXn                                                                                    0
#define HWIO_IPA_STATE_RX_ACTIVE_n_ATTR                                                                                  0x1
#define HWIO_IPA_STATE_RX_ACTIVE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_RX_ACTIVE_n_ADDR(n), HWIO_IPA_STATE_RX_ACTIVE_n_RMSK)
#define HWIO_IPA_STATE_RX_ACTIVE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_RX_ACTIVE_n_ADDR(n), mask)
#define HWIO_IPA_STATE_RX_ACTIVE_n_ENDPOINTS_BMSK                                                                 0xffffffff
#define HWIO_IPA_STATE_RX_ACTIVE_n_ENDPOINTS_SHFT                                                                        0x0

#define HWIO_IPA_STATE_TX_WRAPPER_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x00000090)
#define HWIO_IPA_STATE_TX_WRAPPER_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_STATE_TX_WRAPPER_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_STATE_TX_WRAPPER_RMSK                                                                            0xf00c001f
#define HWIO_IPA_STATE_TX_WRAPPER_ATTR                                                                                   0x1
#define HWIO_IPA_STATE_TX_WRAPPER_IN          \
        in_dword_masked(HWIO_IPA_STATE_TX_WRAPPER_ADDR, HWIO_IPA_STATE_TX_WRAPPER_RMSK)
#define HWIO_IPA_STATE_TX_WRAPPER_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_TX_WRAPPER_ADDR, m)
#define HWIO_IPA_STATE_TX_WRAPPER_COAL_SLAVE_OPEN_FRAME_BMSK                                                      0xf0000000
#define HWIO_IPA_STATE_TX_WRAPPER_COAL_SLAVE_OPEN_FRAME_SHFT                                                            0x1c
#define HWIO_IPA_STATE_TX_WRAPPER_COAL_SLAVE_CTX_IDLE_BMSK                                                           0x80000
#define HWIO_IPA_STATE_TX_WRAPPER_COAL_SLAVE_CTX_IDLE_SHFT                                                              0x13
#define HWIO_IPA_STATE_TX_WRAPPER_COAL_SLAVE_IDLE_BMSK                                                               0x40000
#define HWIO_IPA_STATE_TX_WRAPPER_COAL_SLAVE_IDLE_SHFT                                                                  0x12
#define HWIO_IPA_STATE_TX_WRAPPER_IPA_PROD_BRESP_EMPTY_BMSK                                                             0x10
#define HWIO_IPA_STATE_TX_WRAPPER_IPA_PROD_BRESP_EMPTY_SHFT                                                              0x4
#define HWIO_IPA_STATE_TX_WRAPPER_IPA_PROD_ACKMNGR_STATE_IDLE_BMSK                                                       0x8
#define HWIO_IPA_STATE_TX_WRAPPER_IPA_PROD_ACKMNGR_STATE_IDLE_SHFT                                                       0x3
#define HWIO_IPA_STATE_TX_WRAPPER_IPA_PROD_ACKMNGR_DB_EMPTY_BMSK                                                         0x4
#define HWIO_IPA_STATE_TX_WRAPPER_IPA_PROD_ACKMNGR_DB_EMPTY_SHFT                                                         0x2
#define HWIO_IPA_STATE_TX_WRAPPER_TX1_IDLE_BMSK                                                                          0x2
#define HWIO_IPA_STATE_TX_WRAPPER_TX1_IDLE_SHFT                                                                          0x1
#define HWIO_IPA_STATE_TX_WRAPPER_TX0_IDLE_BMSK                                                                          0x1
#define HWIO_IPA_STATE_TX_WRAPPER_TX0_IDLE_SHFT                                                                          0x0

#define HWIO_IPA_STATE_TX0_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x00000094)
#define HWIO_IPA_STATE_TX0_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000094)
#define HWIO_IPA_STATE_TX0_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000094)
#define HWIO_IPA_STATE_TX0_RMSK                                                                                    0x7ffffff
#define HWIO_IPA_STATE_TX0_ATTR                                                                                          0x1
#define HWIO_IPA_STATE_TX0_IN          \
        in_dword_masked(HWIO_IPA_STATE_TX0_ADDR, HWIO_IPA_STATE_TX0_RMSK)
#define HWIO_IPA_STATE_TX0_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_TX0_ADDR, m)
#define HWIO_IPA_STATE_TX0_SUSPEND_REQ_EMPTY_BMSK                                                                  0x4000000
#define HWIO_IPA_STATE_TX0_SUSPEND_REQ_EMPTY_SHFT                                                                       0x1a
#define HWIO_IPA_STATE_TX0_CS_SNIF_IDLE_BMSK                                                                       0x2000000
#define HWIO_IPA_STATE_TX0_CS_SNIF_IDLE_SHFT                                                                            0x19
#define HWIO_IPA_STATE_TX0_SUSPEND_EMPTY_BMSK                                                                      0x1000000
#define HWIO_IPA_STATE_TX0_SUSPEND_EMPTY_SHFT                                                                           0x18
#define HWIO_IPA_STATE_TX0_RSRCREL_IDLE_BMSK                                                                        0x800000
#define HWIO_IPA_STATE_TX0_RSRCREL_IDLE_SHFT                                                                            0x17
#define HWIO_IPA_STATE_TX0_HOLB_MASK_IDLE_BMSK                                                                      0x400000
#define HWIO_IPA_STATE_TX0_HOLB_MASK_IDLE_SHFT                                                                          0x16
#define HWIO_IPA_STATE_TX0_HOLB_IDLE_BMSK                                                                           0x200000
#define HWIO_IPA_STATE_TX0_HOLB_IDLE_SHFT                                                                               0x15
#define HWIO_IPA_STATE_TX0_ALIGNER_EMPTY_BMSK                                                                       0x100000
#define HWIO_IPA_STATE_TX0_ALIGNER_EMPTY_SHFT                                                                           0x14
#define HWIO_IPA_STATE_TX0_PF_EMPTY_BMSK                                                                             0x80000
#define HWIO_IPA_STATE_TX0_PF_EMPTY_SHFT                                                                                0x13
#define HWIO_IPA_STATE_TX0_PF_IDLE_BMSK                                                                              0x40000
#define HWIO_IPA_STATE_TX0_PF_IDLE_SHFT                                                                                 0x12
#define HWIO_IPA_STATE_TX0_DMAW_LAST_OUTSD_IDLE_BMSK                                                                 0x20000
#define HWIO_IPA_STATE_TX0_DMAW_LAST_OUTSD_IDLE_SHFT                                                                    0x11
#define HWIO_IPA_STATE_TX0_DMAW_IDLE_BMSK                                                                            0x10000
#define HWIO_IPA_STATE_TX0_DMAW_IDLE_SHFT                                                                               0x10
#define HWIO_IPA_STATE_TX0_AR_IDLE_BMSK                                                                               0x8000
#define HWIO_IPA_STATE_TX0_AR_IDLE_SHFT                                                                                  0xf
#define HWIO_IPA_STATE_TX0_TX_CMD_BRESP_INJ_IDLE_BMSK                                                                 0x4000
#define HWIO_IPA_STATE_TX0_TX_CMD_BRESP_INJ_IDLE_SHFT                                                                    0xe
#define HWIO_IPA_STATE_TX0_TX_CMD_BRESP_ALOC_IDLE_BMSK                                                                0x2000
#define HWIO_IPA_STATE_TX0_TX_CMD_BRESP_ALOC_IDLE_SHFT                                                                   0xd
#define HWIO_IPA_STATE_TX0_TX_CMD_SNIF_IDLE_BMSK                                                                      0x1000
#define HWIO_IPA_STATE_TX0_TX_CMD_SNIF_IDLE_SHFT                                                                         0xc
#define HWIO_IPA_STATE_TX0_TX_CMD_TRNSEQ_IDLE_BMSK                                                                     0x800
#define HWIO_IPA_STATE_TX0_TX_CMD_TRNSEQ_IDLE_SHFT                                                                       0xb
#define HWIO_IPA_STATE_TX0_TX_CMD_MAIN_IDLE_BMSK                                                                       0x400
#define HWIO_IPA_STATE_TX0_TX_CMD_MAIN_IDLE_SHFT                                                                         0xa
#define HWIO_IPA_STATE_TX0_PA_PUB_CNT_EMPTY_BMSK                                                                       0x200
#define HWIO_IPA_STATE_TX0_PA_PUB_CNT_EMPTY_SHFT                                                                         0x9
#define HWIO_IPA_STATE_TX0_PA_RST_IDLE_BMSK                                                                            0x100
#define HWIO_IPA_STATE_TX0_PA_RST_IDLE_SHFT                                                                              0x8
#define HWIO_IPA_STATE_TX0_PA_CTX_IDLE_BMSK                                                                             0x80
#define HWIO_IPA_STATE_TX0_PA_CTX_IDLE_SHFT                                                                              0x7
#define HWIO_IPA_STATE_TX0_PA_IDLE_BMSK                                                                                 0x40
#define HWIO_IPA_STATE_TX0_PA_IDLE_SHFT                                                                                  0x6
#define HWIO_IPA_STATE_TX0_ARBIT_TYPE_BMSK                                                                              0x38
#define HWIO_IPA_STATE_TX0_ARBIT_TYPE_SHFT                                                                               0x3
#define HWIO_IPA_STATE_TX0_FLOPPED_ARBIT_TYPE_BMSK                                                                       0x7
#define HWIO_IPA_STATE_TX0_FLOPPED_ARBIT_TYPE_SHFT                                                                       0x0

#define HWIO_IPA_STATE_TX1_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x00000098)
#define HWIO_IPA_STATE_TX1_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000098)
#define HWIO_IPA_STATE_TX1_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000098)
#define HWIO_IPA_STATE_TX1_RMSK                                                                                    0x7ffffff
#define HWIO_IPA_STATE_TX1_ATTR                                                                                          0x1
#define HWIO_IPA_STATE_TX1_IN          \
        in_dword_masked(HWIO_IPA_STATE_TX1_ADDR, HWIO_IPA_STATE_TX1_RMSK)
#define HWIO_IPA_STATE_TX1_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_TX1_ADDR, m)
#define HWIO_IPA_STATE_TX1_SUSPEND_REQ_EMPTY_BMSK                                                                  0x4000000
#define HWIO_IPA_STATE_TX1_SUSPEND_REQ_EMPTY_SHFT                                                                       0x1a
#define HWIO_IPA_STATE_TX1_CS_SNIF_IDLE_BMSK                                                                       0x2000000
#define HWIO_IPA_STATE_TX1_CS_SNIF_IDLE_SHFT                                                                            0x19
#define HWIO_IPA_STATE_TX1_SUSPEND_EMPTY_BMSK                                                                      0x1000000
#define HWIO_IPA_STATE_TX1_SUSPEND_EMPTY_SHFT                                                                           0x18
#define HWIO_IPA_STATE_TX1_RSRCREL_IDLE_BMSK                                                                        0x800000
#define HWIO_IPA_STATE_TX1_RSRCREL_IDLE_SHFT                                                                            0x17
#define HWIO_IPA_STATE_TX1_HOLB_MASK_IDLE_BMSK                                                                      0x400000
#define HWIO_IPA_STATE_TX1_HOLB_MASK_IDLE_SHFT                                                                          0x16
#define HWIO_IPA_STATE_TX1_HOLB_IDLE_BMSK                                                                           0x200000
#define HWIO_IPA_STATE_TX1_HOLB_IDLE_SHFT                                                                               0x15
#define HWIO_IPA_STATE_TX1_ALIGNER_EMPTY_BMSK                                                                       0x100000
#define HWIO_IPA_STATE_TX1_ALIGNER_EMPTY_SHFT                                                                           0x14
#define HWIO_IPA_STATE_TX1_PF_EMPTY_BMSK                                                                             0x80000
#define HWIO_IPA_STATE_TX1_PF_EMPTY_SHFT                                                                                0x13
#define HWIO_IPA_STATE_TX1_PF_IDLE_BMSK                                                                              0x40000
#define HWIO_IPA_STATE_TX1_PF_IDLE_SHFT                                                                                 0x12
#define HWIO_IPA_STATE_TX1_DMAW_LAST_OUTSD_IDLE_BMSK                                                                 0x20000
#define HWIO_IPA_STATE_TX1_DMAW_LAST_OUTSD_IDLE_SHFT                                                                    0x11
#define HWIO_IPA_STATE_TX1_DMAW_IDLE_BMSK                                                                            0x10000
#define HWIO_IPA_STATE_TX1_DMAW_IDLE_SHFT                                                                               0x10
#define HWIO_IPA_STATE_TX1_AR_IDLE_BMSK                                                                               0x8000
#define HWIO_IPA_STATE_TX1_AR_IDLE_SHFT                                                                                  0xf
#define HWIO_IPA_STATE_TX1_TX_CMD_BRESP_INJ_IDLE_BMSK                                                                 0x4000
#define HWIO_IPA_STATE_TX1_TX_CMD_BRESP_INJ_IDLE_SHFT                                                                    0xe
#define HWIO_IPA_STATE_TX1_TX_CMD_BRESP_ALOC_IDLE_BMSK                                                                0x2000
#define HWIO_IPA_STATE_TX1_TX_CMD_BRESP_ALOC_IDLE_SHFT                                                                   0xd
#define HWIO_IPA_STATE_TX1_TX_CMD_SNIF_IDLE_BMSK                                                                      0x1000
#define HWIO_IPA_STATE_TX1_TX_CMD_SNIF_IDLE_SHFT                                                                         0xc
#define HWIO_IPA_STATE_TX1_TX_CMD_TRNSEQ_IDLE_BMSK                                                                     0x800
#define HWIO_IPA_STATE_TX1_TX_CMD_TRNSEQ_IDLE_SHFT                                                                       0xb
#define HWIO_IPA_STATE_TX1_TX_CMD_MAIN_IDLE_BMSK                                                                       0x400
#define HWIO_IPA_STATE_TX1_TX_CMD_MAIN_IDLE_SHFT                                                                         0xa
#define HWIO_IPA_STATE_TX1_PA_PUB_CNT_EMPTY_BMSK                                                                       0x200
#define HWIO_IPA_STATE_TX1_PA_PUB_CNT_EMPTY_SHFT                                                                         0x9
#define HWIO_IPA_STATE_TX1_PA_RST_IDLE_BMSK                                                                            0x100
#define HWIO_IPA_STATE_TX1_PA_RST_IDLE_SHFT                                                                              0x8
#define HWIO_IPA_STATE_TX1_PA_CTX_IDLE_BMSK                                                                             0x80
#define HWIO_IPA_STATE_TX1_PA_CTX_IDLE_SHFT                                                                              0x7
#define HWIO_IPA_STATE_TX1_PA_IDLE_BMSK                                                                                 0x40
#define HWIO_IPA_STATE_TX1_PA_IDLE_SHFT                                                                                  0x6
#define HWIO_IPA_STATE_TX1_ARBIT_TYPE_BMSK                                                                              0x38
#define HWIO_IPA_STATE_TX1_ARBIT_TYPE_SHFT                                                                               0x3
#define HWIO_IPA_STATE_TX1_FLOPPED_ARBIT_TYPE_BMSK                                                                       0x7
#define HWIO_IPA_STATE_TX1_FLOPPED_ARBIT_TYPE_SHFT                                                                       0x0

#define HWIO_IPA_STATE_TX0_MISC_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x0000009c)
#define HWIO_IPA_STATE_TX0_MISC_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x0000009c)
#define HWIO_IPA_STATE_TX0_MISC_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x0000009c)
#define HWIO_IPA_STATE_TX0_MISC_RMSK                                                                                  0x3fff
#define HWIO_IPA_STATE_TX0_MISC_ATTR                                                                                     0x1
#define HWIO_IPA_STATE_TX0_MISC_IN          \
        in_dword_masked(HWIO_IPA_STATE_TX0_MISC_ADDR, HWIO_IPA_STATE_TX0_MISC_RMSK)
#define HWIO_IPA_STATE_TX0_MISC_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_TX0_MISC_ADDR, m)
#define HWIO_IPA_STATE_TX0_MISC_LAST_CMD_PIPE_BMSK                                                                    0x3fc0
#define HWIO_IPA_STATE_TX0_MISC_LAST_CMD_PIPE_SHFT                                                                       0x6
#define HWIO_IPA_STATE_TX0_MISC_COAL_DIRECT_DMA_BMSK                                                                    0x20
#define HWIO_IPA_STATE_TX0_MISC_COAL_DIRECT_DMA_SHFT                                                                     0x5
#define HWIO_IPA_STATE_TX0_MISC_NLO_DIRECT_DMA_BMSK                                                                     0x10
#define HWIO_IPA_STATE_TX0_MISC_NLO_DIRECT_DMA_SHFT                                                                      0x4
#define HWIO_IPA_STATE_TX0_MISC_PKT_DROP_CNT_IDLE_BMSK                                                                   0x8
#define HWIO_IPA_STATE_TX0_MISC_PKT_DROP_CNT_IDLE_SHFT                                                                   0x3
#define HWIO_IPA_STATE_TX0_MISC_TRNSEQ_FORCE_VALID_BMSK                                                                  0x4
#define HWIO_IPA_STATE_TX0_MISC_TRNSEQ_FORCE_VALID_SHFT                                                                  0x2
#define HWIO_IPA_STATE_TX0_MISC_MBIM_DIRECT_DMA_BMSK                                                                     0x2
#define HWIO_IPA_STATE_TX0_MISC_MBIM_DIRECT_DMA_SHFT                                                                     0x1
#define HWIO_IPA_STATE_TX0_MISC_IPA_MBIM_PKT_FMS_IDLE_BMSK                                                               0x1
#define HWIO_IPA_STATE_TX0_MISC_IPA_MBIM_PKT_FMS_IDLE_SHFT                                                               0x0

#define HWIO_IPA_STATE_TX1_MISC_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x000000a0)
#define HWIO_IPA_STATE_TX1_MISC_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x000000a0)
#define HWIO_IPA_STATE_TX1_MISC_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x000000a0)
#define HWIO_IPA_STATE_TX1_MISC_RMSK                                                                                  0x3fff
#define HWIO_IPA_STATE_TX1_MISC_ATTR                                                                                     0x1
#define HWIO_IPA_STATE_TX1_MISC_IN          \
        in_dword_masked(HWIO_IPA_STATE_TX1_MISC_ADDR, HWIO_IPA_STATE_TX1_MISC_RMSK)
#define HWIO_IPA_STATE_TX1_MISC_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_TX1_MISC_ADDR, m)
#define HWIO_IPA_STATE_TX1_MISC_LAST_CMD_PIPE_BMSK                                                                    0x3fc0
#define HWIO_IPA_STATE_TX1_MISC_LAST_CMD_PIPE_SHFT                                                                       0x6
#define HWIO_IPA_STATE_TX1_MISC_COAL_DIRECT_DMA_BMSK                                                                    0x20
#define HWIO_IPA_STATE_TX1_MISC_COAL_DIRECT_DMA_SHFT                                                                     0x5
#define HWIO_IPA_STATE_TX1_MISC_NLO_DIRECT_DMA_BMSK                                                                     0x10
#define HWIO_IPA_STATE_TX1_MISC_NLO_DIRECT_DMA_SHFT                                                                      0x4
#define HWIO_IPA_STATE_TX1_MISC_PKT_DROP_CNT_IDLE_BMSK                                                                   0x8
#define HWIO_IPA_STATE_TX1_MISC_PKT_DROP_CNT_IDLE_SHFT                                                                   0x3
#define HWIO_IPA_STATE_TX1_MISC_TRNSEQ_FORCE_VALID_BMSK                                                                  0x4
#define HWIO_IPA_STATE_TX1_MISC_TRNSEQ_FORCE_VALID_SHFT                                                                  0x2
#define HWIO_IPA_STATE_TX1_MISC_MBIM_DIRECT_DMA_BMSK                                                                     0x2
#define HWIO_IPA_STATE_TX1_MISC_MBIM_DIRECT_DMA_SHFT                                                                     0x1
#define HWIO_IPA_STATE_TX1_MISC_IPA_MBIM_PKT_FMS_IDLE_BMSK                                                               0x1
#define HWIO_IPA_STATE_TX1_MISC_IPA_MBIM_PKT_FMS_IDLE_SHFT                                                               0x0

#define HWIO_IPA_STATE_FETCHER_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x000000a4)
#define HWIO_IPA_STATE_FETCHER_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x000000a4)
#define HWIO_IPA_STATE_FETCHER_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x000000a4)
#define HWIO_IPA_STATE_FETCHER_RMSK                                                                                  0xfffff
#define HWIO_IPA_STATE_FETCHER_ATTR                                                                                      0x1
#define HWIO_IPA_STATE_FETCHER_IN          \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_ADDR, HWIO_IPA_STATE_FETCHER_RMSK)
#define HWIO_IPA_STATE_FETCHER_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_ADDR, m)
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_IMM_CMD_EXEC_STATE_IDLE_BMSK                                                  0x80000
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_IMM_CMD_EXEC_STATE_IDLE_SHFT                                                     0x13
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_DMAR_SLOT_STATE_IDLE_BMSK                                                     0x7f000
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_DMAR_SLOT_STATE_IDLE_SHFT                                                         0xc
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_DMAR_STATE_IDLE_BMSK                                                            0xfe0
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_DMAR_STATE_IDLE_SHFT                                                              0x5
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_CMPLT_STATE_IDLE_BMSK                                                       0x10
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_CMPLT_STATE_IDLE_SHFT                                                        0x4
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_IMM_STATE_IDLE_BMSK                                                          0x8
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_IMM_STATE_IDLE_SHFT                                                          0x3
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_PKT_STATE_IDLE_BMSK                                                          0x4
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_PKT_STATE_IDLE_SHFT                                                          0x2
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_ALLOC_STATE_IDLE_BMSK                                                        0x2
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_ALLOC_STATE_IDLE_SHFT                                                        0x1
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_STATE_IDLE_BMSK                                                              0x1
#define HWIO_IPA_STATE_FETCHER_IPA_HPS_FTCH_STATE_IDLE_SHFT                                                              0x0

#define HWIO_IPA_STATE_FETCHER_MASK_0_ADDR                                                                        (IPA_CFG_REG_BASE      + 0x000000a8)
#define HWIO_IPA_STATE_FETCHER_MASK_0_PHYS                                                                        (IPA_CFG_REG_BASE_PHYS + 0x000000a8)
#define HWIO_IPA_STATE_FETCHER_MASK_0_OFFS                                                                        (IPA_CFG_REG_BASE_OFFS + 0x000000a8)
#define HWIO_IPA_STATE_FETCHER_MASK_0_RMSK                                                                        0xffffffff
#define HWIO_IPA_STATE_FETCHER_MASK_0_ATTR                                                                               0x1
#define HWIO_IPA_STATE_FETCHER_MASK_0_IN          \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_MASK_0_ADDR, HWIO_IPA_STATE_FETCHER_MASK_0_RMSK)
#define HWIO_IPA_STATE_FETCHER_MASK_0_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_MASK_0_ADDR, m)
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_NO_RESOURCES_HPS_DMAR_BMSK                                       0xff000000
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_NO_RESOURCES_HPS_DMAR_SHFT                                             0x18
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_NO_RESOURCES_CONTEXT_BMSK                                          0xff0000
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_NO_RESOURCES_CONTEXT_SHFT                                              0x10
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_IMM_EXEC_BMSK                                                        0xff00
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_IMM_EXEC_SHFT                                                           0x8
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_DMAR_USES_QUEUE_BMSK                                                   0xff
#define HWIO_IPA_STATE_FETCHER_MASK_0_MASK_QUEUE_DMAR_USES_QUEUE_SHFT                                                    0x0

#define HWIO_IPA_STATE_DFETCHER_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x000000ac)
#define HWIO_IPA_STATE_DFETCHER_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x000000ac)
#define HWIO_IPA_STATE_DFETCHER_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x000000ac)
#define HWIO_IPA_STATE_DFETCHER_RMSK                                                                                0x7f07f3
#define HWIO_IPA_STATE_DFETCHER_ATTR                                                                                     0x1
#define HWIO_IPA_STATE_DFETCHER_IN          \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_ADDR, HWIO_IPA_STATE_DFETCHER_RMSK)
#define HWIO_IPA_STATE_DFETCHER_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_ADDR, m)
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_DMAR_SLOT_STATE_IDLE_BMSK                                                   0x7f0000
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_DMAR_SLOT_STATE_IDLE_SHFT                                                       0x10
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_DMAR_STATE_IDLE_BMSK                                                           0x7f0
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_DMAR_STATE_IDLE_SHFT                                                             0x4
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_FTCH_CMPLT_STATE_IDLE_BMSK                                                       0x2
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_FTCH_CMPLT_STATE_IDLE_SHFT                                                       0x1
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_FTCH_PKT_STATE_IDLE_BMSK                                                         0x1
#define HWIO_IPA_STATE_DFETCHER_IPA_DPS_FTCH_PKT_STATE_IDLE_SHFT                                                         0x0

#define HWIO_IPA_STATE_ACL_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x000000b0)
#define HWIO_IPA_STATE_ACL_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000000b0)
#define HWIO_IPA_STATE_ACL_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000000b0)
#define HWIO_IPA_STATE_ACL_RMSK                                                                                   0x3ffcffff
#define HWIO_IPA_STATE_ACL_ATTR                                                                                          0x1
#define HWIO_IPA_STATE_ACL_IN          \
        in_dword_masked(HWIO_IPA_STATE_ACL_ADDR, HWIO_IPA_STATE_ACL_RMSK)
#define HWIO_IPA_STATE_ACL_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_ACL_ADDR, m)
#define HWIO_IPA_STATE_ACL_IPA_HPS_MULTI_DRBIP_ACTIVE_BMSK                                                        0x20000000
#define HWIO_IPA_STATE_ACL_IPA_HPS_MULTI_DRBIP_ACTIVE_SHFT                                                              0x1d
#define HWIO_IPA_STATE_ACL_IPA_HPS_MULTI_DRBIP_EMPTY_BMSK                                                         0x10000000
#define HWIO_IPA_STATE_ACL_IPA_HPS_MULTI_DRBIP_EMPTY_SHFT                                                               0x1c
#define HWIO_IPA_STATE_ACL_IPA_HPS_COAL_MASTER_ACTIVE_BMSK                                                         0x8000000
#define HWIO_IPA_STATE_ACL_IPA_HPS_COAL_MASTER_ACTIVE_SHFT                                                              0x1b
#define HWIO_IPA_STATE_ACL_IPA_HPS_COAL_MASTER_EMPTY_BMSK                                                          0x4000000
#define HWIO_IPA_STATE_ACL_IPA_HPS_COAL_MASTER_EMPTY_SHFT                                                               0x1a
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2ND_ACTIVE_BMSK                                                          0x2000000
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2ND_ACTIVE_SHFT                                                               0x19
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2ND_EMPTY_BMSK                                                           0x1000000
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2ND_EMPTY_SHFT                                                                0x18
#define HWIO_IPA_STATE_ACL_IPA_DPS_SEQUENCER_IDLE_BMSK                                                              0x800000
#define HWIO_IPA_STATE_ACL_IPA_DPS_SEQUENCER_IDLE_SHFT                                                                  0x17
#define HWIO_IPA_STATE_ACL_IPA_HPS_SEQUENCER_IDLE_BMSK                                                              0x400000
#define HWIO_IPA_STATE_ACL_IPA_HPS_SEQUENCER_IDLE_SHFT                                                                  0x16
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2_ACTIVE_BMSK                                                             0x200000
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2_ACTIVE_SHFT                                                                 0x15
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2_EMPTY_BMSK                                                              0x100000
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_2_EMPTY_SHFT                                                                  0x14
#define HWIO_IPA_STATE_ACL_IPA_DPS_DISPATCHER_ACTIVE_BMSK                                                            0x80000
#define HWIO_IPA_STATE_ACL_IPA_DPS_DISPATCHER_ACTIVE_SHFT                                                               0x13
#define HWIO_IPA_STATE_ACL_IPA_DPS_DISPATCHER_EMPTY_BMSK                                                             0x40000
#define HWIO_IPA_STATE_ACL_IPA_DPS_DISPATCHER_EMPTY_SHFT                                                                0x12
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_ACTIVE_BMSK                                                                 0x8000
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_ACTIVE_SHFT                                                                    0xf
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_EMPTY_BMSK                                                                  0x4000
#define HWIO_IPA_STATE_ACL_IPA_DPS_D_DCPH_EMPTY_SHFT                                                                     0xe
#define HWIO_IPA_STATE_ACL_IPA_HPS_ENQUEUER_ACTIVE_BMSK                                                               0x2000
#define HWIO_IPA_STATE_ACL_IPA_HPS_ENQUEUER_ACTIVE_SHFT                                                                  0xd
#define HWIO_IPA_STATE_ACL_IPA_HPS_ENQUEUER_EMPTY_BMSK                                                                0x1000
#define HWIO_IPA_STATE_ACL_IPA_HPS_ENQUEUER_EMPTY_SHFT                                                                   0xc
#define HWIO_IPA_STATE_ACL_IPA_HPS_UCP_ACTIVE_BMSK                                                                     0x800
#define HWIO_IPA_STATE_ACL_IPA_HPS_UCP_ACTIVE_SHFT                                                                       0xb
#define HWIO_IPA_STATE_ACL_IPA_HPS_UCP_EMPTY_BMSK                                                                      0x400
#define HWIO_IPA_STATE_ACL_IPA_HPS_UCP_EMPTY_SHFT                                                                        0xa
#define HWIO_IPA_STATE_ACL_IPA_HPS_HDRI_ACTIVE_BMSK                                                                    0x200
#define HWIO_IPA_STATE_ACL_IPA_HPS_HDRI_ACTIVE_SHFT                                                                      0x9
#define HWIO_IPA_STATE_ACL_IPA_HPS_HDRI_EMPTY_BMSK                                                                     0x100
#define HWIO_IPA_STATE_ACL_IPA_HPS_HDRI_EMPTY_SHFT                                                                       0x8
#define HWIO_IPA_STATE_ACL_IPA_HPS_ROUTER_ACTIVE_BMSK                                                                   0x80
#define HWIO_IPA_STATE_ACL_IPA_HPS_ROUTER_ACTIVE_SHFT                                                                    0x7
#define HWIO_IPA_STATE_ACL_IPA_HPS_ROUTER_EMPTY_BMSK                                                                    0x40
#define HWIO_IPA_STATE_ACL_IPA_HPS_ROUTER_EMPTY_SHFT                                                                     0x6
#define HWIO_IPA_STATE_ACL_IPA_HPS_FILTER_NAT_ACTIVE_BMSK                                                               0x20
#define HWIO_IPA_STATE_ACL_IPA_HPS_FILTER_NAT_ACTIVE_SHFT                                                                0x5
#define HWIO_IPA_STATE_ACL_IPA_HPS_FILTER_NAT_EMPTY_BMSK                                                                0x10
#define HWIO_IPA_STATE_ACL_IPA_HPS_FILTER_NAT_EMPTY_SHFT                                                                 0x4
#define HWIO_IPA_STATE_ACL_IPA_HPS_PKT_PARSER_ACTIVE_BMSK                                                                0x8
#define HWIO_IPA_STATE_ACL_IPA_HPS_PKT_PARSER_ACTIVE_SHFT                                                                0x3
#define HWIO_IPA_STATE_ACL_IPA_HPS_PKT_PARSER_EMPTY_BMSK                                                                 0x4
#define HWIO_IPA_STATE_ACL_IPA_HPS_PKT_PARSER_EMPTY_SHFT                                                                 0x2
#define HWIO_IPA_STATE_ACL_IPA_HPS_H_DCPH_ACTIVE_BMSK                                                                    0x2
#define HWIO_IPA_STATE_ACL_IPA_HPS_H_DCPH_ACTIVE_SHFT                                                                    0x1
#define HWIO_IPA_STATE_ACL_IPA_HPS_H_DCPH_EMPTY_BMSK                                                                     0x1
#define HWIO_IPA_STATE_ACL_IPA_HPS_H_DCPH_EMPTY_SHFT                                                                     0x0

#define HWIO_IPA_STATE_ADDR                                                                                       (IPA_CFG_REG_BASE      + 0x000000b4)
#define HWIO_IPA_STATE_PHYS                                                                                       (IPA_CFG_REG_BASE_PHYS + 0x000000b4)
#define HWIO_IPA_STATE_OFFS                                                                                       (IPA_CFG_REG_BASE_OFFS + 0x000000b4)
#define HWIO_IPA_STATE_RMSK                                                                                       0xffffffff
#define HWIO_IPA_STATE_ATTR                                                                                              0x1
#define HWIO_IPA_STATE_IN          \
        in_dword_masked(HWIO_IPA_STATE_ADDR, HWIO_IPA_STATE_RMSK)
#define HWIO_IPA_STATE_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_ADDR, m)
#define HWIO_IPA_STATE_IPA_UC_RX_HND_CMDQ_EMPTY_BMSK                                                              0x80000000
#define HWIO_IPA_STATE_IPA_UC_RX_HND_CMDQ_EMPTY_SHFT                                                                    0x1f
#define HWIO_IPA_STATE_IPA_DPS_TX_EMPTY_BMSK                                                                      0x40000000
#define HWIO_IPA_STATE_IPA_DPS_TX_EMPTY_SHFT                                                                            0x1e
#define HWIO_IPA_STATE_IPA_HPS_DPS_EMPTY_BMSK                                                                     0x20000000
#define HWIO_IPA_STATE_IPA_HPS_DPS_EMPTY_SHFT                                                                           0x1d
#define HWIO_IPA_STATE_IPA_RX_HPS_EMPTY_BMSK                                                                      0x10000000
#define HWIO_IPA_STATE_IPA_RX_HPS_EMPTY_SHFT                                                                            0x1c
#define HWIO_IPA_STATE_IPA_RX_SPLT_CMDQ_EMPTY_BMSK                                                                 0xf800000
#define HWIO_IPA_STATE_IPA_RX_SPLT_CMDQ_EMPTY_SHFT                                                                      0x17
#define HWIO_IPA_STATE_IPA_TX_COMMANDER_CMDQ_EMPTY_BMSK                                                             0x400000
#define HWIO_IPA_STATE_IPA_TX_COMMANDER_CMDQ_EMPTY_SHFT                                                                 0x16
#define HWIO_IPA_STATE_IPA_RX_ACKQ_EMPTY_BMSK                                                                       0x200000
#define HWIO_IPA_STATE_IPA_RX_ACKQ_EMPTY_SHFT                                                                           0x15
#define HWIO_IPA_STATE_IPA_UC_ACKQ_EMPTY_BMSK                                                                       0x100000
#define HWIO_IPA_STATE_IPA_UC_ACKQ_EMPTY_SHFT                                                                           0x14
#define HWIO_IPA_STATE_IPA_TX_ACKQ_EMPTY_BMSK                                                                        0x80000
#define HWIO_IPA_STATE_IPA_TX_ACKQ_EMPTY_SHFT                                                                           0x13
#define HWIO_IPA_STATE_IPA_NTF_TX_EMPTY_BMSK                                                                         0x40000
#define HWIO_IPA_STATE_IPA_NTF_TX_EMPTY_SHFT                                                                            0x12
#define HWIO_IPA_STATE_IPA_FULL_IDLE_BMSK                                                                            0x20000
#define HWIO_IPA_STATE_IPA_FULL_IDLE_SHFT                                                                               0x11
#define HWIO_IPA_STATE_IPA_PROD_BRESP_IDLE_BMSK                                                                      0x10000
#define HWIO_IPA_STATE_IPA_PROD_BRESP_IDLE_SHFT                                                                         0x10
#define HWIO_IPA_STATE_IPA_PROD_ACKMNGR_STATE_IDLE_BMSK                                                               0x8000
#define HWIO_IPA_STATE_IPA_PROD_ACKMNGR_STATE_IDLE_SHFT                                                                  0xf
#define HWIO_IPA_STATE_IPA_PROD_ACKMNGR_DB_EMPTY_BMSK                                                                 0x4000
#define HWIO_IPA_STATE_IPA_PROD_ACKMNGR_DB_EMPTY_SHFT                                                                    0xe
#define HWIO_IPA_STATE_IPA_TX_ACKQ_FULL_BMSK                                                                          0x2000
#define HWIO_IPA_STATE_IPA_TX_ACKQ_FULL_SHFT                                                                             0xd
#define HWIO_IPA_STATE_IPA_ACKMNGR_STATE_IDLE_BMSK                                                                    0x1000
#define HWIO_IPA_STATE_IPA_ACKMNGR_STATE_IDLE_SHFT                                                                       0xc
#define HWIO_IPA_STATE_IPA_ACKMNGR_DB_EMPTY_BMSK                                                                       0x800
#define HWIO_IPA_STATE_IPA_ACKMNGR_DB_EMPTY_SHFT                                                                         0xb
#define HWIO_IPA_STATE_IPA_RSRC_STATE_IDLE_BMSK                                                                        0x400
#define HWIO_IPA_STATE_IPA_RSRC_STATE_IDLE_SHFT                                                                          0xa
#define HWIO_IPA_STATE_IPA_RSRC_MNGR_DB_EMPTY_BMSK                                                                     0x200
#define HWIO_IPA_STATE_IPA_RSRC_MNGR_DB_EMPTY_SHFT                                                                       0x9
#define HWIO_IPA_STATE_MBIM_AGGR_IDLE_BMSK                                                                             0x100
#define HWIO_IPA_STATE_MBIM_AGGR_IDLE_SHFT                                                                               0x8
#define HWIO_IPA_STATE_AGGR_IDLE_BMSK                                                                                   0x80
#define HWIO_IPA_STATE_AGGR_IDLE_SHFT                                                                                    0x7
#define HWIO_IPA_STATE_IPA_NOC_IDLE_BMSK                                                                                0x40
#define HWIO_IPA_STATE_IPA_NOC_IDLE_SHFT                                                                                 0x6
#define HWIO_IPA_STATE_IPA_STATUS_SNIFFER_IDLE_BMSK                                                                     0x20
#define HWIO_IPA_STATE_IPA_STATUS_SNIFFER_IDLE_SHFT                                                                      0x5
#define HWIO_IPA_STATE_BAM_GSI_IDLE_BMSK                                                                                0x10
#define HWIO_IPA_STATE_BAM_GSI_IDLE_SHFT                                                                                 0x4
#define HWIO_IPA_STATE_DPL_FIFO_IDLE_BMSK                                                                                0x8
#define HWIO_IPA_STATE_DPL_FIFO_IDLE_SHFT                                                                                0x3
#define HWIO_IPA_STATE_TX_IDLE_BMSK                                                                                      0x4
#define HWIO_IPA_STATE_TX_IDLE_SHFT                                                                                      0x2
#define HWIO_IPA_STATE_RX_IDLE_BMSK                                                                                      0x2
#define HWIO_IPA_STATE_RX_IDLE_SHFT                                                                                      0x1
#define HWIO_IPA_STATE_RX_WAIT_BMSK                                                                                      0x1
#define HWIO_IPA_STATE_RX_WAIT_SHFT                                                                                      0x0

#define HWIO_IPA_STATE_GSI_AOS_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x000000b8)
#define HWIO_IPA_STATE_GSI_AOS_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x000000b8)
#define HWIO_IPA_STATE_GSI_AOS_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x000000b8)
#define HWIO_IPA_STATE_GSI_AOS_RMSK                                                                                      0x3
#define HWIO_IPA_STATE_GSI_AOS_ATTR                                                                                      0x1
#define HWIO_IPA_STATE_GSI_AOS_IN          \
        in_dword_masked(HWIO_IPA_STATE_GSI_AOS_ADDR, HWIO_IPA_STATE_GSI_AOS_RMSK)
#define HWIO_IPA_STATE_GSI_AOS_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_GSI_AOS_ADDR, m)
#define HWIO_IPA_STATE_GSI_AOS_IPA_GSI_AOS_NLO_FSM_IDLE_BMSK                                                             0x2
#define HWIO_IPA_STATE_GSI_AOS_IPA_GSI_AOS_NLO_FSM_IDLE_SHFT                                                             0x1
#define HWIO_IPA_STATE_GSI_AOS_IPA_GSI_AOS_FSM_IDLE_BMSK                                                                 0x1
#define HWIO_IPA_STATE_GSI_AOS_IPA_GSI_AOS_FSM_IDLE_SHFT                                                                 0x0

#define HWIO_IPA_STATE_GSI_IF_ADDR                                                                                (IPA_CFG_REG_BASE      + 0x000000c0)
#define HWIO_IPA_STATE_GSI_IF_PHYS                                                                                (IPA_CFG_REG_BASE_PHYS + 0x000000c0)
#define HWIO_IPA_STATE_GSI_IF_OFFS                                                                                (IPA_CFG_REG_BASE_OFFS + 0x000000c0)
#define HWIO_IPA_STATE_GSI_IF_RMSK                                                                                   0x301ff
#define HWIO_IPA_STATE_GSI_IF_ATTR                                                                                       0x1
#define HWIO_IPA_STATE_GSI_IF_IN          \
        in_dword_masked(HWIO_IPA_STATE_GSI_IF_ADDR, HWIO_IPA_STATE_GSI_IF_RMSK)
#define HWIO_IPA_STATE_GSI_IF_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_GSI_IF_ADDR, m)
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_SKIP_FSM_BMSK                                                                  0x30000
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_SKIP_FSM_SHFT                                                                     0x10
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_TOGGLE_FSM_IDLE_BMSK                                                             0x100
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_TOGGLE_FSM_IDLE_SHFT                                                               0x8
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_PROD_FSM_TX_1_BMSK                                                                0xf0
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_PROD_FSM_TX_1_SHFT                                                                 0x4
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_PROD_FSM_TX_0_BMSK                                                                 0xf
#define HWIO_IPA_STATE_GSI_IF_IPA_GSI_PROD_FSM_TX_0_SHFT                                                                 0x0

#define HWIO_IPA_STATE_GSI_IF_CONS_ADDR                                                                           (IPA_CFG_REG_BASE      + 0x000000c8)
#define HWIO_IPA_STATE_GSI_IF_CONS_PHYS                                                                           (IPA_CFG_REG_BASE_PHYS + 0x000000c8)
#define HWIO_IPA_STATE_GSI_IF_CONS_OFFS                                                                           (IPA_CFG_REG_BASE_OFFS + 0x000000c8)
#define HWIO_IPA_STATE_GSI_IF_CONS_RMSK                                                                                 0xff
#define HWIO_IPA_STATE_GSI_IF_CONS_ATTR                                                                                  0x1
#define HWIO_IPA_STATE_GSI_IF_CONS_IN          \
        in_dword_masked(HWIO_IPA_STATE_GSI_IF_CONS_ADDR, HWIO_IPA_STATE_GSI_IF_CONS_RMSK)
#define HWIO_IPA_STATE_GSI_IF_CONS_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_GSI_IF_CONS_ADDR, m)
#define HWIO_IPA_STATE_GSI_IF_CONS_IPA_STATE_GSI_IF_CONS_CACHE_VLD_BMSK                                                 0xfe
#define HWIO_IPA_STATE_GSI_IF_CONS_IPA_STATE_GSI_IF_CONS_CACHE_VLD_SHFT                                                  0x1
#define HWIO_IPA_STATE_GSI_IF_CONS_IPA_STATE_GSI_IF_CONS_STATE_IDLE_BMSK                                                 0x1
#define HWIO_IPA_STATE_GSI_IF_CONS_IPA_STATE_GSI_IF_CONS_STATE_IDLE_SHFT                                                 0x0

#define HWIO_IPA_STATE_FETCHER_MASK_1_ADDR                                                                        (IPA_CFG_REG_BASE      + 0x000000cc)
#define HWIO_IPA_STATE_FETCHER_MASK_1_PHYS                                                                        (IPA_CFG_REG_BASE_PHYS + 0x000000cc)
#define HWIO_IPA_STATE_FETCHER_MASK_1_OFFS                                                                        (IPA_CFG_REG_BASE_OFFS + 0x000000cc)
#define HWIO_IPA_STATE_FETCHER_MASK_1_RMSK                                                                        0xffffffff
#define HWIO_IPA_STATE_FETCHER_MASK_1_ATTR                                                                               0x1
#define HWIO_IPA_STATE_FETCHER_MASK_1_IN          \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_MASK_1_ADDR, HWIO_IPA_STATE_FETCHER_MASK_1_RMSK)
#define HWIO_IPA_STATE_FETCHER_MASK_1_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_MASK_1_ADDR, m)
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_NO_SPACE_DPL_FIFO_BMSK                                           0xff000000
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_NO_SPACE_DPL_FIFO_SHFT                                                 0x18
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_STEP_MODE_BMSK                                                     0xff0000
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_STEP_MODE_SHFT                                                         0x10
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_ARB_LOCK_BMSK                                                        0xff00
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_ARB_LOCK_SHFT                                                           0x8
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_NO_RESOURCES_ACK_ENTRY_BMSK                                            0xff
#define HWIO_IPA_STATE_FETCHER_MASK_1_MASK_QUEUE_NO_RESOURCES_ACK_ENTRY_SHFT                                             0x0

#define HWIO_IPA_STATE_FETCHER_MASK_2_ADDR                                                                        (IPA_CFG_REG_BASE      + 0x000000d0)
#define HWIO_IPA_STATE_FETCHER_MASK_2_PHYS                                                                        (IPA_CFG_REG_BASE_PHYS + 0x000000d0)
#define HWIO_IPA_STATE_FETCHER_MASK_2_OFFS                                                                        (IPA_CFG_REG_BASE_OFFS + 0x000000d0)
#define HWIO_IPA_STATE_FETCHER_MASK_2_RMSK                                                                            0xffff
#define HWIO_IPA_STATE_FETCHER_MASK_2_ATTR                                                                               0x1
#define HWIO_IPA_STATE_FETCHER_MASK_2_IN          \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_MASK_2_ADDR, HWIO_IPA_STATE_FETCHER_MASK_2_RMSK)
#define HWIO_IPA_STATE_FETCHER_MASK_2_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_FETCHER_MASK_2_ADDR, m)
#define HWIO_IPA_STATE_FETCHER_MASK_2_MASK_QUEUE_DRBIP_PKT_EXCEED_MAX_SIZE_BMSK                                       0xff00
#define HWIO_IPA_STATE_FETCHER_MASK_2_MASK_QUEUE_DRBIP_PKT_EXCEED_MAX_SIZE_SHFT                                          0x8
#define HWIO_IPA_STATE_FETCHER_MASK_2_MASK_QUEUE_DRBIP_NO_DATA_SECTORS_BMSK                                             0xff
#define HWIO_IPA_STATE_FETCHER_MASK_2_MASK_QUEUE_DRBIP_NO_DATA_SECTORS_SHFT                                              0x0

#define HWIO_IPA_STATE_DPL_FIFO_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x000000d4)
#define HWIO_IPA_STATE_DPL_FIFO_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x000000d4)
#define HWIO_IPA_STATE_DPL_FIFO_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x000000d4)
#define HWIO_IPA_STATE_DPL_FIFO_RMSK                                                                                     0x7
#define HWIO_IPA_STATE_DPL_FIFO_ATTR                                                                                     0x1
#define HWIO_IPA_STATE_DPL_FIFO_IN          \
        in_dword_masked(HWIO_IPA_STATE_DPL_FIFO_ADDR, HWIO_IPA_STATE_DPL_FIFO_RMSK)
#define HWIO_IPA_STATE_DPL_FIFO_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_DPL_FIFO_ADDR, m)
#define HWIO_IPA_STATE_DPL_FIFO_POP_FSM_STATE_BMSK                                                                       0x7
#define HWIO_IPA_STATE_DPL_FIFO_POP_FSM_STATE_SHFT                                                                       0x0

#define HWIO_IPA_STATE_COAL_MASTER_ADDR                                                                           (IPA_CFG_REG_BASE      + 0x000000d8)
#define HWIO_IPA_STATE_COAL_MASTER_PHYS                                                                           (IPA_CFG_REG_BASE_PHYS + 0x000000d8)
#define HWIO_IPA_STATE_COAL_MASTER_OFFS                                                                           (IPA_CFG_REG_BASE_OFFS + 0x000000d8)
#define HWIO_IPA_STATE_COAL_MASTER_RMSK                                                                           0xffffffff
#define HWIO_IPA_STATE_COAL_MASTER_ATTR                                                                                  0x1
#define HWIO_IPA_STATE_COAL_MASTER_IN          \
        in_dword_masked(HWIO_IPA_STATE_COAL_MASTER_ADDR, HWIO_IPA_STATE_COAL_MASTER_RMSK)
#define HWIO_IPA_STATE_COAL_MASTER_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_COAL_MASTER_ADDR, m)
#define HWIO_IPA_STATE_COAL_MASTER_VP_TIMER_EXPIRED_BMSK                                                          0xf0000000
#define HWIO_IPA_STATE_COAL_MASTER_VP_TIMER_EXPIRED_SHFT                                                                0x1c
#define HWIO_IPA_STATE_COAL_MASTER_LRU_VP_BMSK                                                                     0xf000000
#define HWIO_IPA_STATE_COAL_MASTER_LRU_VP_SHFT                                                                          0x18
#define HWIO_IPA_STATE_COAL_MASTER_INIT_VP_FSM_STATE_BMSK                                                           0xf00000
#define HWIO_IPA_STATE_COAL_MASTER_INIT_VP_FSM_STATE_SHFT                                                               0x14
#define HWIO_IPA_STATE_COAL_MASTER_CHECK_FIT_FSM_STATE_BMSK                                                          0xf0000
#define HWIO_IPA_STATE_COAL_MASTER_CHECK_FIT_FSM_STATE_SHFT                                                             0x10
#define HWIO_IPA_STATE_COAL_MASTER_HASH_CALC_FSM_STATE_BMSK                                                           0xf000
#define HWIO_IPA_STATE_COAL_MASTER_HASH_CALC_FSM_STATE_SHFT                                                              0xc
#define HWIO_IPA_STATE_COAL_MASTER_FIND_OPEN_FSM_STATE_BMSK                                                            0xf00
#define HWIO_IPA_STATE_COAL_MASTER_FIND_OPEN_FSM_STATE_SHFT                                                              0x8
#define HWIO_IPA_STATE_COAL_MASTER_MAIN_FSM_STATE_BMSK                                                                  0xf0
#define HWIO_IPA_STATE_COAL_MASTER_MAIN_FSM_STATE_SHFT                                                                   0x4
#define HWIO_IPA_STATE_COAL_MASTER_VP_VLD_BMSK                                                                           0xf
#define HWIO_IPA_STATE_COAL_MASTER_VP_VLD_SHFT                                                                           0x0

#define HWIO_IPA_STATE_COAL_MASTER_1_ADDR                                                                         (IPA_CFG_REG_BASE      + 0x000000dc)
#define HWIO_IPA_STATE_COAL_MASTER_1_PHYS                                                                         (IPA_CFG_REG_BASE_PHYS + 0x000000dc)
#define HWIO_IPA_STATE_COAL_MASTER_1_OFFS                                                                         (IPA_CFG_REG_BASE_OFFS + 0x000000dc)
#define HWIO_IPA_STATE_COAL_MASTER_1_RMSK                                                                         0x3fffffff
#define HWIO_IPA_STATE_COAL_MASTER_1_ATTR                                                                                0x1
#define HWIO_IPA_STATE_COAL_MASTER_1_IN          \
        in_dword_masked(HWIO_IPA_STATE_COAL_MASTER_1_ADDR, HWIO_IPA_STATE_COAL_MASTER_1_RMSK)
#define HWIO_IPA_STATE_COAL_MASTER_1_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_COAL_MASTER_1_ADDR, m)
#define HWIO_IPA_STATE_COAL_MASTER_1_ARBITER_STATE_BMSK                                                           0x3c000000
#define HWIO_IPA_STATE_COAL_MASTER_1_ARBITER_STATE_SHFT                                                                 0x1a
#define HWIO_IPA_STATE_COAL_MASTER_1_CHECK_FIT_FSM_STATE_BMSK                                                      0x3c00000
#define HWIO_IPA_STATE_COAL_MASTER_1_CHECK_FIT_FSM_STATE_SHFT                                                           0x16
#define HWIO_IPA_STATE_COAL_MASTER_1_CHECK_FIT_RD_CTX_LINE_BMSK                                                     0x3f0000
#define HWIO_IPA_STATE_COAL_MASTER_1_CHECK_FIT_RD_CTX_LINE_SHFT                                                         0x10
#define HWIO_IPA_STATE_COAL_MASTER_1_INIT_VP_FSM_STATE_BMSK                                                           0xf000
#define HWIO_IPA_STATE_COAL_MASTER_1_INIT_VP_FSM_STATE_SHFT                                                              0xc
#define HWIO_IPA_STATE_COAL_MASTER_1_INIT_VP_RD_PKT_LINE_BMSK                                                          0xfc0
#define HWIO_IPA_STATE_COAL_MASTER_1_INIT_VP_RD_PKT_LINE_SHFT                                                            0x6
#define HWIO_IPA_STATE_COAL_MASTER_1_INIT_VP_WR_CTX_LINE_BMSK                                                           0x3f
#define HWIO_IPA_STATE_COAL_MASTER_1_INIT_VP_WR_CTX_LINE_SHFT                                                            0x0

#define HWIO_IPA_STATE_NLO_AGGR_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x000000e0)
#define HWIO_IPA_STATE_NLO_AGGR_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x000000e0)
#define HWIO_IPA_STATE_NLO_AGGR_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x000000e0)
#define HWIO_IPA_STATE_NLO_AGGR_RMSK                                                                              0xffffffff
#define HWIO_IPA_STATE_NLO_AGGR_ATTR                                                                                     0x1
#define HWIO_IPA_STATE_NLO_AGGR_IN          \
        in_dword_masked(HWIO_IPA_STATE_NLO_AGGR_ADDR, HWIO_IPA_STATE_NLO_AGGR_RMSK)
#define HWIO_IPA_STATE_NLO_AGGR_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_NLO_AGGR_ADDR, m)
#define HWIO_IPA_STATE_NLO_AGGR_NLO_AGGR_STATE_BMSK                                                               0xffffffff
#define HWIO_IPA_STATE_NLO_AGGR_NLO_AGGR_STATE_SHFT                                                                      0x0

#define HWIO_IPA_STATE_CTXH_ADDR                                                                                  (IPA_CFG_REG_BASE      + 0x000000e4)
#define HWIO_IPA_STATE_CTXH_PHYS                                                                                  (IPA_CFG_REG_BASE_PHYS + 0x000000e4)
#define HWIO_IPA_STATE_CTXH_OFFS                                                                                  (IPA_CFG_REG_BASE_OFFS + 0x000000e4)
#define HWIO_IPA_STATE_CTXH_RMSK                                                                                         0x3
#define HWIO_IPA_STATE_CTXH_ATTR                                                                                         0x1
#define HWIO_IPA_STATE_CTXH_IN          \
        in_dword_masked(HWIO_IPA_STATE_CTXH_ADDR, HWIO_IPA_STATE_CTXH_RMSK)
#define HWIO_IPA_STATE_CTXH_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_CTXH_ADDR, m)
#define HWIO_IPA_STATE_CTXH_IPA_CTXH_WR_IDLE_BMSK                                                                        0x2
#define HWIO_IPA_STATE_CTXH_IPA_CTXH_WR_IDLE_SHFT                                                                        0x1
#define HWIO_IPA_STATE_CTXH_IPA_CTXH_RD_IDLE_BMSK                                                                        0x1
#define HWIO_IPA_STATE_CTXH_IPA_CTXH_RD_IDLE_SHFT                                                                        0x0

#define HWIO_IPA_STATE_UC_QMB_ADDR                                                                                (IPA_CFG_REG_BASE      + 0x000000e8)
#define HWIO_IPA_STATE_UC_QMB_PHYS                                                                                (IPA_CFG_REG_BASE_PHYS + 0x000000e8)
#define HWIO_IPA_STATE_UC_QMB_OFFS                                                                                (IPA_CFG_REG_BASE_OFFS + 0x000000e8)
#define HWIO_IPA_STATE_UC_QMB_RMSK                                                                                 0x1ff01ff
#define HWIO_IPA_STATE_UC_QMB_ATTR                                                                                       0x1
#define HWIO_IPA_STATE_UC_QMB_IN          \
        in_dword_masked(HWIO_IPA_STATE_UC_QMB_ADDR, HWIO_IPA_STATE_UC_QMB_RMSK)
#define HWIO_IPA_STATE_UC_QMB_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_UC_QMB_ADDR, m)
#define HWIO_IPA_STATE_UC_QMB_QUEUE_1_IDLE_BMSK                                                                    0x1000000
#define HWIO_IPA_STATE_UC_QMB_QUEUE_1_IDLE_SHFT                                                                         0x18
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_FULL_QUEUE_1_BMSK                                                            0x800000
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_FULL_QUEUE_1_SHFT                                                                0x17
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_EMPTY_QUEUE_1_BMSK                                                           0x400000
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_EMPTY_QUEUE_1_SHFT                                                               0x16
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_FULL_QUEUE_1_BMSK                                                           0x200000
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_FULL_QUEUE_1_SHFT                                                               0x15
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_EMPTY_QUEUE_1_BMSK                                                          0x100000
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_EMPTY_QUEUE_1_SHFT                                                              0x14
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_FULL_QUEUE_1_BMSK                                                             0x80000
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_FULL_QUEUE_1_SHFT                                                                0x13
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_EMPTY_QUEUE_1_BMSK                                                            0x40000
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_EMPTY_QUEUE_1_SHFT                                                               0x12
#define HWIO_IPA_STATE_UC_QMB_CTRL_FSM_STATE_QUEUE_1_BMSK                                                            0x30000
#define HWIO_IPA_STATE_UC_QMB_CTRL_FSM_STATE_QUEUE_1_SHFT                                                               0x10
#define HWIO_IPA_STATE_UC_QMB_QUEUE_0_IDLE_BMSK                                                                        0x100
#define HWIO_IPA_STATE_UC_QMB_QUEUE_0_IDLE_SHFT                                                                          0x8
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_FULL_QUEUE_0_BMSK                                                                0x80
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_FULL_QUEUE_0_SHFT                                                                 0x7
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_EMPTY_QUEUE_0_BMSK                                                               0x40
#define HWIO_IPA_STATE_UC_QMB_CMD_FIFO_EMPTY_QUEUE_0_SHFT                                                                0x6
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_FULL_QUEUE_0_BMSK                                                               0x20
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_FULL_QUEUE_0_SHFT                                                                0x5
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_EMPTY_QUEUE_0_BMSK                                                              0x10
#define HWIO_IPA_STATE_UC_QMB_COMP_FIFO_EMPTY_QUEUE_0_SHFT                                                               0x4
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_FULL_QUEUE_0_BMSK                                                                 0x8
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_FULL_QUEUE_0_SHFT                                                                 0x3
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_EMPTY_QUEUE_0_BMSK                                                                0x4
#define HWIO_IPA_STATE_UC_QMB_OT_TABLE_EMPTY_QUEUE_0_SHFT                                                                0x2
#define HWIO_IPA_STATE_UC_QMB_CTRL_FSM_STATE_QUEUE_0_BMSK                                                                0x3
#define HWIO_IPA_STATE_UC_QMB_CTRL_FSM_STATE_QUEUE_0_SHFT                                                                0x0

#define HWIO_IPA_STATE_DRBIP_ADDR                                                                                 (IPA_CFG_REG_BASE      + 0x000000ec)
#define HWIO_IPA_STATE_DRBIP_PHYS                                                                                 (IPA_CFG_REG_BASE_PHYS + 0x000000ec)
#define HWIO_IPA_STATE_DRBIP_OFFS                                                                                 (IPA_CFG_REG_BASE_OFFS + 0x000000ec)
#define HWIO_IPA_STATE_DRBIP_RMSK                                                                                    0xf0107
#define HWIO_IPA_STATE_DRBIP_ATTR                                                                                        0x1
#define HWIO_IPA_STATE_DRBIP_IN          \
        in_dword_masked(HWIO_IPA_STATE_DRBIP_ADDR, HWIO_IPA_STATE_DRBIP_RMSK)
#define HWIO_IPA_STATE_DRBIP_INM(m)      \
        in_dword_masked(HWIO_IPA_STATE_DRBIP_ADDR, m)
#define HWIO_IPA_STATE_DRBIP_DRBIP_PKT_IDLE_BMSK                                                                     0xf0000
#define HWIO_IPA_STATE_DRBIP_DRBIP_PKT_IDLE_SHFT                                                                        0x10
#define HWIO_IPA_STATE_DRBIP_DRBIP_DCPH_IDLE_BMSK                                                                      0x100
#define HWIO_IPA_STATE_DRBIP_DRBIP_DCPH_IDLE_SHFT                                                                        0x8
#define HWIO_IPA_STATE_DRBIP_DRBIP_DMAR_IDLE_BMSK                                                                        0x7
#define HWIO_IPA_STATE_DRBIP_DRBIP_DMAR_IDLE_SHFT                                                                        0x0

#define HWIO_IPA_STATE_AGGR_ACTIVE_n_ADDR(n)                                                                      (IPA_CFG_REG_BASE      + 0x00000100 + 0x4 * (n))
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_PHYS(n)                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000100 + 0x4 * (n))
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_OFFS(n)                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000100 + 0x4 * (n))
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_RMSK                                                                         0xffffffff
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_MAXn                                                                                  1
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_ATTR                                                                                0x1
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_AGGR_ACTIVE_n_ADDR(n), HWIO_IPA_STATE_AGGR_ACTIVE_n_RMSK)
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_AGGR_ACTIVE_n_ADDR(n), mask)
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_ENDPOINTS_BMSK                                                               0xffffffff
#define HWIO_IPA_STATE_AGGR_ACTIVE_n_ENDPOINTS_SHFT                                                                      0x0

#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_ADDR(n)                                                               (IPA_CFG_REG_BASE      + 0x00000120 + 0x4 * (n))
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_PHYS(n)                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000120 + 0x4 * (n))
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_OFFS(n)                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000120 + 0x4 * (n))
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_RMSK                                                                  0xffffffff
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_MAXn                                                                           1
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_ATTR                                                                         0x1
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_ADDR(n), HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_RMSK)
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_ADDR(n), mask)
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_PIPE_FIFO_EMPTY_BMSK                                                  0xffffffff
#define HWIO_IPA_STATE_GSI_TLV_FIFO_EMPTY_n_PIPE_FIFO_EMPTY_SHFT                                                         0x0

#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_ADDR(n)                                                               (IPA_CFG_REG_BASE      + 0x00000140 + 0x4 * (n))
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_PHYS(n)                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000140 + 0x4 * (n))
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_OFFS(n)                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000140 + 0x4 * (n))
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_RMSK                                                                  0xffffffff
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_MAXn                                                                           1
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_ATTR                                                                         0x1
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_ADDR(n), HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_RMSK)
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_ADDR(n), mask)
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_PIPE_FIFO_EMPTY_BMSK                                                  0xffffffff
#define HWIO_IPA_STATE_GSI_AOS_FIFO_EMPTY_n_PIPE_FIFO_EMPTY_SHFT                                                         0x0

#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_ADDR(n)                                                                 (IPA_CFG_REG_BASE      + 0x00000160 + 0x4 * (n))
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_PHYS(n)                                                                 (IPA_CFG_REG_BASE_PHYS + 0x00000160 + 0x4 * (n))
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_OFFS(n)                                                                 (IPA_CFG_REG_BASE_OFFS + 0x00000160 + 0x4 * (n))
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_RMSK                                                                    0xffffffff
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_MAXn                                                                             1
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_ATTR                                                                           0x1
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_DRBIP_DROP_STATE_n_ADDR(n), HWIO_IPA_STATE_DRBIP_DROP_STATE_n_RMSK)
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_DRBIP_DROP_STATE_n_ADDR(n), mask)
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_CONSUMER_PIPE_DROP_STATE_BMSK                                           0xffffffff
#define HWIO_IPA_STATE_DRBIP_DROP_STATE_n_CONSUMER_PIPE_DROP_STATE_SHFT                                                  0x0

#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_ADDR(n)                                                                  (IPA_CFG_REG_BASE      + 0x00000180 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_PHYS(n)                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000180 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_OFFS(n)                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000180 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_RMSK                                                                     0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_MAXn                                                                              1
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_ATTR                                                                            0x1
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_0_n_ADDR(n), HWIO_IPA_STATE_DFETCHER_MASK_0_n_RMSK)
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_0_n_ADDR(n), mask)
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_MASK_QUEUE_DST_GRP_DMAR_OUTSTANDING_BMSK                                 0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_0_n_MASK_QUEUE_DST_GRP_DMAR_OUTSTANDING_SHFT                                        0x0

#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_ADDR(n)                                                                  (IPA_CFG_REG_BASE      + 0x000001a0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_PHYS(n)                                                                  (IPA_CFG_REG_BASE_PHYS + 0x000001a0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_OFFS(n)                                                                  (IPA_CFG_REG_BASE_OFFS + 0x000001a0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_RMSK                                                                     0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_MAXn                                                                              1
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_ATTR                                                                            0x1
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_1_n_ADDR(n), HWIO_IPA_STATE_DFETCHER_MASK_1_n_RMSK)
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_1_n_ADDR(n), mask)
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_MASK_QUEUE_NO_RESOURCES_DATA_SECTORS_BMSK                                0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_1_n_MASK_QUEUE_NO_RESOURCES_DATA_SECTORS_SHFT                                       0x0

#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_ADDR(n)                                                                  (IPA_CFG_REG_BASE      + 0x000001c0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_PHYS(n)                                                                  (IPA_CFG_REG_BASE_PHYS + 0x000001c0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_OFFS(n)                                                                  (IPA_CFG_REG_BASE_OFFS + 0x000001c0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_RMSK                                                                     0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_MAXn                                                                              1
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_ATTR                                                                            0x1
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_2_n_ADDR(n), HWIO_IPA_STATE_DFETCHER_MASK_2_n_RMSK)
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_2_n_ADDR(n), mask)
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_MASK_QUEUE_NO_RESOURCES_DPS_DMAR_BMSK                                    0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_2_n_MASK_QUEUE_NO_RESOURCES_DPS_DMAR_SHFT                                           0x0

#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_ADDR(n)                                                                  (IPA_CFG_REG_BASE      + 0x000001e0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_PHYS(n)                                                                  (IPA_CFG_REG_BASE_PHYS + 0x000001e0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_OFFS(n)                                                                  (IPA_CFG_REG_BASE_OFFS + 0x000001e0 + 0x4 * (n))
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_RMSK                                                                     0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_MAXn                                                                              1
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_ATTR                                                                            0x1
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_3_n_ADDR(n), HWIO_IPA_STATE_DFETCHER_MASK_3_n_RMSK)
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STATE_DFETCHER_MASK_3_n_ADDR(n), mask)
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_MASK_QUEUE_NO_RESOURCES_SEG_CTX_BMSK                                     0xffffffff
#define HWIO_IPA_STATE_DFETCHER_MASK_3_n_MASK_QUEUE_NO_RESOURCES_SEG_CTX_SHFT                                            0x0

#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x00000200 + 0x4 * (n))
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000200 + 0x4 * (n))
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000200 + 0x4 * (n))
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_RMSK                                                                       0xffffffff
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_MAXn                                                                                1
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_ATTR                                                                              0x1
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_BAM_ACTIVATED_PORTS_n_ADDR(n), HWIO_IPA_BAM_ACTIVATED_PORTS_n_RMSK)
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_BAM_ACTIVATED_PORTS_n_ADDR(n), mask)
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_ENDPOINTS_BMSK                                                             0xffffffff
#define HWIO_IPA_BAM_ACTIVATED_PORTS_n_ENDPOINTS_SHFT                                                                    0x0

#define HWIO_IPA_YELLOW_MARKER_BELOW_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x00000220 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000220 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000220 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_RMSK                                                                       0xffffffff
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_MAXn                                                                                1
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_ATTR                                                                              0x1
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_INI(n)        \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_BELOW_n_ADDR(n), HWIO_IPA_YELLOW_MARKER_BELOW_n_RMSK)
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_BELOW_n_ADDR(n), mask)
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_ENDPOINTS_BMSK                                                             0xffffffff
#define HWIO_IPA_YELLOW_MARKER_BELOW_n_ENDPOINTS_SHFT                                                                    0x0

#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ADDR(n)                                                                 (IPA_CFG_REG_BASE      + 0x00000240 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_PHYS(n)                                                                 (IPA_CFG_REG_BASE_PHYS + 0x00000240 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_OFFS(n)                                                                 (IPA_CFG_REG_BASE_OFFS + 0x00000240 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_RMSK                                                                    0xffffffff
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_MAXn                                                                             1
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ATTR                                                                           0x3
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ADDR(n), HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_RMSK)
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ADDR(n), mask)
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ADDR(n),val)
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ADDR(n),mask,val,HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_INI(n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ENDPOINTS_BMSK                                                          0xffffffff
#define HWIO_IPA_YELLOW_MARKER_BELOW_EN_n_ENDPOINTS_SHFT                                                                 0x0

#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_ADDR(n)                                                                (IPA_CFG_REG_BASE      + 0x00000260 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_PHYS(n)                                                                (IPA_CFG_REG_BASE_PHYS + 0x00000260 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_OFFS(n)                                                                (IPA_CFG_REG_BASE_OFFS + 0x00000260 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_RMSK                                                                   0xffffffff
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_MAXn                                                                            1
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_ATTR                                                                          0x2
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_ADDR(n),val)
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_ENDPOINTS_BMSK                                                         0xffffffff
#define HWIO_IPA_YELLOW_MARKER_BELOW_CLR_n_ENDPOINTS_SHFT                                                                0x0

#define HWIO_IPA_RED_MARKER_BELOW_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x00000280 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000280 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000280 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_n_RMSK                                                                          0xffffffff
#define HWIO_IPA_RED_MARKER_BELOW_n_MAXn                                                                                   1
#define HWIO_IPA_RED_MARKER_BELOW_n_ATTR                                                                                 0x1
#define HWIO_IPA_RED_MARKER_BELOW_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RED_MARKER_BELOW_n_ADDR(n), HWIO_IPA_RED_MARKER_BELOW_n_RMSK)
#define HWIO_IPA_RED_MARKER_BELOW_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RED_MARKER_BELOW_n_ADDR(n), mask)
#define HWIO_IPA_RED_MARKER_BELOW_n_ENDPOINTS_BMSK                                                                0xffffffff
#define HWIO_IPA_RED_MARKER_BELOW_n_ENDPOINTS_SHFT                                                                       0x0

#define HWIO_IPA_RED_MARKER_BELOW_EN_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x000002a0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x000002a0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x000002a0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_RMSK                                                                       0xffffffff
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_MAXn                                                                                1
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_ATTR                                                                              0x3
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RED_MARKER_BELOW_EN_n_ADDR(n), HWIO_IPA_RED_MARKER_BELOW_EN_n_RMSK)
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RED_MARKER_BELOW_EN_n_ADDR(n), mask)
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RED_MARKER_BELOW_EN_n_ADDR(n),val)
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RED_MARKER_BELOW_EN_n_ADDR(n),mask,val,HWIO_IPA_RED_MARKER_BELOW_EN_n_INI(n))
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_ENDPOINTS_BMSK                                                             0xffffffff
#define HWIO_IPA_RED_MARKER_BELOW_EN_n_ENDPOINTS_SHFT                                                                    0x0

#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_ADDR(n)                                                                   (IPA_CFG_REG_BASE      + 0x000002c0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_PHYS(n)                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000002c0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_OFFS(n)                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000002c0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_RMSK                                                                      0xffffffff
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_MAXn                                                                               1
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_ATTR                                                                             0x2
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RED_MARKER_BELOW_CLR_n_ADDR(n),val)
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_ENDPOINTS_BMSK                                                            0xffffffff
#define HWIO_IPA_RED_MARKER_BELOW_CLR_n_ENDPOINTS_SHFT                                                                   0x0

#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_ADDR(n)                                                                   (IPA_CFG_REG_BASE      + 0x000002e0 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_PHYS(n)                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000002e0 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_OFFS(n)                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000002e0 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_RMSK                                                                      0xffffffff
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_MAXn                                                                               1
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_ATTR                                                                             0x1
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_INI(n)        \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_SHADOW_n_ADDR(n), HWIO_IPA_YELLOW_MARKER_SHADOW_n_RMSK)
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_SHADOW_n_ADDR(n), mask)
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_ENDPOINTS_BMSK                                                            0xffffffff
#define HWIO_IPA_YELLOW_MARKER_SHADOW_n_ENDPOINTS_SHFT                                                                   0x0

#define HWIO_IPA_RED_MARKER_SHADOW_n_ADDR(n)                                                                      (IPA_CFG_REG_BASE      + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_SHADOW_n_PHYS(n)                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_SHADOW_n_OFFS(n)                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_SHADOW_n_RMSK                                                                         0xffffffff
#define HWIO_IPA_RED_MARKER_SHADOW_n_MAXn                                                                                  1
#define HWIO_IPA_RED_MARKER_SHADOW_n_ATTR                                                                                0x1
#define HWIO_IPA_RED_MARKER_SHADOW_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RED_MARKER_SHADOW_n_ADDR(n), HWIO_IPA_RED_MARKER_SHADOW_n_RMSK)
#define HWIO_IPA_RED_MARKER_SHADOW_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RED_MARKER_SHADOW_n_ADDR(n), mask)
#define HWIO_IPA_RED_MARKER_SHADOW_n_ENDPOINTS_BMSK                                                               0xffffffff
#define HWIO_IPA_RED_MARKER_SHADOW_n_ENDPOINTS_SHFT                                                                      0x0

#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x00000320 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000320 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000320 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_RMSK                                                                       0xffffffff
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_MAXn                                                                                1
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_ATTR                                                                              0x1
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_ABOVE_n_ADDR(n), HWIO_IPA_YELLOW_MARKER_ABOVE_n_RMSK)
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_ABOVE_n_ADDR(n), mask)
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_ENDPOINTS_BMSK                                                             0xffffffff
#define HWIO_IPA_YELLOW_MARKER_ABOVE_n_ENDPOINTS_SHFT                                                                    0x0

#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ADDR(n)                                                                 (IPA_CFG_REG_BASE      + 0x00000340 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_PHYS(n)                                                                 (IPA_CFG_REG_BASE_PHYS + 0x00000340 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_OFFS(n)                                                                 (IPA_CFG_REG_BASE_OFFS + 0x00000340 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_RMSK                                                                    0xffffffff
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_MAXn                                                                             1
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ATTR                                                                           0x3
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ADDR(n), HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_RMSK)
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ADDR(n), mask)
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ADDR(n),val)
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ADDR(n),mask,val,HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_INI(n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ENDPOINTS_BMSK                                                          0xffffffff
#define HWIO_IPA_YELLOW_MARKER_ABOVE_EN_n_ENDPOINTS_SHFT                                                                 0x0

#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_ADDR(n)                                                                (IPA_CFG_REG_BASE      + 0x00000360 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_PHYS(n)                                                                (IPA_CFG_REG_BASE_PHYS + 0x00000360 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_OFFS(n)                                                                (IPA_CFG_REG_BASE_OFFS + 0x00000360 + 0x4 * (n))
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_RMSK                                                                   0xffffffff
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_MAXn                                                                            1
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_ATTR                                                                          0x2
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_ADDR(n),val)
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_ENDPOINTS_BMSK                                                         0xffffffff
#define HWIO_IPA_YELLOW_MARKER_ABOVE_CLR_n_ENDPOINTS_SHFT                                                                0x0

#define HWIO_IPA_RED_MARKER_ABOVE_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x00000380 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000380 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000380 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_n_RMSK                                                                          0xffffffff
#define HWIO_IPA_RED_MARKER_ABOVE_n_MAXn                                                                                   1
#define HWIO_IPA_RED_MARKER_ABOVE_n_ATTR                                                                                 0x1
#define HWIO_IPA_RED_MARKER_ABOVE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RED_MARKER_ABOVE_n_ADDR(n), HWIO_IPA_RED_MARKER_ABOVE_n_RMSK)
#define HWIO_IPA_RED_MARKER_ABOVE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RED_MARKER_ABOVE_n_ADDR(n), mask)
#define HWIO_IPA_RED_MARKER_ABOVE_n_ENDPOINTS_BMSK                                                                0xffffffff
#define HWIO_IPA_RED_MARKER_ABOVE_n_ENDPOINTS_SHFT                                                                       0x0

#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x000003a0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x000003a0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x000003a0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_RMSK                                                                       0xffffffff
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_MAXn                                                                                1
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_ATTR                                                                              0x3
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_RED_MARKER_ABOVE_EN_n_ADDR(n), HWIO_IPA_RED_MARKER_ABOVE_EN_n_RMSK)
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_RED_MARKER_ABOVE_EN_n_ADDR(n), mask)
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RED_MARKER_ABOVE_EN_n_ADDR(n),val)
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_RED_MARKER_ABOVE_EN_n_ADDR(n),mask,val,HWIO_IPA_RED_MARKER_ABOVE_EN_n_INI(n))
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_ENDPOINTS_BMSK                                                             0xffffffff
#define HWIO_IPA_RED_MARKER_ABOVE_EN_n_ENDPOINTS_SHFT                                                                    0x0

#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_ADDR(n)                                                                   (IPA_CFG_REG_BASE      + 0x000003c0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_PHYS(n)                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000003c0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_OFFS(n)                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000003c0 + 0x4 * (n))
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_RMSK                                                                      0xffffffff
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_MAXn                                                                               1
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_ATTR                                                                             0x2
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_RED_MARKER_ABOVE_CLR_n_ADDR(n),val)
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_ENDPOINTS_BMSK                                                            0xffffffff
#define HWIO_IPA_RED_MARKER_ABOVE_CLR_n_ENDPOINTS_SHFT                                                                   0x0

#define HWIO_IPA_FILT_ROUT_CACHE_CFG_ADDR                                                                         (IPA_CFG_REG_BASE      + 0x00000400)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_PHYS                                                                         (IPA_CFG_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_OFFS                                                                         (IPA_CFG_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_RMSK                                                                         0xffff0111
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_ATTR                                                                                0x3
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_IN          \
        in_dword_masked(HWIO_IPA_FILT_ROUT_CACHE_CFG_ADDR, HWIO_IPA_FILT_ROUT_CACHE_CFG_RMSK)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_FILT_ROUT_CACHE_CFG_ADDR, m)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_OUT(v)      \
        out_dword(HWIO_IPA_FILT_ROUT_CACHE_CFG_ADDR,v)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_FILT_ROUT_CACHE_CFG_ADDR,m,v,HWIO_IPA_FILT_ROUT_CACHE_CFG_IN)
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_CACHE_LRU_EVICTION_THRESHOLD_BMSK                                            0xffff0000
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_CACHE_LRU_EVICTION_THRESHOLD_SHFT                                                  0x10
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_CACHE_LOW_PRIORITY_HASHABLE_HIT_DISABLE_BMSK                                      0x100
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_CACHE_LOW_PRIORITY_HASHABLE_HIT_DISABLE_SHFT                                        0x8
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_IPA_FILTER_CACHE_EN_BMSK                                                           0x10
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_IPA_FILTER_CACHE_EN_SHFT                                                            0x4
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_IPA_ROUTER_CACHE_EN_BMSK                                                            0x1
#define HWIO_IPA_FILT_ROUT_CACHE_CFG_IPA_ROUTER_CACHE_EN_SHFT                                                            0x0

#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x000004e0)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x000004e0)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x000004e0)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_RMSK                                                                    0xffff11
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_ATTR                                                                         0x3
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IN          \
        in_dword_masked(HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_ADDR, HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_RMSK)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_ADDR, m)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_OUT(v)      \
        out_dword(HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_ADDR,v)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_ADDR,m,v,HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IN)
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_FILTER_CACHE_REDUCE_LEVEL_BMSK                                      0xff0000
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_FILTER_CACHE_REDUCE_LEVEL_SHFT                                          0x10
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_ROUTER_CACHE_REDUCE_LEVEL_BMSK                                        0xff00
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_ROUTER_CACHE_REDUCE_LEVEL_SHFT                                           0x8
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_FILTER_CACHE_REDUCE_EN_BMSK                                             0x10
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_FILTER_CACHE_REDUCE_EN_SHFT                                              0x4
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_ROUTER_CACHE_REDUCE_EN_BMSK                                              0x1
#define HWIO_IPA_FILT_ROUT_CACHE_REDUCE_CFG_IPA_ROUTER_CACHE_REDUCE_EN_SHFT                                              0x0

#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x00000404)
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000404)
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000404)
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_RMSK                                                                             0x11
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_ATTR                                                                              0x2
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_OUT(v)      \
        out_dword(HWIO_IPA_FILT_ROUT_CACHE_FLUSH_ADDR,v)
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_IPA_FILTER_CACHE_FLUSH_BMSK                                                      0x10
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_IPA_FILTER_CACHE_FLUSH_SHFT                                                       0x4
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_IPA_ROUTER_CACHE_FLUSH_BMSK                                                       0x1
#define HWIO_IPA_FILT_ROUT_CACHE_FLUSH_IPA_ROUTER_CACHE_FLUSH_SHFT                                                       0x0

#define HWIO_IPA_FILT_ROUT_CFG_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x00000408)
#define HWIO_IPA_FILT_ROUT_CFG_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000408)
#define HWIO_IPA_FILT_ROUT_CFG_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000408)
#define HWIO_IPA_FILT_ROUT_CFG_RMSK                                                                                    0x111
#define HWIO_IPA_FILT_ROUT_CFG_ATTR                                                                                      0x3
#define HWIO_IPA_FILT_ROUT_CFG_IN          \
        in_dword_masked(HWIO_IPA_FILT_ROUT_CFG_ADDR, HWIO_IPA_FILT_ROUT_CFG_RMSK)
#define HWIO_IPA_FILT_ROUT_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_FILT_ROUT_CFG_ADDR, m)
#define HWIO_IPA_FILT_ROUT_CFG_OUT(v)      \
        out_dword(HWIO_IPA_FILT_ROUT_CFG_ADDR,v)
#define HWIO_IPA_FILT_ROUT_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_FILT_ROUT_CFG_ADDR,m,v,HWIO_IPA_FILT_ROUT_CFG_IN)
#define HWIO_IPA_FILT_ROUT_CFG_FILT_ROUT_DATA_CACHE_EN_BMSK                                                            0x100
#define HWIO_IPA_FILT_ROUT_CFG_FILT_ROUT_DATA_CACHE_EN_SHFT                                                              0x8
#define HWIO_IPA_FILT_ROUT_CFG_FILTER_PREFETCH_EN_BMSK                                                                  0x10
#define HWIO_IPA_FILT_ROUT_CFG_FILTER_PREFETCH_EN_SHFT                                                                   0x4
#define HWIO_IPA_FILT_ROUT_CFG_ROUTER_PREFETCH_EN_BMSK                                                                   0x1
#define HWIO_IPA_FILT_ROUT_CFG_ROUTER_PREFETCH_EN_SHFT                                                                   0x0

#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_ADDR                                                                     (IPA_CFG_REG_BASE      + 0x0000040c)
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_PHYS                                                                     (IPA_CFG_REG_BASE_PHYS + 0x0000040c)
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_OFFS                                                                     (IPA_CFG_REG_BASE_OFFS + 0x0000040c)
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_RMSK                                                                     0xffffffff
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_ATTR                                                                            0x1
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_IN          \
        in_dword_masked(HWIO_IPA_IPV4_FILTER_INIT_VALUES_ADDR, HWIO_IPA_IPV4_FILTER_INIT_VALUES_RMSK)
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_FILTER_INIT_VALUES_ADDR, m)
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_IP_V4_FILTER_INIT_NON_HASHED_ADDR_BMSK                                   0xffff0000
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_IP_V4_FILTER_INIT_NON_HASHED_ADDR_SHFT                                         0x10
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_IP_V4_FILTER_INIT_HASHED_ADDR_BMSK                                           0xffff
#define HWIO_IPA_IPV4_FILTER_INIT_VALUES_IP_V4_FILTER_INIT_HASHED_ADDR_SHFT                                              0x0

#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_ADDR                                                                     (IPA_CFG_REG_BASE      + 0x00000410)
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_PHYS                                                                     (IPA_CFG_REG_BASE_PHYS + 0x00000410)
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_OFFS                                                                     (IPA_CFG_REG_BASE_OFFS + 0x00000410)
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_RMSK                                                                     0xffffffff
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_ATTR                                                                            0x1
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_IN          \
        in_dword_masked(HWIO_IPA_IPV6_FILTER_INIT_VALUES_ADDR, HWIO_IPA_IPV6_FILTER_INIT_VALUES_RMSK)
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_FILTER_INIT_VALUES_ADDR, m)
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_IP_V6_FILTER_INIT_NON_HASHED_ADDR_BMSK                                   0xffff0000
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_IP_V6_FILTER_INIT_NON_HASHED_ADDR_SHFT                                         0x10
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_IP_V6_FILTER_INIT_HASHED_ADDR_BMSK                                           0xffff
#define HWIO_IPA_IPV6_FILTER_INIT_VALUES_IP_V6_FILTER_INIT_HASHED_ADDR_SHFT                                              0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x00000414)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000414)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000414)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_RMSK                                                                      0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_0_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_0_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_0_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_IP_V4_NAT_INIT_RULES_ADDR_BMSK                                            0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_IP_V4_NAT_INIT_RULES_ADDR_SHFT                                                   0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x00000418)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000418)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000418)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_RMSK                                                                  0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_ATTR                                                                         0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_IP_V4_NAT_INIT_RULES_ADDR_BMSK                                        0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_0_MSB_IP_V4_NAT_INIT_RULES_ADDR_SHFT                                               0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x0000041c)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x0000041c)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x0000041c)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_RMSK                                                                      0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_1_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_1_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_1_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_IP_V4_NAT_INIT_EXP_RULES_ADDR_BMSK                                        0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_IP_V4_NAT_INIT_EXP_RULES_ADDR_SHFT                                               0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x00000420)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000420)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000420)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_RMSK                                                                  0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_ATTR                                                                         0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_IP_V4_NAT_INIT_EXP_RULES_ADDR_BMSK                                    0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_1_MSB_IP_V4_NAT_INIT_EXP_RULES_ADDR_SHFT                                           0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x00000424)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000424)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000424)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_RMSK                                                                      0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_2_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_2_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_2_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_IP_V4_NAT_INIT_INDEX_TABLE_ADDR_BMSK                                      0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_IP_V4_NAT_INIT_INDEX_TABLE_ADDR_SHFT                                             0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x00000428)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000428)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000428)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_RMSK                                                                  0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_ATTR                                                                         0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_IP_V4_NAT_INIT_INDEX_TABLE_ADDR_BMSK                                  0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_2_MSB_IP_V4_NAT_INIT_INDEX_TABLE_ADDR_SHFT                                         0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x0000042c)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x0000042c)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x0000042c)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_RMSK                                                                      0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_3_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_3_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_3_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_IP_V4_NAT_INIT_INDEX_TABLE_EXP_ADDR_BMSK                                  0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_IP_V4_NAT_INIT_INDEX_TABLE_EXP_ADDR_SHFT                                         0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x00000430)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000430)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000430)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_RMSK                                                                  0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_ATTR                                                                         0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_IP_V4_NAT_INIT_INDEX_TABLE_EXP_ADDR_BMSK                              0xffffffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_3_MSB_IP_V4_NAT_INIT_INDEX_TABLE_EXP_ADDR_SHFT                                     0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x00000434)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000434)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000434)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_RMSK                                                                      0x3ffffff7
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_4_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_4_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_4_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_SIZE_EXP_TABLES_BMSK                                       0x3ff00000
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_SIZE_EXP_TABLES_SHFT                                             0x14
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_SIZE_BASE_TABLES_BMSK                                         0xfff00
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_SIZE_BASE_TABLES_SHFT                                             0x8
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_INDEX_TABLE_EXP_ADDR_TYPE_BMSK                                   0x80
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_INDEX_TABLE_EXP_ADDR_TYPE_SHFT                                    0x7
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_INDEX_TABLE_ADDR_TYPE_BMSK                                       0x40
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_INDEX_TABLE_ADDR_TYPE_SHFT                                        0x6
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_EXP_RULES_ADDR_TYPE_BMSK                                         0x20
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_EXP_RULES_ADDR_TYPE_SHFT                                          0x5
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_RULES_ADDR_TYPE_BMSK                                             0x10
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_RULES_ADDR_TYPE_SHFT                                              0x4
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_TABLE_INDEX_BMSK                                                  0x7
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_4_IP_V4_NAT_INIT_TABLE_INDEX_SHFT                                                  0x0

#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x00000438)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000438)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000438)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_RMSK                                                                         0xfffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_IN          \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_5_ADDR, HWIO_IPA_IPV4_NAT_INIT_VALUES_5_RMSK)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_NAT_INIT_VALUES_5_ADDR, m)
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_IP_V4_NAT_INIT_PDN_CONFIG_TABLE_ADDR_BMSK                                    0xfffff
#define HWIO_IPA_IPV4_NAT_INIT_VALUES_5_IP_V4_NAT_INIT_PDN_CONFIG_TABLE_ADDR_SHFT                                        0x0

#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x0000043c)
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x0000043c)
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x0000043c)
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_RMSK                                                                      0xffffffff
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_ATTR                                                                             0x1
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_IN          \
        in_dword_masked(HWIO_IPA_IPV4_ROUTE_INIT_VALUES_ADDR, HWIO_IPA_IPV4_ROUTE_INIT_VALUES_RMSK)
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV4_ROUTE_INIT_VALUES_ADDR, m)
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_IP_V4_ROUTE_INIT_NON_HASHED_ADDR_BMSK                                     0xffff0000
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_IP_V4_ROUTE_INIT_NON_HASHED_ADDR_SHFT                                           0x10
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_IP_V4_ROUTE_INIT_HASHED_ADDR_BMSK                                             0xffff
#define HWIO_IPA_IPV4_ROUTE_INIT_VALUES_IP_V4_ROUTE_INIT_HASHED_ADDR_SHFT                                                0x0

#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x00000440)
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000440)
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000440)
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_RMSK                                                                      0xffffffff
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_ATTR                                                                             0x1
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_IN          \
        in_dword_masked(HWIO_IPA_IPV6_ROUTE_INIT_VALUES_ADDR, HWIO_IPA_IPV6_ROUTE_INIT_VALUES_RMSK)
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_ROUTE_INIT_VALUES_ADDR, m)
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_IP_V6_ROUTE_INIT_NON_HASHED_ADDR_BMSK                                     0xffff0000
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_IP_V6_ROUTE_INIT_NON_HASHED_ADDR_SHFT                                           0x10
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_IP_V6_ROUTE_INIT_HASHED_ADDR_BMSK                                             0xffff
#define HWIO_IPA_IPV6_ROUTE_INIT_VALUES_IP_V6_ROUTE_INIT_HASHED_ADDR_SHFT                                                0x0

#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_ADDR                                                               (IPA_CFG_REG_BASE      + 0x00000444)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_PHYS                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000444)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_OFFS                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000444)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_RMSK                                                               0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_ATTR                                                                      0x1
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_IN          \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_ADDR, HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_RMSK)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_ADDR, m)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_IP_V6_CONN_TRACK_INIT_TABLE_ADDR_BMSK                              0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_IP_V6_CONN_TRACK_INIT_TABLE_ADDR_SHFT                                     0x0

#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_ADDR                                                           (IPA_CFG_REG_BASE      + 0x00000448)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_PHYS                                                           (IPA_CFG_REG_BASE_PHYS + 0x00000448)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_OFFS                                                           (IPA_CFG_REG_BASE_OFFS + 0x00000448)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_RMSK                                                           0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_ATTR                                                                  0x1
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_IN          \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_ADDR, HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_RMSK)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_ADDR, m)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_IP_V6_CONN_TRACK_INIT_TABLE_ADDR_BMSK                          0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_0_MSB_IP_V6_CONN_TRACK_INIT_TABLE_ADDR_SHFT                                 0x0

#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_ADDR                                                               (IPA_CFG_REG_BASE      + 0x0000044c)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_PHYS                                                               (IPA_CFG_REG_BASE_PHYS + 0x0000044c)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_OFFS                                                               (IPA_CFG_REG_BASE_OFFS + 0x0000044c)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_RMSK                                                               0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_ATTR                                                                      0x1
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_IN          \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_ADDR, HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_RMSK)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_ADDR, m)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_IP_V6_CONN_TRACK_INIT_EXP_TABLE_ADDR_BMSK                          0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_IP_V6_CONN_TRACK_INIT_EXP_TABLE_ADDR_SHFT                                 0x0

#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_ADDR                                                           (IPA_CFG_REG_BASE      + 0x00000450)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_PHYS                                                           (IPA_CFG_REG_BASE_PHYS + 0x00000450)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_OFFS                                                           (IPA_CFG_REG_BASE_OFFS + 0x00000450)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_RMSK                                                           0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_ATTR                                                                  0x1
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_IN          \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_ADDR, HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_RMSK)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_ADDR, m)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_IP_V6_CONN_TRACK_INIT_EXP_TABLE_ADDR_BMSK                      0xffffffff
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_1_MSB_IP_V6_CONN_TRACK_INIT_EXP_TABLE_ADDR_SHFT                             0x0

#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_ADDR                                                               (IPA_CFG_REG_BASE      + 0x00000454)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_PHYS                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000454)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_OFFS                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000454)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_RMSK                                                               0x3fffff37
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_ATTR                                                                      0x1
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IN          \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_ADDR, HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_RMSK)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_INM(m)      \
        in_dword_masked(HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_ADDR, m)
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_SIZE_EXP_TABLES_BMSK                         0x3ff00000
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_SIZE_EXP_TABLES_SHFT                               0x14
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_SIZE_BASE_TABLES_BMSK                           0xfff00
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_SIZE_BASE_TABLES_SHFT                               0x8
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_EXP_TABLE_ADDR_TYPE_BMSK                           0x20
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_EXP_TABLE_ADDR_TYPE_SHFT                            0x5
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_TABLE_ADDR_TYPE_BMSK                               0x10
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_TABLE_ADDR_TYPE_SHFT                                0x4
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_TABLE_INDEX_BMSK                                    0x7
#define HWIO_IPA_IPV6_CONN_TRACK_INIT_VALUES_2_IP_V6_CONN_TRACK_INIT_TABLE_INDEX_SHFT                                    0x0

#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x00000458)
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000458)
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000458)
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_RMSK                                                                        0xffff000
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_ATTR                                                                              0x1
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_IN          \
        in_dword_masked(HWIO_IPA_HDR_INIT_LOCAL_VALUES_ADDR, HWIO_IPA_HDR_INIT_LOCAL_VALUES_RMSK)
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_HDR_INIT_LOCAL_VALUES_ADDR, m)
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_HDR_INIT_LOCAL_HDR_ADDR_BMSK                                                0xffff000
#define HWIO_IPA_HDR_INIT_LOCAL_VALUES_HDR_INIT_LOCAL_HDR_ADDR_SHFT                                                      0xc

#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_ADDR                                                                      (IPA_CFG_REG_BASE      + 0x0000045c)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_PHYS                                                                      (IPA_CFG_REG_BASE_PHYS + 0x0000045c)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_OFFS                                                                      (IPA_CFG_REG_BASE_OFFS + 0x0000045c)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_RMSK                                                                      0xffffffff
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_ATTR                                                                             0x1
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_IN          \
        in_dword_masked(HWIO_IPA_HDR_INIT_SYSTEM_VALUES_ADDR, HWIO_IPA_HDR_INIT_SYSTEM_VALUES_RMSK)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_HDR_INIT_SYSTEM_VALUES_ADDR, m)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_HDR_INIT_SYSTEM_HDR_TABLE_ADDR_BMSK                                       0xffffffff
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_HDR_INIT_SYSTEM_HDR_TABLE_ADDR_SHFT                                              0x0

#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x00000460)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000460)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000460)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_RMSK                                                                  0xffffffff
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_ATTR                                                                         0x1
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_IN          \
        in_dword_masked(HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_ADDR, HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_RMSK)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_ADDR, m)
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_HDR_INIT_SYSTEM_HDR_TABLE_ADDR_BMSK                                   0xffffffff
#define HWIO_IPA_HDR_INIT_SYSTEM_VALUES_MSB_HDR_INIT_SYSTEM_HDR_TABLE_ADDR_SHFT                                          0x0

#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x00000464)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00000464)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00000464)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_RMSK                                                                  0xffffffff
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_ATTR                                                                         0x1
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IN          \
        in_dword_masked(HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_ADDR, HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_RMSK)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_ADDR, m)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_HDRI_PIPE_BMSK                                                0xff000000
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_HDRI_PIPE_SHFT                                                      0x18
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_CONN_TRACK_PIPE_BMSK                                            0xff0000
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_CONN_TRACK_PIPE_SHFT                                                0x10
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_NAT_PIPE_BMSK                                                     0xff00
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_NAT_PIPE_SHFT                                                        0x8
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_FILTER_ROUTER_PIPE_BMSK                                             0xff
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_IMM_CMD_FILTER_ROUTER_PIPE_SHFT                                              0x0

#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_ADDR                                                                (IPA_CFG_REG_BASE      + 0x00000468)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_PHYS                                                                (IPA_CFG_REG_BASE_PHYS + 0x00000468)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_OFFS                                                                (IPA_CFG_REG_BASE_OFFS + 0x00000468)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_RMSK                                                                      0xff
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_ATTR                                                                       0x1
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_IN          \
        in_dword_masked(HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_ADDR, HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_RMSK)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_INM(m)      \
        in_dword_masked(HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_ADDR, m)
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_IMM_CMD_GEN_PIPE_BMSK                                                     0xff
#define HWIO_IPA_IMM_CMD_ACCESS_PIPE_VALUES_1_IMM_CMD_GEN_PIPE_SHFT                                                      0x0

#define HWIO_IPA_FRAG_VALUES_ADDR                                                                                 (IPA_CFG_REG_BASE      + 0x0000046c)
#define HWIO_IPA_FRAG_VALUES_PHYS                                                                                 (IPA_CFG_REG_BASE_PHYS + 0x0000046c)
#define HWIO_IPA_FRAG_VALUES_OFFS                                                                                 (IPA_CFG_REG_BASE_OFFS + 0x0000046c)
#define HWIO_IPA_FRAG_VALUES_RMSK                                                                                  0xf00ffff
#define HWIO_IPA_FRAG_VALUES_ATTR                                                                                        0x3
#define HWIO_IPA_FRAG_VALUES_IN          \
        in_dword_masked(HWIO_IPA_FRAG_VALUES_ADDR, HWIO_IPA_FRAG_VALUES_RMSK)
#define HWIO_IPA_FRAG_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_FRAG_VALUES_ADDR, m)
#define HWIO_IPA_FRAG_VALUES_OUT(v)      \
        out_dword(HWIO_IPA_FRAG_VALUES_ADDR,v)
#define HWIO_IPA_FRAG_VALUES_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_FRAG_VALUES_ADDR,m,v,HWIO_IPA_FRAG_VALUES_IN)
#define HWIO_IPA_FRAG_VALUES_IPA_FRAG_FAIRNESS_CNT_BMSK                                                            0xf000000
#define HWIO_IPA_FRAG_VALUES_IPA_FRAG_FAIRNESS_CNT_SHFT                                                                 0x18
#define HWIO_IPA_FRAG_VALUES_IPA_FRAG_RAM_LAST_ADDR_BMSK                                                              0xffff
#define HWIO_IPA_FRAG_VALUES_IPA_FRAG_RAM_LAST_ADDR_SHFT                                                                 0x0

#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR                                                                     (IPA_CFG_REG_BASE      + 0x00000470)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_PHYS                                                                     (IPA_CFG_REG_BASE_PHYS + 0x00000470)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_OFFS                                                                     (IPA_CFG_REG_BASE_OFFS + 0x00000470)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_RMSK                                                                     0xffffffff
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ATTR                                                                            0x3
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_IN          \
        in_dword_masked(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR, HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_RMSK)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_INM(m)      \
        in_dword_masked(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR, m)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_OUT(v)      \
        out_dword(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR,v)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR,m,v,HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_IN)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR_BMSK                                                                0xfffffff8
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ADDR_SHFT                                                                       0x3
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ZERO_BMSK                                                                       0x7
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_ZERO_SHFT                                                                       0x0

#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR                                                                 (IPA_CFG_REG_BASE      + 0x00000474)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_PHYS                                                                 (IPA_CFG_REG_BASE_PHYS + 0x00000474)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_OFFS                                                                 (IPA_CFG_REG_BASE_OFFS + 0x00000474)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_RMSK                                                                 0xffffffff
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ATTR                                                                        0x3
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_IN          \
        in_dword_masked(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR, HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_RMSK)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR, m)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_OUT(v)      \
        out_dword(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR,v)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR,m,v,HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_IN)
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR_BMSK                                                            0xffffffff
#define HWIO_IPA_SYS_PKT_PROC_CNTXT_BASE_MSB_ADDR_SHFT                                                                   0x0

#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR                                                                   (IPA_CFG_REG_BASE      + 0x00000478)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_PHYS                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000478)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_OFFS                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000478)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_RMSK                                                                      0x3ffff
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ATTR                                                                          0x3
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_IN          \
        in_dword_masked(HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR, HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_RMSK)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_INM(m)      \
        in_dword_masked(HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR, m)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_OUT(v)      \
        out_dword(HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR,v)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR,m,v,HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_IN)
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR_BMSK                                                                 0x3fff8
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ADDR_SHFT                                                                     0x3
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ZERO_BMSK                                                                     0x7
#define HWIO_IPA_LOCAL_PKT_PROC_CNTXT_BASE_ZERO_SHFT                                                                     0x0

#define HWIO_IPA_SCND_FRAG_VALUES_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x00000480)
#define HWIO_IPA_SCND_FRAG_VALUES_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00000480)
#define HWIO_IPA_SCND_FRAG_VALUES_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00000480)
#define HWIO_IPA_SCND_FRAG_VALUES_RMSK                                                                             0xf00ffff
#define HWIO_IPA_SCND_FRAG_VALUES_ATTR                                                                                   0x3
#define HWIO_IPA_SCND_FRAG_VALUES_IN          \
        in_dword_masked(HWIO_IPA_SCND_FRAG_VALUES_ADDR, HWIO_IPA_SCND_FRAG_VALUES_RMSK)
#define HWIO_IPA_SCND_FRAG_VALUES_INM(m)      \
        in_dword_masked(HWIO_IPA_SCND_FRAG_VALUES_ADDR, m)
#define HWIO_IPA_SCND_FRAG_VALUES_OUT(v)      \
        out_dword(HWIO_IPA_SCND_FRAG_VALUES_ADDR,v)
#define HWIO_IPA_SCND_FRAG_VALUES_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SCND_FRAG_VALUES_ADDR,m,v,HWIO_IPA_SCND_FRAG_VALUES_IN)
#define HWIO_IPA_SCND_FRAG_VALUES_IPA_SCND_FRAG_FAIRNESS_CNT_BMSK                                                  0xf000000
#define HWIO_IPA_SCND_FRAG_VALUES_IPA_SCND_FRAG_FAIRNESS_CNT_SHFT                                                       0x18
#define HWIO_IPA_SCND_FRAG_VALUES_IPA_SCND_FRAG_RAM_LAST_ADDR_BMSK                                                    0xffff
#define HWIO_IPA_SCND_FRAG_VALUES_IPA_SCND_FRAG_RAM_LAST_ADDR_SHFT                                                       0x0

#define HWIO_IPA_AOS_CFG_ADDR                                                                                     (IPA_CFG_REG_BASE      + 0x00000484)
#define HWIO_IPA_AOS_CFG_PHYS                                                                                     (IPA_CFG_REG_BASE_PHYS + 0x00000484)
#define HWIO_IPA_AOS_CFG_OFFS                                                                                     (IPA_CFG_REG_BASE_OFFS + 0x00000484)
#define HWIO_IPA_AOS_CFG_RMSK                                                                                            0x1
#define HWIO_IPA_AOS_CFG_ATTR                                                                                            0x3
#define HWIO_IPA_AOS_CFG_IN          \
        in_dword_masked(HWIO_IPA_AOS_CFG_ADDR, HWIO_IPA_AOS_CFG_RMSK)
#define HWIO_IPA_AOS_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_AOS_CFG_ADDR, m)
#define HWIO_IPA_AOS_CFG_OUT(v)      \
        out_dword(HWIO_IPA_AOS_CFG_ADDR,v)
#define HWIO_IPA_AOS_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_AOS_CFG_ADDR,m,v,HWIO_IPA_AOS_CFG_IN)
#define HWIO_IPA_AOS_CFG_IPA_AOS_TX_RX_PRIORITY_BMSK                                                                     0x1
#define HWIO_IPA_AOS_CFG_IPA_AOS_TX_RX_PRIORITY_SHFT                                                                     0x0

#define HWIO_IPA_TX_CFG_ADDR                                                                                      (IPA_CFG_REG_BASE      + 0x00000488)
#define HWIO_IPA_TX_CFG_PHYS                                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000488)
#define HWIO_IPA_TX_CFG_OFFS                                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000488)
#define HWIO_IPA_TX_CFG_RMSK                                                                                        0x17fffc
#define HWIO_IPA_TX_CFG_ATTR                                                                                             0x3
#define HWIO_IPA_TX_CFG_IN          \
        in_dword_masked(HWIO_IPA_TX_CFG_ADDR, HWIO_IPA_TX_CFG_RMSK)
#define HWIO_IPA_TX_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_TX_CFG_ADDR, m)
#define HWIO_IPA_TX_CFG_OUT(v)      \
        out_dword(HWIO_IPA_TX_CFG_ADDR,v)
#define HWIO_IPA_TX_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TX_CFG_ADDR,m,v,HWIO_IPA_TX_CFG_IN)
#define HWIO_IPA_TX_CFG_HOLB_STICKY_DROP_EN_BMSK                                                                    0x100000
#define HWIO_IPA_TX_CFG_HOLB_STICKY_DROP_EN_SHFT                                                                        0x14
#define HWIO_IPA_TX_CFG_SSPND_PA_NO_START_STATE_BMSK                                                                 0x40000
#define HWIO_IPA_TX_CFG_SSPND_PA_NO_START_STATE_SHFT                                                                    0x12
#define HWIO_IPA_TX_CFG_DUAL_TX_ENABLE_BMSK                                                                          0x20000
#define HWIO_IPA_TX_CFG_DUAL_TX_ENABLE_SHFT                                                                             0x11
#define HWIO_IPA_TX_CFG_PREFETCH_ALMOST_EMPTY_SIZE_TX1_BMSK                                                          0x1e000
#define HWIO_IPA_TX_CFG_PREFETCH_ALMOST_EMPTY_SIZE_TX1_SHFT                                                              0xd
#define HWIO_IPA_TX_CFG_PA_MASK_EN_BMSK                                                                               0x1000
#define HWIO_IPA_TX_CFG_PA_MASK_EN_SHFT                                                                                  0xc
#define HWIO_IPA_TX_CFG_DMAW_MAX_BEATS_256_DIS_BMSK                                                                    0x800
#define HWIO_IPA_TX_CFG_DMAW_MAX_BEATS_256_DIS_SHFT                                                                      0xb
#define HWIO_IPA_TX_CFG_DMAW_SCND_OUTSD_PRED_EN_BMSK                                                                   0x400
#define HWIO_IPA_TX_CFG_DMAW_SCND_OUTSD_PRED_EN_SHFT                                                                     0xa
#define HWIO_IPA_TX_CFG_DMAW_SCND_OUTSD_PRED_THRESHOLD_BMSK                                                            0x3c0
#define HWIO_IPA_TX_CFG_DMAW_SCND_OUTSD_PRED_THRESHOLD_SHFT                                                              0x6
#define HWIO_IPA_TX_CFG_PREFETCH_ALMOST_EMPTY_SIZE_TX0_BMSK                                                             0x3c
#define HWIO_IPA_TX_CFG_PREFETCH_ALMOST_EMPTY_SIZE_TX0_SHFT                                                              0x2

#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_ADDR                                                                         (IPA_CFG_REG_BASE      + 0x0000048c)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_PHYS                                                                         (IPA_CFG_REG_BASE_PHYS + 0x0000048c)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_OFFS                                                                         (IPA_CFG_REG_BASE_OFFS + 0x0000048c)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_RMSK                                                                         0xffffffff
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_ATTR                                                                                0x3
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_IN          \
        in_dword_masked(HWIO_IPA_NAT_UC_EXTERNAL_CFG_ADDR, HWIO_IPA_NAT_UC_EXTERNAL_CFG_RMSK)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_NAT_UC_EXTERNAL_CFG_ADDR, m)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_OUT(v)      \
        out_dword(HWIO_IPA_NAT_UC_EXTERNAL_CFG_ADDR,v)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NAT_UC_EXTERNAL_CFG_ADDR,m,v,HWIO_IPA_NAT_UC_EXTERNAL_CFG_IN)
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_IPA_NAT_UC_EXTERNAL_TABLE_ADDR_LSB_BMSK                                      0xffffffff
#define HWIO_IPA_NAT_UC_EXTERNAL_CFG_IPA_NAT_UC_EXTERNAL_TABLE_ADDR_LSB_SHFT                                             0x0

#define HWIO_IPA_NAT_UC_LOCAL_CFG_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x00000490)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00000490)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00000490)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_RMSK                                                                            0xffffffff
#define HWIO_IPA_NAT_UC_LOCAL_CFG_ATTR                                                                                   0x3
#define HWIO_IPA_NAT_UC_LOCAL_CFG_IN          \
        in_dword_masked(HWIO_IPA_NAT_UC_LOCAL_CFG_ADDR, HWIO_IPA_NAT_UC_LOCAL_CFG_RMSK)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_NAT_UC_LOCAL_CFG_ADDR, m)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_OUT(v)      \
        out_dword(HWIO_IPA_NAT_UC_LOCAL_CFG_ADDR,v)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NAT_UC_LOCAL_CFG_ADDR,m,v,HWIO_IPA_NAT_UC_LOCAL_CFG_IN)
#define HWIO_IPA_NAT_UC_LOCAL_CFG_IPA_NAT_UC_LOCAL_TABLE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_IPA_NAT_UC_LOCAL_CFG_IPA_NAT_UC_LOCAL_TABLE_ADDR_LSB_SHFT                                                   0x0

#define HWIO_IPA_NAT_UC_SHARED_CFG_ADDR                                                                           (IPA_CFG_REG_BASE      + 0x00000494)
#define HWIO_IPA_NAT_UC_SHARED_CFG_PHYS                                                                           (IPA_CFG_REG_BASE_PHYS + 0x00000494)
#define HWIO_IPA_NAT_UC_SHARED_CFG_OFFS                                                                           (IPA_CFG_REG_BASE_OFFS + 0x00000494)
#define HWIO_IPA_NAT_UC_SHARED_CFG_RMSK                                                                           0xffffffff
#define HWIO_IPA_NAT_UC_SHARED_CFG_ATTR                                                                                  0x3
#define HWIO_IPA_NAT_UC_SHARED_CFG_IN          \
        in_dword_masked(HWIO_IPA_NAT_UC_SHARED_CFG_ADDR, HWIO_IPA_NAT_UC_SHARED_CFG_RMSK)
#define HWIO_IPA_NAT_UC_SHARED_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_NAT_UC_SHARED_CFG_ADDR, m)
#define HWIO_IPA_NAT_UC_SHARED_CFG_OUT(v)      \
        out_dword(HWIO_IPA_NAT_UC_SHARED_CFG_ADDR,v)
#define HWIO_IPA_NAT_UC_SHARED_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NAT_UC_SHARED_CFG_ADDR,m,v,HWIO_IPA_NAT_UC_SHARED_CFG_IN)
#define HWIO_IPA_NAT_UC_SHARED_CFG_IPA_NAT_UC_LOCAL_TABLE_ADDR_MSB_BMSK                                           0xffff0000
#define HWIO_IPA_NAT_UC_SHARED_CFG_IPA_NAT_UC_LOCAL_TABLE_ADDR_MSB_SHFT                                                 0x10
#define HWIO_IPA_NAT_UC_SHARED_CFG_IPA_NAT_UC_EXTERNAL_TABLE_ADDR_MSB_BMSK                                            0xffff
#define HWIO_IPA_NAT_UC_SHARED_CFG_IPA_NAT_UC_EXTERNAL_TABLE_ADDR_MSB_SHFT                                               0x0

#define HWIO_IPA_RAM_INTLV_CFG_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x00000498)
#define HWIO_IPA_RAM_INTLV_CFG_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000498)
#define HWIO_IPA_RAM_INTLV_CFG_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000498)
#define HWIO_IPA_RAM_INTLV_CFG_RMSK                                                                                   0xffff
#define HWIO_IPA_RAM_INTLV_CFG_ATTR                                                                                      0x3
#define HWIO_IPA_RAM_INTLV_CFG_IN          \
        in_dword_masked(HWIO_IPA_RAM_INTLV_CFG_ADDR, HWIO_IPA_RAM_INTLV_CFG_RMSK)
#define HWIO_IPA_RAM_INTLV_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RAM_INTLV_CFG_ADDR, m)
#define HWIO_IPA_RAM_INTLV_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RAM_INTLV_CFG_ADDR,v)
#define HWIO_IPA_RAM_INTLV_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RAM_INTLV_CFG_ADDR,m,v,HWIO_IPA_RAM_INTLV_CFG_IN)
#define HWIO_IPA_RAM_INTLV_CFG_IPA_RAM_INTLV_CFG_BMSK                                                                 0xffff
#define HWIO_IPA_RAM_INTLV_CFG_IPA_RAM_INTLV_CFG_SHFT                                                                    0x0

#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_ADDR                                                                  (IPA_CFG_REG_BASE      + 0x0000049c)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_PHYS                                                                  (IPA_CFG_REG_BASE_PHYS + 0x0000049c)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_OFFS                                                                  (IPA_CFG_REG_BASE_OFFS + 0x0000049c)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_RMSK                                                                  0xffffffff
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_ATTR                                                                         0x3
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_IN          \
        in_dword_masked(HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_ADDR, HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_RMSK)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_ADDR, m)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_OUT(v)      \
        out_dword(HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_ADDR,v)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_ADDR,m,v,HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_IN)
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_IPA_CONN_TRACK_UC_EXTERNAL_TABLE_ADDR_LSB_BMSK                        0xffffffff
#define HWIO_IPA_CONN_TRACK_UC_EXTERNAL_CFG_IPA_CONN_TRACK_UC_EXTERNAL_TABLE_ADDR_LSB_SHFT                               0x0

#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_ADDR                                                                     (IPA_CFG_REG_BASE      + 0x000004a0)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_PHYS                                                                     (IPA_CFG_REG_BASE_PHYS + 0x000004a0)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_OFFS                                                                     (IPA_CFG_REG_BASE_OFFS + 0x000004a0)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_RMSK                                                                     0xffffffff
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_ATTR                                                                            0x3
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_IN          \
        in_dword_masked(HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_ADDR, HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_RMSK)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_ADDR, m)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_OUT(v)      \
        out_dword(HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_ADDR,v)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_ADDR,m,v,HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_IN)
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_IPA_CONN_TRACK_UC_LOCAL_TABLE_ADDR_LSB_BMSK                              0xffffffff
#define HWIO_IPA_CONN_TRACK_UC_LOCAL_CFG_IPA_CONN_TRACK_UC_LOCAL_TABLE_ADDR_LSB_SHFT                                     0x0

#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_ADDR                                                                    (IPA_CFG_REG_BASE      + 0x000004a4)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_PHYS                                                                    (IPA_CFG_REG_BASE_PHYS + 0x000004a4)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_OFFS                                                                    (IPA_CFG_REG_BASE_OFFS + 0x000004a4)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_RMSK                                                                    0xffffffff
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_ATTR                                                                           0x3
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_IN          \
        in_dword_masked(HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_ADDR, HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_RMSK)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_ADDR, m)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_OUT(v)      \
        out_dword(HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_ADDR,v)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_ADDR,m,v,HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_IN)
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_IPA_CONN_TRACK_UC_LOCAL_TABLE_ADDR_MSB_BMSK                             0xffff0000
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_IPA_CONN_TRACK_UC_LOCAL_TABLE_ADDR_MSB_SHFT                                   0x10
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_IPA_CONN_TRACK_UC_EXTERNAL_TABLE_ADDR_MSB_BMSK                              0xffff
#define HWIO_IPA_CONN_TRACK_UC_SHARED_CFG_IPA_CONN_TRACK_UC_EXTERNAL_TABLE_ADDR_MSB_SHFT                                 0x0

#define HWIO_IPA_IDLE_INDICATION_CFG_ADDR                                                                         (IPA_CFG_REG_BASE      + 0x000004a8)
#define HWIO_IPA_IDLE_INDICATION_CFG_PHYS                                                                         (IPA_CFG_REG_BASE_PHYS + 0x000004a8)
#define HWIO_IPA_IDLE_INDICATION_CFG_OFFS                                                                         (IPA_CFG_REG_BASE_OFFS + 0x000004a8)
#define HWIO_IPA_IDLE_INDICATION_CFG_RMSK                                                                            0x1ffff
#define HWIO_IPA_IDLE_INDICATION_CFG_ATTR                                                                                0x3
#define HWIO_IPA_IDLE_INDICATION_CFG_IN          \
        in_dword_masked(HWIO_IPA_IDLE_INDICATION_CFG_ADDR, HWIO_IPA_IDLE_INDICATION_CFG_RMSK)
#define HWIO_IPA_IDLE_INDICATION_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_IDLE_INDICATION_CFG_ADDR, m)
#define HWIO_IPA_IDLE_INDICATION_CFG_OUT(v)      \
        out_dword(HWIO_IPA_IDLE_INDICATION_CFG_ADDR,v)
#define HWIO_IPA_IDLE_INDICATION_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_IDLE_INDICATION_CFG_ADDR,m,v,HWIO_IPA_IDLE_INDICATION_CFG_IN)
#define HWIO_IPA_IDLE_INDICATION_CFG_IDLE_INDICATION_ENABLE_BMSK                                                     0x10000
#define HWIO_IPA_IDLE_INDICATION_CFG_IDLE_INDICATION_ENABLE_SHFT                                                        0x10
#define HWIO_IPA_IDLE_INDICATION_CFG_ENTER_IDLE_DEBOUNCE_THRESH_BMSK                                                  0xffff
#define HWIO_IPA_IDLE_INDICATION_CFG_ENTER_IDLE_DEBOUNCE_THRESH_SHFT                                                     0x0

#define HWIO_IPA_QTIME_TIMESTAMP_CFG_ADDR                                                                         (IPA_CFG_REG_BASE      + 0x000004ac)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_PHYS                                                                         (IPA_CFG_REG_BASE_PHYS + 0x000004ac)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_OFFS                                                                         (IPA_CFG_REG_BASE_OFFS + 0x000004ac)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_RMSK                                                                           0x1f1f9f
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_ATTR                                                                                0x3
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_IN          \
        in_dword_masked(HWIO_IPA_QTIME_TIMESTAMP_CFG_ADDR, HWIO_IPA_QTIME_TIMESTAMP_CFG_RMSK)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_QTIME_TIMESTAMP_CFG_ADDR, m)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_OUT(v)      \
        out_dword(HWIO_IPA_QTIME_TIMESTAMP_CFG_ADDR,v)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_QTIME_TIMESTAMP_CFG_ADDR,m,v,HWIO_IPA_QTIME_TIMESTAMP_CFG_IN)
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_NAT_TIMESTAMP_LSB_BMSK                                                         0x1f0000
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_NAT_TIMESTAMP_LSB_SHFT                                                             0x10
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_TAG_TIMESTAMP_LSB_BMSK                                                           0x1f00
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_TAG_TIMESTAMP_LSB_SHFT                                                              0x8
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_DPL_TIMESTAMP_SEL_BMSK                                                             0x80
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_DPL_TIMESTAMP_SEL_SHFT                                                              0x7
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_DPL_TIMESTAMP_LSB_BMSK                                                             0x1f
#define HWIO_IPA_QTIME_TIMESTAMP_CFG_DPL_TIMESTAMP_LSB_SHFT                                                              0x0

#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x000004b0)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x000004b0)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x000004b0)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_RMSK                                                                       0x800001ff
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ATTR                                                                              0x3
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_IN          \
        in_dword_masked(HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ADDR, HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_RMSK)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ADDR, m)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_OUT(v)      \
        out_dword(HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ADDR,v)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ADDR,m,v,HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_IN)
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ENABLE_BMSK                                                                0x80000000
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_ENABLE_SHFT                                                                      0x1f
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_VALUE_BMSK                                                                      0x1ff
#define HWIO_IPA_TIMERS_XO_CLK_DIV_CFG_VALUE_SHFT                                                                        0x0

#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x000004b4)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x000004b4)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x000004b4)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_RMSK                                                                            0xfff
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_ATTR                                                                              0x3
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_IN          \
        in_dword_masked(HWIO_IPA_TIMERS_PULSE_GRAN_CFG_ADDR, HWIO_IPA_TIMERS_PULSE_GRAN_CFG_RMSK)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_TIMERS_PULSE_GRAN_CFG_ADDR, m)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_OUT(v)      \
        out_dword(HWIO_IPA_TIMERS_PULSE_GRAN_CFG_ADDR,v)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_TIMERS_PULSE_GRAN_CFG_ADDR,m,v,HWIO_IPA_TIMERS_PULSE_GRAN_CFG_IN)
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_3_BMSK                                                                     0xe00
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_3_SHFT                                                                       0x9
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_2_BMSK                                                                     0x1c0
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_2_SHFT                                                                       0x6
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_1_BMSK                                                                      0x38
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_1_SHFT                                                                       0x3
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_0_BMSK                                                                       0x7
#define HWIO_IPA_TIMERS_PULSE_GRAN_CFG_GRAN_0_SHFT                                                                       0x0

#define HWIO_IPA_QTIME_SMP_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x000004b8)
#define HWIO_IPA_QTIME_SMP_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000004b8)
#define HWIO_IPA_QTIME_SMP_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000004b8)
#define HWIO_IPA_QTIME_SMP_RMSK                                                                                          0x1
#define HWIO_IPA_QTIME_SMP_ATTR                                                                                          0x2
#define HWIO_IPA_QTIME_SMP_OUT(v)      \
        out_dword(HWIO_IPA_QTIME_SMP_ADDR,v)
#define HWIO_IPA_QTIME_SMP_PULSE_BMSK                                                                                    0x1
#define HWIO_IPA_QTIME_SMP_PULSE_SHFT                                                                                    0x0

#define HWIO_IPA_QTIME_LSB_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x000004bc)
#define HWIO_IPA_QTIME_LSB_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000004bc)
#define HWIO_IPA_QTIME_LSB_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000004bc)
#define HWIO_IPA_QTIME_LSB_RMSK                                                                                   0xffffffff
#define HWIO_IPA_QTIME_LSB_ATTR                                                                                          0x1
#define HWIO_IPA_QTIME_LSB_IN          \
        in_dword_masked(HWIO_IPA_QTIME_LSB_ADDR, HWIO_IPA_QTIME_LSB_RMSK)
#define HWIO_IPA_QTIME_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_QTIME_LSB_ADDR, m)
#define HWIO_IPA_QTIME_LSB_VALUE_BMSK                                                                             0xffffffff
#define HWIO_IPA_QTIME_LSB_VALUE_SHFT                                                                                    0x0

#define HWIO_IPA_QTIME_MSB_ADDR                                                                                   (IPA_CFG_REG_BASE      + 0x000004c0)
#define HWIO_IPA_QTIME_MSB_PHYS                                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000004c0)
#define HWIO_IPA_QTIME_MSB_OFFS                                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000004c0)
#define HWIO_IPA_QTIME_MSB_RMSK                                                                                   0xffffffff
#define HWIO_IPA_QTIME_MSB_ATTR                                                                                          0x1
#define HWIO_IPA_QTIME_MSB_IN          \
        in_dword_masked(HWIO_IPA_QTIME_MSB_ADDR, HWIO_IPA_QTIME_MSB_RMSK)
#define HWIO_IPA_QTIME_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_QTIME_MSB_ADDR, m)
#define HWIO_IPA_QTIME_MSB_VALUE_BMSK                                                                             0xffffffff
#define HWIO_IPA_QTIME_MSB_VALUE_SHFT                                                                                    0x0

#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_ADDR                                                                   (IPA_CFG_REG_BASE      + 0x000004c4)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_PHYS                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000004c4)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_OFFS                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000004c4)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_RMSK                                                                         0xff
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_ATTR                                                                          0x3
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_IN          \
        in_dword_masked(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_ADDR, HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_RMSK)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_ADDR, m)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_OUT(v)      \
        out_dword(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_ADDR,v)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_ADDR,m,v,HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_IN)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_BMSK                                           0xff
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_IPA_SRC_RSRC_AMOUNT_REDUCE_EN_SHFT                                            0x0

#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR                                                             (IPA_CFG_REG_BASE      + 0x000004c8)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_PHYS                                                             (IPA_CFG_REG_BASE_PHYS + 0x000004c8)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_OFFS                                                             (IPA_CFG_REG_BASE_OFFS + 0x000004c8)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_RMSK                                                             0x3f3f3f3f
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_ATTR                                                                    0x3
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IN          \
        in_dword_masked(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR, HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_RMSK)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_INM(m)      \
        in_dword_masked(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR, m)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_OUT(v)      \
        out_dword(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR,v)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR,m,v,HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IN)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_3_BMSK                0x3f000000
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_3_SHFT                      0x18
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_2_BMSK                  0x3f0000
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_2_SHFT                      0x10
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_1_BMSK                    0x3f00
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_1_SHFT                       0x8
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_0_BMSK                      0x3f
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_0_SHFT                       0x0

#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_ADDR                                                             (IPA_CFG_REG_BASE      + 0x000004cc)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_PHYS                                                             (IPA_CFG_REG_BASE_PHYS + 0x000004cc)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_OFFS                                                             (IPA_CFG_REG_BASE_OFFS + 0x000004cc)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_RMSK                                                                   0x3f
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_ATTR                                                                    0x3
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_IN          \
        in_dword_masked(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_ADDR, HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_RMSK)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_INM(m)      \
        in_dword_masked(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_ADDR, m)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_OUT(v)      \
        out_dword(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_ADDR,v)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_ADDR,m,v,HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_IN)
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_4_BMSK                      0x3f
#define HWIO_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUES_1_IPA_SRC_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_4_SHFT                       0x0

#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_ADDR                                                                   (IPA_CFG_REG_BASE      + 0x000004d0)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_PHYS                                                                   (IPA_CFG_REG_BASE_PHYS + 0x000004d0)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_OFFS                                                                   (IPA_CFG_REG_BASE_OFFS + 0x000004d0)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_RMSK                                                                          0xf
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_ATTR                                                                          0x3
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_IN          \
        in_dword_masked(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_ADDR, HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_RMSK)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_INM(m)      \
        in_dword_masked(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_ADDR, m)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_OUT(v)      \
        out_dword(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_ADDR,v)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_ADDR,m,v,HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_IN)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_IPA_DST_RSRC_AMOUNT_REDUCE_EN_BMSK                                            0xf
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_EN_IPA_DST_RSRC_AMOUNT_REDUCE_EN_SHFT                                            0x0

#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR                                                             (IPA_CFG_REG_BASE      + 0x000004d4)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_PHYS                                                             (IPA_CFG_REG_BASE_PHYS + 0x000004d4)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_OFFS                                                             (IPA_CFG_REG_BASE_OFFS + 0x000004d4)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_RMSK                                                                 0x3f3f
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_ATTR                                                                    0x3
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_IN          \
        in_dword_masked(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR, HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_RMSK)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_INM(m)      \
        in_dword_masked(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR, m)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_OUT(v)      \
        out_dword(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR,v)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_ADDR,m,v,HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_IN)
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_DST_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_1_BMSK                    0x3f00
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_DST_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_1_SHFT                       0x8
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_DST_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_0_BMSK                      0x3f
#define HWIO_IPA_DST_RSRC_AMOUNT_REDUCE_VALUES_0_IPA_DST_RSRC_AMOUNT_REDUCE_VALUE_RSRC_TYPE_0_SHFT                       0x0

#define HWIO_IPA_ATOMIC_LOCK_CFG_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x000004d8)
#define HWIO_IPA_ATOMIC_LOCK_CFG_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x000004d8)
#define HWIO_IPA_ATOMIC_LOCK_CFG_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x000004d8)
#define HWIO_IPA_ATOMIC_LOCK_CFG_RMSK                                                                                   0x3f
#define HWIO_IPA_ATOMIC_LOCK_CFG_ATTR                                                                                    0x3
#define HWIO_IPA_ATOMIC_LOCK_CFG_IN          \
        in_dword_masked(HWIO_IPA_ATOMIC_LOCK_CFG_ADDR, HWIO_IPA_ATOMIC_LOCK_CFG_RMSK)
#define HWIO_IPA_ATOMIC_LOCK_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_ATOMIC_LOCK_CFG_ADDR, m)
#define HWIO_IPA_ATOMIC_LOCK_CFG_OUT(v)      \
        out_dword(HWIO_IPA_ATOMIC_LOCK_CFG_ADDR,v)
#define HWIO_IPA_ATOMIC_LOCK_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_ATOMIC_LOCK_CFG_ADDR,m,v,HWIO_IPA_ATOMIC_LOCK_CFG_IN)
#define HWIO_IPA_ATOMIC_LOCK_CFG_GROUPS_TO_MASK_BMSK                                                                    0x3f
#define HWIO_IPA_ATOMIC_LOCK_CFG_GROUPS_TO_MASK_SHFT                                                                     0x0

#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_ADDR                                                                (IPA_CFG_REG_BASE      + 0x000004dc)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_PHYS                                                                (IPA_CFG_REG_BASE_PHYS + 0x000004dc)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_OFFS                                                                (IPA_CFG_REG_BASE_OFFS + 0x000004dc)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_RMSK                                                                   0xffff3
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_ATTR                                                                       0x3
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_IN          \
        in_dword_masked(HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_ADDR, HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_RMSK)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_INM(m)      \
        in_dword_masked(HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_ADDR, m)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_OUT(v)      \
        out_dword(HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_ADDR,v)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_ADDR,m,v,HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_IN)
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_WR_PRIORITY_INDEX_BMSK                                                 0xff000
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_WR_PRIORITY_INDEX_SHFT                                                     0xc
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_RD_PRIORITY_INDEX_BMSK                                                   0xff0
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_RD_PRIORITY_INDEX_SHFT                                                     0x4
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_WR_PRIORITY_VALID_BMSK                                                     0x2
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_WR_PRIORITY_VALID_SHFT                                                     0x1
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_RD_PRIORITY_VALID_BMSK                                                     0x1
#define HWIO_IPA_GENERIC_RAM_ARBITER_PRIORITY_RD_PRIORITY_VALID_SHFT                                                     0x0

#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00000500 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000500 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000500 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_MAXn                                                                          4
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n), HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_1_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_1_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_1_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_1_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_0_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_0_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_0_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_SRC_RSRC_GRP_01_RSRC_TYPE_n_SRC_RSRC_GRP_0_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00000504 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000504 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000504 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_MAXn                                                                          4
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n), HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_3_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_3_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_3_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_3_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_2_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_2_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_2_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_SRC_RSRC_GRP_23_RSRC_TYPE_n_SRC_RSRC_GRP_2_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00000508 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000508 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000508 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_MAXn                                                                          4
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n), HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_5_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_5_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_5_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_5_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_4_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_4_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_4_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_SRC_RSRC_GRP_45_RSRC_TYPE_n_SRC_RSRC_GRP_4_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x0000050c + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x0000050c + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x0000050c + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_MAXn                                                                          4
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n), HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_7_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_7_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_7_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_7_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_6_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_6_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_6_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_SRC_RSRC_GRP_67_RSRC_TYPE_n_SRC_RSRC_GRP_6_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ADDR(n)                                                        (IPA_CFG_REG_BASE      + 0x00000510 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_PHYS(n)                                                        (IPA_CFG_REG_BASE_PHYS + 0x00000510 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_OFFS(n)                                                        (IPA_CFG_REG_BASE_OFFS + 0x00000510 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_RMSK                                                           0x3f3f3f3f
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_MAXn                                                                    4
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ATTR                                                                  0x1
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ADDR(n), HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_RMSK, HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ATTR)
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ADDR(n), mask, HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ATTR)
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_3_CNT_BMSK                                        0x3f000000
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_3_CNT_SHFT                                              0x18
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_2_CNT_BMSK                                          0x3f0000
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_2_CNT_SHFT                                              0x10
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_1_CNT_BMSK                                            0x3f00
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_1_CNT_SHFT                                               0x8
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_0_CNT_BMSK                                              0x3f
#define HWIO_IPA_SRC_RSRC_GRP_0123_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_0_CNT_SHFT                                               0x0

#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ADDR(n)                                                        (IPA_CFG_REG_BASE      + 0x00000514 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_PHYS(n)                                                        (IPA_CFG_REG_BASE_PHYS + 0x00000514 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_OFFS(n)                                                        (IPA_CFG_REG_BASE_OFFS + 0x00000514 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_RMSK                                                               0x3f3f
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_MAXn                                                                    4
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ATTR                                                                  0x1
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ADDR(n), HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_RMSK)
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ADDR(n), mask)
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_5_CNT_BMSK                                            0x3f00
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_5_CNT_SHFT                                               0x8
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_4_CNT_BMSK                                              0x3f
#define HWIO_IPA_SRC_RSRC_GRP_4567_RSRC_TYPE_CNT_n_SRC_RSRC_GRP_4_CNT_SHFT                                               0x0

#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_ADDR(n)                                                                   (IPA_CFG_REG_BASE      + 0x00000518 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_PHYS(n)                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000518 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_OFFS(n)                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000518 + 0x20 * (n))
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_RMSK                                                                            0x3f
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_MAXn                                                                               4
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_ATTR                                                                             0x1
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_ADDR(n), HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_RMSK)
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_ADDR(n), mask)
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_SRC_RSRC_TYPE_AMOUNT_BMSK                                                       0x3f
#define HWIO_IPA_SRC_RSRC_TYPE_AMOUNT_n_SRC_RSRC_TYPE_AMOUNT_SHFT                                                        0x0

#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00000600 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000600 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000600 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_MAXn                                                                          2
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n), HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_1_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_1_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_1_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_1_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_0_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_0_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_0_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_DST_RSRC_GRP_01_RSRC_TYPE_n_DST_RSRC_GRP_0_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00000604 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000604 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000604 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_MAXn                                                                          2
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n), HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_3_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_3_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_3_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_3_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_2_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_2_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_2_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_DST_RSRC_GRP_23_RSRC_TYPE_n_DST_RSRC_GRP_2_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00000608 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000608 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000608 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_RMSK                                                                 0x3f3f3f3f
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_MAXn                                                                          2
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n), HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_5_MAX_LIMIT_BMSK                                        0x3f000000
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_5_MAX_LIMIT_SHFT                                              0x18
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_5_MIN_LIMIT_BMSK                                          0x3f0000
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_5_MIN_LIMIT_SHFT                                              0x10
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_4_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_4_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_4_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_DST_RSRC_GRP_45_RSRC_TYPE_n_DST_RSRC_GRP_4_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x0000060c + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x0000060c + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x0000060c + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_RMSK                                                                     0x3f3f
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_MAXn                                                                          2
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_ATTR                                                                        0x3
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n), HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_RMSK)
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n), mask)
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n),val)
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_ADDR(n),mask,val,HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_INI(n))
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_DST_RSRC_GRP_6_MAX_LIMIT_BMSK                                            0x3f00
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_DST_RSRC_GRP_6_MAX_LIMIT_SHFT                                               0x8
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_DST_RSRC_GRP_6_MIN_LIMIT_BMSK                                              0x3f
#define HWIO_IPA_DST_RSRC_GRP_67_RSRC_TYPE_n_DST_RSRC_GRP_6_MIN_LIMIT_SHFT                                               0x0

#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ADDR(n)                                                        (IPA_CFG_REG_BASE      + 0x00000610 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_PHYS(n)                                                        (IPA_CFG_REG_BASE_PHYS + 0x00000610 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_OFFS(n)                                                        (IPA_CFG_REG_BASE_OFFS + 0x00000610 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_RMSK                                                           0x3f3f3f3f
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_MAXn                                                                    2
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ATTR                                                                  0x1
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ADDR(n), HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_RMSK, HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ATTR)
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ADDR(n), mask, HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_ATTR)
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_3_CNT_BMSK                                        0x3f000000
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_3_CNT_SHFT                                              0x18
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_2_CNT_BMSK                                          0x3f0000
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_2_CNT_SHFT                                              0x10
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_1_CNT_BMSK                                            0x3f00
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_1_CNT_SHFT                                               0x8
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_0_CNT_BMSK                                              0x3f
#define HWIO_IPA_DST_RSRC_GRP_0123_RSRC_TYPE_CNT_n_DST_RSRC_GRP_0_CNT_SHFT                                               0x0

#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ADDR(n)                                                        (IPA_CFG_REG_BASE      + 0x00000614 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_PHYS(n)                                                        (IPA_CFG_REG_BASE_PHYS + 0x00000614 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_OFFS(n)                                                        (IPA_CFG_REG_BASE_OFFS + 0x00000614 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_RMSK                                                             0xffffff
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_MAXn                                                                    2
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ATTR                                                                  0x1
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ADDR(n), HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_RMSK)
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_ADDR(n), mask)
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_DST_RSRC_GRP_6_CNT_BMSK                                          0xff0000
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_DST_RSRC_GRP_6_CNT_SHFT                                              0x10
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_DST_RSRC_GRP_5_CNT_BMSK                                            0xff00
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_DST_RSRC_GRP_5_CNT_SHFT                                               0x8
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_DST_RSRC_GRP_4_CNT_BMSK                                              0xff
#define HWIO_IPA_DST_RSRC_GRP_4567_RSRC_TYPE_CNT_n_DST_RSRC_GRP_4_CNT_SHFT                                               0x0

#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_ADDR(n)                                                                   (IPA_CFG_REG_BASE      + 0x00000618 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_PHYS(n)                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00000618 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_OFFS(n)                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00000618 + 0x20 * (n))
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_RMSK                                                                            0x3f
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_MAXn                                                                               2
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_ATTR                                                                             0x1
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_ADDR(n), HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_RMSK)
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_ADDR(n), mask)
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_DST_RSRC_TYPE_AMOUNT_BMSK                                                       0x3f
#define HWIO_IPA_DST_RSRC_TYPE_AMOUNT_n_DST_RSRC_TYPE_AMOUNT_SHFT                                                        0x0

#define HWIO_IPA_RX_CFG_ADDR                                                                                      (IPA_CFG_REG_BASE      + 0x00000698)
#define HWIO_IPA_RX_CFG_PHYS                                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00000698)
#define HWIO_IPA_RX_CFG_OFFS                                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00000698)
#define HWIO_IPA_RX_CFG_RMSK                                                                                             0x3
#define HWIO_IPA_RX_CFG_ATTR                                                                                             0x3
#define HWIO_IPA_RX_CFG_IN          \
        in_dword_masked(HWIO_IPA_RX_CFG_ADDR, HWIO_IPA_RX_CFG_RMSK)
#define HWIO_IPA_RX_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RX_CFG_ADDR, m)
#define HWIO_IPA_RX_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RX_CFG_ADDR,v)
#define HWIO_IPA_RX_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RX_CFG_ADDR,m,v,HWIO_IPA_RX_CFG_IN)
#define HWIO_IPA_RX_CFG_RX_CMDQ_SPLITTER_CMDQ_PENDING_MUX_DISABLE_BMSK                                                   0x2
#define HWIO_IPA_RX_CFG_RX_CMDQ_SPLITTER_CMDQ_PENDING_MUX_DISABLE_SHFT                                                   0x1
#define HWIO_IPA_RX_CFG_CMDQ_SPLIT_NOT_WAIT_DATA_DESC_PRIOR_HDR_PUSH_BMSK                                                0x1
#define HWIO_IPA_RX_CFG_CMDQ_SPLIT_NOT_WAIT_DATA_DESC_PRIOR_HDR_PUSH_SHFT                                                0x0

#define HWIO_IPA_RSRC_GRP_CFG_ADDR                                                                                (IPA_CFG_REG_BASE      + 0x000006a0)
#define HWIO_IPA_RSRC_GRP_CFG_PHYS                                                                                (IPA_CFG_REG_BASE_PHYS + 0x000006a0)
#define HWIO_IPA_RSRC_GRP_CFG_OFFS                                                                                (IPA_CFG_REG_BASE_OFFS + 0x000006a0)
#define HWIO_IPA_RSRC_GRP_CFG_RMSK                                                                                0x3f1ff171
#define HWIO_IPA_RSRC_GRP_CFG_ATTR                                                                                       0x3
#define HWIO_IPA_RSRC_GRP_CFG_IN          \
        in_dword_masked(HWIO_IPA_RSRC_GRP_CFG_ADDR, HWIO_IPA_RSRC_GRP_CFG_RMSK)
#define HWIO_IPA_RSRC_GRP_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_GRP_CFG_ADDR, m)
#define HWIO_IPA_RSRC_GRP_CFG_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_GRP_CFG_ADDR,v)
#define HWIO_IPA_RSRC_GRP_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_GRP_CFG_ADDR,m,v,HWIO_IPA_RSRC_GRP_CFG_IN)
#define HWIO_IPA_RSRC_GRP_CFG_DST_GRP_SPECIAL_INDEX_BMSK                                                          0x3f000000
#define HWIO_IPA_RSRC_GRP_CFG_DST_GRP_SPECIAL_INDEX_SHFT                                                                0x18
#define HWIO_IPA_RSRC_GRP_CFG_DST_GRP_SPECIAL_VALID_BMSK                                                            0x100000
#define HWIO_IPA_RSRC_GRP_CFG_DST_GRP_SPECIAL_VALID_SHFT                                                                0x14
#define HWIO_IPA_RSRC_GRP_CFG_DST_PIPE_SPECIAL_INDEX_BMSK                                                            0xff000
#define HWIO_IPA_RSRC_GRP_CFG_DST_PIPE_SPECIAL_INDEX_SHFT                                                                0xc
#define HWIO_IPA_RSRC_GRP_CFG_DST_PIPE_SPECIAL_VALID_BMSK                                                              0x100
#define HWIO_IPA_RSRC_GRP_CFG_DST_PIPE_SPECIAL_VALID_SHFT                                                                0x8
#define HWIO_IPA_RSRC_GRP_CFG_SRC_GRP_SPECIAL_INDEX_BMSK                                                                0x70
#define HWIO_IPA_RSRC_GRP_CFG_SRC_GRP_SPECIAL_INDEX_SHFT                                                                 0x4
#define HWIO_IPA_RSRC_GRP_CFG_SRC_GRP_SPECIAL_VALID_BMSK                                                                 0x1
#define HWIO_IPA_RSRC_GRP_CFG_SRC_GRP_SPECIAL_VALID_SHFT                                                                 0x0

#define HWIO_IPA_RSRC_GRP_CFG_EXT_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x000006a4)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x000006a4)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x000006a4)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_RMSK                                                                                  0x71
#define HWIO_IPA_RSRC_GRP_CFG_EXT_ATTR                                                                                   0x3
#define HWIO_IPA_RSRC_GRP_CFG_EXT_IN          \
        in_dword_masked(HWIO_IPA_RSRC_GRP_CFG_EXT_ADDR, HWIO_IPA_RSRC_GRP_CFG_EXT_RMSK)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_INM(m)      \
        in_dword_masked(HWIO_IPA_RSRC_GRP_CFG_EXT_ADDR, m)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_OUT(v)      \
        out_dword(HWIO_IPA_RSRC_GRP_CFG_EXT_ADDR,v)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_RSRC_GRP_CFG_EXT_ADDR,m,v,HWIO_IPA_RSRC_GRP_CFG_EXT_IN)
#define HWIO_IPA_RSRC_GRP_CFG_EXT_SRC_GRP_2ND_PRIORITY_SPECIAL_INDEX_BMSK                                               0x70
#define HWIO_IPA_RSRC_GRP_CFG_EXT_SRC_GRP_2ND_PRIORITY_SPECIAL_INDEX_SHFT                                                0x4
#define HWIO_IPA_RSRC_GRP_CFG_EXT_SRC_GRP_2ND_PRIORITY_SPECIAL_VALID_BMSK                                                0x1
#define HWIO_IPA_RSRC_GRP_CFG_EXT_SRC_GRP_2ND_PRIORITY_SPECIAL_VALID_SHFT                                                0x0

#define HWIO_IPA_AXI_CFG_ADDR                                                                                     (IPA_CFG_REG_BASE      + 0x000006ac)
#define HWIO_IPA_AXI_CFG_PHYS                                                                                     (IPA_CFG_REG_BASE_PHYS + 0x000006ac)
#define HWIO_IPA_AXI_CFG_OFFS                                                                                     (IPA_CFG_REG_BASE_OFFS + 0x000006ac)
#define HWIO_IPA_AXI_CFG_RMSK                                                                                            0xf
#define HWIO_IPA_AXI_CFG_ATTR                                                                                            0x3
#define HWIO_IPA_AXI_CFG_IN          \
        in_dword_masked(HWIO_IPA_AXI_CFG_ADDR, HWIO_IPA_AXI_CFG_RMSK)
#define HWIO_IPA_AXI_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_AXI_CFG_ADDR, m)
#define HWIO_IPA_AXI_CFG_OUT(v)      \
        out_dword(HWIO_IPA_AXI_CFG_ADDR,v)
#define HWIO_IPA_AXI_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_AXI_CFG_ADDR,m,v,HWIO_IPA_AXI_CFG_IN)
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_IPA_WR_BMSK                                                                    0x8
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_IPA_WR_SHFT                                                                    0x3
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_IPA_RD_BMSK                                                                    0x4
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_IPA_RD_SHFT                                                                    0x2
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_GSI_WR_BMSK                                                                    0x2
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_GSI_WR_SHFT                                                                    0x1
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_GSI_RD_BMSK                                                                    0x1
#define HWIO_IPA_AXI_CFG_RELAXED_ORDERING_GSI_RD_SHFT                                                                    0x0

#define HWIO_IPA_AGGR_FORCE_CLOSE_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x000006b0 + 0x4 * (n))
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x000006b0 + 0x4 * (n))
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x000006b0 + 0x4 * (n))
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_RMSK                                                                          0xffffffff
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_MAXn                                                                                   1
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_ATTR                                                                                 0x2
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_AGGR_FORCE_CLOSE_n_ADDR(n),val)
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_AGGR_FORCE_CLOSE_PIPE_BITMAP_BMSK                                             0xffffffff
#define HWIO_IPA_AGGR_FORCE_CLOSE_n_AGGR_FORCE_CLOSE_PIPE_BITMAP_SHFT                                                    0x0

#define HWIO_IPA_STAT_QUOTA_BASE_n_ADDR(n)                                                                        (IPA_CFG_REG_BASE      + 0x000006d0 + 0x4 * (n))
#define HWIO_IPA_STAT_QUOTA_BASE_n_PHYS(n)                                                                        (IPA_CFG_REG_BASE_PHYS + 0x000006d0 + 0x4 * (n))
#define HWIO_IPA_STAT_QUOTA_BASE_n_OFFS(n)                                                                        (IPA_CFG_REG_BASE_OFFS + 0x000006d0 + 0x4 * (n))
#define HWIO_IPA_STAT_QUOTA_BASE_n_RMSK                                                                              0x7ffff
#define HWIO_IPA_STAT_QUOTA_BASE_n_MAXn                                                                                    1
#define HWIO_IPA_STAT_QUOTA_BASE_n_ATTR                                                                                  0x3
#define HWIO_IPA_STAT_QUOTA_BASE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STAT_QUOTA_BASE_n_ADDR(n), HWIO_IPA_STAT_QUOTA_BASE_n_RMSK)
#define HWIO_IPA_STAT_QUOTA_BASE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STAT_QUOTA_BASE_n_ADDR(n), mask)
#define HWIO_IPA_STAT_QUOTA_BASE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_STAT_QUOTA_BASE_n_ADDR(n),val)
#define HWIO_IPA_STAT_QUOTA_BASE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_STAT_QUOTA_BASE_n_ADDR(n),mask,val,HWIO_IPA_STAT_QUOTA_BASE_n_INI(n))
#define HWIO_IPA_STAT_QUOTA_BASE_n_BASE_ADDR_BMSK                                                                    0x7fff8
#define HWIO_IPA_STAT_QUOTA_BASE_n_BASE_ADDR_SHFT                                                                        0x3
#define HWIO_IPA_STAT_QUOTA_BASE_n_BASE_ADDR_OFFSET_BMSK                                                                 0x7
#define HWIO_IPA_STAT_QUOTA_BASE_n_BASE_ADDR_OFFSET_SHFT                                                                 0x0

#define HWIO_IPA_STAT_TETHERING_BASE_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x000006e0 + 0x4 * (n))
#define HWIO_IPA_STAT_TETHERING_BASE_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x000006e0 + 0x4 * (n))
#define HWIO_IPA_STAT_TETHERING_BASE_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x000006e0 + 0x4 * (n))
#define HWIO_IPA_STAT_TETHERING_BASE_n_RMSK                                                                          0x7ffff
#define HWIO_IPA_STAT_TETHERING_BASE_n_MAXn                                                                                1
#define HWIO_IPA_STAT_TETHERING_BASE_n_ATTR                                                                              0x3
#define HWIO_IPA_STAT_TETHERING_BASE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STAT_TETHERING_BASE_n_ADDR(n), HWIO_IPA_STAT_TETHERING_BASE_n_RMSK)
#define HWIO_IPA_STAT_TETHERING_BASE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STAT_TETHERING_BASE_n_ADDR(n), mask)
#define HWIO_IPA_STAT_TETHERING_BASE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_STAT_TETHERING_BASE_n_ADDR(n),val)
#define HWIO_IPA_STAT_TETHERING_BASE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_STAT_TETHERING_BASE_n_ADDR(n),mask,val,HWIO_IPA_STAT_TETHERING_BASE_n_INI(n))
#define HWIO_IPA_STAT_TETHERING_BASE_n_BASE_ADDR_BMSK                                                                0x7fff8
#define HWIO_IPA_STAT_TETHERING_BASE_n_BASE_ADDR_SHFT                                                                    0x3
#define HWIO_IPA_STAT_TETHERING_BASE_n_BASE_ADDR_OFFSET_BMSK                                                             0x7
#define HWIO_IPA_STAT_TETHERING_BASE_n_BASE_ADDR_OFFSET_SHFT                                                             0x0

#define HWIO_IPA_STAT_DROP_CNT_BASE_n_ADDR(n)                                                                     (IPA_CFG_REG_BASE      + 0x000006f0 + 0x4 * (n))
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_PHYS(n)                                                                     (IPA_CFG_REG_BASE_PHYS + 0x000006f0 + 0x4 * (n))
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_OFFS(n)                                                                     (IPA_CFG_REG_BASE_OFFS + 0x000006f0 + 0x4 * (n))
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_RMSK                                                                           0x7ffff
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_MAXn                                                                                 1
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_ATTR                                                                               0x3
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_STAT_DROP_CNT_BASE_n_ADDR(n), HWIO_IPA_STAT_DROP_CNT_BASE_n_RMSK)
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_STAT_DROP_CNT_BASE_n_ADDR(n), mask)
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_STAT_DROP_CNT_BASE_n_ADDR(n),val)
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_STAT_DROP_CNT_BASE_n_ADDR(n),mask,val,HWIO_IPA_STAT_DROP_CNT_BASE_n_INI(n))
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_BASE_ADDR_BMSK                                                                 0x7fff8
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_BASE_ADDR_SHFT                                                                     0x3
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_BASE_ADDR_OFFSET_BMSK                                                              0x7
#define HWIO_IPA_STAT_DROP_CNT_BASE_n_BASE_ADDR_OFFSET_SHFT                                                              0x0

#define HWIO_IPA_STAT_FILTER_IPV4_BASE_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x00000700)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000700)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000700)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_RMSK                                                                          0x7ffff
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_ATTR                                                                              0x3
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_IN          \
        in_dword_masked(HWIO_IPA_STAT_FILTER_IPV4_BASE_ADDR, HWIO_IPA_STAT_FILTER_IPV4_BASE_RMSK)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_INM(m)      \
        in_dword_masked(HWIO_IPA_STAT_FILTER_IPV4_BASE_ADDR, m)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_OUT(v)      \
        out_dword(HWIO_IPA_STAT_FILTER_IPV4_BASE_ADDR,v)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STAT_FILTER_IPV4_BASE_ADDR,m,v,HWIO_IPA_STAT_FILTER_IPV4_BASE_IN)
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_BASE_ADDR_BMSK                                                                0x7fff8
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_BASE_ADDR_SHFT                                                                    0x3
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_BASE_ADDR_OFFSET_BMSK                                                             0x7
#define HWIO_IPA_STAT_FILTER_IPV4_BASE_BASE_ADDR_OFFSET_SHFT                                                             0x0

#define HWIO_IPA_STAT_FILTER_IPV6_BASE_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x00000704)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000704)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000704)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_RMSK                                                                          0x7ffff
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_ATTR                                                                              0x3
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_IN          \
        in_dword_masked(HWIO_IPA_STAT_FILTER_IPV6_BASE_ADDR, HWIO_IPA_STAT_FILTER_IPV6_BASE_RMSK)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_INM(m)      \
        in_dword_masked(HWIO_IPA_STAT_FILTER_IPV6_BASE_ADDR, m)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_OUT(v)      \
        out_dword(HWIO_IPA_STAT_FILTER_IPV6_BASE_ADDR,v)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STAT_FILTER_IPV6_BASE_ADDR,m,v,HWIO_IPA_STAT_FILTER_IPV6_BASE_IN)
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_BASE_ADDR_BMSK                                                                0x7fff8
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_BASE_ADDR_SHFT                                                                    0x3
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_BASE_ADDR_OFFSET_BMSK                                                             0x7
#define HWIO_IPA_STAT_FILTER_IPV6_BASE_BASE_ADDR_OFFSET_SHFT                                                             0x0

#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x00000708)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000708)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000708)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_RMSK                                                                          0x7ffff
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_ATTR                                                                              0x3
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_IN          \
        in_dword_masked(HWIO_IPA_STAT_ROUTER_IPV4_BASE_ADDR, HWIO_IPA_STAT_ROUTER_IPV4_BASE_RMSK)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_INM(m)      \
        in_dword_masked(HWIO_IPA_STAT_ROUTER_IPV4_BASE_ADDR, m)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_OUT(v)      \
        out_dword(HWIO_IPA_STAT_ROUTER_IPV4_BASE_ADDR,v)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STAT_ROUTER_IPV4_BASE_ADDR,m,v,HWIO_IPA_STAT_ROUTER_IPV4_BASE_IN)
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_BASE_ADDR_BMSK                                                                0x7fff8
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_BASE_ADDR_SHFT                                                                    0x3
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_BASE_ADDR_OFFSET_BMSK                                                             0x7
#define HWIO_IPA_STAT_ROUTER_IPV4_BASE_BASE_ADDR_OFFSET_SHFT                                                             0x0

#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_ADDR                                                                       (IPA_CFG_REG_BASE      + 0x0000070c)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_PHYS                                                                       (IPA_CFG_REG_BASE_PHYS + 0x0000070c)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_OFFS                                                                       (IPA_CFG_REG_BASE_OFFS + 0x0000070c)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_RMSK                                                                          0x7ffff
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_ATTR                                                                              0x3
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_IN          \
        in_dword_masked(HWIO_IPA_STAT_ROUTER_IPV6_BASE_ADDR, HWIO_IPA_STAT_ROUTER_IPV6_BASE_RMSK)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_INM(m)      \
        in_dword_masked(HWIO_IPA_STAT_ROUTER_IPV6_BASE_ADDR, m)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_OUT(v)      \
        out_dword(HWIO_IPA_STAT_ROUTER_IPV6_BASE_ADDR,v)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_STAT_ROUTER_IPV6_BASE_ADDR,m,v,HWIO_IPA_STAT_ROUTER_IPV6_BASE_IN)
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_BASE_ADDR_BMSK                                                                0x7fff8
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_BASE_ADDR_SHFT                                                                    0x3
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_BASE_ADDR_OFFSET_BMSK                                                             0x7
#define HWIO_IPA_STAT_ROUTER_IPV6_BASE_BASE_ADDR_OFFSET_SHFT                                                             0x0

#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_ADDR(n,k)                                                             (IPA_CFG_REG_BASE      + 0x00000710 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_PHYS(n,k)                                                             (IPA_CFG_REG_BASE_PHYS + 0x00000710 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_OFFS(n,k)                                                             (IPA_CFG_REG_BASE_OFFS + 0x00000710 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_RMSK                                                                  0xffffffff
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_MAXn                                                                           1
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_MAXk                                                                           1
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_ATTR                                                                         0x3
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_ADDR(n,k), HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_RMSK)
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_ADDR(n,k),mask,val,HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_INI2(n,k))
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_PIPE_MASK_BMSK                                                        0xffffffff
#define HWIO_IPA_STAT_QUOTA_MASK_EE_n_REG_k_PIPE_MASK_SHFT                                                               0x0

#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_ADDR(n,k)                                                         (IPA_CFG_REG_BASE      + 0x00000750 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_PHYS(n,k)                                                         (IPA_CFG_REG_BASE_PHYS + 0x00000750 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_OFFS(n,k)                                                         (IPA_CFG_REG_BASE_OFFS + 0x00000750 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_RMSK                                                              0xffffffff
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_MAXn                                                                       1
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_MAXk                                                                       1
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_ATTR                                                                     0x3
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_ADDR(n,k), HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_RMSK)
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_ADDR(n,k),mask,val,HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_INI2(n,k))
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_PIPE_MASK_BMSK                                                    0xffffffff
#define HWIO_IPA_STAT_TETHERING_MASK_EE_n_REG_k_PIPE_MASK_SHFT                                                           0x0

#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_ADDR(n,k)                                                          (IPA_CFG_REG_BASE      + 0x00000790 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_PHYS(n,k)                                                          (IPA_CFG_REG_BASE_PHYS + 0x00000790 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_OFFS(n,k)                                                          (IPA_CFG_REG_BASE_OFFS + 0x00000790 + 0x4 * (n) + 0x8 * (k))
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_RMSK                                                               0xffffffff
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_MAXn                                                                        1
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_MAXk                                                                        1
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_ATTR                                                                      0x3
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_ADDR(n,k), HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_RMSK)
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_ADDR(n,k), mask)
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_ADDR(n,k),val)
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_ADDR(n,k),mask,val,HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_INI2(n,k))
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_PIPE_MASK_BMSK                                                     0xffffffff
#define HWIO_IPA_STAT_DROP_CNT_MASK_EE_n_REG_k_PIPE_MASK_SHFT                                                            0x0

#define HWIO_IPA_NLO_PP_CFG1_ADDR                                                                                 (IPA_CFG_REG_BASE      + 0x000007d0)
#define HWIO_IPA_NLO_PP_CFG1_PHYS                                                                                 (IPA_CFG_REG_BASE_PHYS + 0x000007d0)
#define HWIO_IPA_NLO_PP_CFG1_OFFS                                                                                 (IPA_CFG_REG_BASE_OFFS + 0x000007d0)
#define HWIO_IPA_NLO_PP_CFG1_RMSK                                                                                 0xffffffff
#define HWIO_IPA_NLO_PP_CFG1_ATTR                                                                                        0x3
#define HWIO_IPA_NLO_PP_CFG1_IN          \
        in_dword_masked(HWIO_IPA_NLO_PP_CFG1_ADDR, HWIO_IPA_NLO_PP_CFG1_RMSK)
#define HWIO_IPA_NLO_PP_CFG1_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_PP_CFG1_ADDR, m)
#define HWIO_IPA_NLO_PP_CFG1_OUT(v)      \
        out_dword(HWIO_IPA_NLO_PP_CFG1_ADDR,v)
#define HWIO_IPA_NLO_PP_CFG1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NLO_PP_CFG1_ADDR,m,v,HWIO_IPA_NLO_PP_CFG1_IN)
#define HWIO_IPA_NLO_PP_CFG1_NLO_ACK_MAX_VP_BMSK                                                                  0xff000000
#define HWIO_IPA_NLO_PP_CFG1_NLO_ACK_MAX_VP_SHFT                                                                        0x18
#define HWIO_IPA_NLO_PP_CFG1_NLO_STATUS_PP_BMSK                                                                     0xff0000
#define HWIO_IPA_NLO_PP_CFG1_NLO_STATUS_PP_SHFT                                                                         0x10
#define HWIO_IPA_NLO_PP_CFG1_NLO_DATA_PP_BMSK                                                                         0xff00
#define HWIO_IPA_NLO_PP_CFG1_NLO_DATA_PP_SHFT                                                                            0x8
#define HWIO_IPA_NLO_PP_CFG1_NLO_ACK_PP_BMSK                                                                            0xff
#define HWIO_IPA_NLO_PP_CFG1_NLO_ACK_PP_SHFT                                                                             0x0

#define HWIO_IPA_NLO_PP_CFG2_ADDR                                                                                 (IPA_CFG_REG_BASE      + 0x000007d4)
#define HWIO_IPA_NLO_PP_CFG2_PHYS                                                                                 (IPA_CFG_REG_BASE_PHYS + 0x000007d4)
#define HWIO_IPA_NLO_PP_CFG2_OFFS                                                                                 (IPA_CFG_REG_BASE_OFFS + 0x000007d4)
#define HWIO_IPA_NLO_PP_CFG2_RMSK                                                                                    0x7ffff
#define HWIO_IPA_NLO_PP_CFG2_ATTR                                                                                        0x3
#define HWIO_IPA_NLO_PP_CFG2_IN          \
        in_dword_masked(HWIO_IPA_NLO_PP_CFG2_ADDR, HWIO_IPA_NLO_PP_CFG2_RMSK)
#define HWIO_IPA_NLO_PP_CFG2_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_PP_CFG2_ADDR, m)
#define HWIO_IPA_NLO_PP_CFG2_OUT(v)      \
        out_dword(HWIO_IPA_NLO_PP_CFG2_ADDR,v)
#define HWIO_IPA_NLO_PP_CFG2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NLO_PP_CFG2_ADDR,m,v,HWIO_IPA_NLO_PP_CFG2_IN)
#define HWIO_IPA_NLO_PP_CFG2_NLO_STATUS_BUFFER_MODE_BMSK                                                             0x40000
#define HWIO_IPA_NLO_PP_CFG2_NLO_STATUS_BUFFER_MODE_SHFT                                                                0x12
#define HWIO_IPA_NLO_PP_CFG2_NLO_DATA_BUFFER_MODE_BMSK                                                               0x20000
#define HWIO_IPA_NLO_PP_CFG2_NLO_DATA_BUFFER_MODE_SHFT                                                                  0x11
#define HWIO_IPA_NLO_PP_CFG2_NLO_ACK_BUFFER_MODE_BMSK                                                                0x10000
#define HWIO_IPA_NLO_PP_CFG2_NLO_ACK_BUFFER_MODE_SHFT                                                                   0x10
#define HWIO_IPA_NLO_PP_CFG2_NLO_DATA_CLOSE_PADD_BMSK                                                                 0xff00
#define HWIO_IPA_NLO_PP_CFG2_NLO_DATA_CLOSE_PADD_SHFT                                                                    0x8
#define HWIO_IPA_NLO_PP_CFG2_NLO_ACK_CLOSE_PADD_BMSK                                                                    0xff
#define HWIO_IPA_NLO_PP_CFG2_NLO_ACK_CLOSE_PADD_SHFT                                                                     0x0

#define HWIO_IPA_NLO_MIN_DSM_CFG_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x000007d8)
#define HWIO_IPA_NLO_MIN_DSM_CFG_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x000007d8)
#define HWIO_IPA_NLO_MIN_DSM_CFG_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x000007d8)
#define HWIO_IPA_NLO_MIN_DSM_CFG_RMSK                                                                             0xffffffff
#define HWIO_IPA_NLO_MIN_DSM_CFG_ATTR                                                                                    0x3
#define HWIO_IPA_NLO_MIN_DSM_CFG_IN          \
        in_dword_masked(HWIO_IPA_NLO_MIN_DSM_CFG_ADDR, HWIO_IPA_NLO_MIN_DSM_CFG_RMSK)
#define HWIO_IPA_NLO_MIN_DSM_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_MIN_DSM_CFG_ADDR, m)
#define HWIO_IPA_NLO_MIN_DSM_CFG_OUT(v)      \
        out_dword(HWIO_IPA_NLO_MIN_DSM_CFG_ADDR,v)
#define HWIO_IPA_NLO_MIN_DSM_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NLO_MIN_DSM_CFG_ADDR,m,v,HWIO_IPA_NLO_MIN_DSM_CFG_IN)
#define HWIO_IPA_NLO_MIN_DSM_CFG_NLO_DATA_MIN_DSM_LEN_BMSK                                                        0xffff0000
#define HWIO_IPA_NLO_MIN_DSM_CFG_NLO_DATA_MIN_DSM_LEN_SHFT                                                              0x10
#define HWIO_IPA_NLO_MIN_DSM_CFG_NLO_ACK_MIN_DSM_LEN_BMSK                                                             0xffff
#define HWIO_IPA_NLO_MIN_DSM_CFG_NLO_ACK_MIN_DSM_LEN_SHFT                                                                0x0

#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x00000800 + 0x8 * (n))
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00000800 + 0x8 * (n))
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00000800 + 0x8 * (n))
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_RMSK                                                                          0x7ffff
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_MAXn                                                                               31
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_ATTR                                                                              0x3
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_INI(n)        \
        in_dword_masked(HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_ADDR(n), HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_RMSK)
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_ADDR(n), mask)
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_ADDR(n),val)
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_ADDR(n),mask,val,HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_INI(n))
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_AGGR_GRAN_SEL_BMSK                                                         0x40000
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_AGGR_GRAN_SEL_SHFT                                                            0x12
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_HARD_BYTE_LIMIT_EN_BMSK                                                    0x20000
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_HARD_BYTE_LIMIT_EN_SHFT                                                       0x11
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_BYTE_LIMIT_BMSK                                                            0x1f800
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_BYTE_LIMIT_SHFT                                                                0xb
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_TIME_LIMIT_BMSK                                                              0x7c0
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_TIME_LIMIT_SHFT                                                                0x6
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_PKT_LIMIT_BMSK                                                                0x3f
#define HWIO_IPA_NLO_VP_AGGR_CFG_LSB_n_VP_PKT_LIMIT_SHFT                                                                 0x0

#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x00000804 + 0x8 * (n))
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00000804 + 0x8 * (n))
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00000804 + 0x8 * (n))
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_RMSK                                                                          0xffffffff
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_MAXn                                                                                  31
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_ATTR                                                                                 0x3
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_NLO_VP_LIMIT_CFG_n_ADDR(n), HWIO_IPA_NLO_VP_LIMIT_CFG_n_RMSK)
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_NLO_VP_LIMIT_CFG_n_ADDR(n), mask)
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_NLO_VP_LIMIT_CFG_n_ADDR(n),val)
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_NLO_VP_LIMIT_CFG_n_ADDR(n),mask,val,HWIO_IPA_NLO_VP_LIMIT_CFG_n_INI(n))
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_UPPER_SIZE_BMSK                                                               0xffff0000
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_UPPER_SIZE_SHFT                                                                     0x10
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_LOWER_SIZE_BMSK                                                                   0xffff
#define HWIO_IPA_NLO_VP_LIMIT_CFG_n_LOWER_SIZE_SHFT                                                                      0x0

#define HWIO_IPA_NLO_VP_FLUSH_REQ_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x00000900)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00000900)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00000900)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_RMSK                                                                            0x80ff00ff
#define HWIO_IPA_NLO_VP_FLUSH_REQ_ATTR                                                                                   0x3
#define HWIO_IPA_NLO_VP_FLUSH_REQ_IN          \
        in_dword_masked(HWIO_IPA_NLO_VP_FLUSH_REQ_ADDR, HWIO_IPA_NLO_VP_FLUSH_REQ_RMSK)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_VP_FLUSH_REQ_ADDR, m)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_OUT(v)      \
        out_dword(HWIO_IPA_NLO_VP_FLUSH_REQ_ADDR,v)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_NLO_VP_FLUSH_REQ_ADDR,m,v,HWIO_IPA_NLO_VP_FLUSH_REQ_IN)
#define HWIO_IPA_NLO_VP_FLUSH_REQ_VP_FLUSH_REQ_BMSK                                                               0x80000000
#define HWIO_IPA_NLO_VP_FLUSH_REQ_VP_FLUSH_REQ_SHFT                                                                     0x1f
#define HWIO_IPA_NLO_VP_FLUSH_REQ_VP_FLUSH_VP_INDX_BMSK                                                             0xff0000
#define HWIO_IPA_NLO_VP_FLUSH_REQ_VP_FLUSH_VP_INDX_SHFT                                                                 0x10
#define HWIO_IPA_NLO_VP_FLUSH_REQ_VP_FLUSH_PP_INDX_BMSK                                                                 0xff
#define HWIO_IPA_NLO_VP_FLUSH_REQ_VP_FLUSH_PP_INDX_SHFT                                                                  0x0

#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_ADDR                                                                         (IPA_CFG_REG_BASE      + 0x00000904)
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_PHYS                                                                         (IPA_CFG_REG_BASE_PHYS + 0x00000904)
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_OFFS                                                                         (IPA_CFG_REG_BASE_OFFS + 0x00000904)
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_RMSK                                                                         0xffffffff
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_ATTR                                                                                0x1
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_IN          \
        in_dword_masked(HWIO_IPA_NLO_VP_FLUSH_COOKIE_ADDR, HWIO_IPA_NLO_VP_FLUSH_COOKIE_RMSK)
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_VP_FLUSH_COOKIE_ADDR, m)
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_VP_FLUSH_COOKIE_BMSK                                                         0xffffffff
#define HWIO_IPA_NLO_VP_FLUSH_COOKIE_VP_FLUSH_COOKIE_SHFT                                                                0x0

#define HWIO_IPA_NLO_VP_FLUSH_ACK_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x00000908)
#define HWIO_IPA_NLO_VP_FLUSH_ACK_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00000908)
#define HWIO_IPA_NLO_VP_FLUSH_ACK_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00000908)
#define HWIO_IPA_NLO_VP_FLUSH_ACK_RMSK                                                                                   0x1
#define HWIO_IPA_NLO_VP_FLUSH_ACK_ATTR                                                                                   0x1
#define HWIO_IPA_NLO_VP_FLUSH_ACK_IN          \
        in_dword_masked(HWIO_IPA_NLO_VP_FLUSH_ACK_ADDR, HWIO_IPA_NLO_VP_FLUSH_ACK_RMSK)
#define HWIO_IPA_NLO_VP_FLUSH_ACK_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_VP_FLUSH_ACK_ADDR, m)
#define HWIO_IPA_NLO_VP_FLUSH_ACK_VP_FLUSH_ACK_BMSK                                                                      0x1
#define HWIO_IPA_NLO_VP_FLUSH_ACK_VP_FLUSH_ACK_SHFT                                                                      0x0

#define HWIO_IPA_NLO_VP_DSM_OPEN_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x0000090c)
#define HWIO_IPA_NLO_VP_DSM_OPEN_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x0000090c)
#define HWIO_IPA_NLO_VP_DSM_OPEN_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x0000090c)
#define HWIO_IPA_NLO_VP_DSM_OPEN_RMSK                                                                             0xffffffff
#define HWIO_IPA_NLO_VP_DSM_OPEN_ATTR                                                                                    0x1
#define HWIO_IPA_NLO_VP_DSM_OPEN_IN          \
        in_dword_masked(HWIO_IPA_NLO_VP_DSM_OPEN_ADDR, HWIO_IPA_NLO_VP_DSM_OPEN_RMSK)
#define HWIO_IPA_NLO_VP_DSM_OPEN_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_VP_DSM_OPEN_ADDR, m)
#define HWIO_IPA_NLO_VP_DSM_OPEN_VP_DSM_OPEN_BMSK                                                                 0xffffffff
#define HWIO_IPA_NLO_VP_DSM_OPEN_VP_DSM_OPEN_SHFT                                                                        0x0

#define HWIO_IPA_NLO_VP_QBAP_OPEN_ADDR                                                                            (IPA_CFG_REG_BASE      + 0x00000910)
#define HWIO_IPA_NLO_VP_QBAP_OPEN_PHYS                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00000910)
#define HWIO_IPA_NLO_VP_QBAP_OPEN_OFFS                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00000910)
#define HWIO_IPA_NLO_VP_QBAP_OPEN_RMSK                                                                            0xffffffff
#define HWIO_IPA_NLO_VP_QBAP_OPEN_ATTR                                                                                   0x1
#define HWIO_IPA_NLO_VP_QBAP_OPEN_IN          \
        in_dword_masked(HWIO_IPA_NLO_VP_QBAP_OPEN_ADDR, HWIO_IPA_NLO_VP_QBAP_OPEN_RMSK)
#define HWIO_IPA_NLO_VP_QBAP_OPEN_INM(m)      \
        in_dword_masked(HWIO_IPA_NLO_VP_QBAP_OPEN_ADDR, m)
#define HWIO_IPA_NLO_VP_QBAP_OPEN_VP_QBAP_OPEN_BMSK                                                               0xffffffff
#define HWIO_IPA_NLO_VP_QBAP_OPEN_VP_QBAP_OPEN_SHFT                                                                      0x0

#define HWIO_IPA_COAL_MASTER_CFG_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x00000914)
#define HWIO_IPA_COAL_MASTER_CFG_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x00000914)
#define HWIO_IPA_COAL_MASTER_CFG_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x00000914)
#define HWIO_IPA_COAL_MASTER_CFG_RMSK                                                                                    0x3
#define HWIO_IPA_COAL_MASTER_CFG_ATTR                                                                                    0x3
#define HWIO_IPA_COAL_MASTER_CFG_IN          \
        in_dword_masked(HWIO_IPA_COAL_MASTER_CFG_ADDR, HWIO_IPA_COAL_MASTER_CFG_RMSK)
#define HWIO_IPA_COAL_MASTER_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_COAL_MASTER_CFG_ADDR, m)
#define HWIO_IPA_COAL_MASTER_CFG_OUT(v)      \
        out_dword(HWIO_IPA_COAL_MASTER_CFG_ADDR,v)
#define HWIO_IPA_COAL_MASTER_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_COAL_MASTER_CFG_ADDR,m,v,HWIO_IPA_COAL_MASTER_CFG_IN)
#define HWIO_IPA_COAL_MASTER_CFG_COAL_ENHANCED_IPV4_ID_EN_BMSK                                                           0x2
#define HWIO_IPA_COAL_MASTER_CFG_COAL_ENHANCED_IPV4_ID_EN_SHFT                                                           0x1
#define HWIO_IPA_COAL_MASTER_CFG_COAL_FORCE_TO_DEFAULT_BMSK                                                              0x1
#define HWIO_IPA_COAL_MASTER_CFG_COAL_FORCE_TO_DEFAULT_SHFT                                                              0x0

#define HWIO_IPA_COAL_EVICT_LRU_ADDR                                                                              (IPA_CFG_REG_BASE      + 0x00000918)
#define HWIO_IPA_COAL_EVICT_LRU_PHYS                                                                              (IPA_CFG_REG_BASE_PHYS + 0x00000918)
#define HWIO_IPA_COAL_EVICT_LRU_OFFS                                                                              (IPA_CFG_REG_BASE_OFFS + 0x00000918)
#define HWIO_IPA_COAL_EVICT_LRU_RMSK                                                                                    0x3f
#define HWIO_IPA_COAL_EVICT_LRU_ATTR                                                                                     0x3
#define HWIO_IPA_COAL_EVICT_LRU_IN          \
        in_dword_masked(HWIO_IPA_COAL_EVICT_LRU_ADDR, HWIO_IPA_COAL_EVICT_LRU_RMSK)
#define HWIO_IPA_COAL_EVICT_LRU_INM(m)      \
        in_dword_masked(HWIO_IPA_COAL_EVICT_LRU_ADDR, m)
#define HWIO_IPA_COAL_EVICT_LRU_OUT(v)      \
        out_dword(HWIO_IPA_COAL_EVICT_LRU_ADDR,v)
#define HWIO_IPA_COAL_EVICT_LRU_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_COAL_EVICT_LRU_ADDR,m,v,HWIO_IPA_COAL_EVICT_LRU_IN)
#define HWIO_IPA_COAL_EVICT_LRU_COAL_VP_LRU_THRSHLD_BMSK                                                                0x3e
#define HWIO_IPA_COAL_EVICT_LRU_COAL_VP_LRU_THRSHLD_SHFT                                                                 0x1
#define HWIO_IPA_COAL_EVICT_LRU_COAL_EVICTION_EN_BMSK                                                                    0x1
#define HWIO_IPA_COAL_EVICT_LRU_COAL_EVICTION_EN_SHFT                                                                    0x0

#define HWIO_IPA_COAL_QMAP_CFG_ADDR                                                                               (IPA_CFG_REG_BASE      + 0x0000091c)
#define HWIO_IPA_COAL_QMAP_CFG_PHYS                                                                               (IPA_CFG_REG_BASE_PHYS + 0x0000091c)
#define HWIO_IPA_COAL_QMAP_CFG_OFFS                                                                               (IPA_CFG_REG_BASE_OFFS + 0x0000091c)
#define HWIO_IPA_COAL_QMAP_CFG_RMSK                                                                                      0x3
#define HWIO_IPA_COAL_QMAP_CFG_ATTR                                                                                      0x3
#define HWIO_IPA_COAL_QMAP_CFG_IN          \
        in_dword_masked(HWIO_IPA_COAL_QMAP_CFG_ADDR, HWIO_IPA_COAL_QMAP_CFG_RMSK)
#define HWIO_IPA_COAL_QMAP_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_COAL_QMAP_CFG_ADDR, m)
#define HWIO_IPA_COAL_QMAP_CFG_OUT(v)      \
        out_dword(HWIO_IPA_COAL_QMAP_CFG_ADDR,v)
#define HWIO_IPA_COAL_QMAP_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_COAL_QMAP_CFG_ADDR,m,v,HWIO_IPA_COAL_QMAP_CFG_IN)
#define HWIO_IPA_COAL_QMAP_CFG_MUX_ID_BYTE_SEL_BMSK                                                                      0x3
#define HWIO_IPA_COAL_QMAP_CFG_MUX_ID_BYTE_SEL_SHFT                                                                      0x0

#define HWIO_IPA_SNIFFER_QMB_SEL_ADDR                                                                             (IPA_CFG_REG_BASE      + 0x00000920)
#define HWIO_IPA_SNIFFER_QMB_SEL_PHYS                                                                             (IPA_CFG_REG_BASE_PHYS + 0x00000920)
#define HWIO_IPA_SNIFFER_QMB_SEL_OFFS                                                                             (IPA_CFG_REG_BASE_OFFS + 0x00000920)
#define HWIO_IPA_SNIFFER_QMB_SEL_RMSK                                                                                    0x1
#define HWIO_IPA_SNIFFER_QMB_SEL_ATTR                                                                                    0x3
#define HWIO_IPA_SNIFFER_QMB_SEL_IN          \
        in_dword_masked(HWIO_IPA_SNIFFER_QMB_SEL_ADDR, HWIO_IPA_SNIFFER_QMB_SEL_RMSK)
#define HWIO_IPA_SNIFFER_QMB_SEL_INM(m)      \
        in_dword_masked(HWIO_IPA_SNIFFER_QMB_SEL_ADDR, m)
#define HWIO_IPA_SNIFFER_QMB_SEL_OUT(v)      \
        out_dword(HWIO_IPA_SNIFFER_QMB_SEL_ADDR,v)
#define HWIO_IPA_SNIFFER_QMB_SEL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_SNIFFER_QMB_SEL_ADDR,m,v,HWIO_IPA_SNIFFER_QMB_SEL_IN)
#define HWIO_IPA_SNIFFER_QMB_SEL_SNIF_QMB_SEL_BMSK                                                                       0x1
#define HWIO_IPA_SNIFFER_QMB_SEL_SNIF_QMB_SEL_SHFT                                                                       0x0

#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_ADDR(n)                                                               (IPA_CFG_REG_BASE      + 0x00000924 + 0x4 * (n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_PHYS(n)                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000924 + 0x4 * (n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_OFFS(n)                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000924 + 0x4 * (n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_RMSK                                                                      0xffff
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_MAXn                                                                           2
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_ATTR                                                                         0x3
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_ADDR(n), HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_RMSK)
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_ADDR(n), mask)
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_ADDR(n),val)
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_ADDR(n),mask,val,HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_INI(n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_IP_ID_MAX_VALUE_BMSK                                                      0xffff
#define HWIO_IPA_ULSO_CFG_IP_ID_MAX_VALUE_n_IP_ID_MAX_VALUE_SHFT                                                         0x0

#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_ADDR(n)                                                               (IPA_CFG_REG_BASE      + 0x00000934 + 0x4 * (n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_PHYS(n)                                                               (IPA_CFG_REG_BASE_PHYS + 0x00000934 + 0x4 * (n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_OFFS(n)                                                               (IPA_CFG_REG_BASE_OFFS + 0x00000934 + 0x4 * (n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_RMSK                                                                      0xffff
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_MAXn                                                                           2
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_ATTR                                                                         0x3
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_ADDR(n), HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_RMSK)
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_ADDR(n), mask)
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_ADDR(n),val)
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_ADDR(n),mask,val,HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_INI(n))
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_IP_ID_MIN_VALUE_BMSK                                                      0xffff
#define HWIO_IPA_ULSO_CFG_IP_ID_MIN_VALUE_n_IP_ID_MIN_VALUE_SHFT                                                         0x0

#define HWIO_IPA_ENDP_INIT_CTRL_n_ADDR(n)                                                                         (IPA_CFG_REG_BASE      + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_n_PHYS(n)                                                                         (IPA_CFG_REG_BASE_PHYS + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_n_OFFS(n)                                                                         (IPA_CFG_REG_BASE_OFFS + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_n_RMSK                                                                                   0x2
#define HWIO_IPA_ENDP_INIT_CTRL_n_MAXn                                                                                    35
#define HWIO_IPA_ENDP_INIT_CTRL_n_ATTR                                                                                   0x3
#define HWIO_IPA_ENDP_INIT_CTRL_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CTRL_n_ADDR(n), HWIO_IPA_ENDP_INIT_CTRL_n_RMSK)
#define HWIO_IPA_ENDP_INIT_CTRL_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CTRL_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_CTRL_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_CTRL_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_CTRL_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_CTRL_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_CTRL_n_INI(n))
#define HWIO_IPA_ENDP_INIT_CTRL_n_ENDP_DELAY_BMSK                                                                        0x2
#define HWIO_IPA_ENDP_INIT_CTRL_n_ENDP_DELAY_SHFT                                                                        0x1

#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x00001004 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00001004 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00001004 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_RMSK                                                                              0x2
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_MAXn                                                                               35
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ATTR                                                                              0x3
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ADDR(n), HWIO_IPA_ENDP_INIT_CTRL_SCND_n_RMSK)
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_CTRL_SCND_n_INI(n))
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ENDP_DELAY_BMSK                                                                   0x2
#define HWIO_IPA_ENDP_INIT_CTRL_SCND_n_ENDP_DELAY_SHFT                                                                   0x1

#define HWIO_IPA_ENDP_INIT_CFG_n_ADDR(n)                                                                          (IPA_CFG_REG_BASE      + 0x00001008 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CFG_n_PHYS(n)                                                                          (IPA_CFG_REG_BASE_PHYS + 0x00001008 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CFG_n_OFFS(n)                                                                          (IPA_CFG_REG_BASE_OFFS + 0x00001008 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CFG_n_RMSK                                                                                  0x17f
#define HWIO_IPA_ENDP_INIT_CFG_n_MAXn                                                                                     35
#define HWIO_IPA_ENDP_INIT_CFG_n_ATTR                                                                                    0x3
#define HWIO_IPA_ENDP_INIT_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CFG_n_ADDR(n), HWIO_IPA_ENDP_INIT_CFG_n_RMSK)
#define HWIO_IPA_ENDP_INIT_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_CFG_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_CFG_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_CFG_n_INI(n))
#define HWIO_IPA_ENDP_INIT_CFG_n_GEN_QMB_MASTER_SEL_BMSK                                                               0x100
#define HWIO_IPA_ENDP_INIT_CFG_n_GEN_QMB_MASTER_SEL_SHFT                                                                 0x8
#define HWIO_IPA_ENDP_INIT_CFG_n_CS_METADATA_HDR_OFFSET_BMSK                                                            0x78
#define HWIO_IPA_ENDP_INIT_CFG_n_CS_METADATA_HDR_OFFSET_SHFT                                                             0x3
#define HWIO_IPA_ENDP_INIT_CFG_n_CS_OFFLOAD_EN_BMSK                                                                      0x6
#define HWIO_IPA_ENDP_INIT_CFG_n_CS_OFFLOAD_EN_SHFT                                                                      0x1
#define HWIO_IPA_ENDP_INIT_CFG_n_FRAG_OFFLOAD_EN_BMSK                                                                    0x1
#define HWIO_IPA_ENDP_INIT_CFG_n_FRAG_OFFLOAD_EN_SHFT                                                                    0x0

#define HWIO_IPA_ENDP_INIT_NAT_n_ADDR(n)                                                                          (IPA_CFG_REG_BASE      + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_NAT_n_PHYS(n)                                                                          (IPA_CFG_REG_BASE_PHYS + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_NAT_n_OFFS(n)                                                                          (IPA_CFG_REG_BASE_OFFS + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_NAT_n_RMSK                                                                                    0x3
#define HWIO_IPA_ENDP_INIT_NAT_n_MAXn                                                                                     15
#define HWIO_IPA_ENDP_INIT_NAT_n_ATTR                                                                                    0x3
#define HWIO_IPA_ENDP_INIT_NAT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_NAT_n_ADDR(n), HWIO_IPA_ENDP_INIT_NAT_n_RMSK)
#define HWIO_IPA_ENDP_INIT_NAT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_NAT_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_NAT_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_NAT_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_NAT_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_NAT_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_NAT_n_INI(n))
#define HWIO_IPA_ENDP_INIT_NAT_n_NAT_EN_BMSK                                                                             0x3
#define HWIO_IPA_ENDP_INIT_NAT_n_NAT_EN_SHFT                                                                             0x0

#define HWIO_IPA_ENDP_INIT_HDR_n_ADDR(n)                                                                          (IPA_CFG_REG_BASE      + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_n_PHYS(n)                                                                          (IPA_CFG_REG_BASE_PHYS + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_n_OFFS(n)                                                                          (IPA_CFG_REG_BASE_OFFS + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_n_RMSK                                                                             0xfbffffff
#define HWIO_IPA_ENDP_INIT_HDR_n_MAXn                                                                                     35
#define HWIO_IPA_ENDP_INIT_HDR_n_ATTR                                                                                    0x3
#define HWIO_IPA_ENDP_INIT_HDR_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_n_ADDR(n), HWIO_IPA_ENDP_INIT_HDR_n_RMSK)
#define HWIO_IPA_ENDP_INIT_HDR_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_HDR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_HDR_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_HDR_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_HDR_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_HDR_n_INI(n))
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_METADATA_MSB_BMSK                                                       0xc0000000
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_METADATA_MSB_SHFT                                                             0x1e
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_LEN_MSB_BMSK                                                                 0x30000000
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_LEN_MSB_SHFT                                                                       0x1c
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_LEN_INC_DEAGG_HDR_BMSK                                                        0x8000000
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_LEN_INC_DEAGG_HDR_SHFT                                                             0x1b
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_PKT_SIZE_BMSK                                                            0x3f00000
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_PKT_SIZE_SHFT                                                                 0x14
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_PKT_SIZE_VALID_BMSK                                                        0x80000
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_PKT_SIZE_VALID_SHFT                                                           0x13
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_ADDITIONAL_CONST_LEN_BMSK                                                       0x7e000
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_ADDITIONAL_CONST_LEN_SHFT                                                           0xd
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_METADATA_BMSK                                                               0x1f80
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_METADATA_SHFT                                                                  0x7
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_METADATA_VALID_BMSK                                                           0x40
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_OFST_METADATA_VALID_SHFT                                                            0x6
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_LEN_BMSK                                                                           0x3f
#define HWIO_IPA_ENDP_INIT_HDR_n_HDR_LEN_SHFT                                                                            0x0

#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_ADDR(n)                                                                      (IPA_CFG_REG_BASE      + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_PHYS(n)                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_OFFS(n)                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_RMSK                                                                         0xff7f3fff
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_MAXn                                                                                 35
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_ATTR                                                                                0x3
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_EXT_n_ADDR(n), HWIO_IPA_ENDP_INIT_HDR_EXT_n_RMSK)
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_EXT_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_HDR_EXT_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_HDR_EXT_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_HDR_EXT_n_INI(n))
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_BYTES_TO_REMOVE_BMSK                                                     0xff000000
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_BYTES_TO_REMOVE_SHFT                                                           0x18
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_BYTES_TO_REMOVE_VALID_BMSK                                                 0x400000
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_BYTES_TO_REMOVE_VALID_SHFT                                                     0x16
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_ADDITIONAL_CONST_LEN_MSB_BMSK                                              0x300000
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_ADDITIONAL_CONST_LEN_MSB_SHFT                                                  0x14
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_OFST_PKT_SIZE_MSB_BMSK                                                      0xc0000
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_OFST_PKT_SIZE_MSB_SHFT                                                         0x12
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_OFFSET_MSB_BMSK                                            0x30000
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_OFFSET_MSB_SHFT                                               0x10
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_PAD_TO_ALIGNMENT_BMSK                                                        0x3c00
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_PAD_TO_ALIGNMENT_SHFT                                                           0xa
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_OFFSET_BMSK                                                  0x3f0
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_OFFSET_SHFT                                                    0x4
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_PAYLOAD_LEN_INC_PADDING_BMSK                                                    0x8
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_PAYLOAD_LEN_INC_PADDING_SHFT                                                    0x3
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_BMSK                                                           0x4
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_SHFT                                                           0x2
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_VALID_BMSK                                                     0x2
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_TOTAL_LEN_OR_PAD_VALID_SHFT                                                     0x1
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_ENDIANESS_BMSK                                                                  0x1
#define HWIO_IPA_ENDP_INIT_HDR_EXT_n_HDR_ENDIANESS_SHFT                                                                  0x0

#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_ADDR(n)                                                            (IPA_CFG_REG_BASE      + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_PHYS(n)                                                            (IPA_CFG_REG_BASE_PHYS + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_OFFS(n)                                                            (IPA_CFG_REG_BASE_OFFS + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_RMSK                                                               0xffffffff
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_MAXn                                                                       35
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_ATTR                                                                      0x3
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_ADDR(n), HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_RMSK)
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_INI(n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_METADATA_MASK_BMSK                                                 0xffffffff
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_MASK_n_METADATA_MASK_SHFT                                                        0x0

#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_ADDR(n)                                                                 (IPA_CFG_REG_BASE      + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_PHYS(n)                                                                 (IPA_CFG_REG_BASE_PHYS + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_OFFS(n)                                                                 (IPA_CFG_REG_BASE_OFFS + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_RMSK                                                                    0xffffffff
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_MAXn                                                                            15
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_ATTR                                                                           0x3
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_METADATA_n_ADDR(n), HWIO_IPA_ENDP_INIT_HDR_METADATA_n_RMSK)
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HDR_METADATA_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_HDR_METADATA_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_HDR_METADATA_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_HDR_METADATA_n_INI(n))
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_METADATA_BMSK                                                           0xffffffff
#define HWIO_IPA_ENDP_INIT_HDR_METADATA_n_METADATA_SHFT                                                                  0x0

#define HWIO_IPA_ENDP_INIT_MODE_n_ADDR(n)                                                                         (IPA_CFG_REG_BASE      + 0x00001020 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_MODE_n_PHYS(n)                                                                         (IPA_CFG_REG_BASE_PHYS + 0x00001020 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_MODE_n_OFFS(n)                                                                         (IPA_CFG_REG_BASE_OFFS + 0x00001020 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_MODE_n_RMSK                                                                            0x7fffffff
#define HWIO_IPA_ENDP_INIT_MODE_n_MAXn                                                                                    15
#define HWIO_IPA_ENDP_INIT_MODE_n_ATTR                                                                                   0x3
#define HWIO_IPA_ENDP_INIT_MODE_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_MODE_n_ADDR(n), HWIO_IPA_ENDP_INIT_MODE_n_RMSK)
#define HWIO_IPA_ENDP_INIT_MODE_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_MODE_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_MODE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_MODE_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_MODE_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_MODE_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_MODE_n_INI(n))
#define HWIO_IPA_ENDP_INIT_MODE_n_DRBIP_ACL_ENABLE_BMSK                                                           0x40000000
#define HWIO_IPA_ENDP_INIT_MODE_n_DRBIP_ACL_ENABLE_SHFT                                                                 0x1e
#define HWIO_IPA_ENDP_INIT_MODE_n_PAD_EN_BMSK                                                                     0x20000000
#define HWIO_IPA_ENDP_INIT_MODE_n_PAD_EN_SHFT                                                                           0x1d
#define HWIO_IPA_ENDP_INIT_MODE_n_PIPE_REPLICATE_EN_BMSK                                                          0x10000000
#define HWIO_IPA_ENDP_INIT_MODE_n_PIPE_REPLICATE_EN_SHFT                                                                0x1c
#define HWIO_IPA_ENDP_INIT_MODE_n_BYTE_THRESHOLD_BMSK                                                              0xffff000
#define HWIO_IPA_ENDP_INIT_MODE_n_BYTE_THRESHOLD_SHFT                                                                    0xc
#define HWIO_IPA_ENDP_INIT_MODE_n_DEST_PIPE_INDEX_BMSK                                                                 0xff0
#define HWIO_IPA_ENDP_INIT_MODE_n_DEST_PIPE_INDEX_SHFT                                                                   0x4
#define HWIO_IPA_ENDP_INIT_MODE_n_BEARER_CNTX_ENABLE_BMSK                                                                0x8
#define HWIO_IPA_ENDP_INIT_MODE_n_BEARER_CNTX_ENABLE_SHFT                                                                0x3
#define HWIO_IPA_ENDP_INIT_MODE_n_MODE_BMSK                                                                              0x7
#define HWIO_IPA_ENDP_INIT_MODE_n_MODE_SHFT                                                                              0x0

#define HWIO_IPA_ENDP_INIT_AGGR_n_ADDR(n)                                                                         (IPA_CFG_REG_BASE      + 0x00001024 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_AGGR_n_PHYS(n)                                                                         (IPA_CFG_REG_BASE_PHYS + 0x00001024 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_AGGR_n_OFFS(n)                                                                         (IPA_CFG_REG_BASE_OFFS + 0x00001024 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_AGGR_n_RMSK                                                                             0xdfff7ff
#define HWIO_IPA_ENDP_INIT_AGGR_n_MAXn                                                                                    35
#define HWIO_IPA_ENDP_INIT_AGGR_n_ATTR                                                                                   0x3
#define HWIO_IPA_ENDP_INIT_AGGR_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_AGGR_n_ADDR(n), HWIO_IPA_ENDP_INIT_AGGR_n_RMSK)
#define HWIO_IPA_ENDP_INIT_AGGR_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_AGGR_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_AGGR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_AGGR_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_AGGR_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_AGGR_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_AGGR_n_INI(n))
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_GRAN_SEL_BMSK                                                               0x8000000
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_GRAN_SEL_SHFT                                                                    0x1b
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_HARD_BYTE_LIMIT_ENABLE_BMSK                                                 0x4000000
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_HARD_BYTE_LIMIT_ENABLE_SHFT                                                      0x1a
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_FORCE_CLOSE_BMSK                                                            0x1000000
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_FORCE_CLOSE_SHFT                                                                 0x18
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_SW_EOF_ACTIVE_BMSK                                                           0x800000
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_SW_EOF_ACTIVE_SHFT                                                               0x17
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_PKT_LIMIT_BMSK                                                               0x7e0000
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_PKT_LIMIT_SHFT                                                                   0x11
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_TIME_LIMIT_BMSK                                                               0x1f000
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_TIME_LIMIT_SHFT                                                                   0xc
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_BYTE_LIMIT_BMSK                                                                 0x7e0
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_BYTE_LIMIT_SHFT                                                                   0x5
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_TYPE_BMSK                                                                        0x1c
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_TYPE_SHFT                                                                         0x2
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_EN_BMSK                                                                           0x3
#define HWIO_IPA_ENDP_INIT_AGGR_n_AGGR_EN_SHFT                                                                           0x0

#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_ADDR(n)                                                                 (IPA_CFG_REG_BASE      + 0x0000102c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_PHYS(n)                                                                 (IPA_CFG_REG_BASE_PHYS + 0x0000102c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_OFFS(n)                                                                 (IPA_CFG_REG_BASE_OFFS + 0x0000102c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_RMSK                                                                           0x1
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_MAXn                                                                            35
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_ATTR                                                                           0x3
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_ADDR(n), HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_RMSK)
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_INI(n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_EN_BMSK                                                                        0x1
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_EN_n_EN_SHFT                                                                        0x0

#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_ADDR(n)                                                              (IPA_CFG_REG_BASE      + 0x00001030 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_PHYS(n)                                                              (IPA_CFG_REG_BASE_PHYS + 0x00001030 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_OFFS(n)                                                              (IPA_CFG_REG_BASE_OFFS + 0x00001030 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_RMSK                                                                      0x31f
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_MAXn                                                                         35
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_ATTR                                                                        0x3
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_ADDR(n), HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_RMSK)
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_INI(n))
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_GRAN_SEL_BMSK                                                             0x300
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_GRAN_SEL_SHFT                                                               0x8
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_TIME_LIMIT_BMSK                                                            0x1f
#define HWIO_IPA_ENDP_INIT_HOL_BLOCK_TIMER_n_TIME_LIMIT_SHFT                                                             0x0

#define HWIO_IPA_ENDP_INIT_DEAGGR_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x00001034 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00001034 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00001034 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_RMSK                                                                          0xffff7fff
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_MAXn                                                                                  15
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_ATTR                                                                                 0x3
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_DEAGGR_n_ADDR(n), HWIO_IPA_ENDP_INIT_DEAGGR_n_RMSK)
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_DEAGGR_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_DEAGGR_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_DEAGGR_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_DEAGGR_n_INI(n))
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_MAX_PACKET_LEN_BMSK                                                           0xffff0000
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_MAX_PACKET_LEN_SHFT                                                                 0x10
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_IGNORE_MIN_PKT_ERR_BMSK                                                           0x4000
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_IGNORE_MIN_PKT_ERR_SHFT                                                              0xe
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_PACKET_OFFSET_LOCATION_BMSK                                                       0x3f00
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_PACKET_OFFSET_LOCATION_SHFT                                                          0x8
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_PACKET_OFFSET_VALID_BMSK                                                            0x80
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_PACKET_OFFSET_VALID_SHFT                                                             0x7
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_SYSPIPE_ERR_DETECTION_BMSK                                                          0x40
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_SYSPIPE_ERR_DETECTION_SHFT                                                           0x6
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_DEAGGR_HDR_LEN_BMSK                                                                 0x3f
#define HWIO_IPA_ENDP_INIT_DEAGGR_n_DEAGGR_HDR_LEN_SHFT                                                                  0x0

#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_ADDR(n)                                                                     (IPA_CFG_REG_BASE      + 0x00001038 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_PHYS(n)                                                                     (IPA_CFG_REG_BASE_PHYS + 0x00001038 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_OFFS(n)                                                                     (IPA_CFG_REG_BASE_OFFS + 0x00001038 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_RMSK                                                                               0x7
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_MAXn                                                                                35
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_ATTR                                                                               0x3
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_RSRC_GRP_n_ADDR(n), HWIO_IPA_ENDP_INIT_RSRC_GRP_n_RMSK)
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_RSRC_GRP_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_RSRC_GRP_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_RSRC_GRP_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_RSRC_GRP_n_INI(n))
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_RSRC_GRP_BMSK                                                                      0x7
#define HWIO_IPA_ENDP_INIT_RSRC_GRP_n_RSRC_GRP_SHFT                                                                      0x0

#define HWIO_IPA_ENDP_INIT_SEQ_n_ADDR(n)                                                                          (IPA_CFG_REG_BASE      + 0x0000103c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_SEQ_n_PHYS(n)                                                                          (IPA_CFG_REG_BASE_PHYS + 0x0000103c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_SEQ_n_OFFS(n)                                                                          (IPA_CFG_REG_BASE_OFFS + 0x0000103c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_SEQ_n_RMSK                                                                                 0x1f1f
#define HWIO_IPA_ENDP_INIT_SEQ_n_MAXn                                                                                     15
#define HWIO_IPA_ENDP_INIT_SEQ_n_ATTR                                                                                    0x3
#define HWIO_IPA_ENDP_INIT_SEQ_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_SEQ_n_ADDR(n), HWIO_IPA_ENDP_INIT_SEQ_n_RMSK)
#define HWIO_IPA_ENDP_INIT_SEQ_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_SEQ_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_SEQ_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_SEQ_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_SEQ_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_SEQ_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_SEQ_n_INI(n))
#define HWIO_IPA_ENDP_INIT_SEQ_n_DPS_SEQ_TYPE_BMSK                                                                    0x1f00
#define HWIO_IPA_ENDP_INIT_SEQ_n_DPS_SEQ_TYPE_SHFT                                                                       0x8
#define HWIO_IPA_ENDP_INIT_SEQ_n_HPS_SEQ_TYPE_BMSK                                                                      0x1f
#define HWIO_IPA_ENDP_INIT_SEQ_n_HPS_SEQ_TYPE_SHFT                                                                       0x0

#define HWIO_IPA_ENDP_STATUS_n_ADDR(n)                                                                            (IPA_CFG_REG_BASE      + 0x00001040 + 0x80 * (n))
#define HWIO_IPA_ENDP_STATUS_n_PHYS(n)                                                                            (IPA_CFG_REG_BASE_PHYS + 0x00001040 + 0x80 * (n))
#define HWIO_IPA_ENDP_STATUS_n_OFFS(n)                                                                            (IPA_CFG_REG_BASE_OFFS + 0x00001040 + 0x80 * (n))
#define HWIO_IPA_ENDP_STATUS_n_RMSK                                                                                    0x3ff
#define HWIO_IPA_ENDP_STATUS_n_MAXn                                                                                       35
#define HWIO_IPA_ENDP_STATUS_n_ATTR                                                                                      0x3
#define HWIO_IPA_ENDP_STATUS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_STATUS_n_ADDR(n), HWIO_IPA_ENDP_STATUS_n_RMSK)
#define HWIO_IPA_ENDP_STATUS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_STATUS_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_STATUS_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_STATUS_n_ADDR(n),val)
#define HWIO_IPA_ENDP_STATUS_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_STATUS_n_ADDR(n),mask,val,HWIO_IPA_ENDP_STATUS_n_INI(n))
#define HWIO_IPA_ENDP_STATUS_n_STATUS_PKT_SUPRESS_BMSK                                                                 0x200
#define HWIO_IPA_ENDP_STATUS_n_STATUS_PKT_SUPRESS_SHFT                                                                   0x9
#define HWIO_IPA_ENDP_STATUS_n_STATUS_ENDP_BMSK                                                                        0x1fe
#define HWIO_IPA_ENDP_STATUS_n_STATUS_ENDP_SHFT                                                                          0x1
#define HWIO_IPA_ENDP_STATUS_n_STATUS_EN_BMSK                                                                            0x1
#define HWIO_IPA_ENDP_STATUS_n_STATUS_EN_SHFT                                                                            0x0

#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_ADDR(n)                                                                      (IPA_CFG_REG_BASE      + 0x00001048 + 0x80 * (n))
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_PHYS(n)                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00001048 + 0x80 * (n))
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_OFFS(n)                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00001048 + 0x80 * (n))
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_RMSK                                                                               0xff
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_MAXn                                                                                 15
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_ATTR                                                                                0x2
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_SRC_ID_WRITE_n_ADDR(n),val)
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_SRC_ID_WRITE_VALUE_BMSK                                                            0xff
#define HWIO_IPA_ENDP_SRC_ID_WRITE_n_SRC_ID_WRITE_VALUE_SHFT                                                             0x0

#define HWIO_IPA_ENDP_SRC_ID_READ_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x0000104c + 0x80 * (n))
#define HWIO_IPA_ENDP_SRC_ID_READ_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x0000104c + 0x80 * (n))
#define HWIO_IPA_ENDP_SRC_ID_READ_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x0000104c + 0x80 * (n))
#define HWIO_IPA_ENDP_SRC_ID_READ_n_RMSK                                                                                0xff
#define HWIO_IPA_ENDP_SRC_ID_READ_n_MAXn                                                                                  15
#define HWIO_IPA_ENDP_SRC_ID_READ_n_ATTR                                                                                 0x1
#define HWIO_IPA_ENDP_SRC_ID_READ_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_SRC_ID_READ_n_ADDR(n), HWIO_IPA_ENDP_SRC_ID_READ_n_RMSK)
#define HWIO_IPA_ENDP_SRC_ID_READ_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_SRC_ID_READ_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_SRC_ID_READ_n_SRC_ID_READ_VALUE_BMSK                                                              0xff
#define HWIO_IPA_ENDP_SRC_ID_READ_n_SRC_ID_READ_VALUE_SHFT                                                               0x0

#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_ADDR(n)                                                                   (IPA_CFG_REG_BASE      + 0x00001050 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_PHYS(n)                                                                   (IPA_CFG_REG_BASE_PHYS + 0x00001050 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_OFFS(n)                                                                   (IPA_CFG_REG_BASE_OFFS + 0x00001050 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_RMSK                                                                             0x1
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_MAXn                                                                              15
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_ATTR                                                                             0x3
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CONN_TRACK_n_ADDR(n), HWIO_IPA_ENDP_INIT_CONN_TRACK_n_RMSK)
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CONN_TRACK_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_CONN_TRACK_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_CONN_TRACK_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_CONN_TRACK_n_INI(n))
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_CONN_TRACK_EN_BMSK                                                               0x1
#define HWIO_IPA_ENDP_INIT_CONN_TRACK_n_CONN_TRACK_EN_SHFT                                                               0x0

#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_ADDR(n)                                                                    (IPA_CFG_REG_BASE      + 0x00001054 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_PHYS(n)                                                                    (IPA_CFG_REG_BASE_PHYS + 0x00001054 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_OFFS(n)                                                                    (IPA_CFG_REG_BASE_OFFS + 0x00001054 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_RMSK                                                                             0x3f
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_MAXn                                                                               15
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_ATTR                                                                              0x3
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_ADDR(n), HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_RMSK)
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_INI(n))
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_DATA_SECTORS_FOR_IMM_CMD_BMSK                                                    0x3f
#define HWIO_IPA_ENDP_INIT_DRBIP_CFG_n_DATA_SECTORS_FOR_IMM_CMD_SHFT                                                     0x0

#define HWIO_IPA_FILTER_CACHE_CFG_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x0000105c + 0x80 * (n))
#define HWIO_IPA_FILTER_CACHE_CFG_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x0000105c + 0x80 * (n))
#define HWIO_IPA_FILTER_CACHE_CFG_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x0000105c + 0x80 * (n))
#define HWIO_IPA_FILTER_CACHE_CFG_n_RMSK                                                                                0x7f
#define HWIO_IPA_FILTER_CACHE_CFG_n_MAXn                                                                                  15
#define HWIO_IPA_FILTER_CACHE_CFG_n_ATTR                                                                                 0x3
#define HWIO_IPA_FILTER_CACHE_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_FILTER_CACHE_CFG_n_ADDR(n), HWIO_IPA_FILTER_CACHE_CFG_n_RMSK)
#define HWIO_IPA_FILTER_CACHE_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_FILTER_CACHE_CFG_n_ADDR(n), mask)
#define HWIO_IPA_FILTER_CACHE_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_FILTER_CACHE_CFG_n_ADDR(n),val)
#define HWIO_IPA_FILTER_CACHE_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_FILTER_CACHE_CFG_n_ADDR(n),mask,val,HWIO_IPA_FILTER_CACHE_CFG_n_INI(n))
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_METADATA_BMSK                                                      0x40
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_METADATA_SHFT                                                       0x6
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_PROTOCOL_BMSK                                                      0x20
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_PROTOCOL_SHFT                                                       0x5
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_DST_PORT_BMSK                                                      0x10
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_DST_PORT_SHFT                                                       0x4
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_SRC_PORT_BMSK                                                       0x8
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_SRC_PORT_SHFT                                                       0x3
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_DST_IP_ADD_BMSK                                                     0x4
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_DST_IP_ADD_SHFT                                                     0x2
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_SRC_IP_ADD_BMSK                                                     0x2
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_SRC_IP_ADD_SHFT                                                     0x1
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_SRC_ID_BMSK                                                         0x1
#define HWIO_IPA_FILTER_CACHE_CFG_n_FILTER_CACHE_MSK_SRC_ID_SHFT                                                         0x0

#define HWIO_IPA_ROUTER_CACHE_CFG_n_ADDR(n)                                                                       (IPA_CFG_REG_BASE      + 0x00001070 + 0x80 * (n))
#define HWIO_IPA_ROUTER_CACHE_CFG_n_PHYS(n)                                                                       (IPA_CFG_REG_BASE_PHYS + 0x00001070 + 0x80 * (n))
#define HWIO_IPA_ROUTER_CACHE_CFG_n_OFFS(n)                                                                       (IPA_CFG_REG_BASE_OFFS + 0x00001070 + 0x80 * (n))
#define HWIO_IPA_ROUTER_CACHE_CFG_n_RMSK                                                                                0x7f
#define HWIO_IPA_ROUTER_CACHE_CFG_n_MAXn                                                                                  35
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ATTR                                                                                 0x3
#define HWIO_IPA_ROUTER_CACHE_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ROUTER_CACHE_CFG_n_ADDR(n), HWIO_IPA_ROUTER_CACHE_CFG_n_RMSK)
#define HWIO_IPA_ROUTER_CACHE_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ROUTER_CACHE_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ROUTER_CACHE_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ROUTER_CACHE_CFG_n_ADDR(n),val)
#define HWIO_IPA_ROUTER_CACHE_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ROUTER_CACHE_CFG_n_ADDR(n),mask,val,HWIO_IPA_ROUTER_CACHE_CFG_n_INI(n))
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_METADATA_BMSK                                                      0x40
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_METADATA_SHFT                                                       0x6
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_PROTOCOL_BMSK                                                      0x20
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_PROTOCOL_SHFT                                                       0x5
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_DST_PORT_BMSK                                                      0x10
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_DST_PORT_SHFT                                                       0x4
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_SRC_PORT_BMSK                                                       0x8
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_SRC_PORT_SHFT                                                       0x3
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_DST_IP_ADD_BMSK                                                     0x4
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_DST_IP_ADD_SHFT                                                     0x2
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_SRC_IP_ADD_BMSK                                                     0x2
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_SRC_IP_ADD_SHFT                                                     0x1
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_SRC_ID_BMSK                                                         0x1
#define HWIO_IPA_ROUTER_CACHE_CFG_n_ROUTER_CACHE_MSK_SRC_ID_SHFT                                                         0x0

#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_ADDR(n)                                                             (IPA_CFG_REG_BASE      + 0x00001060 + 0x80 * (n))
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_PHYS(n)                                                             (IPA_CFG_REG_BASE_PHYS + 0x00001060 + 0x80 * (n))
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_OFFS(n)                                                             (IPA_CFG_REG_BASE_OFFS + 0x00001060 + 0x80 * (n))
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_RMSK                                                                0xfc00fc00
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_MAXn                                                                        35
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_ATTR                                                                       0x3
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_ADDR(n), HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_RMSK)
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_ADDR(n),val)
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_ADDR(n),mask,val,HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_INI(n))
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_IPA_RED_MARKER_CFG_BMSK                                             0xfc000000
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_IPA_RED_MARKER_CFG_SHFT                                                   0x1a
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_IPA_YELLOW_MARKER_CFG_BMSK                                              0xfc00
#define HWIO_IPA_ENDP_YELLOW_RED_MARKER_CFG_n_IPA_YELLOW_MARKER_CFG_SHFT                                                 0xa

#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ADDR(n)                                                                  (IPA_CFG_REG_BASE      + 0x00001064 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_PHYS(n)                                                                  (IPA_CFG_REG_BASE_PHYS + 0x00001064 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_OFFS(n)                                                                  (IPA_CFG_REG_BASE_OFFS + 0x00001064 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_RMSK                                                                            0x3
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_MAXn                                                                             35
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ATTR                                                                            0x1
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ADDR(n), HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_RMSK)
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ENDP_DELAY_STATUS_BMSK                                                          0x2
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ENDP_DELAY_STATUS_SHFT                                                          0x1
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ENDP_SUSPEND_STATUS_BMSK                                                        0x1
#define HWIO_IPA_ENDP_INIT_CTRL_STATUS_n_ENDP_SUSPEND_STATUS_SHFT                                                        0x0

#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_ADDR(n)                                                                     (IPA_CFG_REG_BASE      + 0x00001068 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_PHYS(n)                                                                     (IPA_CFG_REG_BASE_PHYS + 0x00001068 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_OFFS(n)                                                                     (IPA_CFG_REG_BASE_OFFS + 0x00001068 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_RMSK                                                                               0x1
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_MAXn                                                                                35
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_ATTR                                                                               0x3
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_PROD_CFG_n_ADDR(n), HWIO_IPA_ENDP_INIT_PROD_CFG_n_RMSK)
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_PROD_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_PROD_CFG_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_PROD_CFG_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_PROD_CFG_n_INI(n))
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_TX_SEL_BMSK                                                                        0x1
#define HWIO_IPA_ENDP_INIT_PROD_CFG_n_TX_SEL_SHFT                                                                        0x0

#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_ADDR(n)                                                                     (IPA_CFG_REG_BASE      + 0x0000106c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_PHYS(n)                                                                     (IPA_CFG_REG_BASE_PHYS + 0x0000106c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_OFFS(n)                                                                     (IPA_CFG_REG_BASE_OFFS + 0x0000106c + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_RMSK                                                                               0x3
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_MAXn                                                                                15
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_ATTR                                                                               0x3
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_ULSO_CFG_n_ADDR(n), HWIO_IPA_ENDP_INIT_ULSO_CFG_n_RMSK)
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_ULSO_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_ULSO_CFG_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_ULSO_CFG_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_ULSO_CFG_n_INI(n))
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_IPV4_ID_MIN_MAX_VAL_INDEX_BMSK                                                     0x3
#define HWIO_IPA_ENDP_INIT_ULSO_CFG_n_IPV4_ID_MIN_MAX_VAL_INDEX_SHFT                                                     0x0

#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_ADDR(n)                                                                      (IPA_CFG_REG_BASE      + 0x00001074 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_PHYS(n)                                                                      (IPA_CFG_REG_BASE_PHYS + 0x00001074 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_OFFS(n)                                                                      (IPA_CFG_REG_BASE_OFFS + 0x00001074 + 0x80 * (n))
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_RMSK                                                                            0x1ffff
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_MAXn                                                                                 15
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_ATTR                                                                                0x3
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_INI(n)        \
        in_dword_masked(HWIO_IPA_ENDP_INIT_UCP_CFG_n_ADDR(n), HWIO_IPA_ENDP_INIT_UCP_CFG_n_RMSK)
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_ENDP_INIT_UCP_CFG_n_ADDR(n), mask)
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_ENDP_INIT_UCP_CFG_n_ADDR(n),val)
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_ENDP_INIT_UCP_CFG_n_ADDR(n),mask,val,HWIO_IPA_ENDP_INIT_UCP_CFG_n_INI(n))
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_UCP_TRIGGER_EN_BMSK                                                             0x10000
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_UCP_TRIGGER_EN_SHFT                                                                0x10
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_UCP_COMMAND_ID_BMSK                                                              0xffff
#define HWIO_IPA_ENDP_INIT_UCP_CFG_n_UCP_COMMAND_ID_SHFT                                                                 0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_VMIDMT
 *--------------------------------------------------------------------------*/

#define IPA_VMIDMT_REG_BASE                                            (IPA_0_IPA_WRAPPER_BASE      + 0x00130000)
#define IPA_VMIDMT_REG_BASE_PHYS                                       (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00130000)
#define IPA_VMIDMT_REG_BASE_OFFS                                       0x00130000

#define HWIO_IPA_VMIDMT_SCR0_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000000)
#define HWIO_IPA_VMIDMT_SCR0_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_VMIDMT_SCR0_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_VMIDMT_SCR0_RMSK                                      0x3ff707f5
#define HWIO_IPA_VMIDMT_SCR0_ATTR                                             0x3
#define HWIO_IPA_VMIDMT_SCR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SCR0_ADDR, HWIO_IPA_VMIDMT_SCR0_RMSK)
#define HWIO_IPA_VMIDMT_SCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SCR0_ADDR, m)
#define HWIO_IPA_VMIDMT_SCR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SCR0_ADDR,v)
#define HWIO_IPA_VMIDMT_SCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SCR0_ADDR,m,v,HWIO_IPA_VMIDMT_SCR0_IN)
#define HWIO_IPA_VMIDMT_SCR0_NSCFG_BMSK                                0x30000000
#define HWIO_IPA_VMIDMT_SCR0_NSCFG_SHFT                                      0x1c
#define HWIO_IPA_VMIDMT_SCR0_WACFG_BMSK                                 0xc000000
#define HWIO_IPA_VMIDMT_SCR0_WACFG_SHFT                                      0x1a
#define HWIO_IPA_VMIDMT_SCR0_RACFG_BMSK                                 0x3000000
#define HWIO_IPA_VMIDMT_SCR0_RACFG_SHFT                                      0x18
#define HWIO_IPA_VMIDMT_SCR0_SHCFG_BMSK                                  0xc00000
#define HWIO_IPA_VMIDMT_SCR0_SHCFG_SHFT                                      0x16
#define HWIO_IPA_VMIDMT_SCR0_SMCFCFG_BMSK                                0x200000
#define HWIO_IPA_VMIDMT_SCR0_SMCFCFG_SHFT                                    0x15
#define HWIO_IPA_VMIDMT_SCR0_MTCFG_BMSK                                  0x100000
#define HWIO_IPA_VMIDMT_SCR0_MTCFG_SHFT                                      0x14
#define HWIO_IPA_VMIDMT_SCR0_MEMATTR_BMSK                                 0x70000
#define HWIO_IPA_VMIDMT_SCR0_MEMATTR_SHFT                                    0x10
#define HWIO_IPA_VMIDMT_SCR0_USFCFG_BMSK                                    0x400
#define HWIO_IPA_VMIDMT_SCR0_USFCFG_SHFT                                      0xa
#define HWIO_IPA_VMIDMT_SCR0_GSE_BMSK                                       0x200
#define HWIO_IPA_VMIDMT_SCR0_GSE_SHFT                                         0x9
#define HWIO_IPA_VMIDMT_SCR0_STALLD_BMSK                                    0x100
#define HWIO_IPA_VMIDMT_SCR0_STALLD_SHFT                                      0x8
#define HWIO_IPA_VMIDMT_SCR0_TRANSIENTCFG_BMSK                               0xc0
#define HWIO_IPA_VMIDMT_SCR0_TRANSIENTCFG_SHFT                                0x6
#define HWIO_IPA_VMIDMT_SCR0_GCFGFIE_BMSK                                    0x20
#define HWIO_IPA_VMIDMT_SCR0_GCFGFIE_SHFT                                     0x5
#define HWIO_IPA_VMIDMT_SCR0_GCFGERE_BMSK                                    0x10
#define HWIO_IPA_VMIDMT_SCR0_GCFGERE_SHFT                                     0x4
#define HWIO_IPA_VMIDMT_SCR0_GFIE_BMSK                                        0x4
#define HWIO_IPA_VMIDMT_SCR0_GFIE_SHFT                                        0x2
#define HWIO_IPA_VMIDMT_SCR0_CLIENTPD_BMSK                                    0x1
#define HWIO_IPA_VMIDMT_SCR0_CLIENTPD_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_SCR1_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000004)
#define HWIO_IPA_VMIDMT_SCR1_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000004)
#define HWIO_IPA_VMIDMT_SCR1_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000004)
#define HWIO_IPA_VMIDMT_SCR1_RMSK                                       0x1003f00
#define HWIO_IPA_VMIDMT_SCR1_ATTR                                             0x3
#define HWIO_IPA_VMIDMT_SCR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SCR1_ADDR, HWIO_IPA_VMIDMT_SCR1_RMSK)
#define HWIO_IPA_VMIDMT_SCR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SCR1_ADDR, m)
#define HWIO_IPA_VMIDMT_SCR1_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SCR1_ADDR,v)
#define HWIO_IPA_VMIDMT_SCR1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SCR1_ADDR,m,v,HWIO_IPA_VMIDMT_SCR1_IN)
#define HWIO_IPA_VMIDMT_SCR1_GASRAE_BMSK                                0x1000000
#define HWIO_IPA_VMIDMT_SCR1_GASRAE_SHFT                                     0x18
#define HWIO_IPA_VMIDMT_SCR1_NSNUMSMRGO_BMSK                               0x3f00
#define HWIO_IPA_VMIDMT_SCR1_NSNUMSMRGO_SHFT                                  0x8

#define HWIO_IPA_VMIDMT_SCR2_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000008)
#define HWIO_IPA_VMIDMT_SCR2_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_VMIDMT_SCR2_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_VMIDMT_SCR2_RMSK                                            0x1f
#define HWIO_IPA_VMIDMT_SCR2_ATTR                                             0x3
#define HWIO_IPA_VMIDMT_SCR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SCR2_ADDR, HWIO_IPA_VMIDMT_SCR2_RMSK)
#define HWIO_IPA_VMIDMT_SCR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SCR2_ADDR, m)
#define HWIO_IPA_VMIDMT_SCR2_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SCR2_ADDR,v)
#define HWIO_IPA_VMIDMT_SCR2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SCR2_ADDR,m,v,HWIO_IPA_VMIDMT_SCR2_IN)
#define HWIO_IPA_VMIDMT_SCR2_BPVMID_BMSK                                     0x1f
#define HWIO_IPA_VMIDMT_SCR2_BPVMID_SHFT                                      0x0

#define HWIO_IPA_VMIDMT_SACR_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000010)
#define HWIO_IPA_VMIDMT_SACR_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_VMIDMT_SACR_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_VMIDMT_SACR_RMSK                                      0x70000013
#define HWIO_IPA_VMIDMT_SACR_ATTR                                             0x3
#define HWIO_IPA_VMIDMT_SACR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SACR_ADDR, HWIO_IPA_VMIDMT_SACR_RMSK)
#define HWIO_IPA_VMIDMT_SACR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SACR_ADDR, m)
#define HWIO_IPA_VMIDMT_SACR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SACR_ADDR,v)
#define HWIO_IPA_VMIDMT_SACR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SACR_ADDR,m,v,HWIO_IPA_VMIDMT_SACR_IN)
#define HWIO_IPA_VMIDMT_SACR_BPRCNSH_BMSK                              0x40000000
#define HWIO_IPA_VMIDMT_SACR_BPRCNSH_SHFT                                    0x1e
#define HWIO_IPA_VMIDMT_SACR_BPRCISH_BMSK                              0x20000000
#define HWIO_IPA_VMIDMT_SACR_BPRCISH_SHFT                                    0x1d
#define HWIO_IPA_VMIDMT_SACR_BPRCOSH_BMSK                              0x10000000
#define HWIO_IPA_VMIDMT_SACR_BPRCOSH_SHFT                                    0x1c
#define HWIO_IPA_VMIDMT_SACR_BPREQPRIORITYCFG_BMSK                           0x10
#define HWIO_IPA_VMIDMT_SACR_BPREQPRIORITYCFG_SHFT                            0x4
#define HWIO_IPA_VMIDMT_SACR_BPREQPRIORITY_BMSK                               0x3
#define HWIO_IPA_VMIDMT_SACR_BPREQPRIORITY_SHFT                               0x0

#define HWIO_IPA_VMIDMT_SIDR0_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000020)
#define HWIO_IPA_VMIDMT_SIDR0_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000020)
#define HWIO_IPA_VMIDMT_SIDR0_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000020)
#define HWIO_IPA_VMIDMT_SIDR0_RMSK                                     0x88001eff
#define HWIO_IPA_VMIDMT_SIDR0_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_SIDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR0_ADDR, HWIO_IPA_VMIDMT_SIDR0_RMSK)
#define HWIO_IPA_VMIDMT_SIDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_SIDR0_SES_BMSK                                 0x80000000
#define HWIO_IPA_VMIDMT_SIDR0_SES_SHFT                                       0x1f
#define HWIO_IPA_VMIDMT_SIDR0_SMS_BMSK                                  0x8000000
#define HWIO_IPA_VMIDMT_SIDR0_SMS_SHFT                                       0x1b
#define HWIO_IPA_VMIDMT_SIDR0_NUMSIDB_BMSK                                 0x1e00
#define HWIO_IPA_VMIDMT_SIDR0_NUMSIDB_SHFT                                    0x9
#define HWIO_IPA_VMIDMT_SIDR0_NUMSMRG_BMSK                                   0xff
#define HWIO_IPA_VMIDMT_SIDR0_NUMSMRG_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_SIDR1_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000024)
#define HWIO_IPA_VMIDMT_SIDR1_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000024)
#define HWIO_IPA_VMIDMT_SIDR1_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000024)
#define HWIO_IPA_VMIDMT_SIDR1_RMSK                                         0x9f00
#define HWIO_IPA_VMIDMT_SIDR1_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_SIDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR1_ADDR, HWIO_IPA_VMIDMT_SIDR1_RMSK)
#define HWIO_IPA_VMIDMT_SIDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_SIDR1_SMCD_BMSK                                    0x8000
#define HWIO_IPA_VMIDMT_SIDR1_SMCD_SHFT                                       0xf
#define HWIO_IPA_VMIDMT_SIDR1_SSDTP_BMSK                                   0x1000
#define HWIO_IPA_VMIDMT_SIDR1_SSDTP_SHFT                                      0xc
#define HWIO_IPA_VMIDMT_SIDR1_NUMSSDNDX_BMSK                                0xf00
#define HWIO_IPA_VMIDMT_SIDR1_NUMSSDNDX_SHFT                                  0x8

#define HWIO_IPA_VMIDMT_SIDR2_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000028)
#define HWIO_IPA_VMIDMT_SIDR2_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000028)
#define HWIO_IPA_VMIDMT_SIDR2_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000028)
#define HWIO_IPA_VMIDMT_SIDR2_RMSK                                           0xff
#define HWIO_IPA_VMIDMT_SIDR2_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_SIDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR2_ADDR, HWIO_IPA_VMIDMT_SIDR2_RMSK)
#define HWIO_IPA_VMIDMT_SIDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_SIDR2_OAS_BMSK                                       0xf0
#define HWIO_IPA_VMIDMT_SIDR2_OAS_SHFT                                        0x4
#define HWIO_IPA_VMIDMT_SIDR2_IAS_BMSK                                        0xf
#define HWIO_IPA_VMIDMT_SIDR2_IAS_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_SIDR4_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000030)
#define HWIO_IPA_VMIDMT_SIDR4_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000030)
#define HWIO_IPA_VMIDMT_SIDR4_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000030)
#define HWIO_IPA_VMIDMT_SIDR4_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_SIDR4_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_SIDR4_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR4_ADDR, HWIO_IPA_VMIDMT_SIDR4_RMSK)
#define HWIO_IPA_VMIDMT_SIDR4_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR4_ADDR, m)
#define HWIO_IPA_VMIDMT_SIDR4_MAJOR_BMSK                               0xf0000000
#define HWIO_IPA_VMIDMT_SIDR4_MAJOR_SHFT                                     0x1c
#define HWIO_IPA_VMIDMT_SIDR4_MINOR_BMSK                                0xfff0000
#define HWIO_IPA_VMIDMT_SIDR4_MINOR_SHFT                                     0x10
#define HWIO_IPA_VMIDMT_SIDR4_STEP_BMSK                                    0xffff
#define HWIO_IPA_VMIDMT_SIDR4_STEP_SHFT                                       0x0

#define HWIO_IPA_VMIDMT_SIDR5_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000034)
#define HWIO_IPA_VMIDMT_SIDR5_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000034)
#define HWIO_IPA_VMIDMT_SIDR5_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000034)
#define HWIO_IPA_VMIDMT_SIDR5_RMSK                                       0xff03ff
#define HWIO_IPA_VMIDMT_SIDR5_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_SIDR5_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR5_ADDR, HWIO_IPA_VMIDMT_SIDR5_RMSK)
#define HWIO_IPA_VMIDMT_SIDR5_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR5_ADDR, m)
#define HWIO_IPA_VMIDMT_SIDR5_NUMMSDRB_BMSK                              0xff0000
#define HWIO_IPA_VMIDMT_SIDR5_NUMMSDRB_SHFT                                  0x10
#define HWIO_IPA_VMIDMT_SIDR5_MSAE_BMSK                                     0x200
#define HWIO_IPA_VMIDMT_SIDR5_MSAE_SHFT                                       0x9
#define HWIO_IPA_VMIDMT_SIDR5_QRIBE_BMSK                                    0x100
#define HWIO_IPA_VMIDMT_SIDR5_QRIBE_SHFT                                      0x8
#define HWIO_IPA_VMIDMT_SIDR5_NVMID_BMSK                                     0xff
#define HWIO_IPA_VMIDMT_SIDR5_NVMID_SHFT                                      0x0

#define HWIO_IPA_VMIDMT_SIDR7_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x0000003c)
#define HWIO_IPA_VMIDMT_SIDR7_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x0000003c)
#define HWIO_IPA_VMIDMT_SIDR7_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x0000003c)
#define HWIO_IPA_VMIDMT_SIDR7_RMSK                                           0xff
#define HWIO_IPA_VMIDMT_SIDR7_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_SIDR7_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR7_ADDR, HWIO_IPA_VMIDMT_SIDR7_RMSK)
#define HWIO_IPA_VMIDMT_SIDR7_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SIDR7_ADDR, m)
#define HWIO_IPA_VMIDMT_SIDR7_MAJOR_BMSK                                     0xf0
#define HWIO_IPA_VMIDMT_SIDR7_MAJOR_SHFT                                      0x4
#define HWIO_IPA_VMIDMT_SIDR7_MINOR_BMSK                                      0xf
#define HWIO_IPA_VMIDMT_SIDR7_MINOR_SHFT                                      0x0

#define HWIO_IPA_VMIDMT_SGFAR0_ADDR                                    (IPA_VMIDMT_REG_BASE      + 0x00000040)
#define HWIO_IPA_VMIDMT_SGFAR0_PHYS                                    (IPA_VMIDMT_REG_BASE_PHYS + 0x00000040)
#define HWIO_IPA_VMIDMT_SGFAR0_OFFS                                    (IPA_VMIDMT_REG_BASE_OFFS + 0x00000040)
#define HWIO_IPA_VMIDMT_SGFAR0_RMSK                                    0xffffffff
#define HWIO_IPA_VMIDMT_SGFAR0_ATTR                                           0x1
#define HWIO_IPA_VMIDMT_SGFAR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFAR0_ADDR, HWIO_IPA_VMIDMT_SGFAR0_RMSK)
#define HWIO_IPA_VMIDMT_SGFAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFAR0_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFAR0_SGFEA0_BMSK                             0xffffffff
#define HWIO_IPA_VMIDMT_SGFAR0_SGFEA0_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_SGFAR1_ADDR                                    (IPA_VMIDMT_REG_BASE      + 0x00000044)
#define HWIO_IPA_VMIDMT_SGFAR1_PHYS                                    (IPA_VMIDMT_REG_BASE_PHYS + 0x00000044)
#define HWIO_IPA_VMIDMT_SGFAR1_OFFS                                    (IPA_VMIDMT_REG_BASE_OFFS + 0x00000044)
#define HWIO_IPA_VMIDMT_SGFAR1_RMSK                                          0xff
#define HWIO_IPA_VMIDMT_SGFAR1_ATTR                                           0x1
#define HWIO_IPA_VMIDMT_SGFAR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFAR1_ADDR, HWIO_IPA_VMIDMT_SGFAR1_RMSK)
#define HWIO_IPA_VMIDMT_SGFAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFAR1_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFAR1_SGFEA1_BMSK                                   0xff
#define HWIO_IPA_VMIDMT_SGFAR1_SGFEA1_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_SGFSR_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000048)
#define HWIO_IPA_VMIDMT_SGFSR_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000048)
#define HWIO_IPA_VMIDMT_SGFSR_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000048)
#define HWIO_IPA_VMIDMT_SGFSR_RMSK                                     0xc0000026
#define HWIO_IPA_VMIDMT_SGFSR_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_SGFSR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSR_ADDR, HWIO_IPA_VMIDMT_SGFSR_RMSK)
#define HWIO_IPA_VMIDMT_SGFSR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSR_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFSR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SGFSR_ADDR,v)
#define HWIO_IPA_VMIDMT_SGFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SGFSR_ADDR,m,v,HWIO_IPA_VMIDMT_SGFSR_IN)
#define HWIO_IPA_VMIDMT_SGFSR_MULTI_CLIENT_BMSK                        0x80000000
#define HWIO_IPA_VMIDMT_SGFSR_MULTI_CLIENT_SHFT                              0x1f
#define HWIO_IPA_VMIDMT_SGFSR_MULTI_CFG_BMSK                           0x40000000
#define HWIO_IPA_VMIDMT_SGFSR_MULTI_CFG_SHFT                                 0x1e
#define HWIO_IPA_VMIDMT_SGFSR_CAF_BMSK                                       0x20
#define HWIO_IPA_VMIDMT_SGFSR_CAF_SHFT                                        0x5
#define HWIO_IPA_VMIDMT_SGFSR_SMCF_BMSK                                       0x4
#define HWIO_IPA_VMIDMT_SGFSR_SMCF_SHFT                                       0x2
#define HWIO_IPA_VMIDMT_SGFSR_USF_BMSK                                        0x2
#define HWIO_IPA_VMIDMT_SGFSR_USF_SHFT                                        0x1

#define HWIO_IPA_VMIDMT_SGFSRRESTORE_ADDR                              (IPA_VMIDMT_REG_BASE      + 0x0000004c)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_PHYS                              (IPA_VMIDMT_REG_BASE_PHYS + 0x0000004c)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_OFFS                              (IPA_VMIDMT_REG_BASE_OFFS + 0x0000004c)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_RMSK                              0xc0000026
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_ATTR                                     0x3
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSRRESTORE_ADDR, HWIO_IPA_VMIDMT_SGFSRRESTORE_RMSK)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSRRESTORE_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SGFSRRESTORE_ADDR,v)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SGFSRRESTORE_ADDR,m,v,HWIO_IPA_VMIDMT_SGFSRRESTORE_IN)
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_MULTI_CLIENT_BMSK                 0x80000000
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_MULTI_CLIENT_SHFT                       0x1f
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_MULTI_CFG_BMSK                    0x40000000
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_MULTI_CFG_SHFT                          0x1e
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_CAF_BMSK                                0x20
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_CAF_SHFT                                 0x5
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_SMCF_BMSK                                0x4
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_SMCF_SHFT                                0x2
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_USF_BMSK                                 0x2
#define HWIO_IPA_VMIDMT_SGFSRRESTORE_USF_SHFT                                 0x1

#define HWIO_IPA_VMIDMT_SGFSYNDR0_ADDR                                 (IPA_VMIDMT_REG_BASE      + 0x00000050)
#define HWIO_IPA_VMIDMT_SGFSYNDR0_PHYS                                 (IPA_VMIDMT_REG_BASE_PHYS + 0x00000050)
#define HWIO_IPA_VMIDMT_SGFSYNDR0_OFFS                                 (IPA_VMIDMT_REG_BASE_OFFS + 0x00000050)
#define HWIO_IPA_VMIDMT_SGFSYNDR0_RMSK                                      0x132
#define HWIO_IPA_VMIDMT_SGFSYNDR0_ATTR                                        0x1
#define HWIO_IPA_VMIDMT_SGFSYNDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSYNDR0_ADDR, HWIO_IPA_VMIDMT_SGFSYNDR0_RMSK)
#define HWIO_IPA_VMIDMT_SGFSYNDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSYNDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFSYNDR0_MSSSELFAUTH_BMSK                          0x100
#define HWIO_IPA_VMIDMT_SGFSYNDR0_MSSSELFAUTH_SHFT                            0x8
#define HWIO_IPA_VMIDMT_SGFSYNDR0_NSATTR_BMSK                                0x20
#define HWIO_IPA_VMIDMT_SGFSYNDR0_NSATTR_SHFT                                 0x5
#define HWIO_IPA_VMIDMT_SGFSYNDR0_NSSTATE_BMSK                               0x10
#define HWIO_IPA_VMIDMT_SGFSYNDR0_NSSTATE_SHFT                                0x4
#define HWIO_IPA_VMIDMT_SGFSYNDR0_WNR_BMSK                                    0x2
#define HWIO_IPA_VMIDMT_SGFSYNDR0_WNR_SHFT                                    0x1

#define HWIO_IPA_VMIDMT_SGFSYNDR1_ADDR                                 (IPA_VMIDMT_REG_BASE      + 0x00000054)
#define HWIO_IPA_VMIDMT_SGFSYNDR1_PHYS                                 (IPA_VMIDMT_REG_BASE_PHYS + 0x00000054)
#define HWIO_IPA_VMIDMT_SGFSYNDR1_OFFS                                 (IPA_VMIDMT_REG_BASE_OFFS + 0x00000054)
#define HWIO_IPA_VMIDMT_SGFSYNDR1_RMSK                                 0x7fff00ff
#define HWIO_IPA_VMIDMT_SGFSYNDR1_ATTR                                        0x1
#define HWIO_IPA_VMIDMT_SGFSYNDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSYNDR1_ADDR, HWIO_IPA_VMIDMT_SGFSYNDR1_RMSK)
#define HWIO_IPA_VMIDMT_SGFSYNDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSYNDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFSYNDR1_MSDINDEX_BMSK                        0x7f000000
#define HWIO_IPA_VMIDMT_SGFSYNDR1_MSDINDEX_SHFT                              0x18
#define HWIO_IPA_VMIDMT_SGFSYNDR1_SSDINDEX_BMSK                          0xff0000
#define HWIO_IPA_VMIDMT_SGFSYNDR1_SSDINDEX_SHFT                              0x10
#define HWIO_IPA_VMIDMT_SGFSYNDR1_STREAMINDEX_BMSK                           0xff
#define HWIO_IPA_VMIDMT_SGFSYNDR1_STREAMINDEX_SHFT                            0x0

#define HWIO_IPA_VMIDMT_SGFSYNDR2_ADDR                                 (IPA_VMIDMT_REG_BASE      + 0x00000058)
#define HWIO_IPA_VMIDMT_SGFSYNDR2_PHYS                                 (IPA_VMIDMT_REG_BASE_PHYS + 0x00000058)
#define HWIO_IPA_VMIDMT_SGFSYNDR2_OFFS                                 (IPA_VMIDMT_REG_BASE_OFFS + 0x00000058)
#define HWIO_IPA_VMIDMT_SGFSYNDR2_RMSK                                 0x1f1fffff
#define HWIO_IPA_VMIDMT_SGFSYNDR2_ATTR                                        0x1
#define HWIO_IPA_VMIDMT_SGFSYNDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSYNDR2_ADDR, HWIO_IPA_VMIDMT_SGFSYNDR2_RMSK)
#define HWIO_IPA_VMIDMT_SGFSYNDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SGFSYNDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_SGFSYNDR2_ATID_BMSK                            0x1f000000
#define HWIO_IPA_VMIDMT_SGFSYNDR2_ATID_SHFT                                  0x18
#define HWIO_IPA_VMIDMT_SGFSYNDR2_AVMID_BMSK                             0x1f0000
#define HWIO_IPA_VMIDMT_SGFSYNDR2_AVMID_SHFT                                 0x10
#define HWIO_IPA_VMIDMT_SGFSYNDR2_ABID_BMSK                                0xe000
#define HWIO_IPA_VMIDMT_SGFSYNDR2_ABID_SHFT                                   0xd
#define HWIO_IPA_VMIDMT_SGFSYNDR2_APID_BMSK                                0x1f00
#define HWIO_IPA_VMIDMT_SGFSYNDR2_APID_SHFT                                   0x8
#define HWIO_IPA_VMIDMT_SGFSYNDR2_AMID_BMSK                                  0xff
#define HWIO_IPA_VMIDMT_SGFSYNDR2_AMID_SHFT                                   0x0

#define HWIO_IPA_VMIDMT_VMIDMTSCR0_ADDR                                (IPA_VMIDMT_REG_BASE      + 0x00000090)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_PHYS                                (IPA_VMIDMT_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_OFFS                                (IPA_VMIDMT_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_RMSK                                       0x1
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_ATTR                                       0x3
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_VMIDMTSCR0_ADDR, HWIO_IPA_VMIDMT_VMIDMTSCR0_RMSK)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_VMIDMTSCR0_ADDR, m)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_VMIDMTSCR0_ADDR,v)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_VMIDMTSCR0_ADDR,m,v,HWIO_IPA_VMIDMT_VMIDMTSCR0_IN)
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_CLKONOFFE_BMSK                             0x1
#define HWIO_IPA_VMIDMT_VMIDMTSCR0_CLKONOFFE_SHFT                             0x0

#define HWIO_IPA_VMIDMT_CR0_ADDR                                       (IPA_VMIDMT_REG_BASE      + 0x00000000)
#define HWIO_IPA_VMIDMT_CR0_PHYS                                       (IPA_VMIDMT_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_VMIDMT_CR0_OFFS                                       (IPA_VMIDMT_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_VMIDMT_CR0_RMSK                                        0xff70ff5
#define HWIO_IPA_VMIDMT_CR0_ATTR                                              0x3
#define HWIO_IPA_VMIDMT_CR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_CR0_ADDR, HWIO_IPA_VMIDMT_CR0_RMSK)
#define HWIO_IPA_VMIDMT_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_CR0_ADDR, m)
#define HWIO_IPA_VMIDMT_CR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_CR0_ADDR,v)
#define HWIO_IPA_VMIDMT_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_CR0_ADDR,m,v,HWIO_IPA_VMIDMT_CR0_IN)
#define HWIO_IPA_VMIDMT_CR0_WACFG_BMSK                                  0xc000000
#define HWIO_IPA_VMIDMT_CR0_WACFG_SHFT                                       0x1a
#define HWIO_IPA_VMIDMT_CR0_RACFG_BMSK                                  0x3000000
#define HWIO_IPA_VMIDMT_CR0_RACFG_SHFT                                       0x18
#define HWIO_IPA_VMIDMT_CR0_SHCFG_BMSK                                   0xc00000
#define HWIO_IPA_VMIDMT_CR0_SHCFG_SHFT                                       0x16
#define HWIO_IPA_VMIDMT_CR0_SMCFCFG_BMSK                                 0x200000
#define HWIO_IPA_VMIDMT_CR0_SMCFCFG_SHFT                                     0x15
#define HWIO_IPA_VMIDMT_CR0_MTCFG_BMSK                                   0x100000
#define HWIO_IPA_VMIDMT_CR0_MTCFG_SHFT                                       0x14
#define HWIO_IPA_VMIDMT_CR0_MEMATTR_BMSK                                  0x70000
#define HWIO_IPA_VMIDMT_CR0_MEMATTR_SHFT                                     0x10
#define HWIO_IPA_VMIDMT_CR0_VMIDPNE_BMSK                                    0x800
#define HWIO_IPA_VMIDMT_CR0_VMIDPNE_SHFT                                      0xb
#define HWIO_IPA_VMIDMT_CR0_USFCFG_BMSK                                     0x400
#define HWIO_IPA_VMIDMT_CR0_USFCFG_SHFT                                       0xa
#define HWIO_IPA_VMIDMT_CR0_GSE_BMSK                                        0x200
#define HWIO_IPA_VMIDMT_CR0_GSE_SHFT                                          0x9
#define HWIO_IPA_VMIDMT_CR0_STALLD_BMSK                                     0x100
#define HWIO_IPA_VMIDMT_CR0_STALLD_SHFT                                       0x8
#define HWIO_IPA_VMIDMT_CR0_TRANSIENTCFG_BMSK                                0xc0
#define HWIO_IPA_VMIDMT_CR0_TRANSIENTCFG_SHFT                                 0x6
#define HWIO_IPA_VMIDMT_CR0_GCFGFIE_BMSK                                     0x20
#define HWIO_IPA_VMIDMT_CR0_GCFGFIE_SHFT                                      0x5
#define HWIO_IPA_VMIDMT_CR0_GCFGERE_BMSK                                     0x10
#define HWIO_IPA_VMIDMT_CR0_GCFGERE_SHFT                                      0x4
#define HWIO_IPA_VMIDMT_CR0_GFIE_BMSK                                         0x4
#define HWIO_IPA_VMIDMT_CR0_GFIE_SHFT                                         0x2
#define HWIO_IPA_VMIDMT_CR0_CLIENTPD_BMSK                                     0x1
#define HWIO_IPA_VMIDMT_CR0_CLIENTPD_SHFT                                     0x0

#define HWIO_IPA_VMIDMT_CR2_ADDR                                       (IPA_VMIDMT_REG_BASE      + 0x00000008)
#define HWIO_IPA_VMIDMT_CR2_PHYS                                       (IPA_VMIDMT_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_VMIDMT_CR2_OFFS                                       (IPA_VMIDMT_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_VMIDMT_CR2_RMSK                                             0x1f
#define HWIO_IPA_VMIDMT_CR2_ATTR                                              0x3
#define HWIO_IPA_VMIDMT_CR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_CR2_ADDR, HWIO_IPA_VMIDMT_CR2_RMSK)
#define HWIO_IPA_VMIDMT_CR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_CR2_ADDR, m)
#define HWIO_IPA_VMIDMT_CR2_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_CR2_ADDR,v)
#define HWIO_IPA_VMIDMT_CR2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_CR2_ADDR,m,v,HWIO_IPA_VMIDMT_CR2_IN)
#define HWIO_IPA_VMIDMT_CR2_BPVMID_BMSK                                      0x1f
#define HWIO_IPA_VMIDMT_CR2_BPVMID_SHFT                                       0x0

#define HWIO_IPA_VMIDMT_ACR_ADDR                                       (IPA_VMIDMT_REG_BASE      + 0x00000010)
#define HWIO_IPA_VMIDMT_ACR_PHYS                                       (IPA_VMIDMT_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_VMIDMT_ACR_OFFS                                       (IPA_VMIDMT_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_VMIDMT_ACR_RMSK                                       0x70000013
#define HWIO_IPA_VMIDMT_ACR_ATTR                                              0x3
#define HWIO_IPA_VMIDMT_ACR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_ACR_ADDR, HWIO_IPA_VMIDMT_ACR_RMSK)
#define HWIO_IPA_VMIDMT_ACR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_ACR_ADDR, m)
#define HWIO_IPA_VMIDMT_ACR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_ACR_ADDR,v)
#define HWIO_IPA_VMIDMT_ACR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_ACR_ADDR,m,v,HWIO_IPA_VMIDMT_ACR_IN)
#define HWIO_IPA_VMIDMT_ACR_BPRCNSH_BMSK                               0x40000000
#define HWIO_IPA_VMIDMT_ACR_BPRCNSH_SHFT                                     0x1e
#define HWIO_IPA_VMIDMT_ACR_BPRCISH_BMSK                               0x20000000
#define HWIO_IPA_VMIDMT_ACR_BPRCISH_SHFT                                     0x1d
#define HWIO_IPA_VMIDMT_ACR_BPRCOSH_BMSK                               0x10000000
#define HWIO_IPA_VMIDMT_ACR_BPRCOSH_SHFT                                     0x1c
#define HWIO_IPA_VMIDMT_ACR_BPREQPRIORITYCFG_BMSK                            0x10
#define HWIO_IPA_VMIDMT_ACR_BPREQPRIORITYCFG_SHFT                             0x4
#define HWIO_IPA_VMIDMT_ACR_BPREQPRIORITY_BMSK                                0x3
#define HWIO_IPA_VMIDMT_ACR_BPREQPRIORITY_SHFT                                0x0

#define HWIO_IPA_VMIDMT_IDR0_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000020)
#define HWIO_IPA_VMIDMT_IDR0_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000020)
#define HWIO_IPA_VMIDMT_IDR0_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000020)
#define HWIO_IPA_VMIDMT_IDR0_RMSK                                       0x8001eff
#define HWIO_IPA_VMIDMT_IDR0_ATTR                                             0x1
#define HWIO_IPA_VMIDMT_IDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR0_ADDR, HWIO_IPA_VMIDMT_IDR0_RMSK)
#define HWIO_IPA_VMIDMT_IDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_IDR0_SMS_BMSK                                   0x8000000
#define HWIO_IPA_VMIDMT_IDR0_SMS_SHFT                                        0x1b
#define HWIO_IPA_VMIDMT_IDR0_NUMSIDB_BMSK                                  0x1e00
#define HWIO_IPA_VMIDMT_IDR0_NUMSIDB_SHFT                                     0x9
#define HWIO_IPA_VMIDMT_IDR0_NUMSMRG_BMSK                                    0xff
#define HWIO_IPA_VMIDMT_IDR0_NUMSMRG_SHFT                                     0x0

#define HWIO_IPA_VMIDMT_IDR1_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000024)
#define HWIO_IPA_VMIDMT_IDR1_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000024)
#define HWIO_IPA_VMIDMT_IDR1_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000024)
#define HWIO_IPA_VMIDMT_IDR1_RMSK                                          0x9f00
#define HWIO_IPA_VMIDMT_IDR1_ATTR                                             0x1
#define HWIO_IPA_VMIDMT_IDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR1_ADDR, HWIO_IPA_VMIDMT_IDR1_RMSK)
#define HWIO_IPA_VMIDMT_IDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_IDR1_SMCD_BMSK                                     0x8000
#define HWIO_IPA_VMIDMT_IDR1_SMCD_SHFT                                        0xf
#define HWIO_IPA_VMIDMT_IDR1_SSDTP_BMSK                                    0x1000
#define HWIO_IPA_VMIDMT_IDR1_SSDTP_SHFT                                       0xc
#define HWIO_IPA_VMIDMT_IDR1_NUMSSDNDX_BMSK                                 0xf00
#define HWIO_IPA_VMIDMT_IDR1_NUMSSDNDX_SHFT                                   0x8

#define HWIO_IPA_VMIDMT_IDR2_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000028)
#define HWIO_IPA_VMIDMT_IDR2_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000028)
#define HWIO_IPA_VMIDMT_IDR2_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000028)
#define HWIO_IPA_VMIDMT_IDR2_RMSK                                            0xff
#define HWIO_IPA_VMIDMT_IDR2_ATTR                                             0x1
#define HWIO_IPA_VMIDMT_IDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR2_ADDR, HWIO_IPA_VMIDMT_IDR2_RMSK)
#define HWIO_IPA_VMIDMT_IDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_IDR2_OAS_BMSK                                        0xf0
#define HWIO_IPA_VMIDMT_IDR2_OAS_SHFT                                         0x4
#define HWIO_IPA_VMIDMT_IDR2_IAS_BMSK                                         0xf
#define HWIO_IPA_VMIDMT_IDR2_IAS_SHFT                                         0x0

#define HWIO_IPA_VMIDMT_IDR4_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000030)
#define HWIO_IPA_VMIDMT_IDR4_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000030)
#define HWIO_IPA_VMIDMT_IDR4_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000030)
#define HWIO_IPA_VMIDMT_IDR4_RMSK                                      0xffffffff
#define HWIO_IPA_VMIDMT_IDR4_ATTR                                             0x1
#define HWIO_IPA_VMIDMT_IDR4_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR4_ADDR, HWIO_IPA_VMIDMT_IDR4_RMSK)
#define HWIO_IPA_VMIDMT_IDR4_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR4_ADDR, m)
#define HWIO_IPA_VMIDMT_IDR4_MAJOR_BMSK                                0xf0000000
#define HWIO_IPA_VMIDMT_IDR4_MAJOR_SHFT                                      0x1c
#define HWIO_IPA_VMIDMT_IDR4_MINOR_BMSK                                 0xfff0000
#define HWIO_IPA_VMIDMT_IDR4_MINOR_SHFT                                      0x10
#define HWIO_IPA_VMIDMT_IDR4_STEP_BMSK                                     0xffff
#define HWIO_IPA_VMIDMT_IDR4_STEP_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_IDR5_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000034)
#define HWIO_IPA_VMIDMT_IDR5_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000034)
#define HWIO_IPA_VMIDMT_IDR5_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000034)
#define HWIO_IPA_VMIDMT_IDR5_RMSK                                        0xff03ff
#define HWIO_IPA_VMIDMT_IDR5_ATTR                                             0x1
#define HWIO_IPA_VMIDMT_IDR5_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR5_ADDR, HWIO_IPA_VMIDMT_IDR5_RMSK)
#define HWIO_IPA_VMIDMT_IDR5_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR5_ADDR, m)
#define HWIO_IPA_VMIDMT_IDR5_NUMMSDRB_BMSK                               0xff0000
#define HWIO_IPA_VMIDMT_IDR5_NUMMSDRB_SHFT                                   0x10
#define HWIO_IPA_VMIDMT_IDR5_MSAE_BMSK                                      0x200
#define HWIO_IPA_VMIDMT_IDR5_MSAE_SHFT                                        0x9
#define HWIO_IPA_VMIDMT_IDR5_QRIBE_BMSK                                     0x100
#define HWIO_IPA_VMIDMT_IDR5_QRIBE_SHFT                                       0x8
#define HWIO_IPA_VMIDMT_IDR5_NVMID_BMSK                                      0xff
#define HWIO_IPA_VMIDMT_IDR5_NVMID_SHFT                                       0x0

#define HWIO_IPA_VMIDMT_IDR7_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x0000003c)
#define HWIO_IPA_VMIDMT_IDR7_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x0000003c)
#define HWIO_IPA_VMIDMT_IDR7_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x0000003c)
#define HWIO_IPA_VMIDMT_IDR7_RMSK                                            0xff
#define HWIO_IPA_VMIDMT_IDR7_ATTR                                             0x1
#define HWIO_IPA_VMIDMT_IDR7_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR7_ADDR, HWIO_IPA_VMIDMT_IDR7_RMSK)
#define HWIO_IPA_VMIDMT_IDR7_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_IDR7_ADDR, m)
#define HWIO_IPA_VMIDMT_IDR7_MAJOR_BMSK                                      0xf0
#define HWIO_IPA_VMIDMT_IDR7_MAJOR_SHFT                                       0x4
#define HWIO_IPA_VMIDMT_IDR7_MINOR_BMSK                                       0xf
#define HWIO_IPA_VMIDMT_IDR7_MINOR_SHFT                                       0x0

#define HWIO_IPA_VMIDMT_GFAR0_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000040)
#define HWIO_IPA_VMIDMT_GFAR0_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000040)
#define HWIO_IPA_VMIDMT_GFAR0_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000040)
#define HWIO_IPA_VMIDMT_GFAR0_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_GFAR0_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_GFAR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFAR0_ADDR, HWIO_IPA_VMIDMT_GFAR0_RMSK)
#define HWIO_IPA_VMIDMT_GFAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFAR0_ADDR, m)
#define HWIO_IPA_VMIDMT_GFAR0_GFEA0_BMSK                               0xffffffff
#define HWIO_IPA_VMIDMT_GFAR0_GFEA0_SHFT                                      0x0

#define HWIO_IPA_VMIDMT_GFAR1_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000044)
#define HWIO_IPA_VMIDMT_GFAR1_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000044)
#define HWIO_IPA_VMIDMT_GFAR1_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000044)
#define HWIO_IPA_VMIDMT_GFAR1_RMSK                                           0xff
#define HWIO_IPA_VMIDMT_GFAR1_ATTR                                            0x1
#define HWIO_IPA_VMIDMT_GFAR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFAR1_ADDR, HWIO_IPA_VMIDMT_GFAR1_RMSK)
#define HWIO_IPA_VMIDMT_GFAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFAR1_ADDR, m)
#define HWIO_IPA_VMIDMT_GFAR1_GFEA1_BMSK                                     0xff
#define HWIO_IPA_VMIDMT_GFAR1_GFEA1_SHFT                                      0x0

#define HWIO_IPA_VMIDMT_GFSR_ADDR                                      (IPA_VMIDMT_REG_BASE      + 0x00000048)
#define HWIO_IPA_VMIDMT_GFSR_PHYS                                      (IPA_VMIDMT_REG_BASE_PHYS + 0x00000048)
#define HWIO_IPA_VMIDMT_GFSR_OFFS                                      (IPA_VMIDMT_REG_BASE_OFFS + 0x00000048)
#define HWIO_IPA_VMIDMT_GFSR_RMSK                                      0xc00000a6
#define HWIO_IPA_VMIDMT_GFSR_ATTR                                             0x3
#define HWIO_IPA_VMIDMT_GFSR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSR_ADDR, HWIO_IPA_VMIDMT_GFSR_RMSK)
#define HWIO_IPA_VMIDMT_GFSR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSR_ADDR, m)
#define HWIO_IPA_VMIDMT_GFSR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_GFSR_ADDR,v)
#define HWIO_IPA_VMIDMT_GFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_GFSR_ADDR,m,v,HWIO_IPA_VMIDMT_GFSR_IN)
#define HWIO_IPA_VMIDMT_GFSR_MULTI_CLIENT_BMSK                         0x80000000
#define HWIO_IPA_VMIDMT_GFSR_MULTI_CLIENT_SHFT                               0x1f
#define HWIO_IPA_VMIDMT_GFSR_MULTI_CFG_BMSK                            0x40000000
#define HWIO_IPA_VMIDMT_GFSR_MULTI_CFG_SHFT                                  0x1e
#define HWIO_IPA_VMIDMT_GFSR_PF_BMSK                                         0x80
#define HWIO_IPA_VMIDMT_GFSR_PF_SHFT                                          0x7
#define HWIO_IPA_VMIDMT_GFSR_CAF_BMSK                                        0x20
#define HWIO_IPA_VMIDMT_GFSR_CAF_SHFT                                         0x5
#define HWIO_IPA_VMIDMT_GFSR_SMCF_BMSK                                        0x4
#define HWIO_IPA_VMIDMT_GFSR_SMCF_SHFT                                        0x2
#define HWIO_IPA_VMIDMT_GFSR_USF_BMSK                                         0x2
#define HWIO_IPA_VMIDMT_GFSR_USF_SHFT                                         0x1

#define HWIO_IPA_VMIDMT_GFSRRESTORE_ADDR                               (IPA_VMIDMT_REG_BASE      + 0x0000004c)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_PHYS                               (IPA_VMIDMT_REG_BASE_PHYS + 0x0000004c)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_OFFS                               (IPA_VMIDMT_REG_BASE_OFFS + 0x0000004c)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_RMSK                               0xc00000a6
#define HWIO_IPA_VMIDMT_GFSRRESTORE_ATTR                                      0x3
#define HWIO_IPA_VMIDMT_GFSRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSRRESTORE_ADDR, HWIO_IPA_VMIDMT_GFSRRESTORE_RMSK)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSRRESTORE_ADDR, m)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_GFSRRESTORE_ADDR,v)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_GFSRRESTORE_ADDR,m,v,HWIO_IPA_VMIDMT_GFSRRESTORE_IN)
#define HWIO_IPA_VMIDMT_GFSRRESTORE_MULTI_CLIENT_BMSK                  0x80000000
#define HWIO_IPA_VMIDMT_GFSRRESTORE_MULTI_CLIENT_SHFT                        0x1f
#define HWIO_IPA_VMIDMT_GFSRRESTORE_MULTI_CFG_BMSK                     0x40000000
#define HWIO_IPA_VMIDMT_GFSRRESTORE_MULTI_CFG_SHFT                           0x1e
#define HWIO_IPA_VMIDMT_GFSRRESTORE_PF_BMSK                                  0x80
#define HWIO_IPA_VMIDMT_GFSRRESTORE_PF_SHFT                                   0x7
#define HWIO_IPA_VMIDMT_GFSRRESTORE_CAF_BMSK                                 0x20
#define HWIO_IPA_VMIDMT_GFSRRESTORE_CAF_SHFT                                  0x5
#define HWIO_IPA_VMIDMT_GFSRRESTORE_SMCF_BMSK                                 0x4
#define HWIO_IPA_VMIDMT_GFSRRESTORE_SMCF_SHFT                                 0x2
#define HWIO_IPA_VMIDMT_GFSRRESTORE_USF_BMSK                                  0x2
#define HWIO_IPA_VMIDMT_GFSRRESTORE_USF_SHFT                                  0x1

#define HWIO_IPA_VMIDMT_GFSYNDR0_ADDR                                  (IPA_VMIDMT_REG_BASE      + 0x00000050)
#define HWIO_IPA_VMIDMT_GFSYNDR0_PHYS                                  (IPA_VMIDMT_REG_BASE_PHYS + 0x00000050)
#define HWIO_IPA_VMIDMT_GFSYNDR0_OFFS                                  (IPA_VMIDMT_REG_BASE_OFFS + 0x00000050)
#define HWIO_IPA_VMIDMT_GFSYNDR0_RMSK                                       0x132
#define HWIO_IPA_VMIDMT_GFSYNDR0_ATTR                                         0x1
#define HWIO_IPA_VMIDMT_GFSYNDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSYNDR0_ADDR, HWIO_IPA_VMIDMT_GFSYNDR0_RMSK)
#define HWIO_IPA_VMIDMT_GFSYNDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSYNDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_GFSYNDR0_MSSSELFAUTH_BMSK                           0x100
#define HWIO_IPA_VMIDMT_GFSYNDR0_MSSSELFAUTH_SHFT                             0x8
#define HWIO_IPA_VMIDMT_GFSYNDR0_NSATTR_BMSK                                 0x20
#define HWIO_IPA_VMIDMT_GFSYNDR0_NSATTR_SHFT                                  0x5
#define HWIO_IPA_VMIDMT_GFSYNDR0_NSSTATE_BMSK                                0x10
#define HWIO_IPA_VMIDMT_GFSYNDR0_NSSTATE_SHFT                                 0x4
#define HWIO_IPA_VMIDMT_GFSYNDR0_WNR_BMSK                                     0x2
#define HWIO_IPA_VMIDMT_GFSYNDR0_WNR_SHFT                                     0x1

#define HWIO_IPA_VMIDMT_GFSYNDR1_ADDR                                  (IPA_VMIDMT_REG_BASE      + 0x00000054)
#define HWIO_IPA_VMIDMT_GFSYNDR1_PHYS                                  (IPA_VMIDMT_REG_BASE_PHYS + 0x00000054)
#define HWIO_IPA_VMIDMT_GFSYNDR1_OFFS                                  (IPA_VMIDMT_REG_BASE_OFFS + 0x00000054)
#define HWIO_IPA_VMIDMT_GFSYNDR1_RMSK                                  0x7fff00ff
#define HWIO_IPA_VMIDMT_GFSYNDR1_ATTR                                         0x1
#define HWIO_IPA_VMIDMT_GFSYNDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSYNDR1_ADDR, HWIO_IPA_VMIDMT_GFSYNDR1_RMSK)
#define HWIO_IPA_VMIDMT_GFSYNDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSYNDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_GFSYNDR1_MSDINDEX_BMSK                         0x7f000000
#define HWIO_IPA_VMIDMT_GFSYNDR1_MSDINDEX_SHFT                               0x18
#define HWIO_IPA_VMIDMT_GFSYNDR1_SSDINDEX_BMSK                           0xff0000
#define HWIO_IPA_VMIDMT_GFSYNDR1_SSDINDEX_SHFT                               0x10
#define HWIO_IPA_VMIDMT_GFSYNDR1_STREAMINDEX_BMSK                            0xff
#define HWIO_IPA_VMIDMT_GFSYNDR1_STREAMINDEX_SHFT                             0x0

#define HWIO_IPA_VMIDMT_GFSYNDR2_ADDR                                  (IPA_VMIDMT_REG_BASE      + 0x00000058)
#define HWIO_IPA_VMIDMT_GFSYNDR2_PHYS                                  (IPA_VMIDMT_REG_BASE_PHYS + 0x00000058)
#define HWIO_IPA_VMIDMT_GFSYNDR2_OFFS                                  (IPA_VMIDMT_REG_BASE_OFFS + 0x00000058)
#define HWIO_IPA_VMIDMT_GFSYNDR2_RMSK                                  0x1f1fffff
#define HWIO_IPA_VMIDMT_GFSYNDR2_ATTR                                         0x1
#define HWIO_IPA_VMIDMT_GFSYNDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSYNDR2_ADDR, HWIO_IPA_VMIDMT_GFSYNDR2_RMSK)
#define HWIO_IPA_VMIDMT_GFSYNDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_GFSYNDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_GFSYNDR2_ATID_BMSK                             0x1f000000
#define HWIO_IPA_VMIDMT_GFSYNDR2_ATID_SHFT                                   0x18
#define HWIO_IPA_VMIDMT_GFSYNDR2_AVMID_BMSK                              0x1f0000
#define HWIO_IPA_VMIDMT_GFSYNDR2_AVMID_SHFT                                  0x10
#define HWIO_IPA_VMIDMT_GFSYNDR2_ABID_BMSK                                 0xe000
#define HWIO_IPA_VMIDMT_GFSYNDR2_ABID_SHFT                                    0xd
#define HWIO_IPA_VMIDMT_GFSYNDR2_APID_BMSK                                 0x1f00
#define HWIO_IPA_VMIDMT_GFSYNDR2_APID_SHFT                                    0x8
#define HWIO_IPA_VMIDMT_GFSYNDR2_AMID_BMSK                                   0xff
#define HWIO_IPA_VMIDMT_GFSYNDR2_AMID_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_VMIDMTCR0_ADDR                                 (IPA_VMIDMT_REG_BASE      + 0x00000090)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_PHYS                                 (IPA_VMIDMT_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_OFFS                                 (IPA_VMIDMT_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_RMSK                                        0x1
#define HWIO_IPA_VMIDMT_VMIDMTCR0_ATTR                                        0x3
#define HWIO_IPA_VMIDMT_VMIDMTCR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_VMIDMTCR0_ADDR, HWIO_IPA_VMIDMT_VMIDMTCR0_RMSK)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_VMIDMTCR0_ADDR, m)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_VMIDMTCR0_ADDR,v)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_VMIDMTCR0_ADDR,m,v,HWIO_IPA_VMIDMT_VMIDMTCR0_IN)
#define HWIO_IPA_VMIDMT_VMIDMTCR0_CLKONOFFE_BMSK                              0x1
#define HWIO_IPA_VMIDMT_VMIDMTCR0_CLKONOFFE_SHFT                              0x0

#define HWIO_IPA_VMIDMT_VMIDMTACR_ADDR                                 (IPA_VMIDMT_REG_BASE      + 0x0000009c)
#define HWIO_IPA_VMIDMT_VMIDMTACR_PHYS                                 (IPA_VMIDMT_REG_BASE_PHYS + 0x0000009c)
#define HWIO_IPA_VMIDMT_VMIDMTACR_OFFS                                 (IPA_VMIDMT_REG_BASE_OFFS + 0x0000009c)
#define HWIO_IPA_VMIDMT_VMIDMTACR_RMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_VMIDMTACR_ATTR                                        0x3
#define HWIO_IPA_VMIDMT_VMIDMTACR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_VMIDMTACR_ADDR, HWIO_IPA_VMIDMT_VMIDMTACR_RMSK)
#define HWIO_IPA_VMIDMT_VMIDMTACR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_VMIDMTACR_ADDR, m)
#define HWIO_IPA_VMIDMT_VMIDMTACR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_VMIDMTACR_ADDR,v)
#define HWIO_IPA_VMIDMT_VMIDMTACR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_VMIDMTACR_ADDR,m,v,HWIO_IPA_VMIDMT_VMIDMTACR_IN)
#define HWIO_IPA_VMIDMT_VMIDMTACR_RWE_BMSK                             0xffffffff
#define HWIO_IPA_VMIDMT_VMIDMTACR_RWE_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_NSCR0_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000400)
#define HWIO_IPA_VMIDMT_NSCR0_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_VMIDMT_NSCR0_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_VMIDMT_NSCR0_RMSK                                      0xff70ff5
#define HWIO_IPA_VMIDMT_NSCR0_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_NSCR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSCR0_ADDR, HWIO_IPA_VMIDMT_NSCR0_RMSK)
#define HWIO_IPA_VMIDMT_NSCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSCR0_ADDR, m)
#define HWIO_IPA_VMIDMT_NSCR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_NSCR0_ADDR,v)
#define HWIO_IPA_VMIDMT_NSCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_NSCR0_ADDR,m,v,HWIO_IPA_VMIDMT_NSCR0_IN)
#define HWIO_IPA_VMIDMT_NSCR0_WACFG_BMSK                                0xc000000
#define HWIO_IPA_VMIDMT_NSCR0_WACFG_SHFT                                     0x1a
#define HWIO_IPA_VMIDMT_NSCR0_RACFG_BMSK                                0x3000000
#define HWIO_IPA_VMIDMT_NSCR0_RACFG_SHFT                                     0x18
#define HWIO_IPA_VMIDMT_NSCR0_SHCFG_BMSK                                 0xc00000
#define HWIO_IPA_VMIDMT_NSCR0_SHCFG_SHFT                                     0x16
#define HWIO_IPA_VMIDMT_NSCR0_SMCFCFG_BMSK                               0x200000
#define HWIO_IPA_VMIDMT_NSCR0_SMCFCFG_SHFT                                   0x15
#define HWIO_IPA_VMIDMT_NSCR0_MTCFG_BMSK                                 0x100000
#define HWIO_IPA_VMIDMT_NSCR0_MTCFG_SHFT                                     0x14
#define HWIO_IPA_VMIDMT_NSCR0_MEMATTR_BMSK                                0x70000
#define HWIO_IPA_VMIDMT_NSCR0_MEMATTR_SHFT                                   0x10
#define HWIO_IPA_VMIDMT_NSCR0_VMIDPNE_BMSK                                  0x800
#define HWIO_IPA_VMIDMT_NSCR0_VMIDPNE_SHFT                                    0xb
#define HWIO_IPA_VMIDMT_NSCR0_USFCFG_BMSK                                   0x400
#define HWIO_IPA_VMIDMT_NSCR0_USFCFG_SHFT                                     0xa
#define HWIO_IPA_VMIDMT_NSCR0_GSE_BMSK                                      0x200
#define HWIO_IPA_VMIDMT_NSCR0_GSE_SHFT                                        0x9
#define HWIO_IPA_VMIDMT_NSCR0_STALLD_BMSK                                   0x100
#define HWIO_IPA_VMIDMT_NSCR0_STALLD_SHFT                                     0x8
#define HWIO_IPA_VMIDMT_NSCR0_TRANSIENTCFG_BMSK                              0xc0
#define HWIO_IPA_VMIDMT_NSCR0_TRANSIENTCFG_SHFT                               0x6
#define HWIO_IPA_VMIDMT_NSCR0_GCFGFIE_BMSK                                   0x20
#define HWIO_IPA_VMIDMT_NSCR0_GCFGFIE_SHFT                                    0x5
#define HWIO_IPA_VMIDMT_NSCR0_GCFGERE_BMSK                                   0x10
#define HWIO_IPA_VMIDMT_NSCR0_GCFGERE_SHFT                                    0x4
#define HWIO_IPA_VMIDMT_NSCR0_GFIE_BMSK                                       0x4
#define HWIO_IPA_VMIDMT_NSCR0_GFIE_SHFT                                       0x2
#define HWIO_IPA_VMIDMT_NSCR0_CLIENTPD_BMSK                                   0x1
#define HWIO_IPA_VMIDMT_NSCR0_CLIENTPD_SHFT                                   0x0

#define HWIO_IPA_VMIDMT_NSCR2_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000408)
#define HWIO_IPA_VMIDMT_NSCR2_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000408)
#define HWIO_IPA_VMIDMT_NSCR2_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000408)
#define HWIO_IPA_VMIDMT_NSCR2_RMSK                                           0x1f
#define HWIO_IPA_VMIDMT_NSCR2_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_NSCR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSCR2_ADDR, HWIO_IPA_VMIDMT_NSCR2_RMSK)
#define HWIO_IPA_VMIDMT_NSCR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSCR2_ADDR, m)
#define HWIO_IPA_VMIDMT_NSCR2_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_NSCR2_ADDR,v)
#define HWIO_IPA_VMIDMT_NSCR2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_NSCR2_ADDR,m,v,HWIO_IPA_VMIDMT_NSCR2_IN)
#define HWIO_IPA_VMIDMT_NSCR2_BPVMID_BMSK                                    0x1f
#define HWIO_IPA_VMIDMT_NSCR2_BPVMID_SHFT                                     0x0

#define HWIO_IPA_VMIDMT_NSACR_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000410)
#define HWIO_IPA_VMIDMT_NSACR_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000410)
#define HWIO_IPA_VMIDMT_NSACR_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000410)
#define HWIO_IPA_VMIDMT_NSACR_RMSK                                     0x70000013
#define HWIO_IPA_VMIDMT_NSACR_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_NSACR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSACR_ADDR, HWIO_IPA_VMIDMT_NSACR_RMSK)
#define HWIO_IPA_VMIDMT_NSACR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSACR_ADDR, m)
#define HWIO_IPA_VMIDMT_NSACR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_NSACR_ADDR,v)
#define HWIO_IPA_VMIDMT_NSACR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_NSACR_ADDR,m,v,HWIO_IPA_VMIDMT_NSACR_IN)
#define HWIO_IPA_VMIDMT_NSACR_BPRCNSH_BMSK                             0x40000000
#define HWIO_IPA_VMIDMT_NSACR_BPRCNSH_SHFT                                   0x1e
#define HWIO_IPA_VMIDMT_NSACR_BPRCISH_BMSK                             0x20000000
#define HWIO_IPA_VMIDMT_NSACR_BPRCISH_SHFT                                   0x1d
#define HWIO_IPA_VMIDMT_NSACR_BPRCOSH_BMSK                             0x10000000
#define HWIO_IPA_VMIDMT_NSACR_BPRCOSH_SHFT                                   0x1c
#define HWIO_IPA_VMIDMT_NSACR_BPREQPRIORITYCFG_BMSK                          0x10
#define HWIO_IPA_VMIDMT_NSACR_BPREQPRIORITYCFG_SHFT                           0x4
#define HWIO_IPA_VMIDMT_NSACR_BPREQPRIORITY_BMSK                              0x3
#define HWIO_IPA_VMIDMT_NSACR_BPREQPRIORITY_SHFT                              0x0

#define HWIO_IPA_VMIDMT_NSGFAR0_ADDR                                   (IPA_VMIDMT_REG_BASE      + 0x00000440)
#define HWIO_IPA_VMIDMT_NSGFAR0_PHYS                                   (IPA_VMIDMT_REG_BASE_PHYS + 0x00000440)
#define HWIO_IPA_VMIDMT_NSGFAR0_OFFS                                   (IPA_VMIDMT_REG_BASE_OFFS + 0x00000440)
#define HWIO_IPA_VMIDMT_NSGFAR0_RMSK                                   0xffffffff
#define HWIO_IPA_VMIDMT_NSGFAR0_ATTR                                          0x1
#define HWIO_IPA_VMIDMT_NSGFAR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFAR0_ADDR, HWIO_IPA_VMIDMT_NSGFAR0_RMSK)
#define HWIO_IPA_VMIDMT_NSGFAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFAR0_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFAR0_GFEA0_BMSK                             0xffffffff
#define HWIO_IPA_VMIDMT_NSGFAR0_GFEA0_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_NSGFAR1_ADDR                                   (IPA_VMIDMT_REG_BASE      + 0x00000444)
#define HWIO_IPA_VMIDMT_NSGFAR1_PHYS                                   (IPA_VMIDMT_REG_BASE_PHYS + 0x00000444)
#define HWIO_IPA_VMIDMT_NSGFAR1_OFFS                                   (IPA_VMIDMT_REG_BASE_OFFS + 0x00000444)
#define HWIO_IPA_VMIDMT_NSGFAR1_RMSK                                         0xff
#define HWIO_IPA_VMIDMT_NSGFAR1_ATTR                                          0x1
#define HWIO_IPA_VMIDMT_NSGFAR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFAR1_ADDR, HWIO_IPA_VMIDMT_NSGFAR1_RMSK)
#define HWIO_IPA_VMIDMT_NSGFAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFAR1_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFAR1_GFEA1_BMSK                                   0xff
#define HWIO_IPA_VMIDMT_NSGFAR1_GFEA1_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_NSGFSR_ADDR                                    (IPA_VMIDMT_REG_BASE      + 0x00000448)
#define HWIO_IPA_VMIDMT_NSGFSR_PHYS                                    (IPA_VMIDMT_REG_BASE_PHYS + 0x00000448)
#define HWIO_IPA_VMIDMT_NSGFSR_OFFS                                    (IPA_VMIDMT_REG_BASE_OFFS + 0x00000448)
#define HWIO_IPA_VMIDMT_NSGFSR_RMSK                                    0xc00000a6
#define HWIO_IPA_VMIDMT_NSGFSR_ATTR                                           0x3
#define HWIO_IPA_VMIDMT_NSGFSR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSR_ADDR, HWIO_IPA_VMIDMT_NSGFSR_RMSK)
#define HWIO_IPA_VMIDMT_NSGFSR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSR_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFSR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_NSGFSR_ADDR,v)
#define HWIO_IPA_VMIDMT_NSGFSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_NSGFSR_ADDR,m,v,HWIO_IPA_VMIDMT_NSGFSR_IN)
#define HWIO_IPA_VMIDMT_NSGFSR_MULTI_CLIENT_BMSK                       0x80000000
#define HWIO_IPA_VMIDMT_NSGFSR_MULTI_CLIENT_SHFT                             0x1f
#define HWIO_IPA_VMIDMT_NSGFSR_MULTI_CFG_BMSK                          0x40000000
#define HWIO_IPA_VMIDMT_NSGFSR_MULTI_CFG_SHFT                                0x1e
#define HWIO_IPA_VMIDMT_NSGFSR_PF_BMSK                                       0x80
#define HWIO_IPA_VMIDMT_NSGFSR_PF_SHFT                                        0x7
#define HWIO_IPA_VMIDMT_NSGFSR_CAF_BMSK                                      0x20
#define HWIO_IPA_VMIDMT_NSGFSR_CAF_SHFT                                       0x5
#define HWIO_IPA_VMIDMT_NSGFSR_SMCF_BMSK                                      0x4
#define HWIO_IPA_VMIDMT_NSGFSR_SMCF_SHFT                                      0x2
#define HWIO_IPA_VMIDMT_NSGFSR_USF_BMSK                                       0x2
#define HWIO_IPA_VMIDMT_NSGFSR_USF_SHFT                                       0x1

#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_ADDR                             (IPA_VMIDMT_REG_BASE      + 0x0000044c)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_PHYS                             (IPA_VMIDMT_REG_BASE_PHYS + 0x0000044c)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_OFFS                             (IPA_VMIDMT_REG_BASE_OFFS + 0x0000044c)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_RMSK                             0xc00000a6
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_ATTR                                    0x3
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSRRESTORE_ADDR, HWIO_IPA_VMIDMT_NSGFSRRESTORE_RMSK)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSRRESTORE_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_NSGFSRRESTORE_ADDR,v)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_NSGFSRRESTORE_ADDR,m,v,HWIO_IPA_VMIDMT_NSGFSRRESTORE_IN)
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_MULTI_CLIENT_BMSK                0x80000000
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_MULTI_CLIENT_SHFT                      0x1f
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_MULTI_CFG_BMSK                   0x40000000
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_MULTI_CFG_SHFT                         0x1e
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_PF_BMSK                                0x80
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_PF_SHFT                                 0x7
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_CAF_BMSK                               0x20
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_CAF_SHFT                                0x5
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_SMCF_BMSK                               0x4
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_SMCF_SHFT                               0x2
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_USF_BMSK                                0x2
#define HWIO_IPA_VMIDMT_NSGFSRRESTORE_USF_SHFT                                0x1

#define HWIO_IPA_VMIDMT_NSGFSYNDR0_ADDR                                (IPA_VMIDMT_REG_BASE      + 0x00000450)
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_PHYS                                (IPA_VMIDMT_REG_BASE_PHYS + 0x00000450)
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_OFFS                                (IPA_VMIDMT_REG_BASE_OFFS + 0x00000450)
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_RMSK                                     0x132
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_ATTR                                       0x1
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSYNDR0_ADDR, HWIO_IPA_VMIDMT_NSGFSYNDR0_RMSK)
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSYNDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_MSSSELFAUTH_BMSK                         0x100
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_MSSSELFAUTH_SHFT                           0x8
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_NSATTR_BMSK                               0x20
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_NSATTR_SHFT                                0x5
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_NSSTATE_BMSK                              0x10
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_NSSTATE_SHFT                               0x4
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_WNR_BMSK                                   0x2
#define HWIO_IPA_VMIDMT_NSGFSYNDR0_WNR_SHFT                                   0x1

#define HWIO_IPA_VMIDMT_NSGFSYNDR1_ADDR                                (IPA_VMIDMT_REG_BASE      + 0x00000454)
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_PHYS                                (IPA_VMIDMT_REG_BASE_PHYS + 0x00000454)
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_OFFS                                (IPA_VMIDMT_REG_BASE_OFFS + 0x00000454)
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_RMSK                                0x7fff00ff
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_ATTR                                       0x1
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSYNDR1_ADDR, HWIO_IPA_VMIDMT_NSGFSYNDR1_RMSK)
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSYNDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_MSDINDEX_BMSK                       0x7f000000
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_MSDINDEX_SHFT                             0x18
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_SSDINDEX_BMSK                         0xff0000
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_SSDINDEX_SHFT                             0x10
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_STREAMINDEX_BMSK                          0xff
#define HWIO_IPA_VMIDMT_NSGFSYNDR1_STREAMINDEX_SHFT                           0x0

#define HWIO_IPA_VMIDMT_NSGFSYNDR2_ADDR                                (IPA_VMIDMT_REG_BASE      + 0x00000458)
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_PHYS                                (IPA_VMIDMT_REG_BASE_PHYS + 0x00000458)
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_OFFS                                (IPA_VMIDMT_REG_BASE_OFFS + 0x00000458)
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_RMSK                                0x1f1fffff
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_ATTR                                       0x1
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSYNDR2_ADDR, HWIO_IPA_VMIDMT_NSGFSYNDR2_RMSK)
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSGFSYNDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_ATID_BMSK                           0x1f000000
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_ATID_SHFT                                 0x18
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_AVMID_BMSK                            0x1f0000
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_AVMID_SHFT                                0x10
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_ABID_BMSK                               0xe000
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_ABID_SHFT                                  0xd
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_APID_BMSK                               0x1f00
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_APID_SHFT                                  0x8
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_AMID_BMSK                                 0xff
#define HWIO_IPA_VMIDMT_NSGFSYNDR2_AMID_SHFT                                  0x0

#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_ADDR                               (IPA_VMIDMT_REG_BASE      + 0x00000490)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_PHYS                               (IPA_VMIDMT_REG_BASE_PHYS + 0x00000490)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_OFFS                               (IPA_VMIDMT_REG_BASE_OFFS + 0x00000490)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_RMSK                                      0x1
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_ATTR                                      0x3
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_NSVMIDMTCR0_ADDR, HWIO_IPA_VMIDMT_NSVMIDMTCR0_RMSK)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_NSVMIDMTCR0_ADDR, m)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_NSVMIDMTCR0_ADDR,v)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_NSVMIDMTCR0_ADDR,m,v,HWIO_IPA_VMIDMT_NSVMIDMTCR0_IN)
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_CLKONOFFE_BMSK                            0x1
#define HWIO_IPA_VMIDMT_NSVMIDMTCR0_CLKONOFFE_SHFT                            0x0

#define HWIO_IPA_VMIDMT_SSDR0_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000080)
#define HWIO_IPA_VMIDMT_SSDR0_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000080)
#define HWIO_IPA_VMIDMT_SSDR0_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000080)
#define HWIO_IPA_VMIDMT_SSDR0_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_SSDR0_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_SSDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR0_ADDR, HWIO_IPA_VMIDMT_SSDR0_RMSK)
#define HWIO_IPA_VMIDMT_SSDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_SSDR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SSDR0_ADDR,v)
#define HWIO_IPA_VMIDMT_SSDR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SSDR0_ADDR,m,v,HWIO_IPA_VMIDMT_SSDR0_IN)
#define HWIO_IPA_VMIDMT_SSDR0_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_SSDR0_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_SSDR1_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000084)
#define HWIO_IPA_VMIDMT_SSDR1_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000084)
#define HWIO_IPA_VMIDMT_SSDR1_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000084)
#define HWIO_IPA_VMIDMT_SSDR1_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_SSDR1_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_SSDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR1_ADDR, HWIO_IPA_VMIDMT_SSDR1_RMSK)
#define HWIO_IPA_VMIDMT_SSDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_SSDR1_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SSDR1_ADDR,v)
#define HWIO_IPA_VMIDMT_SSDR1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SSDR1_ADDR,m,v,HWIO_IPA_VMIDMT_SSDR1_IN)
#define HWIO_IPA_VMIDMT_SSDR1_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_SSDR1_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_SSDR2_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000088)
#define HWIO_IPA_VMIDMT_SSDR2_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000088)
#define HWIO_IPA_VMIDMT_SSDR2_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000088)
#define HWIO_IPA_VMIDMT_SSDR2_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_SSDR2_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_SSDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR2_ADDR, HWIO_IPA_VMIDMT_SSDR2_RMSK)
#define HWIO_IPA_VMIDMT_SSDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_SSDR2_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SSDR2_ADDR,v)
#define HWIO_IPA_VMIDMT_SSDR2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SSDR2_ADDR,m,v,HWIO_IPA_VMIDMT_SSDR2_IN)
#define HWIO_IPA_VMIDMT_SSDR2_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_SSDR2_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_SSDR3_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x0000008c)
#define HWIO_IPA_VMIDMT_SSDR3_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x0000008c)
#define HWIO_IPA_VMIDMT_SSDR3_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x0000008c)
#define HWIO_IPA_VMIDMT_SSDR3_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_SSDR3_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_SSDR3_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR3_ADDR, HWIO_IPA_VMIDMT_SSDR3_RMSK)
#define HWIO_IPA_VMIDMT_SSDR3_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_SSDR3_ADDR, m)
#define HWIO_IPA_VMIDMT_SSDR3_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_SSDR3_ADDR,v)
#define HWIO_IPA_VMIDMT_SSDR3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SSDR3_ADDR,m,v,HWIO_IPA_VMIDMT_SSDR3_IN)
#define HWIO_IPA_VMIDMT_SSDR3_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_SSDR3_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_MSDR0_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000480)
#define HWIO_IPA_VMIDMT_MSDR0_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000480)
#define HWIO_IPA_VMIDMT_MSDR0_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000480)
#define HWIO_IPA_VMIDMT_MSDR0_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_MSDR0_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_MSDR0_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR0_ADDR, HWIO_IPA_VMIDMT_MSDR0_RMSK)
#define HWIO_IPA_VMIDMT_MSDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR0_ADDR, m)
#define HWIO_IPA_VMIDMT_MSDR0_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_MSDR0_ADDR,v)
#define HWIO_IPA_VMIDMT_MSDR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_MSDR0_ADDR,m,v,HWIO_IPA_VMIDMT_MSDR0_IN)
#define HWIO_IPA_VMIDMT_MSDR0_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_MSDR0_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_MSDR1_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000484)
#define HWIO_IPA_VMIDMT_MSDR1_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000484)
#define HWIO_IPA_VMIDMT_MSDR1_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000484)
#define HWIO_IPA_VMIDMT_MSDR1_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_MSDR1_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_MSDR1_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR1_ADDR, HWIO_IPA_VMIDMT_MSDR1_RMSK)
#define HWIO_IPA_VMIDMT_MSDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR1_ADDR, m)
#define HWIO_IPA_VMIDMT_MSDR1_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_MSDR1_ADDR,v)
#define HWIO_IPA_VMIDMT_MSDR1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_MSDR1_ADDR,m,v,HWIO_IPA_VMIDMT_MSDR1_IN)
#define HWIO_IPA_VMIDMT_MSDR1_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_MSDR1_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_MSDR2_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x00000488)
#define HWIO_IPA_VMIDMT_MSDR2_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x00000488)
#define HWIO_IPA_VMIDMT_MSDR2_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x00000488)
#define HWIO_IPA_VMIDMT_MSDR2_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_MSDR2_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_MSDR2_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR2_ADDR, HWIO_IPA_VMIDMT_MSDR2_RMSK)
#define HWIO_IPA_VMIDMT_MSDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR2_ADDR, m)
#define HWIO_IPA_VMIDMT_MSDR2_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_MSDR2_ADDR,v)
#define HWIO_IPA_VMIDMT_MSDR2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_MSDR2_ADDR,m,v,HWIO_IPA_VMIDMT_MSDR2_IN)
#define HWIO_IPA_VMIDMT_MSDR2_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_MSDR2_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_MSDR3_ADDR                                     (IPA_VMIDMT_REG_BASE      + 0x0000048c)
#define HWIO_IPA_VMIDMT_MSDR3_PHYS                                     (IPA_VMIDMT_REG_BASE_PHYS + 0x0000048c)
#define HWIO_IPA_VMIDMT_MSDR3_OFFS                                     (IPA_VMIDMT_REG_BASE_OFFS + 0x0000048c)
#define HWIO_IPA_VMIDMT_MSDR3_RMSK                                     0xffffffff
#define HWIO_IPA_VMIDMT_MSDR3_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_MSDR3_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR3_ADDR, HWIO_IPA_VMIDMT_MSDR3_RMSK)
#define HWIO_IPA_VMIDMT_MSDR3_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_MSDR3_ADDR, m)
#define HWIO_IPA_VMIDMT_MSDR3_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_MSDR3_ADDR,v)
#define HWIO_IPA_VMIDMT_MSDR3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_MSDR3_ADDR,m,v,HWIO_IPA_VMIDMT_MSDR3_IN)
#define HWIO_IPA_VMIDMT_MSDR3_RWE_BMSK                                 0xffffffff
#define HWIO_IPA_VMIDMT_MSDR3_RWE_SHFT                                        0x0

#define HWIO_IPA_VMIDMT_MCR_ADDR                                       (IPA_VMIDMT_REG_BASE      + 0x00000494)
#define HWIO_IPA_VMIDMT_MCR_PHYS                                       (IPA_VMIDMT_REG_BASE_PHYS + 0x00000494)
#define HWIO_IPA_VMIDMT_MCR_OFFS                                       (IPA_VMIDMT_REG_BASE_OFFS + 0x00000494)
#define HWIO_IPA_VMIDMT_MCR_RMSK                                              0x7
#define HWIO_IPA_VMIDMT_MCR_ATTR                                              0x3
#define HWIO_IPA_VMIDMT_MCR_IN          \
        in_dword_masked(HWIO_IPA_VMIDMT_MCR_ADDR, HWIO_IPA_VMIDMT_MCR_RMSK)
#define HWIO_IPA_VMIDMT_MCR_INM(m)      \
        in_dword_masked(HWIO_IPA_VMIDMT_MCR_ADDR, m)
#define HWIO_IPA_VMIDMT_MCR_OUT(v)      \
        out_dword(HWIO_IPA_VMIDMT_MCR_ADDR,v)
#define HWIO_IPA_VMIDMT_MCR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_MCR_ADDR,m,v,HWIO_IPA_VMIDMT_MCR_IN)
#define HWIO_IPA_VMIDMT_MCR_CLKONOFFE_BMSK                                    0x4
#define HWIO_IPA_VMIDMT_MCR_CLKONOFFE_SHFT                                    0x2
#define HWIO_IPA_VMIDMT_MCR_BPMSACFG_BMSK                                     0x2
#define HWIO_IPA_VMIDMT_MCR_BPMSACFG_SHFT                                     0x1
#define HWIO_IPA_VMIDMT_MCR_BPSMSACFG_BMSK                                    0x1
#define HWIO_IPA_VMIDMT_MCR_BPSMSACFG_SHFT                                    0x0

#define HWIO_IPA_VMIDMT_S2VRn_ADDR(n)                                  (IPA_VMIDMT_REG_BASE      + 0x00000c00 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_S2VRn_PHYS(n)                                  (IPA_VMIDMT_REG_BASE_PHYS + 0x00000c00 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_S2VRn_OFFS(n)                                  (IPA_VMIDMT_REG_BASE_OFFS + 0x00000c00 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_S2VRn_RMSK                                     0x30ff7b1f
#define HWIO_IPA_VMIDMT_S2VRn_MAXn                                             47
#define HWIO_IPA_VMIDMT_S2VRn_ATTR                                            0x3
#define HWIO_IPA_VMIDMT_S2VRn_INI(n)        \
        in_dword_masked(HWIO_IPA_VMIDMT_S2VRn_ADDR(n), HWIO_IPA_VMIDMT_S2VRn_RMSK)
#define HWIO_IPA_VMIDMT_S2VRn_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_VMIDMT_S2VRn_ADDR(n), mask)
#define HWIO_IPA_VMIDMT_S2VRn_OUTI(n,val)    \
        out_dword(HWIO_IPA_VMIDMT_S2VRn_ADDR(n),val)
#define HWIO_IPA_VMIDMT_S2VRn_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_S2VRn_ADDR(n),mask,val,HWIO_IPA_VMIDMT_S2VRn_INI(n))
#define HWIO_IPA_VMIDMT_S2VRn_TRANSIENTCFG_BMSK                        0x30000000
#define HWIO_IPA_VMIDMT_S2VRn_TRANSIENTCFG_SHFT                              0x1c
#define HWIO_IPA_VMIDMT_S2VRn_WACFG_BMSK                                 0xc00000
#define HWIO_IPA_VMIDMT_S2VRn_WACFG_SHFT                                     0x16
#define HWIO_IPA_VMIDMT_S2VRn_RACFG_BMSK                                 0x300000
#define HWIO_IPA_VMIDMT_S2VRn_RACFG_SHFT                                     0x14
#define HWIO_IPA_VMIDMT_S2VRn_NSCFG_BMSK                                  0xc0000
#define HWIO_IPA_VMIDMT_S2VRn_NSCFG_SHFT                                     0x12
#define HWIO_IPA_VMIDMT_S2VRn_TYPE_BMSK                                   0x30000
#define HWIO_IPA_VMIDMT_S2VRn_TYPE_SHFT                                      0x10
#define HWIO_IPA_VMIDMT_S2VRn_MEMATTR_BMSK                                 0x7000
#define HWIO_IPA_VMIDMT_S2VRn_MEMATTR_SHFT                                    0xc
#define HWIO_IPA_VMIDMT_S2VRn_MTCFG_BMSK                                    0x800
#define HWIO_IPA_VMIDMT_S2VRn_MTCFG_SHFT                                      0xb
#define HWIO_IPA_VMIDMT_S2VRn_SHCFG_BMSK                                    0x300
#define HWIO_IPA_VMIDMT_S2VRn_SHCFG_SHFT                                      0x8
#define HWIO_IPA_VMIDMT_S2VRn_VMID_BMSK                                      0x1f
#define HWIO_IPA_VMIDMT_S2VRn_VMID_SHFT                                       0x0

#define HWIO_IPA_VMIDMT_AS2VRn_ADDR(n)                                 (IPA_VMIDMT_REG_BASE      + 0x00000e00 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_AS2VRn_PHYS(n)                                 (IPA_VMIDMT_REG_BASE_PHYS + 0x00000e00 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_AS2VRn_OFFS(n)                                 (IPA_VMIDMT_REG_BASE_OFFS + 0x00000e00 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_AS2VRn_RMSK                                    0x70000013
#define HWIO_IPA_VMIDMT_AS2VRn_MAXn                                            47
#define HWIO_IPA_VMIDMT_AS2VRn_ATTR                                           0x3
#define HWIO_IPA_VMIDMT_AS2VRn_INI(n)        \
        in_dword_masked(HWIO_IPA_VMIDMT_AS2VRn_ADDR(n), HWIO_IPA_VMIDMT_AS2VRn_RMSK)
#define HWIO_IPA_VMIDMT_AS2VRn_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_VMIDMT_AS2VRn_ADDR(n), mask)
#define HWIO_IPA_VMIDMT_AS2VRn_OUTI(n,val)    \
        out_dword(HWIO_IPA_VMIDMT_AS2VRn_ADDR(n),val)
#define HWIO_IPA_VMIDMT_AS2VRn_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_AS2VRn_ADDR(n),mask,val,HWIO_IPA_VMIDMT_AS2VRn_INI(n))
#define HWIO_IPA_VMIDMT_AS2VRn_RCNSH_BMSK                              0x40000000
#define HWIO_IPA_VMIDMT_AS2VRn_RCNSH_SHFT                                    0x1e
#define HWIO_IPA_VMIDMT_AS2VRn_RCISH_BMSK                              0x20000000
#define HWIO_IPA_VMIDMT_AS2VRn_RCISH_SHFT                                    0x1d
#define HWIO_IPA_VMIDMT_AS2VRn_RCOSH_BMSK                              0x10000000
#define HWIO_IPA_VMIDMT_AS2VRn_RCOSH_SHFT                                    0x1c
#define HWIO_IPA_VMIDMT_AS2VRn_REQPRIORITYCFG_BMSK                           0x10
#define HWIO_IPA_VMIDMT_AS2VRn_REQPRIORITYCFG_SHFT                            0x4
#define HWIO_IPA_VMIDMT_AS2VRn_REQPRIORITY_BMSK                               0x3
#define HWIO_IPA_VMIDMT_AS2VRn_REQPRIORITY_SHFT                               0x0

#define HWIO_IPA_VMIDMT_SMRn_ADDR(n)                                   (IPA_VMIDMT_REG_BASE      + 0x00000800 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_SMRn_PHYS(n)                                   (IPA_VMIDMT_REG_BASE_PHYS + 0x00000800 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_SMRn_OFFS(n)                                   (IPA_VMIDMT_REG_BASE_OFFS + 0x00000800 + 0x4 * (n))
#define HWIO_IPA_VMIDMT_SMRn_RMSK                                      0x80ff00ff
#define HWIO_IPA_VMIDMT_SMRn_MAXn                                              47
#define HWIO_IPA_VMIDMT_SMRn_ATTR                                             0x3
#define HWIO_IPA_VMIDMT_SMRn_INI(n)        \
        in_dword_masked(HWIO_IPA_VMIDMT_SMRn_ADDR(n), HWIO_IPA_VMIDMT_SMRn_RMSK)
#define HWIO_IPA_VMIDMT_SMRn_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_VMIDMT_SMRn_ADDR(n), mask)
#define HWIO_IPA_VMIDMT_SMRn_OUTI(n,val)    \
        out_dword(HWIO_IPA_VMIDMT_SMRn_ADDR(n),val)
#define HWIO_IPA_VMIDMT_SMRn_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_VMIDMT_SMRn_ADDR(n),mask,val,HWIO_IPA_VMIDMT_SMRn_INI(n))
#define HWIO_IPA_VMIDMT_SMRn_VALID_BMSK                                0x80000000
#define HWIO_IPA_VMIDMT_SMRn_VALID_SHFT                                      0x1f
#define HWIO_IPA_VMIDMT_SMRn_MASK_BMSK                                   0xff0000
#define HWIO_IPA_VMIDMT_SMRn_MASK_SHFT                                       0x10
#define HWIO_IPA_VMIDMT_SMRn_ID_BMSK                                         0xff
#define HWIO_IPA_VMIDMT_SMRn_ID_SHFT                                          0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_0_GSI_TOP
 *--------------------------------------------------------------------------*/

#define IPA_0_GSI_TOP_REG_BASE (IPA_0_IPA_WRAPPER_BASE      + 0x00000000)
#define IPA_0_GSI_TOP_REG_BASE_PHYS (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00000000)
#define IPA_0_GSI_TOP_REG_BASE_OFFS 0x00000000

/*----------------------------------------------------------------------------
 * MODULE: IPA_GSI_TOP_GSI
 *--------------------------------------------------------------------------*/

#define IPA_GSI_TOP_GSI_REG_BASE                                                                         (IPA_0_IPA_WRAPPER_BASE      + 0x00004000)
#define IPA_GSI_TOP_GSI_REG_BASE_PHYS                                                                    (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00004000)
#define IPA_GSI_TOP_GSI_REG_BASE_OFFS                                                                    0x00004000

#define HWIO_IPA_GSI_TOP_GSI_CFG_ADDR                                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000000)
#define HWIO_IPA_GSI_TOP_GSI_CFG_PHYS                                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_GSI_TOP_GSI_CFG_OFFS                                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_GSI_TOP_GSI_CFG_RMSK                                                                         0xf3f
#define HWIO_IPA_GSI_TOP_GSI_CFG_ATTR                                                                           0x3
#define HWIO_IPA_GSI_TOP_GSI_CFG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_CFG_ADDR, HWIO_IPA_GSI_TOP_GSI_CFG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_CFG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_CFG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_CFG_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_CFG_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_CFG_IN)
#define HWIO_IPA_GSI_TOP_GSI_CFG_SLEEP_CLK_DIV_BMSK                                                           0xf00
#define HWIO_IPA_GSI_TOP_GSI_CFG_SLEEP_CLK_DIV_SHFT                                                             0x8
#define HWIO_IPA_GSI_TOP_GSI_CFG_BP_MTRIX_DISABLE_BMSK                                                         0x20
#define HWIO_IPA_GSI_TOP_GSI_CFG_BP_MTRIX_DISABLE_SHFT                                                          0x5
#define HWIO_IPA_GSI_TOP_GSI_CFG_GSI_PWR_CLPS_BMSK                                                             0x10
#define HWIO_IPA_GSI_TOP_GSI_CFG_GSI_PWR_CLPS_SHFT                                                              0x4
#define HWIO_IPA_GSI_TOP_GSI_CFG_UC_IS_MCS_BMSK                                                                 0x8
#define HWIO_IPA_GSI_TOP_GSI_CFG_UC_IS_MCS_SHFT                                                                 0x3
#define HWIO_IPA_GSI_TOP_GSI_CFG_DOUBLE_MCS_CLK_FREQ_BMSK                                                       0x4
#define HWIO_IPA_GSI_TOP_GSI_CFG_DOUBLE_MCS_CLK_FREQ_SHFT                                                       0x2
#define HWIO_IPA_GSI_TOP_GSI_CFG_MCS_ENABLE_BMSK                                                                0x2
#define HWIO_IPA_GSI_TOP_GSI_CFG_MCS_ENABLE_SHFT                                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_CFG_GSI_ENABLE_BMSK                                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_CFG_GSI_ENABLE_SHFT                                                                0x0

#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_ADDR                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000008)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_PHYS                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_OFFS                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_RMSK                                                   0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_ATTR                                                          0x3
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_ADDR, HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_IN)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_VER_BMSK                                               0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_MCS_CODE_VER_VER_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_ZEROS_ADDR                                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000010)
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_PHYS                                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_OFFS                                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_RMSK                                                                  0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_ATTR                                                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_ZEROS_ADDR, HWIO_IPA_GSI_TOP_GSI_ZEROS_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_ZEROS_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_ZEROS_BMSK                                                            0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_ZEROS_ZEROS_SHFT                                                                   0x0

#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_ADDR                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000018)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_PHYS                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000018)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_OFFS                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000018)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_RMSK                                                   0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_ATTR                                                          0x3
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_ADDR, HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_IN)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_BASE_ADDR_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_LSB_BASE_ADDR_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_ADDR                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000001c)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_PHYS                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000001c)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_OFFS                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000001c)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_RMSK                                                   0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_ATTR                                                          0x3
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_ADDR, HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_IN)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_BASE_ADDR_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_BASE_ADDR_MSB_BASE_ADDR_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_ADDR                                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000020)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_PHYS                                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000020)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_OFFS                                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000020)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_RMSK                                                                   0xffff
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_ATTR                                                                      0x3
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_ADDR, HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_IN)
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_16_HW_CGC_EN_BMSK                                               0x8000
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_16_HW_CGC_EN_SHFT                                                  0xf
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_15_HW_CGC_EN_BMSK                                               0x4000
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_15_HW_CGC_EN_SHFT                                                  0xe
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_14_HW_CGC_EN_BMSK                                               0x2000
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_14_HW_CGC_EN_SHFT                                                  0xd
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_13_HW_CGC_EN_BMSK                                               0x1000
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_13_HW_CGC_EN_SHFT                                                  0xc
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_12_HW_CGC_EN_BMSK                                                0x800
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_12_HW_CGC_EN_SHFT                                                  0xb
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_11_HW_CGC_EN_BMSK                                                0x400
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_11_HW_CGC_EN_SHFT                                                  0xa
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_10_HW_CGC_EN_BMSK                                                0x200
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_10_HW_CGC_EN_SHFT                                                  0x9
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_9_HW_CGC_EN_BMSK                                                 0x100
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_9_HW_CGC_EN_SHFT                                                   0x8
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_8_HW_CGC_EN_BMSK                                                  0x80
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_8_HW_CGC_EN_SHFT                                                   0x7
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_7_HW_CGC_EN_BMSK                                                  0x40
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_7_HW_CGC_EN_SHFT                                                   0x6
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_6_HW_CGC_EN_BMSK                                                  0x20
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_6_HW_CGC_EN_SHFT                                                   0x5
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_5_HW_CGC_EN_BMSK                                                  0x10
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_5_HW_CGC_EN_SHFT                                                   0x4
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_4_HW_CGC_EN_BMSK                                                   0x8
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_4_HW_CGC_EN_SHFT                                                   0x3
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_3_HW_CGC_EN_BMSK                                                   0x4
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_3_HW_CGC_EN_SHFT                                                   0x2
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_2_HW_CGC_EN_BMSK                                                   0x2
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_2_HW_CGC_EN_SHFT                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_1_HW_CGC_EN_BMSK                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_CGC_CTRL_REGION_1_HW_CGC_EN_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_ADDR                                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000030)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_PHYS                                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000030)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_OFFS                                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000030)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_RMSK                                                                 0xffffff
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_ATTR                                                                      0x3
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_ADDR, HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_IN)
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_CLIENT_OOWR_BMSK                                                     0xff0000
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_CLIENT_OOWR_SHFT                                                         0x10
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_CLIENT_OORD_BMSK                                                       0xff00
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_CLIENT_OORD_SHFT                                                          0x8
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_CLIENT_REQ_PRIO_BMSK                                                     0xff
#define HWIO_IPA_GSI_TOP_GSI_MOQA_CFG_CLIENT_REQ_PRIO_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_ADDR                                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000038)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_PHYS                                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000038)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_OFFS                                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000038)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_RMSK                                                                    0xff03
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_ATTR                                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_REE_CFG_ADDR, HWIO_IPA_GSI_TOP_GSI_REE_CFG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_REE_CFG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_REE_CFG_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_REE_CFG_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_REE_CFG_IN)
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_MAX_BURST_SIZE_BMSK                                                     0xff00
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_MAX_BURST_SIZE_SHFT                                                        0x8
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_CHANNEL_EMPTY_INT_ENABLE_BMSK                                              0x2
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_CHANNEL_EMPTY_INT_ENABLE_SHFT                                              0x1
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_MOVE_TO_ESC_CLR_MODE_TRSH_BMSK                                             0x1
#define HWIO_IPA_GSI_TOP_GSI_REE_CFG_MOVE_TO_ESC_CLR_MODE_TRSH_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_ADDR(k)                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000060 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_PHYS(k)                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000060 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_OFFS(k)                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000060 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_MAXk                                                                1
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_ATTR                                                              0x1
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_INI(k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_ADDR(k), HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_INMI(k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_ADDR(k), mask)
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_CHID_BIT_MAP_BMSK                                          0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_PERIPH_PENDING_k_CHID_BIT_MAP_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ADDR                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000080)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_PHYS                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000080)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_OFFS                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000080)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_RMSK                                                                0x3f
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ATTR                                                                 0x3
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ADDR, HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_IN)
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_AREQPRIORITY_BMSK                                                   0x30
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_AREQPRIORITY_SHFT                                                    0x4
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ATRANSIENT_BMSK                                                      0x8
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ATRANSIENT_SHFT                                                      0x3
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ANOALLOCATE_BMSK                                                     0x4
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ANOALLOCATE_SHFT                                                     0x2
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_AINNERSHARED_BMSK                                                    0x2
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_AINNERSHARED_SHFT                                                    0x1
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ASHARED_BMSK                                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_MSI_CACHEATTR_ASHARED_SHFT                                                         0x0

#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000084)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000084)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000084)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_RMSK                                                              0x3f
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ATTR                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ADDR, HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_IN)
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_AREQPRIORITY_BMSK                                                 0x30
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_AREQPRIORITY_SHFT                                                  0x4
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ATRANSIENT_BMSK                                                    0x8
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ATRANSIENT_SHFT                                                    0x3
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ANOALLOCATE_BMSK                                                   0x4
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ANOALLOCATE_SHFT                                                   0x2
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_AINNERSHARED_BMSK                                                  0x2
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_AINNERSHARED_SHFT                                                  0x1
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ASHARED_BMSK                                                       0x1
#define HWIO_IPA_GSI_TOP_GSI_EVENT_CACHEATTR_ASHARED_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ADDR                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000088)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_PHYS                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000088)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_OFFS                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000088)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_RMSK                                                               0x3f
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ATTR                                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ADDR, HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_IN)
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_AREQPRIORITY_BMSK                                                  0x30
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_AREQPRIORITY_SHFT                                                   0x4
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ATRANSIENT_BMSK                                                     0x8
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ATRANSIENT_SHFT                                                     0x3
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ANOALLOCATE_BMSK                                                    0x4
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ANOALLOCATE_SHFT                                                    0x2
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_AINNERSHARED_BMSK                                                   0x2
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_AINNERSHARED_SHFT                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ASHARED_BMSK                                                        0x1
#define HWIO_IPA_GSI_TOP_GSI_DATA_CACHEATTR_ASHARED_SHFT                                                        0x0

#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ADDR                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000090)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_PHYS                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_OFFS                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_RMSK                                                                0x3f
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ATTR                                                                 0x3
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ADDR, HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_IN)
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_AREQPRIORITY_BMSK                                                   0x30
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_AREQPRIORITY_SHFT                                                    0x4
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ATRANSIENT_BMSK                                                      0x8
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ATRANSIENT_SHFT                                                      0x3
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ANOALLOCATE_BMSK                                                     0x4
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ANOALLOCATE_SHFT                                                     0x2
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_AINNERSHARED_BMSK                                                    0x2
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_AINNERSHARED_SHFT                                                    0x1
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ASHARED_BMSK                                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_TRE_CACHEATTR_ASHARED_SHFT                                                         0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_ADDR                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000100)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_PHYS                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000100)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_OFFS                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000100)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_RMSK                                                               0xfff
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_ATTR                                                                 0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_CH_EMPTY_INT_WEIGHT_BMSK                                           0xf00
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_CH_EMPTY_INT_WEIGHT_SHFT                                             0x8
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_NEW_RE_INT_WEIGHT_BMSK                                              0xf0
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_NEW_RE_INT_WEIGHT_SHFT                                               0x4
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_STOP_CH_COMP_INT_WEIGHT_BMSK                                         0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_REE_STOP_CH_COMP_INT_WEIGHT_SHFT                                         0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_ADDR                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000104)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_PHYS                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000104)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_OFFS                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000104)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_RMSK                                                             0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_EVNT_ENG_INT_WEIGHT_BMSK                                         0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_EVT_ENG_EVNT_ENG_INT_WEIGHT_SHFT                                         0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_ADDR                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000108)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_PHYS                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000108)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_OFFS                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000108)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_RMSK                                                             0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_INT_ENG_INT_WEIGHT_BMSK                                          0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_INT_ENG_INT_ENG_INT_WEIGHT_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_ADDR                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000010c)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_PHYS                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000010c)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_OFFS                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000010c)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_RMSK                                                                0xff
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_ATTR                                                                 0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_EE_GENERIC_INT_WEIGHT_BMSK                                          0xf0
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_EE_GENERIC_INT_WEIGHT_SHFT                                           0x4
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_CH_CMD_INT_WEIGHT_BMSK                                               0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_CSR_CH_CMD_INT_WEIGHT_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_ADDR                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000110)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_PHYS                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000110)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_OFFS                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000110)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_RMSK                                                          0xffff
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_CH_NOT_FULL_INT_WEIGHT_BMSK                                   0xf000
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_CH_NOT_FULL_INT_WEIGHT_SHFT                                      0xc
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_TLV_2_INT_WEIGHT_BMSK                                          0xf00
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_TLV_2_INT_WEIGHT_SHFT                                            0x8
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_TLV_1_INT_WEIGHT_BMSK                                           0xf0
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_TLV_1_INT_WEIGHT_SHFT                                            0x4
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_TLV_0_INT_WEIGHT_BMSK                                            0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TLV_ENG_TLV_0_INT_WEIGHT_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_ADDR                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000114)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_PHYS                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000114)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_OFFS                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000114)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_RMSK                                                           0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_TIMER_INT_WEIGHT_BMSK                                          0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_TIMER_ENG_TIMER_INT_WEIGHT_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_ADDR                                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000118)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_PHYS                                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000118)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_OFFS                                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000118)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_RMSK                                                              0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_NEW_DB_INT_WEIGHT_BMSK                                            0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_DB_ENG_NEW_DB_INT_WEIGHT_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_ADDR                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000011c)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_PHYS                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000011c)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_OFFS                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000011c)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_RMSK                                                          0xff
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_WRITE_INT_WEIGHT_BMSK                                         0xf0
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_WRITE_INT_WEIGHT_SHFT                                          0x4
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_READ_INT_WEIGHT_BMSK                                           0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_RD_WR_ENG_READ_INT_WEIGHT_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_ADDR                                              (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000120)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_PHYS                                              (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000120)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_OFFS                                              (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000120)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_RMSK                                                     0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_ATTR                                                     0x3
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_ADDR, HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_RMSK)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_ADDR, m)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_ADDR,v)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_ADDR,m,v,HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_IN)
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_UCONTROLLER_GP_INT_WEIGHT_BMSK                           0xf
#define HWIO_IPA_GSI_TOP_IC_INT_WEIGHT_UCONTROLLER_ENG_UCONTROLLER_GP_INT_WEIGHT_SHFT                           0x0

#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_ADDR                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000128)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_PHYS                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000128)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_OFFS                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000128)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_RMSK                                                        0x13f3f
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_ADDR, HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_RMSK)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_ADDR, m)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_ADDR,v)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_ADDR,m,v,HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_IN)
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_LL_NON_LL_FIX_PRIORITY_BMSK                                 0x10000
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_LL_NON_LL_FIX_PRIORITY_SHFT                                    0x10
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_NON_LL_WEIGHT_BMSK                                           0x3f00
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_NON_LL_WEIGHT_SHFT                                              0x8
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_LL_WEIGHT_BMSK                                                 0x3f
#define HWIO_IPA_GSI_TOP_LOW_LATENCY_ARB_WEIGHT_LL_WEIGHT_SHFT                                                  0x0

#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_ADDR(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_PHYS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_OFFS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000300 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_RMSK                                                         0xffff03
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_ATTR                                                              0x0
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_ADDR(n), HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_INI(n))
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_MAX_EV_ALLOC_BMSK                                            0xff0000
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_MAX_EV_ALLOC_SHFT                                                0x10
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_MAX_CH_ALLOC_BMSK                                              0xff00
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_MAX_CH_ALLOC_SHFT                                                 0x8
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_EE_PRIO_BMSK                                                      0x3
#define HWIO_IPA_GSI_TOP_GSI_MANAGER_EE_QOS_n_EE_PRIO_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_ADDR                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000200)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_PHYS                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000200)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_OFFS                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000200)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_RMSK                                               0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_ATTR                                                  0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_SHRAM_PTR_BMSK                                     0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CNTXT_BASE_ADDR_SHRAM_PTR_SHFT                                        0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_ADDR                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000204)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_PHYS                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000204)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_OFFS                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000204)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_RMSK                                               0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_ATTR                                                  0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_SHRAM_PTR_BMSK                                     0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_CNTXT_BASE_ADDR_SHRAM_PTR_SHFT                                        0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000208)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000208)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000208)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_RMSK                                             0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_ATTR                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_SHRAM_PTR_BMSK                                   0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_STORAGE_BASE_ADDR_SHRAM_PTR_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000020c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000020c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000020c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_RMSK                                             0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_ATTR                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_SHRAM_PTR_BMSK                                   0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_RE_ESC_BUF_BASE_ADDR_SHRAM_PTR_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_ADDR                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000240)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_PHYS                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000240)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_OFFS                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000240)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_RMSK                                              0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_ATTR                                                 0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_SHRAM_PTR_BMSK                                    0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_SCRACH_BASE_ADDR_SHRAM_PTR_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000244)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000244)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000244)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_RMSK                                             0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_ATTR                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_SHRAM_PTR_BMSK                                   0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_FUNC_STACK_BASE_ADDR_SHRAM_PTR_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_ADDR                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000210)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_PHYS                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000210)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_OFFS                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000210)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_RMSK                                            0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_ATTR                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_SHRAM_PTR_BMSK                                  0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH_BASE_ADDR_SHRAM_PTR_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_ADDR                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000214)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_PHYS                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000214)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_OFFS                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000214)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_RMSK                                           0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_ATTR                                              0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_SHRAM_PTR_BMSK                                 0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH1_BASE_ADDR_SHRAM_PTR_SHFT                                    0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_ADDR                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000218)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_PHYS                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000218)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_OFFS                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000218)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_RMSK                                           0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_ATTR                                              0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_SHRAM_PTR_BMSK                                 0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH2_BASE_ADDR_SHRAM_PTR_SHFT                                    0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_ADDR                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000021c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_PHYS                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000021c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_OFFS                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000021c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_RMSK                                           0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_ATTR                                              0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_SHRAM_PTR_BMSK                                 0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_MCS_SCRATCH3_BASE_ADDR_SHRAM_PTR_SHFT                                    0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_ADDR                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000254)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_PHYS                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000254)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_OFFS                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000254)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_RMSK                                      0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_SHRAM_PTR_BMSK                            0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_VP_TRANS_TABLE_BASE_ADDR_SHRAM_PTR_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_ADDR                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000258)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_PHYS                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000258)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_OFFS                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000258)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_RMSK                                      0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_SHRAM_PTR_BMSK                            0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EV_VP_TRANS_TABLE_BASE_ADDR_SHRAM_PTR_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_ADDR                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000025c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_PHYS                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000025c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_OFFS                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000025c)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_RMSK                                         0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_ATTR                                            0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_SHRAM_PTR_BMSK                               0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_USER_INFO_DATA_BASE_ADDR_SHRAM_PTR_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_ADDR                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000260)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_PHYS                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000260)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_OFFS                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000260)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_RMSK                                            0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_ATTR                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_SHRAM_PTR_BMSK                                  0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EE_CMD_FIFO_BASE_ADDR_SHRAM_PTR_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_ADDR                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000264)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_PHYS                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000264)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_OFFS                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000264)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_RMSK                                            0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_ATTR                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_SHRAM_PTR_BMSK                                  0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_CH_CMD_FIFO_BASE_ADDR_SHRAM_PTR_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_ADDR                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000268)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_PHYS                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000268)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_OFFS                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000268)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_RMSK                                         0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_ATTR                                            0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_ADDR, HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_IN)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_SHRAM_PTR_BMSK                               0xffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_PTR_EVE_ED_STORAGE_BASE_ADDR_SHRAM_PTR_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000400)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_RMSK                                                             0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_ATTR                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_IRAM_PTR_BMSK                                                    0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_CMD_IRAM_PTR_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_ADDR                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000404)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_PHYS                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000404)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_OFFS                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000404)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_RMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_ATTR                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_IRAM_PTR_BMSK                                            0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EE_GENERIC_CMD_IRAM_PTR_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_ADDR                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000408)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_PHYS                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000408)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_OFFS                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000408)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_RMSK                                                    0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_ATTR                                                      0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_IRAM_PTR_BMSK                                           0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TLV_CH_NOT_FULL_IRAM_PTR_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000414)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000414)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000414)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_RMSK                                                             0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_ATTR                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_IRAM_PTR_BMSK                                                    0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_MSI_DB_IRAM_PTR_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_ADDR                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000418)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_PHYS                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000418)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_OFFS                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000418)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_RMSK                                                              0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_ATTR                                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_IRAM_PTR_BMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DB_IRAM_PTR_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_ADDR                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000041c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_PHYS                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000041c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_OFFS                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000041c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_RMSK                                                              0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_ATTR                                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_IRAM_PTR_BMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EV_DB_IRAM_PTR_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000420)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000420)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000420)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_RMSK                                                             0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_ATTR                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_IRAM_PTR_BMSK                                                    0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_NEW_RE_IRAM_PTR_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_ADDR                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000424)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_PHYS                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000424)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_OFFS                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000424)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_RMSK                                                        0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_ATTR                                                          0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_IRAM_PTR_BMSK                                               0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_DIS_COMP_IRAM_PTR_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_ADDR                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000428)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_PHYS                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000428)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_OFFS                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000428)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_RMSK                                                           0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_IRAM_PTR_BMSK                                                  0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_CH_EMPTY_IRAM_PTR_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_ADDR                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000042c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_PHYS                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000042c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_OFFS                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000042c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_RMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_ATTR                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_IRAM_PTR_BMSK                                            0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_EVENT_GEN_COMP_IRAM_PTR_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_ADDR                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000430)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_PHYS                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000430)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_OFFS                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000430)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_RMSK                                                 0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_ATTR                                                   0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_IRAM_PTR_BMSK                                        0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_0_IRAM_PTR_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_ADDR                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000434)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_PHYS                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000434)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_OFFS                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000434)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_RMSK                                                 0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_ATTR                                                   0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_IRAM_PTR_BMSK                                        0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_2_IRAM_PTR_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_ADDR                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000438)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_PHYS                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000438)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_OFFS                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000438)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_RMSK                                                 0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_ATTR                                                   0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_IRAM_PTR_BMSK                                        0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_PERIPH_IF_TLV_IN_1_IRAM_PTR_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_ADDR                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000043c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_PHYS                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000043c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_OFFS                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000043c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_RMSK                                                      0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_ATTR                                                        0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_IRAM_PTR_BMSK                                             0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_TIMER_EXPIRED_IRAM_PTR_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_ADDR                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000440)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_PHYS                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000440)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_OFFS                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000440)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_RMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_ATTR                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_IRAM_PTR_BMSK                                            0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_WRITE_ENG_COMP_IRAM_PTR_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_ADDR                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000444)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_PHYS                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000444)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_OFFS                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000444)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_RMSK                                                      0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_ATTR                                                        0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_IRAM_PTR_BMSK                                             0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_READ_ENG_COMP_IRAM_PTR_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_ADDR                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000448)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_PHYS                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000448)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_OFFS                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000448)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_RMSK                                                          0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_IRAM_PTR_BMSK                                                 0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_UC_GP_INT_IRAM_PTR_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_ADDR                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000044c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_PHYS                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000044c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_OFFS                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000044c)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_RMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_ATTR                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_IRAM_PTR_BMSK                                            0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_MOD_STOPED_IRAM_PTR_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_ADDR                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x00000470)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_PHYS                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00000470)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_OFFS                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00000470)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_RMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_ATTR                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_ADDR, HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_IN)
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_IRAM_PTR_BMSK                                            0xfff
#define HWIO_IPA_GSI_TOP_GSI_IRAM_PTR_INT_NOTIFY_MCS_IRAM_PTR_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ADDR(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x000a4000 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_PHYS(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000a4000 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_OFFS(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000a4000 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_RMSK                                                             0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_MAXn                                                                   8255
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ATTR                                                                    0x3
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ADDR(n), HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_RMSK, HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ATTR)
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ADDR(n), mask, HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ATTR)
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INI(n))
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_3_BMSK                                                 0xff000000
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_3_SHFT                                                       0x18
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_2_BMSK                                                   0xff0000
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_2_SHFT                                                       0x10
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_1_BMSK                                                     0xff00
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_1_SHFT                                                        0x8
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_0_BMSK                                                       0xff
#define HWIO_IPA_GSI_TOP_GSI_INST_RAM_n_INST_BYTE_0_SHFT                                                        0x0

#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_ADDR(n)                                                             (IPA_GSI_TOP_GSI_REG_BASE      + 0x00002000 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_PHYS(n)                                                             (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00002000 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_OFFS(n)                                                             (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00002000 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_RMSK                                                                0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_MAXn                                                                      2047
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_ATTR                                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_n_ADDR(n), HWIO_IPA_GSI_TOP_GSI_SHRAM_n_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SHRAM_n_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SHRAM_n_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SHRAM_n_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_GSI_SHRAM_n_INI(n))
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_SHRAM_BMSK                                                          0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_SHRAM_n_SHRAM_SHFT                                                                 0x0

#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_ADDR(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x00009000 + 0x400 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_PHYS(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00009000 + 0x400 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_OFFS(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00009000 + 0x400 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_RMSK                                                      0x1ff
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_MAXn                                                          2
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_MAXk                                                         27
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_ATTR                                                        0x3
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_ADDR(n,k), HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_INI2(n,k))
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_VALID_BMSK                                                0x100
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_VALID_SHFT                                                  0x8
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_PHY_CH_BMSK                                                0xff
#define HWIO_IPA_GSI_TOP_GSI_MAP_EE_n_CH_k_VP_TABLE_PHY_CH_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_ADDR                                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001000)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_PHYS                                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001000)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_OFFS                                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001000)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_RMSK                                                              0xf00ff
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_ATTR                                                                  0x3
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_ADDR, HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_IN)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_HW_EVENTS_SEL_BMSK                                            0xf0000
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_HW_EVENTS_SEL_SHFT                                               0x10
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_BMSK                                                 0xff
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_SHFT                                                  0x0
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_ZEROS_FVAL                                            0x0
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MCS_0_FVAL                                            0x1
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MCS_1_FVAL                                            0x2
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MCS_2_FVAL                                            0x3
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MCS_3_FVAL                                            0x4
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MCS_4_FVAL                                            0x5
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_DB_ENG_FVAL                                           0x9
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_0_FVAL                                            0xb
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_1_FVAL                                            0xc
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_2_FVAL                                            0xd
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_3_FVAL                                            0xe
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_4_FVAL                                            0xf
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_5_FVAL                                           0x10
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_6_FVAL                                           0x11
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_7_FVAL                                           0x12
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_EVE_0_FVAL                                           0x13
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_EVE_1_FVAL                                           0x14
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_EVE_2_FVAL                                           0x15
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_EVE_3_FVAL                                           0x16
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_EVE_4_FVAL                                           0x17
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_EVE_5_FVAL                                           0x18
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IE_0_FVAL                                            0x1b
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IE_1_FVAL                                            0x1c
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IE_2_FVAL                                            0x1d
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IC_0_FVAL                                            0x1f
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IC_1_FVAL                                            0x20
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IC_2_FVAL                                            0x21
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IC_3_FVAL                                            0x22
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IC_4_FVAL                                            0x23
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MOQA_0_FVAL                                          0x27
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MOQA_1_FVAL                                          0x28
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MOQA_2_FVAL                                          0x29
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MOQA_3_FVAL                                          0x2a
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_TMR_0_FVAL                                           0x2b
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_TMR_1_FVAL                                           0x2c
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_TMR_2_FVAL                                           0x2d
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_TMR_3_FVAL                                           0x2e
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_RD_WR_0_FVAL                                         0x33
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_RD_WR_1_FVAL                                         0x34
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_RD_WR_2_FVAL                                         0x35
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_RD_WR_3_FVAL                                         0x36
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_CSR_FVAL                                             0x3a
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_SDMA_0_FVAL                                          0x3c
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_SMDA_1_FVAL                                          0x3d
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_CSR_1_FVAL                                           0x3e
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_CSR_2_FVAL                                           0x3f
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_MCS_5_FVAL                                           0x40
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IC_5_FVAL                                            0x41
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_CSR_3_FVAL                                           0x42
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_TLV_0_FVAL                                           0x43
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_8_FVAL                                           0x44
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_IE_NOTIFY_FVAL                                       0x45
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_DB_MSI_FVAL                                          0x46
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_SEL_GSI_TESTBUS_SEL_REE_9_FVAL                                           0x47

#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_ADDR                                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001008)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_PHYS                                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001008)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_OFFS                                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001008)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_RMSK                                                           0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_ATTR                                                                  0x1
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_ADDR, HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_GSI_TESTBUS_REG_BMSK                                           0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_TEST_BUS_REG_GSI_TESTBUS_REG_SHFT                                                  0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_ADDR                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001010)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_PHYS                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001010)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_OFFS                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001010)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_RMSK                                                             0x1fff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_ATTR                                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_SDMA_BUSY_BMSK                                                   0x1000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_SDMA_BUSY_SHFT                                                      0xc
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_IC_BUSY_BMSK                                                      0x800
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_IC_BUSY_SHFT                                                        0xb
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_UC_BUSY_BMSK                                                      0x400
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_UC_BUSY_SHFT                                                        0xa
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_DBG_CNT_BUSY_BMSK                                                 0x200
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_DBG_CNT_BUSY_SHFT                                                   0x9
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_DB_ENG_BUSY_BMSK                                                  0x100
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_DB_ENG_BUSY_SHFT                                                    0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_REE_PWR_CLPS_BUSY_BMSK                                             0x80
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_REE_PWR_CLPS_BUSY_SHFT                                              0x7
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_INT_ENG_BUSY_BMSK                                                  0x40
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_INT_ENG_BUSY_SHFT                                                   0x6
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_EV_ENG_BUSY_BMSK                                                   0x20
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_EV_ENG_BUSY_SHFT                                                    0x5
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_RD_WR_BUSY_BMSK                                                    0x10
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_RD_WR_BUSY_SHFT                                                     0x4
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_TIMER_BUSY_BMSK                                                     0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_TIMER_BUSY_SHFT                                                     0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_MCS_BUSY_BMSK                                                       0x4
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_MCS_BUSY_SHFT                                                       0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_REE_BUSY_BMSK                                                       0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_REE_BUSY_SHFT                                                       0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_CSR_BUSY_BMSK                                                       0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_BUSY_REG_CSR_BUSY_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_ADDR(k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a80 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_PHYS(k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a80 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_OFFS(k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a80 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_RMSK                                                  0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_MAXk                                                           1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_ATTR                                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_INI(k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_ADDR(k), HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_INMI(k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_ADDR(k), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_CHID_BIT_MAP_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EVENT_PENDING_k_CHID_BIT_MAP_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_ADDR(k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001aa0 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_PHYS(k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001aa0 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_OFFS(k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001aa0 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_RMSK                                                  0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_MAXk                                                           1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_ATTR                                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_INI(k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_ADDR(k), HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_INMI(k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_ADDR(k), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_CHID_BIT_MAP_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_TIMER_PENDING_k_CHID_BIT_MAP_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_ADDR(k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001ac0 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_PHYS(k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001ac0 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_OFFS(k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001ac0 + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_RMSK                                                  0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_MAXk                                                           1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_ATTR                                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_INI(k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_ADDR(k), HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_INMI(k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_ADDR(k), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_CHID_BIT_MAP_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_RD_WR_PENDING_k_CHID_BIT_MAP_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_ADDR                                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001030)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_PHYS                                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001030)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_OFFS                                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001030)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_RMSK                                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_ATTR                                                                   0x3
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_ADDR, HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_IN)
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_FIX_IEOB_WRONG_MSK_DISABLE_BMSK                                        0x1
#define HWIO_IPA_GSI_TOP_GSI_SPARE_REG_1_FIX_IEOB_WRONG_MSK_DISABLE_SHFT                                        0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_ADDR                                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001040)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_PHYS                                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001040)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_OFFS                                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001040)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_RMSK                                                            0xfff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_IN)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_IRAM_PTR_BMSK                                                   0xfff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FROM_SW_IRAM_PTR_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_ADDR                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001044)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_PHYS                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001044)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_OFFS                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001044)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_RMSK                                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_ATTR                                                                0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_IN)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_MCS_STALL_BMSK                                                      0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_STALL_MCS_STALL_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_ADDR                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001048)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_PHYS                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001048)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_OFFS                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001048)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_RMSK                                                          0xfff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_ATTR                                                            0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_IRAM_PTR_BMSK                                                 0xfff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_PC_FOR_DEBUG_IRAM_PTR_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_ADDR                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001050)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_PHYS                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001050)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_OFFS                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001050)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_RMSK                                                        0xffff01
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_IN)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_SEL_MID_BMSK                                                0xff0000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_SEL_MID_SHFT                                                    0x10
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_SEL_TID_BMSK                                                  0xff00
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_SEL_TID_SHFT                                                     0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_SEL_WRITE_BMSK                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_SEL_SEL_WRITE_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_ADDR                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001058)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_PHYS                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001058)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_OFFS                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001058)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_RMSK                                                             0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_ATTR                                                             0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_LOG_CLR_BMSK                                                     0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_CLR_LOG_CLR_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ADDR                                              (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001060)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_PHYS                                              (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001060)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_OFFS                                              (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001060)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_RMSK                                               0x1ffff01
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ATTR                                                     0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_SAVED_BMSK                                     0x1000000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_SAVED_SHFT                                          0x18
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_MID_BMSK                                        0xff0000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_MID_SHFT                                            0x10
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_TID_BMSK                                          0xff00
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_TID_SHFT                                             0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_WRITE_BMSK                                           0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_ERR_TRNS_ID_ERR_WRITE_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001064)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001064)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001064)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_RMSK                                                        0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_ADDR_31_0_BMSK                                              0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_0_ADDR_31_0_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001068)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001068)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001068)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_RMSK                                                        0xfff7ffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AREQPRIORITY_BMSK                                           0xf0000000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AREQPRIORITY_SHFT                                                 0x1c
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ASIZE_BMSK                                                   0xf000000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ASIZE_SHFT                                                        0x18
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ALEN_BMSK                                                     0xf00000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ALEN_SHFT                                                         0x14
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AOOOWR_BMSK                                                    0x40000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AOOOWR_SHFT                                                       0x12
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AOOORD_BMSK                                                    0x20000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AOOORD_SHFT                                                       0x11
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ATRANSIENT_BMSK                                                0x10000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ATRANSIENT_SHFT                                                   0x10
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ACACHEABLE_BMSK                                                 0x8000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ACACHEABLE_SHFT                                                    0xf
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ASHARED_BMSK                                                    0x4000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ASHARED_SHFT                                                       0xe
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ANOALLOCATE_BMSK                                                0x2000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ANOALLOCATE_SHFT                                                   0xd
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AINNERSHARED_BMSK                                               0x1000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_AINNERSHARED_SHFT                                                  0xc
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ADDR_43_32_BMSK                                                  0xfff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_1_ADDR_43_32_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000106c)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000106c)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000106c)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_RMSK                                                            0xffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_AMEMTYPE_BMSK                                                   0xf000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_AMEMTYPE_SHFT                                                      0xc
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_AMMUSID_BMSK                                                     0xfff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_2_AMMUSID_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_ADDR(n)                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001070 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_PHYS(n)                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001070 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_OFFS(n)                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001070 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_MAXn                                                     3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_ATTR                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_ADDR(n), HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_MID_BMSK                                        0xf8000000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_MID_SHFT                                              0x1b
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_TID_BMSK                                         0x7c00000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_TID_SHFT                                              0x16
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_WRITE_BMSK                                        0x200000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_WRITE_SHFT                                            0x15
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_ADDR_20_0_BMSK                                    0x1fffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_QSB_LOG_LAST_MISC_IDn_ADDR_20_0_SHFT                                         0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001080 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001080 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001080 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_MAXn                                                            31
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_ATTR                                                           0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_DATA_IN_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_WRITE_DATA_IN_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_ADDR(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001100 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_PHYS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001100 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_OFFS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001100 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_RMSK                                                     0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_MAXn                                                             31
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_ATTR                                                            0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_ADDR(n), HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_RF_REG_BMSK                                              0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_RF_n_READ_RF_REG_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ADDR(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001180 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_PHYS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001180 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_OFFS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001180 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_RMSK                                                       0x1fffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_MAXn                                                              7
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ADDR(n), HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_INI(n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_CHAIN_BMSK                                                 0x100000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_CHAIN_SHFT                                                     0x14
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_VIRTUAL_CHNL_BMSK                                           0xff000
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_VIRTUAL_CHNL_SHFT                                               0xc
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_EE_BMSK                                                       0xf00
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_EE_SHFT                                                         0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_EVNT_TYPE_BMSK                                                 0xf8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_EVNT_TYPE_SHFT                                                  0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_CLR_AT_READ_BMSK                                                0x4
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_CLR_AT_READ_SHFT                                                0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_STOP_AT_WRAP_ARND_BMSK                                          0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_STOP_AT_WRAP_ARND_SHFT                                          0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ENABLE_BMSK                                                     0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTER_CFGn_ENABLE_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_ADDR(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x000011a0 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_PHYS(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000011a0 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_OFFS(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000011a0 + 0x4 * (n))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_RMSK                                                             0xffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_MAXn                                                                  7
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_ATTR                                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_ADDR(n), HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_COUNTER_VALUE_BMSK                                               0xffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_COUNTERn_COUNTER_VALUE_SHFT                                                  0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x000011c0 + 0x4 * (n) + 0x24 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000011c0 + 0x4 * (n) + 0x24 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000011c0 + 0x4 * (n) + 0x24 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_MAXn                                                     8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_MAXk                                                     1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_ATTR                                                   0x2
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_DATA_IN_BMSK                                    0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_WR_DATA_IN_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x000012e0 + 0x4 * (n) + 0x24 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000012e0 + 0x4 * (n) + 0x24 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000012e0 + 0x4 * (n) + 0x24 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_MAXn                                                     8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_MAXk                                                     1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_ATTR                                                   0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_ADDR(n,k), HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_MSK_REG_BMSK                                    0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_SW_MSK_REG_n_SEC_k_RD_MSK_REG_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_ADDR(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001400 + 0x80 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_PHYS(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001400 + 0x80 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_OFFS(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001400 + 0x80 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_RMSK                                                    0x1ff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_MAXn                                                        3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_MAXk                                                       27
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_ATTR                                                      0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_ADDR(n,k), HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_VALID_BMSK                                              0x100
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_VALID_SHFT                                                0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_PHY_CH_BMSK                                              0xff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_CH_k_VP_TABLE_PHY_CH_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_ADDR(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001600 + 0x100 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_PHYS(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001600 + 0x100 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_OFFS(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001600 + 0x100 * (n) + 0x4 * (k))
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_RMSK                                                    0x1ff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_MAXn                                                        3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_MAXk                                                       26
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_ATTR                                                      0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_ADDR(n,k), HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_VALID_BMSK                                              0x100
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_VALID_SHFT                                                0x8
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_PHY_EV_CH_BMSK                                           0xff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_EE_n_EV_k_VP_TABLE_PHY_EV_CH_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_ADDR                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a54)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_PHYS                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a54)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_OFFS                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a54)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_RMSK                                                 0xff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_ATTR                                                  0x3
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_IN)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_PREFETCH_BUF_CH_ID_BMSK                              0xff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_CH_ID_PREFETCH_BUF_CH_ID_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_ADDR                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a58)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_PHYS                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a58)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_OFFS                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a58)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_RMSK                                          0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_ATTR                                                 0x1
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_ADDR, HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_PREFETCH_BUF_STATUS_BMSK                      0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_DEBUG_REE_PREFETCH_BUF_STATUS_PREFETCH_BUF_STATUS_SHFT                             0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_ADDR                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a5c)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_PHYS                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a5c)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_OFFS                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a5c)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_RMSK                                               0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_ATTR                                                      0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_BP_CNT_LSB_BMSK                                    0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_LSB_BP_CNT_LSB_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_ADDR                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a60)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_PHYS                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a60)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_OFFS                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a60)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_RMSK                                                      0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_ATTR                                                      0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_BP_CNT_MSB_BMSK                                           0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_CNT_MSB_BP_CNT_MSB_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_ADDR                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a64)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_PHYS                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a64)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_OFFS                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a64)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_RMSK                                   0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_ATTR                                          0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_BP_AND_PENDING_CNT_LSB_BMSK            0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_LSB_BP_AND_PENDING_CNT_LSB_SHFT                   0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_ADDR                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a68)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_PHYS                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a68)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_OFFS                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a68)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_RMSK                                          0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_ATTR                                          0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_BP_AND_PENDING_CNT_MSB_BMSK                   0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_BP_AND_PENDING_CNT_MSB_BP_AND_PENDING_CNT_MSB_SHFT                   0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a6c)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a6c)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a6c)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_RMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_ATTR                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_MCS_BUSY_CNT_LSB_BMSK                        0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_LSB_MCS_BUSY_CNT_LSB_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a70)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a70)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a70)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_RMSK                                                0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_ATTR                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_MCS_BUSY_CNT_MSB_BMSK                               0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_BUSY_CNT_MSB_MCS_BUSY_CNT_MSB_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a74)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a74)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a74)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_RMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_ATTR                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_MCS_IDLE_CNT_LSB_BMSK                        0xffffffff
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_LSB_MCS_IDLE_CNT_LSB_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_ADDR                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00001a78)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_PHYS                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00001a78)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_OFFS                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00001a78)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_RMSK                                                0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_ATTR                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_MCS_IDLE_CNT_MSB_BMSK                               0xf
#define HWIO_IPA_GSI_TOP_GSI_MCS_PROFILING_MCS_IDLE_CNT_MSB_MCS_IDLE_CNT_MSB_SHFT                               0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014000 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014000 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014000 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ELEMENT_SIZE_BMSK                                         0xff000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_ELEMENT_SIZE_SHFT                                               0x18
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_BMSK                                                0xf00000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_SHFT                                                    0x14
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_NOT_ALLOCATED_FVAL                                       0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_ALLOCATED_FVAL                                           0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_STARTED_FVAL                                             0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_STOPED_FVAL                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_STOP_IN_PROC_FVAL                                        0x4
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHSTATE_ERROR_FVAL                                               0xf
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHID_BMSK                                                    0xff000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHID_SHFT                                                        0xc
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_EE_BMSK                                                        0xf00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_EE_SHFT                                                          0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_DIR_BMSK                                                 0x80
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_DIR_SHFT                                                  0x7
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_DIR_INBOUND_FVAL                                          0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_DIR_OUTBOUND_FVAL                                         0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_PROTOCOL_BMSK                                            0x7f
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_PROTOCOL_SHFT                                             0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_PROTOCOL_MHI_FVAL                                         0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_PROTOCOL_XHCI_FVAL                                        0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_PROTOCOL_GPI_FVAL                                         0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_0_CHTYPE_PROTOCOL_XDCI_FVAL                                        0x3

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014004 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014004 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014004 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ERINDEX_BMSK                                              0xff000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_ERINDEX_SHFT                                                    0x18
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_R_LENGTH_BMSK                                               0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_1_R_LENGTH_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014008 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014008 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014008 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_R_BASE_ADDR_LSBS_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_2_R_BASE_ADDR_LSBS_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001400c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001400c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001400c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_R_BASE_ADDR_MSBS_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_3_R_BASE_ADDR_MSBS_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014010 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014010 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014010 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_READ_PTR_LSB_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_4_READ_PTR_LSB_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014014 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014014 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014014 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_ATTR                                                             0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_READ_PTR_MSB_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_5_READ_PTR_MSB_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014018 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014018 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014018 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_ATTR                                                             0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_WRITE_PTR_LSB_BMSK                                        0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_6_WRITE_PTR_LSB_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001401c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001401c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001401c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_ATTR                                                             0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_WRITE_PTR_MSB_BMSK                                        0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_7_WRITE_PTR_MSB_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014020 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014020 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014020 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_MAXk                                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_DB_MSI_DATA_BMSK                                          0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CNTXT_8_DB_MSI_DATA_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ADDR(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014024 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_PHYS(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014024 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_OFFS(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014024 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_RMSK                                                     0xf
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_MAXn                                                       2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_MAXk                                                      27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ATTR                                                     0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_BMSK                                     0xf
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_SHFT                                     0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_TWO_FVAL                                 0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_THREE_FVAL                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_FOUR_FVAL                                0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_FIVE_FVAL                                0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_SIX_FVAL                                 0x4

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_ADDR(n,k)                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014028 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_PHYS(n,k)                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014028 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_OFFS(n,k)                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014028 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_RMSK                                          0xffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_MAXn                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_MAXk                                              27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_ATTR                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_CH_ALMST_EMPTY_THRSHOLD_BMSK                  0xffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_CH_ALMST_EMPTY_THRSHOLD_CH_ALMST_EMPTY_THRSHOLD_SHFT                     0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014040 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014040 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014040 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_RMSK                                              0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_MAXn                                                     2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_MAXk                                                    27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_ATTR                                                   0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_READ_PTR_BMSK                                     0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_READ_PTR_READ_PTR_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_ADDR(n,k)                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014044 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_PHYS(n,k)                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014044 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_OFFS(n,k)                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014044 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_RMSK                                             0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_MAXn                                                    2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_MAXk                                                   27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_ATTR                                                  0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_RE_INTR_DB_BMSK                                  0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_RE_FETCH_WRITE_PTR_RE_INTR_DB_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_ADDR(n,k)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014048 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PHYS(n,k)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014048 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_OFFS(n,k)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014048 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_RMSK                                                           0x3ff3f0f
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_MAXn                                                                   2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_MAXk                                                                  27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_ATTR                                                                 0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_LOW_LATENCY_EN_BMSK                                            0x2000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_LOW_LATENCY_EN_SHFT                                                 0x19
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_DB_IN_BYTES_BMSK                                               0x1000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_DB_IN_BYTES_SHFT                                                    0x18
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_EMPTY_LVL_THRSHOLD_BMSK                                         0xff0000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_EMPTY_LVL_THRSHOLD_SHFT                                             0x10
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PREFETCH_MODE_BMSK                                                0x3c00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PREFETCH_MODE_SHFT                                                   0xa
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PREFETCH_MODE_USE_PREFETCH_BUFS_FVAL                                 0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PREFETCH_MODE_ESCAPE_BUF_ONLY_FVAL                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PREFETCH_MODE_SMART_PRE_FETCH_FVAL                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_PREFETCH_MODE_FREE_PRE_FETCH_FVAL                                    0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_USE_DB_ENG_BMSK                                                    0x200
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_USE_DB_ENG_SHFT                                                      0x9
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_MAX_PREFETCH_BMSK                                                  0x100
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_MAX_PREFETCH_SHFT                                                    0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_MAX_PREFETCH_ONE_PREFETCH_SEG_FVAL                                   0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_MAX_PREFETCH_TWO_PREFETCH_SEG_FVAL                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_WRR_WEIGHT_BMSK                                                      0xf
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_QOS_WRR_WEIGHT_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001404c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001404c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001404c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_0_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014050 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014050 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014050 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_1_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014054 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014054 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014054 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_2_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014058 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014058 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014058 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_3_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001405c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001405c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001405c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_4_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014060 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014060 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014060 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_5_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014064 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014064 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014064 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_6_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014068 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014068 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014068 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_7_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001406c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001406c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001406c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_8_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014070 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014070 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014070 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_MAXk                                                            27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_SCRATCH_BMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_SCRATCH_9_SCRATCH_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_ADDR(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x00014074 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_PHYS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00014074 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_OFFS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00014074 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_RMSK                                                 0xffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_MAXn                                                      2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_MAXk                                                     27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_ATTR                                                    0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_LAST_DB_2_MCS_BMSK                                   0xffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DB_ENG_WRITE_PTR_LAST_DB_2_MCS_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c000 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c000 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c000 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ELEMENT_SIZE_BMSK                                          0xff000000
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_ELEMENT_SIZE_SHFT                                                0x18
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHSTATE_BMSK                                                 0xf00000
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHSTATE_SHFT                                                     0x14
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHSTATE_NOT_ALLOCATED_FVAL                                        0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHSTATE_ALLOCATED_FVAL                                            0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_EE_BMSK                                                       0xf0000
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_EE_SHFT                                                          0x10
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_EVCHID_BMSK                                                    0xff00
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_EVCHID_SHFT                                                       0x8
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INTYPE_BMSK                                                      0x80
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INTYPE_SHFT                                                       0x7
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INTYPE_MSI_FVAL                                                   0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_INTYPE_IRQ_FVAL                                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHTYPE_BMSK                                                      0x7f
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHTYPE_SHFT                                                       0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHTYPE_MHI_EV_FVAL                                                0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHTYPE_XHCI_EV_FVAL                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHTYPE_GPI_EV_FVAL                                                0x2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_0_CHTYPE_XDCI_FVAL                                                  0x3

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c004 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c004 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c004 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_RMSK                                                         0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_R_LENGTH_BMSK                                                0xffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_1_R_LENGTH_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c008 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c008 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c008 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_R_BASE_ADDR_LSBS_BMSK                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_2_R_BASE_ADDR_LSBS_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c00c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c00c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c00c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_R_BASE_ADDR_MSBS_BMSK                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_3_R_BASE_ADDR_MSBS_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c010 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c010 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c010 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_READ_PTR_LSB_BMSK                                          0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_4_READ_PTR_LSB_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c014 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c014 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c014 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_ATTR                                                              0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_READ_PTR_MSB_BMSK                                          0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_5_READ_PTR_MSB_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c018 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c018 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c018 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_ATTR                                                              0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_WRITE_PTR_LSB_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_6_WRITE_PTR_LSB_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c01c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c01c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c01c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_ATTR                                                              0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_WRITE_PTR_MSB_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_7_WRITE_PTR_MSB_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c020 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c020 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c020 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INT_MOD_CNT_BMSK                                           0xff000000
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INT_MOD_CNT_SHFT                                                 0x18
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INT_MODC_BMSK                                                0xff0000
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INT_MODC_SHFT                                                    0x10
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INT_MODT_BMSK                                                  0xffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_8_INT_MODT_SHFT                                                     0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_ADDR(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c024 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_PHYS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c024 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_OFFS(n,k)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c024 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_MAXk                                                               26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_INTVEC_BMSK                                                0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_9_INTVEC_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c028 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c028 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c028 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_MAXk                                                              26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_MSI_ADDR_LSB_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_10_MSI_ADDR_LSB_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c02c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c02c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c02c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_MAXk                                                              26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_MSI_ADDR_MSB_BMSK                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_11_MSI_ADDR_MSB_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c030 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c030 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c030 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_MAXk                                                              26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_RP_UPDATE_ADDR_LSB_BMSK                                   0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_12_RP_UPDATE_ADDR_LSB_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_ADDR(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c034 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_PHYS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c034 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_OFFS(n,k)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c034 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_MAXk                                                              26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_RP_UPDATE_ADDR_MSB_BMSK                                   0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_CNTXT_13_RP_UPDATE_ADDR_MSB_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ADDR(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c038 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_PHYS(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c038 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_OFFS(n,k)                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c038 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_RMSK                                                      0xf
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_MAXn                                                        2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_MAXk                                                       26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ATTR                                                      0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_BMSK                                      0xf
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_SHFT                                      0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_TWO_FVAL                                  0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_THREE_FVAL                                0x1
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_FOUR_FVAL                                 0x2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_FIVE_FVAL                                 0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_ELEM_SIZE_SHIFT_ELEM_SIZE_SHIFT_SIX_FVAL                                  0x4

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_ADDR(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c048 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_PHYS(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c048 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_OFFS(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c048 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_RMSK                                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_MAXn                                                              2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_MAXk                                                             26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_SCRATCH_BMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_0_SCRATCH_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_ADDR(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c04c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_PHYS(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c04c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_OFFS(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c04c + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_RMSK                                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_MAXn                                                              2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_MAXk                                                             26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_SCRATCH_BMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_1_SCRATCH_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_ADDR(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0001c050 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_PHYS(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0001c050 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_OFFS(n,k)                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0001c050 + 0x12000 * (n) + 0x80 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_RMSK                                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_MAXn                                                              2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_MAXk                                                             26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_SCRATCH_BMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_SCRATCH_2_SCRATCH_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_ADDR(n,k)                                              (IPA_GSI_TOP_GSI_REG_BASE      + 0x00024000 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_PHYS(n,k)                                              (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00024000 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_OFFS(n,k)                                              (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00024000 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_RMSK                                                   0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_MAXn                                                            2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_MAXk                                                           27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_ATTR                                                          0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_WRITE_PTR_LSB_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_0_WRITE_PTR_LSB_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_ADDR(n,k)                                              (IPA_GSI_TOP_GSI_REG_BASE      + 0x00024004 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_PHYS(n,k)                                              (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00024004 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_OFFS(n,k)                                              (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00024004 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_RMSK                                                   0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_MAXn                                                            2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_MAXk                                                           27
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_ATTR                                                          0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_WRITE_PTR_MSB_BMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_k_DOORBELL_1_WRITE_PTR_MSB_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00024800 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00024800 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00024800 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_MAXk                                                            26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_ATTR                                                           0x2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_WRITE_PTR_LSB_BMSK                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_0_WRITE_PTR_LSB_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_ADDR(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE      + 0x00024804 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_PHYS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00024804 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_OFFS(n,k)                                               (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00024804 + 0x12000 * (n) + 0x8 * (k))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_MAXk                                                            26
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_ATTR                                                           0x2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_WRITE_PTR_MSB_BMSK                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_k_DOORBELL_1_WRITE_PTR_MSB_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_ADDR(n)                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025000 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_PHYS(n)                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025000 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_OFFS(n)                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025000 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_RMSK                                                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_MAXn                                                                     2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_ATTR                                                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_ENABLED_BMSK                                                           0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_STATUS_ENABLED_SHFT                                                           0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_ADDR(n)                                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025008 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_PHYS(n)                                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025008 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OFFS(n)                                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025008 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_RMSK                                                            0xff0000ff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_MAXn                                                                     2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_ATTR                                                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_BMSK                                                     0xff000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_SHFT                                                           0x18
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_ALLOCATE_FVAL                                                   0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_START_FVAL                                                      0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_STOP_FVAL                                                       0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_RESET_FVAL                                                      0x9
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_DE_ALLOC_FVAL                                                   0xa
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_OPCODE_DB_STOP_FVAL                                                    0xb
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_CHID_BMSK                                                             0xff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_CH_CMD_CHID_SHFT                                                              0x0

#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_ADDR(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025010 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_PHYS(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025010 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OFFS(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025010 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_RMSK                                                             0xff0000ff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_MAXn                                                                      2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_ATTR                                                                    0x2
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OPCODE_BMSK                                                      0xff000000
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OPCODE_SHFT                                                            0x18
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OPCODE_ALLOCATE_FVAL                                                    0x0
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OPCODE_RESET_FVAL                                                       0x9
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_OPCODE_DE_ALLOC_FVAL                                                    0xa
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_CHID_BMSK                                                              0xff
#define HWIO_IPA_GSI_TOP_EE_n_EV_CH_CMD_CHID_SHFT                                                               0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025018 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025018 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025018 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_ATTR                                                           0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_OPCODE_BMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_EE_GENERIC_CMD_OPCODE_SHFT                                                    0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025038 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025038 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025038 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_RMSK                                                        0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_USE_AXI_M_BMSK                                              0x80000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_USE_AXI_M_SHFT                                                    0x1f
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_PERIPH_SEC_GRP_BMSK                                         0x7c000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_PERIPH_SEC_GRP_SHFT                                               0x1a
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_PERIPH_CONF_ADDR_BUS_W_BMSK                                  0x3e00000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_PERIPH_CONF_ADDR_BUS_W_SHFT                                       0x15
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_NUM_EES_BMSK                                                  0x1f0000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_NUM_EES_SHFT                                                      0x10
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_GSI_CH_NUM_BMSK                                                 0xff00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_GSI_CH_NUM_SHFT                                                    0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_GSI_EV_CH_NUM_BMSK                                                0xff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_0_GSI_EV_CH_NUM_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x0002503c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0002503c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0002503c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_RMSK                                                        0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_BLK_INT_ACCESS_REGION_2_EN_BMSK                         0x80000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_BLK_INT_ACCESS_REGION_2_EN_SHFT                               0x1f
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_BLK_INT_ACCESS_REGION_1_EN_BMSK                         0x40000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_BLK_INT_ACCESS_REGION_1_EN_SHFT                               0x1e
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_SIMPLE_RD_WR_BMSK                                       0x20000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_SIMPLE_RD_WR_SHFT                                             0x1d
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_ESCAPE_BUF_ONLY_BMSK                                    0x10000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_ESCAPE_BUF_ONLY_SHFT                                          0x1c
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_UC_IF_BMSK                                           0x8000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_UC_IF_SHFT                                                0x1b
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_DB_ENG_BMSK                                          0x4000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_DB_ENG_SHFT                                               0x1a
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_BP_MTRIX_BMSK                                        0x2000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_BP_MTRIX_SHFT                                             0x19
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_NUM_TIMERS_BMSK                                          0x1f00000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_NUM_TIMERS_SHFT                                               0x14
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_XPU_BMSK                                               0x80000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_USE_XPU_SHFT                                                  0x13
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_QRIB_EN_BMSK                                               0x40000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_QRIB_EN_SHFT                                                  0x12
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_VMIDACR_EN_BMSK                                            0x20000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_VMIDACR_EN_SHFT                                               0x11
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_SEC_EN_BMSK                                                0x10000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_SEC_EN_SHFT                                                   0x10
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_NONSEC_EN_BMSK                                              0xf000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_NONSEC_EN_SHFT                                                 0xc
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_NUM_QAD_BMSK                                                 0xf00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_NUM_QAD_SHFT                                                   0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_M_DATA_BUS_W_BMSK                                             0xff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_1_GSI_M_DATA_BUS_W_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025040 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025040 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025040 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_RMSK                                                        0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_USE_INTER_EE_BMSK                                       0x80000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_USE_INTER_EE_SHFT                                             0x1f
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_USE_RD_WR_ENG_BMSK                                      0x40000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_USE_RD_WR_ENG_SHFT                                            0x1e
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_SDMA_N_IOVEC_BMSK                                       0x38000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_SDMA_N_IOVEC_SHFT                                             0x1b
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_SDMA_MAX_BURST_BMSK                                      0x7f80000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_SDMA_MAX_BURST_SHFT                                           0x13
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_SDMA_N_INT_BMSK                                            0x70000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_SDMA_N_INT_SHFT                                               0x10
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_USE_SDMA_BMSK                                               0x8000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_USE_SDMA_SHFT                                                  0xf
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_CH_FULL_LOGIC_BMSK                                          0x4000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_CH_FULL_LOGIC_SHFT                                             0xe
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_CH_PEND_TRANSLATE_BMSK                                      0x2000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_CH_PEND_TRANSLATE_SHFT                                         0xd
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_BMSK                                              0x1f00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_SHFT                                                 0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_ONE_KB_FVAL                                          0x0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_TWO_KB_FVAL                                          0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_TWO_N_HALF_KB_FVAL                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_THREE_KB_FVAL                                        0x3
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_THREE_N_HALF_KB_FVAL                                 0x4
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_IRAM_SIZE_FOUR_KB_FVAL                                         0x5
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_NUM_CH_PER_EE_BMSK                                            0xff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_2_GSI_NUM_CH_PER_EE_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025044 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025044 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025044 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_RMSK                                                        0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_MAJOR_BMSK                                                  0xf0000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_MAJOR_SHFT                                                        0x1c
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_MINOR_BMSK                                                   0xfff0000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_MINOR_SHFT                                                        0x10
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_STEP_BMSK                                                       0xffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_SW_VERSION_STEP_SHFT                                                          0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_ADDR(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025048 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_PHYS(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025048 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_OFFS(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025048 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_RMSK                                                      0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_ATTR                                                             0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_VER_BMSK                                                  0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_MCS_CODE_VER_VER_SHFT                                                         0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x0002504c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0002504c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0002504c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_RMSK                                                        0x1fffffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_DB_MSI_MODE_BMSK                                    0x10000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_DB_MSI_MODE_SHFT                                          0x1c
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_SLEEP_CLK_DIV_BMSK                                   0x8000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_SLEEP_CLK_DIV_SHFT                                        0x1b
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_VIR_CH_IF_BMSK                                       0x4000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_VIR_CH_IF_SHFT                                            0x1a
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_IROM_BMSK                                            0x2000000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_USE_IROM_SHFT                                                 0x19
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_REE_MAX_BURST_LEN_BMSK                                   0x1f00000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_REE_MAX_BURST_LEN_SHFT                                        0x14
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_M_ADDR_BUS_W_BMSK                                          0xff000
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_M_ADDR_BUS_W_SHFT                                              0xc
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_NUM_PREFETCH_BUFS_BMSK                                       0xf00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_NUM_PREFETCH_BUFS_SHFT                                         0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_SDMA_MAX_OS_WR_BMSK                                           0xf0
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_SDMA_MAX_OS_WR_SHFT                                            0x4
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_SDMA_MAX_OS_RD_BMSK                                            0xf
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_3_GSI_SDMA_MAX_OS_RD_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025050 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025050 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025050 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_RMSK                                                            0xffff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_GSI_IRAM_PROTCOL_CNT_BMSK                                       0xff00
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_GSI_IRAM_PROTCOL_CNT_SHFT                                          0x8
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_GSI_NUM_EV_PER_EE_BMSK                                            0xff
#define HWIO_IPA_GSI_TOP_EE_n_GSI_HW_PARAM_4_GSI_NUM_EV_PER_EE_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_ADDR(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025080 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_PHYS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025080 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_OFFS(n)                                                     (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025080 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_RMSK                                                              0x7f
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MAXn                                                                 2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_ATTR                                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_GENERAL_BMSK                                                      0x40
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_GENERAL_SHFT                                                       0x6
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_INTER_EE_EV_CTRL_BMSK                                             0x20
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_INTER_EE_EV_CTRL_SHFT                                              0x5
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_INTER_EE_CH_CTRL_BMSK                                             0x10
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_INTER_EE_CH_CTRL_SHFT                                              0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_IEOB_BMSK                                                          0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_IEOB_SHFT                                                          0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_GLOB_EE_BMSK                                                       0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_GLOB_EE_SHFT                                                       0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_EV_CTRL_BMSK                                                       0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_EV_CTRL_SHFT                                                       0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_CH_CTRL_BMSK                                                       0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_CH_CTRL_SHFT                                                       0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025088 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025088 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025088 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_RMSK                                                          0x7f
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_GENERAL_BMSK                                                  0x40
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_GENERAL_SHFT                                                   0x6
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INTER_EE_EV_CTRL_BMSK                                         0x20
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INTER_EE_EV_CTRL_SHFT                                          0x5
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INTER_EE_CH_CTRL_BMSK                                         0x10
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_INTER_EE_CH_CTRL_SHFT                                          0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_IEOB_BMSK                                                      0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_IEOB_SHFT                                                      0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_GLOB_EE_BMSK                                                   0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_GLOB_EE_SHFT                                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_EV_CTRL_BMSK                                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_EV_CTRL_SHFT                                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_CH_CTRL_BMSK                                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_TYPE_IRQ_MSK_CH_CTRL_SHFT                                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_ADDR(n,k)                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025090 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_PHYS(n,k)                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025090 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_OFFS(n,k)                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025090 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_RMSK                                                0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_MAXn                                                         2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_MAXk                                                         0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_ATTR                                                       0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_GSI_CH_BIT_MAP_BMSK                                 0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_k_GSI_CH_BIT_MAP_SHFT                                        0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025094 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025094 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025094 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_MAXn                                                     2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_MAXk                                                     0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_ATTR                                                   0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_GSI_CH_BIT_MAP_MSK_BMSK                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_MSK_k_GSI_CH_BIT_MAP_MSK_SHFT                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025098 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025098 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025098 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_MAXn                                                     2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_MAXk                                                     0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_ATTR                                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_GSI_CH_BIT_MAP_BMSK                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_GSI_CH_IRQ_CLR_k_GSI_CH_BIT_MAP_SHFT                                    0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_ADDR(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x0002509c + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_PHYS(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0002509c + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_OFFS(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0002509c + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_RMSK                                                 0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_MAXn                                                          2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_MAXk                                                          0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_ATTR                                                        0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_EV_CH_BIT_MAP_BMSK                                   0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_k_EV_CH_BIT_MAP_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x000250a0 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_PHYS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000250a0 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_OFFS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000250a0 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_RMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_MAXn                                                      2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_MAXk                                                      0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_ATTR                                                    0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_EV_CH_BIT_MAP_MSK_BMSK                           0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_MSK_k_EV_CH_BIT_MAP_MSK_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_ADDR(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x000250a4 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_PHYS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000250a4 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_OFFS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000250a4 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_RMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_MAXn                                                      2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_MAXk                                                      0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_ATTR                                                    0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_EV_CH_BIT_MAP_BMSK                               0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_EV_CH_IRQ_CLR_k_EV_CH_BIT_MAP_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_ADDR(n,k)                                             (IPA_GSI_TOP_GSI_REG_BASE      + 0x000250a8 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_PHYS(n,k)                                             (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000250a8 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_OFFS(n,k)                                             (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000250a8 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_RMSK                                                  0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_MAXn                                                           2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_MAXk                                                           0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_ATTR                                                         0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_EV_CH_BIT_MAP_BMSK                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_k_EV_CH_BIT_MAP_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_ADDR(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x000250ac + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_PHYS(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000250ac + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_OFFS(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000250ac + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_RMSK                                              0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_MAXn                                                       2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_MAXk                                                       0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_ATTR                                                     0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_ADDR(n,k), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_INI2(n,k))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_EV_CH_BIT_MAP_MSK_BMSK                            0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_MSK_k_EV_CH_BIT_MAP_MSK_SHFT                                   0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_ADDR(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE      + 0x000250b0 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_PHYS(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x000250b0 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_OFFS(n,k)                                         (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x000250b0 + 0x24 * (k) + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_RMSK                                              0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_MAXn                                                       2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_MAXk                                                       0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_ATTR                                                     0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_EV_CH_BIT_MAP_BMSK                                0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SRC_IEOB_IRQ_CLR_k_EV_CH_BIT_MAP_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_ADDR(n)                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025200 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_PHYS(n)                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025200 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_OFFS(n)                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025200 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_RMSK                                                          0xf
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_MAXn                                                            2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_ATTR                                                          0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_GP_INT3_BMSK                                                  0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_GP_INT3_SHFT                                                  0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_GP_INT2_BMSK                                                  0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_GP_INT2_SHFT                                                  0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_GP_INT1_BMSK                                                  0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_GP_INT1_SHFT                                                  0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_ERROR_INT_BMSK                                                0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_STTS_ERROR_INT_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ADDR(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025204 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_PHYS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025204 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_OFFS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025204 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_RMSK                                                            0xf
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_MAXn                                                              2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ATTR                                                            0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_GP_INT3_BMSK                                                    0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_GP_INT3_SHFT                                                    0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_GP_INT2_BMSK                                                    0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_GP_INT2_SHFT                                                    0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_GP_INT1_BMSK                                                    0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_GP_INT1_SHFT                                                    0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ERROR_INT_BMSK                                                  0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_EN_ERROR_INT_SHFT                                                  0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025208 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025208 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025208 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_RMSK                                                           0xf
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_ATTR                                                           0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_GP_INT3_BMSK                                                   0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_GP_INT3_SHFT                                                   0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_GP_INT2_BMSK                                                   0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_GP_INT2_SHFT                                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_GP_INT1_BMSK                                                   0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_GP_INT1_SHFT                                                   0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_ERROR_INT_BMSK                                                 0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GLOB_IRQ_CLR_ERROR_INT_SHFT                                                 0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x0002520c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0002520c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0002520c + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_RMSK                                                           0xf
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_ATTR                                                           0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_MCS_STACK_OVRFLOW_BMSK                                     0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_MCS_STACK_OVRFLOW_SHFT                                     0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_CMD_FIFO_OVRFLOW_BMSK                                      0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_CMD_FIFO_OVRFLOW_SHFT                                      0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_BUS_ERROR_BMSK                                             0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_BUS_ERROR_SHFT                                             0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_BREAK_POINT_BMSK                                           0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_STTS_GSI_BREAK_POINT_SHFT                                           0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_ADDR(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025210 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_PHYS(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025210 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_OFFS(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025210 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_RMSK                                                             0xf
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_ATTR                                                             0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_MCS_STACK_OVRFLOW_BMSK                                       0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_MCS_STACK_OVRFLOW_SHFT                                       0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_CMD_FIFO_OVRFLOW_BMSK                                        0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_CMD_FIFO_OVRFLOW_SHFT                                        0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_BUS_ERROR_BMSK                                               0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_BUS_ERROR_SHFT                                               0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_BREAK_POINT_BMSK                                             0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_EN_GSI_BREAK_POINT_SHFT                                             0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_ADDR(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025214 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_PHYS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025214 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_OFFS(n)                                                  (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025214 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_RMSK                                                            0xf
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_MAXn                                                              2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_ATTR                                                            0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_MCS_STACK_OVRFLOW_BMSK                                      0x8
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_MCS_STACK_OVRFLOW_SHFT                                      0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_CMD_FIFO_OVRFLOW_BMSK                                       0x4
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_CMD_FIFO_OVRFLOW_SHFT                                       0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_BUS_ERROR_BMSK                                              0x2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_BUS_ERROR_SHFT                                              0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_BREAK_POINT_BMSK                                            0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_GSI_IRQ_CLR_GSI_BREAK_POINT_SHFT                                            0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_ADDR(n)                                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025220 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_PHYS(n)                                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025220 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_OFFS(n)                                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025220 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_RMSK                                                                 0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_MAXn                                                                   2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_ATTR                                                                 0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INTYPE_BMSK                                                          0x1
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INTYPE_SHFT                                                          0x0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INTYPE_MSI_FVAL                                                      0x0
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INTSET_INTYPE_IRQ_FVAL                                                      0x1

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025230 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025230 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025230 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_MSI_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_LSB_MSI_ADDR_LSB_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_ADDR(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025234 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_PHYS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025234 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_OFFS(n)                                                 (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025234 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_RMSK                                                    0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_MAXn                                                             2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_ATTR                                                           0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_MSI_ADDR_MSB_BMSK                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_MSI_BASE_MSB_MSI_ADDR_MSB_SHFT                                              0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_ADDR(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025238 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_PHYS(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025238 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_OFFS(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025238 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_RMSK                                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_MAXn                                                                  2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_ATTR                                                                0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_INT_VEC_BMSK                                                 0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_INT_VEC_INT_VEC_SHFT                                                        0x0

#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ADDR(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025240 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_PHYS(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025240 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_OFFS(n)                                                          (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025240 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_RMSK                                                             0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_MAXn                                                                      2
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ATTR                                                                    0x3
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ERROR_LOG_BMSK                                                   0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_ERROR_LOG_SHFT                                                          0x0

#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_ADDR(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025244 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_PHYS(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025244 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_OFFS(n)                                                      (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025244 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_RMSK                                                         0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_MAXn                                                                  2
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_ATTR                                                                0x2
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_ERROR_LOG_CLR_BMSK                                           0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_ERROR_LOG_CLR_ERROR_LOG_CLR_SHFT                                                  0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_ADDR(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025400 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_PHYS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025400 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_OFFS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025400 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_SCRATCH_BMSK                                               0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_0_SCRATCH_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_ADDR(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x00025404 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_PHYS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x00025404 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_OFFS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x00025404 + 0x12000 * (n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_RMSK                                                       0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_ADDR(n), HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_RMSK)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_INI(n))
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_SCRATCH_BMSK                                               0xffffffff
#define HWIO_IPA_GSI_TOP_EE_n_CNTXT_SCRATCH_1_SCRATCH_SHFT                                                      0x0

#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_ADDR                                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000b000)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_PHYS                                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000b000)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_OFFS                                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000b000)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_RMSK                                                                       0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_ATTR                                                                       0x3
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_CFG_ADDR, HWIO_IPA_GSI_TOP_GSI_MCS_CFG_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MCS_CFG_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MCS_CFG_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MCS_CFG_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_MCS_CFG_IN)
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_MCS_ENABLE_BMSK                                                            0x1
#define HWIO_IPA_GSI_TOP_GSI_MCS_CFG_MCS_ENABLE_SHFT                                                            0x0

#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000b008)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000b008)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000b008)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_RMSK                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_ATTR                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_ADDR, HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_IN)
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_DIS_DEBUG_SHRAM_WRITE_BMSK                                         0x2
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_DIS_DEBUG_SHRAM_WRITE_SHFT                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_DIS_IRAM_WRITE_BMSK                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_TZ_FW_AUTH_LOCK_DIS_IRAM_WRITE_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_ADDR                                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000b010)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_PHYS                                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000b010)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_OFFS                                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000b010)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_RMSK                                                              0x3
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_ATTR                                                              0x3
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_ADDR, HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_IN)
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_DIS_DEBUG_SHRAM_WRITE_BMSK                                        0x2
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_DIS_DEBUG_SHRAM_WRITE_SHFT                                        0x1
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_DIS_IRAM_WRITE_BMSK                                               0x1
#define HWIO_IPA_GSI_TOP_GSI_MSA_FW_AUTH_LOCK_DIS_IRAM_WRITE_SHFT                                               0x0

#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_ADDR                                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000b018)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_PHYS                                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000b018)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_OFFS                                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000b018)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_RMSK                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_ATTR                                                               0x3
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_ADDR, HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_RMSK)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_ADDR, m)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_ADDR,v)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_ADDR,m,v,HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_IN)
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_DIS_DEBUG_SHRAM_WRITE_BMSK                                         0x2
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_DIS_DEBUG_SHRAM_WRITE_SHFT                                         0x1
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_DIS_IRAM_WRITE_BMSK                                                0x1
#define HWIO_IPA_GSI_TOP_GSI_SP_FW_AUTH_LOCK_DIS_IRAM_WRITE_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_ADDR(n)                                                (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c000 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_PHYS(n)                                                (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c000 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_OFFS(n)                                                (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c000 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_RMSK                                                          0xf
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_MAXn                                                            2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_ATTR                                                          0x3
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_ADDR(n), HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_RMSK)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_INI(n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_EE_NUMBER_BMSK                                                0xf
#define HWIO_IPA_GSI_TOP_INTER_EE_n_ORIGINATOR_EE_EE_NUMBER_SHFT                                                0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_ADDR(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c008 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_PHYS(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c008 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OFFS(n)                                                   (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c008 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_RMSK                                                      0xff0000ff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_MAXn                                                               2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_ATTR                                                             0x2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_BMSK                                               0xff000000
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_SHFT                                                     0x18
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_START_FVAL                                                0x1
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_STOP_FVAL                                                 0x2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_RESET_FVAL                                                0x9
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_DE_ALLOC_FVAL                                             0xa
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_OPCODE_DB_STOP_FVAL                                              0xb
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_CHID_BMSK                                                       0xff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_GSI_CH_CMD_CHID_SHFT                                                        0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_ADDR(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c010 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_PHYS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c010 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_OFFS(n)                                                    (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c010 + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_RMSK                                                       0xff0000ff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_MAXn                                                                2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_ATTR                                                              0x2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_OPCODE_BMSK                                                0xff000000
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_OPCODE_SHFT                                                      0x18
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_OPCODE_RESET_FVAL                                                 0x9
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_OPCODE_DE_ALLOC_FVAL                                              0xa
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_CHID_BMSK                                                        0xff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_EV_CH_CMD_CHID_SHFT                                                         0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_ADDR(n,k)                                           (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c018 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_PHYS(n,k)                                           (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c018 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_OFFS(n,k)                                           (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c018 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_RMSK                                                0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_MAXn                                                         2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_MAXk                                                         0
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_ATTR                                                       0x1
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_ADDR(n,k), HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_RMSK)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_GSI_CH_BIT_MAP_BMSK                                 0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_k_GSI_CH_BIT_MAP_SHFT                                        0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c01c + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c01c + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c01c + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_MAXn                                                     2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_MAXk                                                     0
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_ATTR                                                   0x3
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k), HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_RMSK)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_INI2(n,k))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_GSI_CH_BIT_MAP_MSK_BMSK                         0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_MSK_k_GSI_CH_BIT_MAP_MSK_SHFT                                0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_ADDR(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c020 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_PHYS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c020 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_OFFS(n,k)                                       (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c020 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_RMSK                                            0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_MAXn                                                     2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_MAXk                                                     0
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_ATTR                                                   0x2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_GSI_CH_BIT_MAP_BMSK                             0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_GSI_CH_IRQ_CLR_k_GSI_CH_BIT_MAP_SHFT                                    0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_ADDR(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c024 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_PHYS(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c024 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_OFFS(n,k)                                            (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c024 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_RMSK                                                 0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_MAXn                                                          2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_MAXk                                                          0
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_ATTR                                                        0x1
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_ADDR(n,k), HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_RMSK)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_EV_CH_BIT_MAP_BMSK                                   0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_k_EV_CH_BIT_MAP_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c028 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_PHYS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c028 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_OFFS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c028 + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_RMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_MAXn                                                      2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_MAXk                                                      0
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_ATTR                                                    0x3
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_INI2(n,k)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k), HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_RMSK)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_INMI2(n,k,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k), mask)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_OUTMI2(n,k,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_ADDR(n,k),mask,val,HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_INI2(n,k))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_EV_CH_BIT_MAP_MSK_BMSK                           0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_MSK_k_EV_CH_BIT_MAP_MSK_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_ADDR(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE      + 0x0000c02c + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_PHYS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_PHYS + 0x0000c02c + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_OFFS(n,k)                                        (IPA_GSI_TOP_GSI_REG_BASE_OFFS + 0x0000c02c + 0x18 * (k) + 0x1000 * (n))
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_RMSK                                             0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_MAXn                                                      2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_MAXk                                                      0
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_ATTR                                                    0x2
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_OUTI2(n,k,val)    \
        out_dword(HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_ADDR(n,k),val)
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_EV_CH_BIT_MAP_BMSK                               0xffffffff
#define HWIO_IPA_GSI_TOP_INTER_EE_n_SRC_EV_CH_IRQ_CLR_k_EV_CH_BIT_MAP_SHFT                                      0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_GSI_TOP_XPU3
 *--------------------------------------------------------------------------*/

#define IPA_GSI_TOP_XPU3_REG_BASE                                            (IPA_0_IPA_WRAPPER_BASE      + 0x00000000)
#define IPA_GSI_TOP_XPU3_REG_BASE_PHYS                                       (IPA_0_IPA_WRAPPER_BASE_PHYS + 0x00000000)
#define IPA_GSI_TOP_XPU3_REG_BASE_OFFS                                       0x00000000

#define HWIO_IPA_GSI_TOP_XPU3_GCR0_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000000)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_RMSK                                             0x3
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_ATTR                                             0x3
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_GCR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_GCR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_GCR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_GCR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_GCR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_GCR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_AALOG_MODE_DIS_BMSK                              0x2
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_AALOG_MODE_DIS_SHFT                              0x1
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_AADEN_BMSK                                       0x1
#define HWIO_IPA_GSI_TOP_XPU3_GCR0_AADEN_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_XPU3_SCR0_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000008)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_RMSK                                           0x10f
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_ATTR                                             0x3
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SCR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_SCR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SCR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_SCR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_SCR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_SCR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_DYNAMIC_CLK_EN_BMSK                            0x100
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_DYNAMIC_CLK_EN_SHFT                              0x8
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCLEIE_BMSK                                      0x8
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCLEIE_SHFT                                      0x3
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCFGEIE_BMSK                                     0x4
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCFGEIE_SHFT                                     0x2
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCLERE_BMSK                                      0x2
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCLERE_SHFT                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCFGERE_BMSK                                     0x1
#define HWIO_IPA_GSI_TOP_XPU3_SCR0_SCFGERE_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_XPU3_CR0_ADDR                                       (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000010)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_PHYS                                       (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_OFFS                                       (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_RMSK                                            0x18f
#define HWIO_IPA_GSI_TOP_XPU3_CR0_ATTR                                              0x3
#define HWIO_IPA_GSI_TOP_XPU3_CR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_CR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_CR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_CR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_CR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_CR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_CR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_CR0_DYNAMIC_CLK_EN_BMSK                             0x100
#define HWIO_IPA_GSI_TOP_XPU3_CR0_DYNAMIC_CLK_EN_SHFT                               0x8
#define HWIO_IPA_GSI_TOP_XPU3_CR0_VMIDEN_BMSK                                      0x80
#define HWIO_IPA_GSI_TOP_XPU3_CR0_VMIDEN_SHFT                                       0x7
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CLEIE_BMSK                                        0x8
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CLEIE_SHFT                                        0x3
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CFGEIE_BMSK                                       0x4
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CFGEIE_SHFT                                       0x2
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CLERE_BMSK                                        0x2
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CLERE_SHFT                                        0x1
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CFGERE_BMSK                                       0x1
#define HWIO_IPA_GSI_TOP_XPU3_CR0_CFGERE_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_ADDR                                  (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000020)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_PHYS                                  (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000020)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_OFFS                                  (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000020)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_RMSK                                  0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_SUVMID_BMSK                           0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_RPU_ACR0_SUVMID_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_ADDR                                 (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000080)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_PHYS                                 (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000080)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_OFFS                                 (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000080)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_RMSK                                        0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_ATTR                                        0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_QAD0LOG_MODE_DIS_BMSK                       0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_QAD0LOG_MODE_DIS_SHFT                       0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_QAD0DEN_BMSK                                0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_GCR0_QAD0DEN_SHFT                                0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_ADDR                                  (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000090)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_PHYS                                  (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_OFFS                                  (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_RMSK                                       0x10f
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_DYNAMIC_CLK_EN_BMSK                        0x100
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_DYNAMIC_CLK_EN_SHFT                          0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CLEIE_BMSK                                   0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CLEIE_SHFT                                   0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CFGEIE_BMSK                                  0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CFGEIE_SHFT                                  0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CLERE_BMSK                                   0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CLERE_SHFT                                   0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CFGERE_BMSK                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_CR0_CFGERE_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_ADDR                                 (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000100)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_PHYS                                 (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000100)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_OFFS                                 (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000100)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_RMSK                                        0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_ATTR                                        0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_QAD1LOG_MODE_DIS_BMSK                       0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_QAD1LOG_MODE_DIS_SHFT                       0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_QAD1DEN_BMSK                                0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_GCR0_QAD1DEN_SHFT                                0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_ADDR                                  (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000110)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_PHYS                                  (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000110)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_OFFS                                  (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000110)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_RMSK                                       0x10f
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_DYNAMIC_CLK_EN_BMSK                        0x100
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_DYNAMIC_CLK_EN_SHFT                          0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CLEIE_BMSK                                   0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CLEIE_SHFT                                   0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CFGEIE_BMSK                                  0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CFGEIE_SHFT                                  0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CLERE_BMSK                                   0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CLERE_SHFT                                   0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CFGERE_BMSK                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_CR0_CFGERE_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_IDR3_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x000003ec)
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x000003ec)
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x000003ec)
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_RMSK                                           0x3ff
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_ATTR                                             0x1
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR3_ADDR, HWIO_IPA_GSI_TOP_XPU3_IDR3_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR3_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_PT_BMSK                                        0x200
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_PT_SHFT                                          0x9
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_MV_BMSK                                        0x100
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_MV_SHFT                                          0x8
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_NVMID_BMSK                                      0xff
#define HWIO_IPA_GSI_TOP_XPU3_IDR3_NVMID_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_XPU3_IDR2_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x000003f0)
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x000003f0)
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x000003f0)
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_RMSK                                      0xffffff0f
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_ATTR                                             0x1
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR2_ADDR, HWIO_IPA_GSI_TOP_XPU3_IDR2_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR2_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_NONSEC_EN_BMSK                            0xff000000
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_NONSEC_EN_SHFT                                  0x18
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_SEC_EN_BMSK                                 0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_SEC_EN_SHFT                                     0x10
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_VMIDACR_EN_BMSK                               0xff00
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_VMIDACR_EN_SHFT                                  0x8
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_NUM_QAD_BMSK                                     0xf
#define HWIO_IPA_GSI_TOP_XPU3_IDR2_NUM_QAD_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_XPU3_IDR1_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x000003f4)
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x000003f4)
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x000003f4)
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_RMSK                                      0x3f3f0000
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_ATTR                                             0x1
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_IDR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_CLIENT_ADDR_WIDTH_BMSK                    0x3f000000
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_CLIENT_ADDR_WIDTH_SHFT                          0x18
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_CONFIG_ADDR_WIDTH_BMSK                      0x3f0000
#define HWIO_IPA_GSI_TOP_XPU3_IDR1_CONFIG_ADDR_WIDTH_SHFT                          0x10

#define HWIO_IPA_GSI_TOP_XPU3_IDR0_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x000003f8)
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x000003f8)
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x000003f8)
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_RMSK                                       0x3ff0023
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_ATTR                                             0x1
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_IDR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_IDR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_NRG_BMSK                                   0x3ff0000
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_NRG_SHFT                                        0x10
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_CLIENTREQ_HALT_ACK_HW_EN_BMSK                   0x20
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_CLIENTREQ_HALT_ACK_HW_EN_SHFT                    0x5
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_XPUTYPE_BMSK                                     0x3
#define HWIO_IPA_GSI_TOP_XPU3_IDR0_XPUTYPE_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_XPU3_REV_ADDR                                       (IPA_GSI_TOP_XPU3_REG_BASE      + 0x000003fc)
#define HWIO_IPA_GSI_TOP_XPU3_REV_PHYS                                       (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x000003fc)
#define HWIO_IPA_GSI_TOP_XPU3_REV_OFFS                                       (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x000003fc)
#define HWIO_IPA_GSI_TOP_XPU3_REV_RMSK                                       0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_REV_ATTR                                              0x1
#define HWIO_IPA_GSI_TOP_XPU3_REV_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_REV_ADDR, HWIO_IPA_GSI_TOP_XPU3_REV_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_REV_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_REV_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_REV_MAJOR_BMSK                                 0xf0000000
#define HWIO_IPA_GSI_TOP_XPU3_REV_MAJOR_SHFT                                       0x1c
#define HWIO_IPA_GSI_TOP_XPU3_REV_MINOR_BMSK                                  0xfff0000
#define HWIO_IPA_GSI_TOP_XPU3_REV_MINOR_SHFT                                       0x10
#define HWIO_IPA_GSI_TOP_XPU3_REV_STEP_BMSK                                      0xffff
#define HWIO_IPA_GSI_TOP_XPU3_REV_STEP_SHFT                                         0x0

#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_ADDR                              (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000400)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_PHYS                              (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_OFFS                              (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_RMSK                                     0x1
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_ATTR                                     0x3
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_ADDR, HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_IN)
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_LOG_MODE_DIS_BMSK                        0x1
#define HWIO_IPA_GSI_TOP_XPU3_LOG_MODE_DIS_LOG_MODE_DIS_SHFT                        0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_ADDR(r)                        (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000500 + 0x4 * (r))
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_PHYS(r)                        (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000500 + 0x4 * (r))
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_OFFS(r)                        (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000500 + 0x4 * (r))
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_RMSK                             0x1fffff
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_MAXr                                    0
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_ATTR                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_INI(r)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_ADDR(r), HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_INMI(r,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_ADDR(r), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_RGFREESTATUS_BMSK                0x1fffff
#define HWIO_IPA_GSI_TOP_XPU3_RGN_FREESTATUSr_RGFREESTATUS_SHFT                     0x0

#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_ADDR                                     (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000800)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_PHYS                                     (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000800)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_OFFS                                     (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000800)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_RMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_ATTR                                            0x1
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SEAR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_SEAR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SEAR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_ADDR_31_0_BMSK                           0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_SEAR0_ADDR_31_0_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_SESR_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000808)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000808)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000808)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_RMSK                                             0xf
#define HWIO_IPA_GSI_TOP_XPU3_SESR_ATTR                                             0x3
#define HWIO_IPA_GSI_TOP_XPU3_SESR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESR_ADDR, HWIO_IPA_GSI_TOP_XPU3_SESR_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESR_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_SESR_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_SESR_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_SESR_IN)
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CLMULTI_BMSK                                     0x8
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CLMULTI_SHFT                                     0x3
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CFGMULTI_BMSK                                    0x4
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CFGMULTI_SHFT                                    0x2
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CLIENT_BMSK                                      0x2
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CLIENT_SHFT                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CFG_BMSK                                         0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESR_CFG_SHFT                                         0x0

#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x0000080c)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x0000080c)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x0000080c)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_RMSK                                      0xf
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_ATTR                                      0x3
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_ADDR, HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_IN)
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CLMULTI_BMSK                              0x8
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CLMULTI_SHFT                              0x3
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CFGMULTI_BMSK                             0x4
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CFGMULTI_SHFT                             0x2
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CLIENT_BMSK                               0x2
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CLIENT_SHFT                               0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CFG_BMSK                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESRRESTORE_CFG_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ADDR                                   (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000810)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_PHYS                                   (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000810)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_OFFS                                   (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000810)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_RMSK                                   0x67ffff0f
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ATTR                                          0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_SESYNR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_AC_BMSK                                0x40000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_AC_SHFT                                      0x1e
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_BURSTLEN_BMSK                          0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_BURSTLEN_SHFT                                0x1d
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ASIZE_BMSK                              0x7000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ASIZE_SHFT                                   0x18
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ALEN_BMSK                                0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_ALEN_SHFT                                    0x10
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_QAD_BMSK                                   0xff00
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_QAD_SHFT                                      0x8
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_XPRIV_BMSK                                    0x8
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_XPRIV_SHFT                                    0x3
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_XINST_BMSK                                    0x4
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_XINST_SHFT                                    0x2
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_AWRITE_BMSK                                   0x2
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_AWRITE_SHFT                                   0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_XPROTNS_BMSK                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR0_XPROTNS_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_ADDR                                   (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000814)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_PHYS                                   (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000814)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_OFFS                                   (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000814)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_RMSK                                   0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_ATTR                                          0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESYNR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_SESYNR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESYNR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_TID_BMSK                               0xff000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_TID_SHFT                                     0x18
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_VMID_BMSK                                0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_VMID_SHFT                                    0x10
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_BID_BMSK                                   0xe000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_BID_SHFT                                      0xd
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_PID_BMSK                                   0x1f00
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_PID_SHFT                                      0x8
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_MID_BMSK                                     0xff
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR1_MID_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ADDR                                   (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000818)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_PHYS                                   (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000818)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_OFFS                                   (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000818)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_RMSK                                   0xffffff87
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ATTR                                          0x1
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ADDR, HWIO_IPA_GSI_TOP_XPU3_SESYNR2_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_BAR_BMSK                               0xc0000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_BAR_SHFT                                     0x1e
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_BURST_BMSK                             0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_BURST_SHFT                                   0x1d
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_CACHEABLE_BMSK                         0x10000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_CACHEABLE_SHFT                               0x1c
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_DEVICE_BMSK                             0x8000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_DEVICE_SHFT                                  0x1b
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_DEVICE_TYPE_BMSK                        0x6000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_DEVICE_TYPE_SHFT                             0x19
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_EARLYWRRESP_BMSK                        0x1000000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_EARLYWRRESP_SHFT                             0x18
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ERROR_BMSK                               0x800000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ERROR_SHFT                                   0x17
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_EXCLUSIVE_BMSK                           0x400000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_EXCLUSIVE_SHFT                               0x16
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_FULL_BMSK                                0x200000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_FULL_SHFT                                    0x15
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_SHARED_BMSK                              0x100000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_SHARED_SHFT                                  0x14
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_WRITETHROUGH_BMSK                         0x80000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_WRITETHROUGH_SHFT                            0x13
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERNOALLOCATE_BMSK                      0x40000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERNOALLOCATE_SHFT                         0x12
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERCACHEABLE_BMSK                       0x20000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERCACHEABLE_SHFT                          0x11
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERSHARED_BMSK                          0x10000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERSHARED_SHFT                             0x10
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERTRANSIENT_BMSK                        0x8000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERTRANSIENT_SHFT                           0xf
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERWRITETHROUGH_BMSK                     0x4000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_INNERWRITETHROUGH_SHFT                        0xe
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_PORTMREL_BMSK                              0x2000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_PORTMREL_SHFT                                 0xd
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ORDEREDRD_BMSK                             0x1000
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ORDEREDRD_SHFT                                0xc
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ORDEREDWR_BMSK                              0x800
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_ORDEREDWR_SHFT                                0xb
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_OOORD_BMSK                                  0x400
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_OOORD_SHFT                                    0xa
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_OOOWR_BMSK                                  0x200
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_OOOWR_SHFT                                    0x9
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_NOALLOCATE_BMSK                             0x100
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_NOALLOCATE_SHFT                               0x8
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_TRANSIENT_BMSK                               0x80
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_TRANSIENT_SHFT                                0x7
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_MEMTYPE_BMSK                                  0x7
#define HWIO_IPA_GSI_TOP_XPU3_SESYNR2_MEMTYPE_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_ADDR                                     (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000804)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_PHYS                                     (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000804)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_OFFS                                     (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000804)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_RMSK                                     0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_ATTR                                            0x1
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SEAR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_SEAR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_SEAR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_ADDR_63_32_BMSK                          0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_SEAR1_ADDR_63_32_SHFT                                 0x0

#define HWIO_IPA_GSI_TOP_XPU3_EAR0_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_RMSK                                      0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_ATTR                                             0x1
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_EAR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_EAR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_EAR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_ADDR_31_0_BMSK                            0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_EAR0_ADDR_31_0_SHFT                                   0x0

#define HWIO_IPA_GSI_TOP_XPU3_ESR_ADDR                                       (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_PHYS                                       (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_OFFS                                       (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_RMSK                                              0xf
#define HWIO_IPA_GSI_TOP_XPU3_ESR_ATTR                                              0x3
#define HWIO_IPA_GSI_TOP_XPU3_ESR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESR_ADDR, HWIO_IPA_GSI_TOP_XPU3_ESR_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESR_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_ESR_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_ESR_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_ESR_IN)
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CLMULTI_BMSK                                      0x8
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CLMULTI_SHFT                                      0x3
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CFGMULTI_BMSK                                     0x4
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CFGMULTI_SHFT                                     0x2
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CLIENT_BMSK                                       0x2
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CLIENT_SHFT                                       0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CFG_BMSK                                          0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESR_CFG_SHFT                                          0x0

#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_ADDR                                (IPA_GSI_TOP_XPU3_REG_BASE      + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_PHYS                                (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_OFFS                                (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_RMSK                                       0xf
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_ATTR                                       0x3
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_ADDR, HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_IN)
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CLMULTI_BMSK                               0x8
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CLMULTI_SHFT                               0x3
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CFGMULTI_BMSK                              0x4
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CFGMULTI_SHFT                              0x2
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CLIENT_BMSK                                0x2
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CLIENT_SHFT                                0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CFG_BMSK                                   0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESRRESTORE_CFG_SHFT                                   0x0

#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ADDR                                    (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_PHYS                                    (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_OFFS                                    (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_RMSK                                    0x67ffff0f
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ATTR                                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_ESYNR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_AC_BMSK                                 0x40000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_AC_SHFT                                       0x1e
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_BURSTLEN_BMSK                           0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_BURSTLEN_SHFT                                 0x1d
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ASIZE_BMSK                               0x7000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ASIZE_SHFT                                    0x18
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ALEN_BMSK                                 0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_ALEN_SHFT                                     0x10
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_QAD_BMSK                                    0xff00
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_QAD_SHFT                                       0x8
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_XPRIV_BMSK                                     0x8
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_XPRIV_SHFT                                     0x3
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_XINST_BMSK                                     0x4
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_XINST_SHFT                                     0x2
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_AWRITE_BMSK                                    0x2
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_AWRITE_SHFT                                    0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_XPROTNS_BMSK                                   0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR0_XPROTNS_SHFT                                   0x0

#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_ADDR                                    (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_PHYS                                    (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_OFFS                                    (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_RMSK                                    0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_ATTR                                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESYNR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_ESYNR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESYNR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_TID_BMSK                                0xff000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_TID_SHFT                                      0x18
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_VMID_BMSK                                 0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_VMID_SHFT                                     0x10
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_BID_BMSK                                    0xe000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_BID_SHFT                                       0xd
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_PID_BMSK                                    0x1f00
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_PID_SHFT                                       0x8
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_MID_BMSK                                      0xff
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR1_MID_SHFT                                       0x0

#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ADDR                                    (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_PHYS                                    (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_OFFS                                    (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_RMSK                                    0xffffff87
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ATTR                                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ADDR, HWIO_IPA_GSI_TOP_XPU3_ESYNR2_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_BAR_BMSK                                0xc0000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_BAR_SHFT                                      0x1e
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_BURST_BMSK                              0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_BURST_SHFT                                    0x1d
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_CACHEABLE_BMSK                          0x10000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_CACHEABLE_SHFT                                0x1c
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_DEVICE_BMSK                              0x8000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_DEVICE_SHFT                                   0x1b
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_DEVICE_TYPE_BMSK                         0x6000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_DEVICE_TYPE_SHFT                              0x19
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_EARLYWRRESP_BMSK                         0x1000000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_EARLYWRRESP_SHFT                              0x18
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ERROR_BMSK                                0x800000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ERROR_SHFT                                    0x17
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_EXCLUSIVE_BMSK                            0x400000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_EXCLUSIVE_SHFT                                0x16
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_FULL_BMSK                                 0x200000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_FULL_SHFT                                     0x15
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_SHARED_BMSK                               0x100000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_SHARED_SHFT                                   0x14
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_WRITETHROUGH_BMSK                          0x80000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_WRITETHROUGH_SHFT                             0x13
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERNOALLOCATE_BMSK                       0x40000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERNOALLOCATE_SHFT                          0x12
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERCACHEABLE_BMSK                        0x20000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERCACHEABLE_SHFT                           0x11
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERSHARED_BMSK                           0x10000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERSHARED_SHFT                              0x10
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERTRANSIENT_BMSK                         0x8000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERTRANSIENT_SHFT                            0xf
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERWRITETHROUGH_BMSK                      0x4000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_INNERWRITETHROUGH_SHFT                         0xe
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_PORTMREL_BMSK                               0x2000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_PORTMREL_SHFT                                  0xd
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ORDEREDRD_BMSK                              0x1000
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ORDEREDRD_SHFT                                 0xc
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ORDEREDWR_BMSK                               0x800
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_ORDEREDWR_SHFT                                 0xb
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_OOORD_BMSK                                   0x400
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_OOORD_SHFT                                     0xa
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_OOOWR_BMSK                                   0x200
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_OOOWR_SHFT                                     0x9
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_NOALLOCATE_BMSK                              0x100
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_NOALLOCATE_SHFT                                0x8
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_TRANSIENT_BMSK                                0x80
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_TRANSIENT_SHFT                                 0x7
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_MEMTYPE_BMSK                                   0x7
#define HWIO_IPA_GSI_TOP_XPU3_ESYNR2_MEMTYPE_SHFT                                   0x0

#define HWIO_IPA_GSI_TOP_XPU3_EAR1_ADDR                                      (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_PHYS                                      (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_OFFS                                      (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_RMSK                                      0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_ATTR                                             0x1
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_EAR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_EAR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_EAR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_ADDR_63_32_BMSK                           0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_EAR1_ADDR_63_32_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_ADDR                                 (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_PHYS                                 (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_OFFS                                 (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_RMSK                                 0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_ATTR                                        0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_ADDR_31_0_BMSK                       0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR0_ADDR_31_0_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_ADDR                                  (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_PHYS                                  (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_OFFS                                  (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_RMSK                                         0xf
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CLMULTI_BMSK                                 0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CLMULTI_SHFT                                 0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CFGMULTI_BMSK                                0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CFGMULTI_SHFT                                0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CLIENT_BMSK                                  0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CLIENT_SHFT                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CFG_BMSK                                     0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESR_CFG_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_ADDR                           (IPA_GSI_TOP_XPU3_REG_BASE      + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_PHYS                           (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_OFFS                           (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_RMSK                                  0xf
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_ATTR                                  0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CLMULTI_BMSK                          0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CLMULTI_SHFT                          0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CFGMULTI_BMSK                         0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CFGMULTI_SHFT                         0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CLIENT_BMSK                           0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CLIENT_SHFT                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CFG_BMSK                              0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESRRESTORE_CFG_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_RMSK                               0x67ffff0f
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ATTR                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_AC_BMSK                            0x40000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_AC_SHFT                                  0x1e
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_BURSTLEN_BMSK                      0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_BURSTLEN_SHFT                            0x1d
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ASIZE_BMSK                          0x7000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ASIZE_SHFT                               0x18
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ALEN_BMSK                            0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_ALEN_SHFT                                0x10
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_QAD_BMSK                               0xff00
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_QAD_SHFT                                  0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_XPRIV_BMSK                                0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_XPRIV_SHFT                                0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_XINST_BMSK                                0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_XINST_SHFT                                0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_AWRITE_BMSK                               0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_AWRITE_SHFT                               0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_XPROTNS_BMSK                              0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR0_XPROTNS_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_RMSK                               0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_ATTR                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_TID_BMSK                           0xff000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_TID_SHFT                                 0x18
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_VMID_BMSK                            0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_VMID_SHFT                                0x10
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_BID_BMSK                               0xe000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_BID_SHFT                                  0xd
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_PID_BMSK                               0x1f00
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_PID_SHFT                                  0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_MID_BMSK                                 0xff
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR1_MID_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_RMSK                               0xffffff87
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ATTR                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_BAR_BMSK                           0xc0000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_BAR_SHFT                                 0x1e
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_BURST_BMSK                         0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_BURST_SHFT                               0x1d
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_CACHEABLE_BMSK                     0x10000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_CACHEABLE_SHFT                           0x1c
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_DEVICE_BMSK                         0x8000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_DEVICE_SHFT                              0x1b
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_DEVICE_TYPE_BMSK                    0x6000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_DEVICE_TYPE_SHFT                         0x19
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_EARLYWRRESP_BMSK                    0x1000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_EARLYWRRESP_SHFT                         0x18
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ERROR_BMSK                           0x800000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ERROR_SHFT                               0x17
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_EXCLUSIVE_BMSK                       0x400000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_EXCLUSIVE_SHFT                           0x16
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_FULL_BMSK                            0x200000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_FULL_SHFT                                0x15
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_SHARED_BMSK                          0x100000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_SHARED_SHFT                              0x14
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_WRITETHROUGH_BMSK                     0x80000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_WRITETHROUGH_SHFT                        0x13
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERNOALLOCATE_BMSK                  0x40000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERNOALLOCATE_SHFT                     0x12
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERCACHEABLE_BMSK                   0x20000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERCACHEABLE_SHFT                      0x11
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERSHARED_BMSK                      0x10000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERSHARED_SHFT                         0x10
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERTRANSIENT_BMSK                    0x8000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERTRANSIENT_SHFT                       0xf
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERWRITETHROUGH_BMSK                 0x4000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_INNERWRITETHROUGH_SHFT                    0xe
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_PORTMREL_BMSK                          0x2000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_PORTMREL_SHFT                             0xd
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ORDEREDRD_BMSK                         0x1000
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ORDEREDRD_SHFT                            0xc
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ORDEREDWR_BMSK                          0x800
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_ORDEREDWR_SHFT                            0xb
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_OOORD_BMSK                              0x400
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_OOORD_SHFT                                0xa
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_OOOWR_BMSK                              0x200
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_OOOWR_SHFT                                0x9
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_NOALLOCATE_BMSK                         0x100
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_NOALLOCATE_SHFT                           0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_TRANSIENT_BMSK                           0x80
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_TRANSIENT_SHFT                            0x7
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_MEMTYPE_BMSK                              0x7
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_ESYNR2_MEMTYPE_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_ADDR                                 (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_PHYS                                 (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_OFFS                                 (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_RMSK                                 0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_ATTR                                        0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_ADDR_63_32_BMSK                      0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD0_EAR1_ADDR_63_32_SHFT                             0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_ADDR                                 (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_PHYS                                 (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_OFFS                                 (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000880)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_RMSK                                 0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_ATTR                                        0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_ADDR_31_0_BMSK                       0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR0_ADDR_31_0_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_ADDR                                  (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_PHYS                                  (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_OFFS                                  (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000888)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_RMSK                                         0xf
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CLMULTI_BMSK                                 0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CLMULTI_SHFT                                 0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CFGMULTI_BMSK                                0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CFGMULTI_SHFT                                0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CLIENT_BMSK                                  0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CLIENT_SHFT                                  0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CFG_BMSK                                     0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESR_CFG_SHFT                                     0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_ADDR                           (IPA_GSI_TOP_XPU3_REG_BASE      + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_PHYS                           (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_OFFS                           (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x0000088c)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_RMSK                                  0xf
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_ATTR                                  0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_ADDR,v)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_ADDR,m,v,HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_IN)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CLMULTI_BMSK                          0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CLMULTI_SHFT                          0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CFGMULTI_BMSK                         0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CFGMULTI_SHFT                         0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CLIENT_BMSK                           0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CLIENT_SHFT                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CFG_BMSK                              0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESRRESTORE_CFG_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000890)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_RMSK                               0x67ffff0f
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ATTR                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_AC_BMSK                            0x40000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_AC_SHFT                                  0x1e
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_BURSTLEN_BMSK                      0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_BURSTLEN_SHFT                            0x1d
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ASIZE_BMSK                          0x7000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ASIZE_SHFT                               0x18
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ALEN_BMSK                            0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_ALEN_SHFT                                0x10
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_QAD_BMSK                               0xff00
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_QAD_SHFT                                  0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_XPRIV_BMSK                                0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_XPRIV_SHFT                                0x3
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_XINST_BMSK                                0x4
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_XINST_SHFT                                0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_AWRITE_BMSK                               0x2
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_AWRITE_SHFT                               0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_XPROTNS_BMSK                              0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR0_XPROTNS_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000894)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_RMSK                               0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_ATTR                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_TID_BMSK                           0xff000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_TID_SHFT                                 0x18
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_VMID_BMSK                            0xff0000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_VMID_SHFT                                0x10
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_BID_BMSK                               0xe000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_BID_SHFT                                  0xd
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_PID_BMSK                               0x1f00
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_PID_SHFT                                  0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_MID_BMSK                                 0xff
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR1_MID_SHFT                                  0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ADDR                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_PHYS                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_OFFS                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000898)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_RMSK                               0xffffff87
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ATTR                                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_BAR_BMSK                           0xc0000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_BAR_SHFT                                 0x1e
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_BURST_BMSK                         0x20000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_BURST_SHFT                               0x1d
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_CACHEABLE_BMSK                     0x10000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_CACHEABLE_SHFT                           0x1c
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_DEVICE_BMSK                         0x8000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_DEVICE_SHFT                              0x1b
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_DEVICE_TYPE_BMSK                    0x6000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_DEVICE_TYPE_SHFT                         0x19
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_EARLYWRRESP_BMSK                    0x1000000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_EARLYWRRESP_SHFT                         0x18
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ERROR_BMSK                           0x800000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ERROR_SHFT                               0x17
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_EXCLUSIVE_BMSK                       0x400000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_EXCLUSIVE_SHFT                           0x16
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_FULL_BMSK                            0x200000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_FULL_SHFT                                0x15
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_SHARED_BMSK                          0x100000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_SHARED_SHFT                              0x14
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_WRITETHROUGH_BMSK                     0x80000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_WRITETHROUGH_SHFT                        0x13
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERNOALLOCATE_BMSK                  0x40000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERNOALLOCATE_SHFT                     0x12
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERCACHEABLE_BMSK                   0x20000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERCACHEABLE_SHFT                      0x11
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERSHARED_BMSK                      0x10000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERSHARED_SHFT                         0x10
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERTRANSIENT_BMSK                    0x8000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERTRANSIENT_SHFT                       0xf
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERWRITETHROUGH_BMSK                 0x4000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_INNERWRITETHROUGH_SHFT                    0xe
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_PORTMREL_BMSK                          0x2000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_PORTMREL_SHFT                             0xd
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ORDEREDRD_BMSK                         0x1000
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ORDEREDRD_SHFT                            0xc
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ORDEREDWR_BMSK                          0x800
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_ORDEREDWR_SHFT                            0xb
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_OOORD_BMSK                              0x400
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_OOORD_SHFT                                0xa
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_OOOWR_BMSK                              0x200
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_OOOWR_SHFT                                0x9
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_NOALLOCATE_BMSK                         0x100
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_NOALLOCATE_SHFT                           0x8
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_TRANSIENT_BMSK                           0x80
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_TRANSIENT_SHFT                            0x7
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_MEMTYPE_BMSK                              0x7
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_ESYNR2_MEMTYPE_SHFT                              0x0

#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_ADDR                                 (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_PHYS                                 (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_OFFS                                 (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000884)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_RMSK                                 0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_ATTR                                        0x1
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_IN          \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_ADDR, HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_ADDR, m)
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_ADDR_63_32_BMSK                      0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_QAD1_EAR1_ADDR_63_32_SHFT                             0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_ADDR(r)                       (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00000900 + 0x4 * (r))
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_PHYS(r)                       (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00000900 + 0x4 * (r))
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_OFFS(r)                       (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00000900 + 0x4 * (r))
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_RMSK                            0x1fffff
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_MAXr                                   0
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_ATTR                                 0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_INI(r)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_ADDR(r), HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_INMI(r,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_ADDR(r), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_RGOWNERSTATUS_BMSK              0x1fffff
#define HWIO_IPA_GSI_TOP_XPU3_RGN_OWNERSTATUSr_RGOWNERSTATUS_SHFT                   0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_ADDR(n)                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_PHYS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_OFFS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_RMSK                                       0x107
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_MAXn                                          20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_RG_SEC_APPS_BMSK                           0x100
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_RG_SEC_APPS_SHFT                             0x8
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_RG_OWNER_BMSK                                0x7
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR0_RG_OWNER_SHFT                                0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_ADDR(n)                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_PHYS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_OFFS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_RMSK                                         0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_MAXn                                          20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_SECURE_ACCESS_LOCK_BMSK                      0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGn_GCR3_SECURE_ACCESS_LOCK_SHFT                      0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_ADDR(n)                                (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_PHYS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_OFFS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_RMSK                                          0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_MAXn                                           20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_ATTR                                          0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_RGSCLRDEN_APPS_BMSK                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR0_RGSCLRDEN_APPS_SHFT                           0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_ADDR(n)                                (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_PHYS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_OFFS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_RMSK                                          0x7
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_MAXn                                           20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_ATTR                                          0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_RGCLRDEN_BMSK                                 0x7
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR1_RGCLRDEN_SHFT                                 0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_ADDR(n)                                (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_PHYS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_OFFS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_RMSK                                          0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_MAXn                                           20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_ATTR                                          0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_RGSCLWREN_APPS_BMSK                           0x1
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR2_RGSCLWREN_APPS_SHFT                           0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_ADDR(n)                                (IPA_GSI_TOP_XPU3_REG_BASE      + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_PHYS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_OFFS(n)                                (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_RMSK                                          0x7
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_MAXn                                           20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_ATTR                                          0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_RGCLWREN_BMSK                                 0x7
#define HWIO_IPA_GSI_TOP_XPU3_RGn_CR3_RGCLWREN_SHFT                                 0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_ADDR(n)                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00001040 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_PHYS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00001040 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_OFFS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00001040 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_RMSK                                  0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_MAXn                                          20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_RE_BMSK                               0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_RGn_RACR_RE_SHFT                                      0x0

#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_ADDR(n)                               (IPA_GSI_TOP_XPU3_REG_BASE      + 0x00001060 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_PHYS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_PHYS + 0x00001060 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_OFFS(n)                               (IPA_GSI_TOP_XPU3_REG_BASE_OFFS + 0x00001060 + 0x80 * (n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_RMSK                                  0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_MAXn                                          20
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_ATTR                                         0x3
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_INI(n)        \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_ADDR(n), HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_RMSK)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_ADDR(n), mask)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_OUTI(n,val)    \
        out_dword(HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_ADDR(n),val)
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_ADDR(n),mask,val,HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_INI(n))
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_WE_BMSK                               0xffffffff
#define HWIO_IPA_GSI_TOP_XPU3_RGn_WACR_WE_SHFT                                      0x0

/*----------------------------------------------------------------------------
 * MODULE: IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG
 *--------------------------------------------------------------------------*/

#define IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE                             (SNOC_IPA_MS_MPU_CFG_BASE      + 0x00000000)
#define IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS                        (SNOC_IPA_MS_MPU_CFG_BASE_PHYS + 0x00000000)
#define IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS                        0x00000000

#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000000)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000000)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000000)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_RMSK                                             0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_ATTR                                             0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_AALOG_MODE_DIS_BMSK                              0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_AALOG_MODE_DIS_SHFT                              0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_AADEN_BMSK                                       0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_GCR0_AADEN_SHFT                                       0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000008)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000008)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000008)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_RMSK                                           0x10f
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_ATTR                                             0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_DYNAMIC_CLK_EN_BMSK                            0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_DYNAMIC_CLK_EN_SHFT                              0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCLEIE_BMSK                                      0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCLEIE_SHFT                                      0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCFGEIE_BMSK                                     0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCFGEIE_SHFT                                     0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCLERE_BMSK                                      0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCLERE_SHFT                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCFGERE_BMSK                                     0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SCR0_SCFGERE_SHFT                                     0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_ADDR                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000010)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_PHYS                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000010)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_OFFS                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000010)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_RMSK                                            0x10f
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_ATTR                                              0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_CR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_CR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_CR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_CR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_CR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_CR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_DYNAMIC_CLK_EN_BMSK                             0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_DYNAMIC_CLK_EN_SHFT                               0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CLEIE_BMSK                                        0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CLEIE_SHFT                                        0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CFGEIE_BMSK                                       0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CFGEIE_SHFT                                       0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CLERE_BMSK                                        0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CLERE_SHFT                                        0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CFGERE_BMSK                                       0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_CR0_CFGERE_SHFT                                       0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_ADDR                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000080)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_PHYS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000080)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_OFFS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000080)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_RMSK                                        0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_ATTR                                        0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_QAD0LOG_MODE_DIS_BMSK                       0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_QAD0LOG_MODE_DIS_SHFT                       0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_QAD0DEN_BMSK                                0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_GCR0_QAD0DEN_SHFT                                0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_ADDR                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000090)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_PHYS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000090)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_OFFS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000090)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_RMSK                                       0x10f
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_DYNAMIC_CLK_EN_BMSK                        0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_DYNAMIC_CLK_EN_SHFT                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CLEIE_BMSK                                   0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CLEIE_SHFT                                   0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CFGEIE_BMSK                                  0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CFGEIE_SHFT                                  0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CLERE_BMSK                                   0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CLERE_SHFT                                   0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CFGERE_BMSK                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_CR0_CFGERE_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_ADDR                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000100)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_PHYS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000100)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_OFFS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000100)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_RMSK                                        0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_ATTR                                        0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_QAD1LOG_MODE_DIS_BMSK                       0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_QAD1LOG_MODE_DIS_SHFT                       0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_QAD1DEN_BMSK                                0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_GCR0_QAD1DEN_SHFT                                0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_ADDR                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000110)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_PHYS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000110)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_OFFS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000110)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_RMSK                                       0x10f
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_DYNAMIC_CLK_EN_BMSK                        0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_DYNAMIC_CLK_EN_SHFT                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CLEIE_BMSK                                   0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CLEIE_SHFT                                   0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CFGEIE_BMSK                                  0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CFGEIE_SHFT                                  0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CLERE_BMSK                                   0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CLERE_SHFT                                   0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CFGERE_BMSK                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_CR0_CFGERE_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_ADDR                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000300)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_PHYS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000300)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_OFFS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000300)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_RMSK                                       0x107
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_UMR_SEC_APPS_BMSK                          0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_UMR_SEC_APPS_SHFT                            0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_UMR_OWNER_BMSK                               0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR0_UMR_OWNER_SHFT                               0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_ADDR                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000030c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_PHYS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000030c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_OFFS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000030c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_RMSK                                         0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_UMR_SECURE_ACCESS_LOCK_BMSK                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_GCR3_UMR_SECURE_ACCESS_LOCK_SHFT                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000310)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000310)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000310)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_RMSK                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_UMRSCLRDEN_APPS_BMSK                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR0_UMRSCLRDEN_APPS_SHFT                          0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000314)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000314)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000314)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_RMSK                                          0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ARM_QC_APPROACH_BMSK                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_ARM_QC_APPROACH_SHFT                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_UMRCLRDEN_BMSK                                0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR1_UMRCLRDEN_SHFT                                0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000318)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000318)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000318)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_RMSK                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_UMRSCLWREN_APPS_BMSK                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR2_UMRSCLWREN_APPS_SHFT                          0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000031c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000031c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000031c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_RMSK                                          0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_UMRCLWREN_BMSK                                0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_UMR_CR3_UMRCLWREN_SHFT                                0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000003ec)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000003ec)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000003ec)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_RMSK                                           0x3ff
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_ATTR                                             0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_PT_BMSK                                        0x200
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_PT_SHFT                                          0x9
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_MV_BMSK                                        0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_MV_SHFT                                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_NVMID_BMSK                                      0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR3_NVMID_SHFT                                       0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000003f0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000003f0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000003f0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_RMSK                                      0xffffff0f
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_ATTR                                             0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_NONSEC_EN_BMSK                            0xff000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_NONSEC_EN_SHFT                                  0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_SEC_EN_BMSK                                 0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_SEC_EN_SHFT                                     0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_VMIDACR_EN_BMSK                               0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_VMIDACR_EN_SHFT                                  0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_NUM_QAD_BMSK                                     0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR2_NUM_QAD_SHFT                                     0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000003f4)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000003f4)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000003f4)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_RMSK                                      0x3f3f3f3f
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_ATTR                                             0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_CLIENT_ADDR_WIDTH_BMSK                    0x3f000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_CLIENT_ADDR_WIDTH_SHFT                          0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_CONFIG_ADDR_WIDTH_BMSK                      0x3f0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_CONFIG_ADDR_WIDTH_SHFT                          0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_MSB_MPU_BMSK                                  0x3f00
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_MSB_MPU_SHFT                                     0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_LSB_BMSK                                        0x3f
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR1_LSB_SHFT                                         0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000003f8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000003f8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000003f8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_RMSK                                       0x3ff0073
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_ATTR                                             0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_NRG_BMSK                                   0x3ff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_NRG_SHFT                                        0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_BLED_BMSK                                       0x40
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_BLED_SHFT                                        0x6
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_CLIENTREQ_HALT_ACK_HW_EN_BMSK                   0x20
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_CLIENTREQ_HALT_ACK_HW_EN_SHFT                    0x5
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_XPU_CLIENT_PIPELINE_EN_BMSK                     0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_XPU_CLIENT_PIPELINE_EN_SHFT                      0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_XPUTYPE_BMSK                                     0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_IDR0_XPUTYPE_SHFT                                     0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_ADDR                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000003fc)
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_PHYS                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000003fc)
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_OFFS                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000003fc)
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_RMSK                                       0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_ATTR                                              0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_REV_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_REV_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_REV_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_MAJOR_BMSK                                 0xf0000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_MAJOR_SHFT                                       0x1c
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_MINOR_BMSK                                  0xfff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_MINOR_SHFT                                       0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_STEP_BMSK                                      0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_REV_STEP_SHFT                                         0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_ADDR                              (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000400)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_PHYS                              (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000400)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_OFFS                              (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000400)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_RMSK                                     0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_ATTR                                     0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_LOG_MODE_DIS_BMSK                        0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_LOG_MODE_DIS_LOG_MODE_DIS_SHFT                        0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_ADDR(r)                        (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000500 + 0x4 * (r))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_PHYS(r)                        (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000500 + 0x4 * (r))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_OFFS(r)                        (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000500 + 0x4 * (r))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_RMSK                                0x3ff
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_MAXr                                    0
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_ATTR                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_INI(r)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_ADDR(r), HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_INMI(r,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_ADDR(r), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_RGFREESTATUS_BMSK                   0x3ff
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_FREESTATUSr_RGFREESTATUS_SHFT                     0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_ADDR                                     (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000800)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_PHYS                                     (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000800)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_OFFS                                     (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000800)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_RMSK                                     0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_ATTR                                            0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_ADDR_31_0_BMSK                           0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR0_ADDR_31_0_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000808)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000808)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000808)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_RMSK                                             0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_ATTR                                             0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESR_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESR_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESR_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_SESR_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_SESR_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_SESR_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CLMULTI_BMSK                                     0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CLMULTI_SHFT                                     0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CFGMULTI_BMSK                                    0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CFGMULTI_SHFT                                    0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CLIENT_BMSK                                      0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CLIENT_SHFT                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CFG_BMSK                                         0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESR_CFG_SHFT                                         0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000080c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000080c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000080c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_RMSK                                      0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_ATTR                                      0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CLMULTI_BMSK                              0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CLMULTI_SHFT                              0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CFGMULTI_BMSK                             0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CFGMULTI_SHFT                             0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CLIENT_BMSK                               0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CLIENT_SHFT                               0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CFG_BMSK                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESRRESTORE_CFG_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000810)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000810)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000810)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_RMSK                                   0x67ffff0f
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ATTR                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_AC_BMSK                                0x40000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_AC_SHFT                                      0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_BURSTLEN_BMSK                          0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_BURSTLEN_SHFT                                0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ASIZE_BMSK                              0x7000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ASIZE_SHFT                                   0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ALEN_BMSK                                0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_ALEN_SHFT                                    0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_QAD_BMSK                                   0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_QAD_SHFT                                      0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_XPRIV_BMSK                                    0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_XPRIV_SHFT                                    0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_XINST_BMSK                                    0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_XINST_SHFT                                    0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_AWRITE_BMSK                                   0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_AWRITE_SHFT                                   0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_XPROTNS_BMSK                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR0_XPROTNS_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000814)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000814)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000814)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_RMSK                                   0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_ATTR                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_TID_BMSK                               0xff000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_TID_SHFT                                     0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_VMID_BMSK                                0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_VMID_SHFT                                    0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_BID_BMSK                                   0xe000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_BID_SHFT                                      0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_PID_BMSK                                   0x1f00
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_PID_SHFT                                      0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_MID_BMSK                                     0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR1_MID_SHFT                                      0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000818)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000818)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000818)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_RMSK                                   0xffffff87
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ATTR                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_BAR_BMSK                               0xc0000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_BAR_SHFT                                     0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_BURST_BMSK                             0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_BURST_SHFT                                   0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_CACHEABLE_BMSK                         0x10000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_CACHEABLE_SHFT                               0x1c
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_DEVICE_BMSK                             0x8000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_DEVICE_SHFT                                  0x1b
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_DEVICE_TYPE_BMSK                        0x6000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_DEVICE_TYPE_SHFT                             0x19
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_EARLYWRRESP_BMSK                        0x1000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_EARLYWRRESP_SHFT                             0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ERROR_BMSK                               0x800000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ERROR_SHFT                                   0x17
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_EXCLUSIVE_BMSK                           0x400000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_EXCLUSIVE_SHFT                               0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_FULL_BMSK                                0x200000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_FULL_SHFT                                    0x15
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_SHARED_BMSK                              0x100000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_SHARED_SHFT                                  0x14
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_WRITETHROUGH_BMSK                         0x80000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_WRITETHROUGH_SHFT                            0x13
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERNOALLOCATE_BMSK                      0x40000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERNOALLOCATE_SHFT                         0x12
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERCACHEABLE_BMSK                       0x20000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERCACHEABLE_SHFT                          0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERSHARED_BMSK                          0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERSHARED_SHFT                             0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERTRANSIENT_BMSK                        0x8000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERTRANSIENT_SHFT                           0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERWRITETHROUGH_BMSK                     0x4000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_INNERWRITETHROUGH_SHFT                        0xe
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_PORTMREL_BMSK                              0x2000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_PORTMREL_SHFT                                 0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ORDEREDRD_BMSK                             0x1000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ORDEREDRD_SHFT                                0xc
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ORDEREDWR_BMSK                              0x800
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_ORDEREDWR_SHFT                                0xb
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_OOORD_BMSK                                  0x400
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_OOORD_SHFT                                    0xa
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_OOOWR_BMSK                                  0x200
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_OOOWR_SHFT                                    0x9
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_NOALLOCATE_BMSK                             0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_NOALLOCATE_SHFT                               0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_TRANSIENT_BMSK                               0x80
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_TRANSIENT_SHFT                                0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_MEMTYPE_BMSK                                  0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR2_MEMTYPE_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_ADDR                                     (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000804)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_PHYS                                     (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000804)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_OFFS                                     (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000804)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_RMSK                                     0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_ATTR                                            0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_ADDR_63_32_BMSK                          0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SEAR1_ADDR_63_32_SHFT                                 0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000081c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000081c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000081c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_RMSK                                       0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_ATTR                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_SEC_AD_RG_MATCH_BMSK                       0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_SEC_AD_RG_MATCH_SHFT                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_NONSEC_AD_RG_MATCH_BMSK                      0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR3_NONSEC_AD_RG_MATCH_SHFT                       0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ADDR                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000820)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_PHYS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000820)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_OFFS                                   (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000820)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_RMSK                                    0x3ffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ATTR                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ACACHEOPTYPE_BMSK                       0x3c00000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ACACHEOPTYPE_SHFT                            0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ASID_BMSK                                0x3e0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ASID_SHFT                                    0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ACGRANULETRANS_BMSK                       0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_ACGRANULETRANS_SHFT                          0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_AUATTR_BMSK                                0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_SESYNR4_AUATTR_SHFT                                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR                        (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000830)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_PHYS                        (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000830)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_OFFS                        (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000830)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_RMSK                        0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ATTR                               0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR_31_0_BMSK              0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SSHADOW_ADDR_31_0_SHFT                     0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR                          (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000838)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_PHYS                          (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000838)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_OFFS                          (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000838)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_RMSK                          0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ATTR                                 0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR_31_0_BMSK                0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SSHADOW_ADDR_31_0_SHFT                       0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_RMSK                                      0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_ATTR                                             0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_ADDR_31_0_BMSK                            0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR0_ADDR_31_0_SHFT                                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_ADDR                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_PHYS                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_OFFS                                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_RMSK                                              0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_ATTR                                              0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESR_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESR_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESR_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_ESR_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_ESR_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_ESR_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CLMULTI_BMSK                                      0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CLMULTI_SHFT                                      0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CFGMULTI_BMSK                                     0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CFGMULTI_SHFT                                     0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CLIENT_BMSK                                       0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CLIENT_SHFT                                       0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CFG_BMSK                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESR_CFG_SHFT                                          0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_ADDR                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_PHYS                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_OFFS                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_RMSK                                       0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_ATTR                                       0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CLMULTI_BMSK                               0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CLMULTI_SHFT                               0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CFGMULTI_BMSK                              0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CFGMULTI_SHFT                              0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CLIENT_BMSK                                0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CLIENT_SHFT                                0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CFG_BMSK                                   0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESRRESTORE_CFG_SHFT                                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ADDR                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_PHYS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_OFFS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_RMSK                                    0x67ffff0f
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ATTR                                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_AC_BMSK                                 0x40000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_AC_SHFT                                       0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_BURSTLEN_BMSK                           0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_BURSTLEN_SHFT                                 0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ASIZE_BMSK                               0x7000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ASIZE_SHFT                                    0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ALEN_BMSK                                 0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_ALEN_SHFT                                     0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_QAD_BMSK                                    0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_QAD_SHFT                                       0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_XPRIV_BMSK                                     0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_XPRIV_SHFT                                     0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_XINST_BMSK                                     0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_XINST_SHFT                                     0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_AWRITE_BMSK                                    0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_AWRITE_SHFT                                    0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_XPROTNS_BMSK                                   0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR0_XPROTNS_SHFT                                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_ADDR                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_PHYS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_OFFS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_RMSK                                    0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_ATTR                                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_TID_BMSK                                0xff000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_TID_SHFT                                      0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_VMID_BMSK                                 0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_VMID_SHFT                                     0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_BID_BMSK                                    0xe000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_BID_SHFT                                       0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_PID_BMSK                                    0x1f00
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_PID_SHFT                                       0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_MID_BMSK                                      0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR1_MID_SHFT                                       0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ADDR                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_PHYS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_OFFS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_RMSK                                    0xffffff87
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ATTR                                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_BAR_BMSK                                0xc0000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_BAR_SHFT                                      0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_BURST_BMSK                              0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_BURST_SHFT                                    0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_CACHEABLE_BMSK                          0x10000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_CACHEABLE_SHFT                                0x1c
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_DEVICE_BMSK                              0x8000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_DEVICE_SHFT                                   0x1b
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_DEVICE_TYPE_BMSK                         0x6000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_DEVICE_TYPE_SHFT                              0x19
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_EARLYWRRESP_BMSK                         0x1000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_EARLYWRRESP_SHFT                              0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ERROR_BMSK                                0x800000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ERROR_SHFT                                    0x17
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_EXCLUSIVE_BMSK                            0x400000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_EXCLUSIVE_SHFT                                0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_FULL_BMSK                                 0x200000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_FULL_SHFT                                     0x15
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_SHARED_BMSK                               0x100000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_SHARED_SHFT                                   0x14
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_WRITETHROUGH_BMSK                          0x80000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_WRITETHROUGH_SHFT                             0x13
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERNOALLOCATE_BMSK                       0x40000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERNOALLOCATE_SHFT                          0x12
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERCACHEABLE_BMSK                        0x20000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERCACHEABLE_SHFT                           0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERSHARED_BMSK                           0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERSHARED_SHFT                              0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERTRANSIENT_BMSK                         0x8000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERTRANSIENT_SHFT                            0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERWRITETHROUGH_BMSK                      0x4000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_INNERWRITETHROUGH_SHFT                         0xe
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_PORTMREL_BMSK                               0x2000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_PORTMREL_SHFT                                  0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ORDEREDRD_BMSK                              0x1000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ORDEREDRD_SHFT                                 0xc
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ORDEREDWR_BMSK                               0x800
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_ORDEREDWR_SHFT                                 0xb
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_OOORD_BMSK                                   0x400
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_OOORD_SHFT                                     0xa
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_OOOWR_BMSK                                   0x200
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_OOOWR_SHFT                                     0x9
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_NOALLOCATE_BMSK                              0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_NOALLOCATE_SHFT                                0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_TRANSIENT_BMSK                                0x80
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_TRANSIENT_SHFT                                 0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_MEMTYPE_BMSK                                   0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR2_MEMTYPE_SHFT                                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_ADDR                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_PHYS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_OFFS                                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_RMSK                                      0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_ATTR                                             0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_ADDR_63_32_BMSK                           0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_EAR1_ADDR_63_32_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_ADDR                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_PHYS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_OFFS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_RMSK                                        0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_ATTR                                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_SEC_AD_RG_MATCH_BMSK                        0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_SEC_AD_RG_MATCH_SHFT                           0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_NONSEC_AD_RG_MATCH_BMSK                       0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR3_NONSEC_AD_RG_MATCH_SHFT                        0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ADDR                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_PHYS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_OFFS                                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_RMSK                                     0x3ffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ATTR                                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ACACHEOPTYPE_BMSK                        0x3c00000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ACACHEOPTYPE_SHFT                             0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ASID_BMSK                                 0x3e0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ASID_SHFT                                     0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ACGRANULETRANS_BMSK                        0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_ACGRANULETRANS_SHFT                           0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_AUATTR_BMSK                                 0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_ESYNR4_AUATTR_SHFT                                    0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR                         (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_PHYS                         (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_OFFS                         (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_RMSK                         0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ATTR                                0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR_31_0_BMSK               0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_START0_SHADOW_ADDR_31_0_SHFT                      0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_PHYS                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_OFFS                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_RMSK                           0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ATTR                                  0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR_31_0_BMSK                 0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_END0_SHADOW_ADDR_31_0_SHFT                        0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_ADDR                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_PHYS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_OFFS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_RMSK                                 0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_ATTR                                        0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_ADDR_31_0_BMSK                       0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR0_ADDR_31_0_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_ADDR                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_PHYS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_OFFS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_RMSK                                         0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CLMULTI_BMSK                                 0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CLMULTI_SHFT                                 0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CFGMULTI_BMSK                                0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CFGMULTI_SHFT                                0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CLIENT_BMSK                                  0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CLIENT_SHFT                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CFG_BMSK                                     0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESR_CFG_SHFT                                     0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_ADDR                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_PHYS                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_OFFS                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_RMSK                                  0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_ATTR                                  0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CLMULTI_BMSK                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CLMULTI_SHFT                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CFGMULTI_BMSK                         0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CFGMULTI_SHFT                         0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CLIENT_BMSK                           0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CLIENT_SHFT                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CFG_BMSK                              0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESRRESTORE_CFG_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_RMSK                               0x67ffff0f
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_AC_BMSK                            0x40000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_AC_SHFT                                  0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_BURSTLEN_BMSK                      0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_BURSTLEN_SHFT                            0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ASIZE_BMSK                          0x7000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ASIZE_SHFT                               0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ALEN_BMSK                            0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_ALEN_SHFT                                0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_QAD_BMSK                               0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_QAD_SHFT                                  0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_XPRIV_BMSK                                0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_XPRIV_SHFT                                0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_XINST_BMSK                                0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_XINST_SHFT                                0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_AWRITE_BMSK                               0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_AWRITE_SHFT                               0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_XPROTNS_BMSK                              0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR0_XPROTNS_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_RMSK                               0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_TID_BMSK                           0xff000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_TID_SHFT                                 0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_VMID_BMSK                            0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_VMID_SHFT                                0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_BID_BMSK                               0xe000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_BID_SHFT                                  0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_PID_BMSK                               0x1f00
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_PID_SHFT                                  0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_MID_BMSK                                 0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR1_MID_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_RMSK                               0xffffff87
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_BAR_BMSK                           0xc0000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_BAR_SHFT                                 0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_BURST_BMSK                         0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_BURST_SHFT                               0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_CACHEABLE_BMSK                     0x10000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_CACHEABLE_SHFT                           0x1c
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_DEVICE_BMSK                         0x8000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_DEVICE_SHFT                              0x1b
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_DEVICE_TYPE_BMSK                    0x6000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_DEVICE_TYPE_SHFT                         0x19
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_EARLYWRRESP_BMSK                    0x1000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_EARLYWRRESP_SHFT                         0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ERROR_BMSK                           0x800000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ERROR_SHFT                               0x17
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_EXCLUSIVE_BMSK                       0x400000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_EXCLUSIVE_SHFT                           0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_FULL_BMSK                            0x200000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_FULL_SHFT                                0x15
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_SHARED_BMSK                          0x100000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_SHARED_SHFT                              0x14
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_WRITETHROUGH_BMSK                     0x80000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_WRITETHROUGH_SHFT                        0x13
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERNOALLOCATE_BMSK                  0x40000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERNOALLOCATE_SHFT                     0x12
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERCACHEABLE_BMSK                   0x20000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERCACHEABLE_SHFT                      0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERSHARED_BMSK                      0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERSHARED_SHFT                         0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERTRANSIENT_BMSK                    0x8000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERTRANSIENT_SHFT                       0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERWRITETHROUGH_BMSK                 0x4000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_INNERWRITETHROUGH_SHFT                    0xe
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_PORTMREL_BMSK                          0x2000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_PORTMREL_SHFT                             0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ORDEREDRD_BMSK                         0x1000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ORDEREDRD_SHFT                            0xc
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ORDEREDWR_BMSK                          0x800
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_ORDEREDWR_SHFT                            0xb
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_OOORD_BMSK                              0x400
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_OOORD_SHFT                                0xa
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_OOOWR_BMSK                              0x200
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_OOOWR_SHFT                                0x9
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_NOALLOCATE_BMSK                         0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_NOALLOCATE_SHFT                           0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_TRANSIENT_BMSK                           0x80
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_TRANSIENT_SHFT                            0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_MEMTYPE_BMSK                              0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR2_MEMTYPE_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_ADDR                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_PHYS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_OFFS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_RMSK                                 0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_ATTR                                        0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_ADDR_63_32_BMSK                      0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_EAR1_ADDR_63_32_SHFT                             0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_RMSK                                   0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_SEC_AD_RG_MATCH_BMSK                   0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_SEC_AD_RG_MATCH_SHFT                      0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_NONSEC_AD_RG_MATCH_BMSK                  0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR3_NONSEC_AD_RG_MATCH_SHFT                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_RMSK                                0x3ffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ACACHEOPTYPE_BMSK                   0x3c00000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ACACHEOPTYPE_SHFT                        0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ASID_BMSK                            0x3e0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ASID_SHFT                                0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ACGRANULETRANS_BMSK                   0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_ACGRANULETRANS_SHFT                      0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_AUATTR_BMSK                            0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_ESYNR4_AUATTR_SHFT                               0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_PHYS                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_OFFS                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_RMSK                    0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ATTR                           0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR_31_0_BMSK          0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_START0_SHADOW_ADDR_31_0_SHFT                 0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_PHYS                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_OFFS                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_RMSK                      0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ATTR                             0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR_31_0_BMSK            0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD0_RGN_END0_SHADOW_ADDR_31_0_SHFT                   0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_ADDR                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_PHYS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_OFFS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000880)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_RMSK                                 0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_ATTR                                        0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_ADDR_31_0_BMSK                       0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR0_ADDR_31_0_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_ADDR                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_PHYS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_OFFS                                  (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000888)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_RMSK                                         0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CLMULTI_BMSK                                 0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CLMULTI_SHFT                                 0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CFGMULTI_BMSK                                0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CFGMULTI_SHFT                                0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CLIENT_BMSK                                  0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CLIENT_SHFT                                  0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CFG_BMSK                                     0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESR_CFG_SHFT                                     0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_ADDR                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_PHYS                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_OFFS                           (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000088c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_RMSK                                  0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_ATTR                                  0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CLMULTI_BMSK                          0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CLMULTI_SHFT                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CFGMULTI_BMSK                         0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CFGMULTI_SHFT                         0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CLIENT_BMSK                           0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CLIENT_SHFT                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CFG_BMSK                              0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESRRESTORE_CFG_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000890)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_RMSK                               0x67ffff0f
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_AC_BMSK                            0x40000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_AC_SHFT                                  0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_BURSTLEN_BMSK                      0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_BURSTLEN_SHFT                            0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ASIZE_BMSK                          0x7000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ASIZE_SHFT                               0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ALEN_BMSK                            0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_ALEN_SHFT                                0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_QAD_BMSK                               0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_QAD_SHFT                                  0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_XPRIV_BMSK                                0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_XPRIV_SHFT                                0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_XINST_BMSK                                0x4
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_XINST_SHFT                                0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_AWRITE_BMSK                               0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_AWRITE_SHFT                               0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_XPROTNS_BMSK                              0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR0_XPROTNS_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000894)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_RMSK                               0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_TID_BMSK                           0xff000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_TID_SHFT                                 0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_VMID_BMSK                            0xff0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_VMID_SHFT                                0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_BID_BMSK                               0xe000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_BID_SHFT                                  0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_PID_BMSK                               0x1f00
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_PID_SHFT                                  0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_MID_BMSK                                 0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR1_MID_SHFT                                  0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000898)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_RMSK                               0xffffff87
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_BAR_BMSK                           0xc0000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_BAR_SHFT                                 0x1e
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_BURST_BMSK                         0x20000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_BURST_SHFT                               0x1d
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_CACHEABLE_BMSK                     0x10000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_CACHEABLE_SHFT                           0x1c
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_DEVICE_BMSK                         0x8000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_DEVICE_SHFT                              0x1b
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_DEVICE_TYPE_BMSK                    0x6000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_DEVICE_TYPE_SHFT                         0x19
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_EARLYWRRESP_BMSK                    0x1000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_EARLYWRRESP_SHFT                         0x18
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ERROR_BMSK                           0x800000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ERROR_SHFT                               0x17
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_EXCLUSIVE_BMSK                       0x400000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_EXCLUSIVE_SHFT                           0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_FULL_BMSK                            0x200000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_FULL_SHFT                                0x15
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_SHARED_BMSK                          0x100000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_SHARED_SHFT                              0x14
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_WRITETHROUGH_BMSK                     0x80000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_WRITETHROUGH_SHFT                        0x13
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERNOALLOCATE_BMSK                  0x40000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERNOALLOCATE_SHFT                     0x12
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERCACHEABLE_BMSK                   0x20000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERCACHEABLE_SHFT                      0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERSHARED_BMSK                      0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERSHARED_SHFT                         0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERTRANSIENT_BMSK                    0x8000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERTRANSIENT_SHFT                       0xf
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERWRITETHROUGH_BMSK                 0x4000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_INNERWRITETHROUGH_SHFT                    0xe
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_PORTMREL_BMSK                          0x2000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_PORTMREL_SHFT                             0xd
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ORDEREDRD_BMSK                         0x1000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ORDEREDRD_SHFT                            0xc
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ORDEREDWR_BMSK                          0x800
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_ORDEREDWR_SHFT                            0xb
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_OOORD_BMSK                              0x400
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_OOORD_SHFT                                0xa
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_OOOWR_BMSK                              0x200
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_OOOWR_SHFT                                0x9
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_NOALLOCATE_BMSK                         0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_NOALLOCATE_SHFT                           0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_TRANSIENT_BMSK                           0x80
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_TRANSIENT_SHFT                            0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_MEMTYPE_BMSK                              0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR2_MEMTYPE_SHFT                              0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_ADDR                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_PHYS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_OFFS                                 (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000884)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_RMSK                                 0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_ATTR                                        0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_ADDR_63_32_BMSK                      0xffffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_EAR1_ADDR_63_32_SHFT                             0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000089c)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_RMSK                                   0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_SEC_AD_RG_MATCH_BMSK                   0xff00
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_SEC_AD_RG_MATCH_SHFT                      0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_NONSEC_AD_RG_MATCH_BMSK                  0xff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR3_NONSEC_AD_RG_MATCH_SHFT                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ADDR                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_PHYS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_OFFS                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008a0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_RMSK                                0x3ffffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ATTR                                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ACACHEOPTYPE_BMSK                   0x3c00000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ACACHEOPTYPE_SHFT                        0x16
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ASID_BMSK                            0x3e0000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ASID_SHFT                                0x11
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ACGRANULETRANS_BMSK                   0x10000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_ACGRANULETRANS_SHFT                      0x10
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_AUATTR_BMSK                            0xffff
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_ESYNR4_AUATTR_SHFT                               0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_PHYS                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_OFFS                    (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008b0)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_RMSK                    0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ATTR                           0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR_31_0_BMSK          0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_START0_SHADOW_ADDR_31_0_SHFT                 0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_PHYS                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_OFFS                      (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x000008b8)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_RMSK                      0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ATTR                             0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_IN          \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR, HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_INM(m)      \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR, m)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_OUT(v)      \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR,v)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_OUTM(m,v) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR,m,v,HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_IN)
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR_31_0_BMSK            0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_QAD1_RGN_END0_SHADOW_ADDR_31_0_SHFT                   0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_ADDR(r)                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00000900 + 0x4 * (r))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_PHYS(r)                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00000900 + 0x4 * (r))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_OFFS(r)                       (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00000900 + 0x4 * (r))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_RMSK                               0x3ff
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_MAXr                                   0
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_ATTR                                 0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_INI(r)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_ADDR(r), HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_INMI(r,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_ADDR(r), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_RGOWNERSTATUS_BMSK                 0x3ff
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGN_OWNERSTATUSr_RGOWNERSTATUS_SHFT                   0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_ADDR(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_PHYS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_OFFS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001000 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_RMSK                                       0x107
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_MAXn                                           9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_RG_SEC_APPS_BMSK                           0x100
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_RG_SEC_APPS_SHFT                             0x8
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_RG_OWNER_BMSK                                0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR0_RG_OWNER_SHFT                                0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_ADDR(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001004 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_PHYS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001004 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_OFFS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001004 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_RMSK                                  0x80000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_MAXn                                           9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_PD_BMSK                               0x80000000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR1_PD_SHFT                                     0x1f

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ADDR(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001008 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_PHYS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001008 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_OFFS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001008 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_RMSK                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_MAXn                                           9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ASRC_BMSK                                    0x2
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_ASRC_SHFT                                    0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_CSRC_BMSK                                    0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR2_CSRC_SHFT                                    0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_ADDR(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_PHYS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_OFFS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000100c + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_RMSK                                         0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_MAXn                                           9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_SECURE_ACCESS_LOCK_BMSK                      0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_GCR3_SECURE_ACCESS_LOCK_SHFT                      0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_ADDR(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_PHYS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_OFFS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001010 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_RMSK                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_MAXn                                            9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_RGSCLRDEN_APPS_BMSK                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR0_RGSCLRDEN_APPS_SHFT                           0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_ADDR(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_PHYS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_OFFS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001014 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_RMSK                                          0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_MAXn                                            9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_RGCLRDEN_BMSK                                 0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR1_RGCLRDEN_SHFT                                 0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_ADDR(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_PHYS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_OFFS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001018 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_RMSK                                          0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_MAXn                                            9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_RGSCLWREN_APPS_BMSK                           0x1
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR2_RGSCLWREN_APPS_SHFT                           0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_ADDR(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_PHYS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_OFFS(n)                                (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x0000101c + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_RMSK                                          0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_MAXn                                            9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_ATTR                                          0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_RGCLWREN_BMSK                                 0x7
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_CR3_RGCLWREN_SHFT                                 0x0

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR(n)                             (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001030 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_PHYS(n)                             (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001030 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_OFFS(n)                             (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001030 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_RMSK                                0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_MAXn                                         9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ATTR                                       0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR_31_0_BMSK                      0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_START0_ADDR_31_0_SHFT                             0xc

#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE      + 0x00001038 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_PHYS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_PHYS + 0x00001038 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_OFFS(n)                               (IPA_MS_MPU_CFG_SNOC_IPA_MS_MPU_CFG_REG_BASE_OFFS + 0x00001038 + 0x80 * (n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_RMSK                                  0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_MAXn                                           9
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ATTR                                         0x3
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_INI(n)        \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR(n), HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_RMSK)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_INMI(n,mask)    \
        in_dword_masked(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR(n), mask)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_OUTI(n,val)    \
        out_dword(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR(n),val)
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_OUTMI(n,mask,val) \
        out_dword_masked_ns(HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR(n),mask,val,HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_INI(n))
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR_31_0_BMSK                        0xfffff000
#define HWIO_IPA_MS_MPU_CFG_XPU3_RGn_END0_ADDR_31_0_SHFT                               0xc


#endif /* __IPA_HWIO_H__ */
